#include "project.h"

/* APPLICATOR FUNCTIONS OF TYPE PXYDVBIND_FCN(PXYDVBIND)               */

/* Modified to consolidate applicator info. in single table entry      */

/* Modified to include history list (table), maintained by             */
/*    maintain_Apply1_history_table()                                  */
/* below, and handled by                                               */
/*    make_main_menu(), handle_apply1_history_menu() in plot.c         */

APPLY1_TYPE0     *Apply1_history_table        = NULL;
int               N_Apply1_history_table      = 0;
int               MAXN_Apply1_history_table   = 15;

APPLY1_TYPE0      Apply1_misc_table[] = {

   {NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_x_log_c_plus_x,
     "x -> log(c + x)",
     NULL,
     0, NULL, NULL },

   { pxydv_x_log_one_plus_x,
     "x -> log(1 + x)",
     NULL,
     0, NULL, NULL },

   { pxydv_dy_dx,
     "dy/dx",
     "%s'",
     0, NULL, NULL },

   { pxydv_dy_dx_mid,
     "dy/dx (mid)",
     "%s'",
     0, NULL, NULL },

   { pxydv_x_dy_dx,
     "x dy/dx",
     "x %s'",
     0, NULL, NULL },

   { pxydv_int_dx,
     "Int[y dx]",
     "Int[%s]",
     0, NULL, NULL },

   { pxydv_rint_dx,
     "R Int[y dx]",
     "Int[%s]",
     0, NULL, NULL },

   { pxydv_x_times_y,
     "x y",
     "x %s",
     0, NULL, NULL },

   { pxydv_y_divide_x,
     "y / x",
     "%s / x",
     0, NULL, NULL },

   { pxydv_int_dx_divide_x,
     "Int[y dx] / x",
     "Int[%s] / x",
     0, NULL, NULL },

   { pxydv_int_x_p_y_dx,
     "Int[x^p y dx]",
     "Int[x^p %s]",
     0, NULL, NULL },

   { pxydv_x_p,
     "x^p",
     NULL,
     0, NULL, NULL },

   { pxydv_x_p_times_y,
     "x^p y",
     "x^p %s",
     0, NULL, NULL },

   { pxydv_y_p,
     "y^p",
     "%s^p",
     0, NULL, NULL } 

                                        };

int               N_Apply1_misc_table =
                     sizeof(Apply1_misc_table) / sizeof(APPLY1_TYPE0);
/* Apply submenu tables ... */

/* x, y and t transformation functions ... */

APPLY1_TYPE0      Apply1_trans_x_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_x_plus_c,
     "x + c",
     NULL,
     0, NULL, NULL },

   { pxydv_x_times_c,
     "c x",
     NULL,
     0, NULL, NULL },

   { pxydv_x_dev_about_mean,
     "x - Mean[x]",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_x_plus_it_dx,
     "x -> x + dx * it",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_x_plus_t,
     "x -> x + t",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_x_minus_t,
     "x -> x - t",
     NULL,
     0, NULL, NULL },

   { pxydv_interpolate_x_to_pick_x,
     "x -> Interpolate[pick[x]]",
     NULL, 
     1, "Pick window with desired x coordinates.", NULL },

   { pxydv_x_to_pick_x,
     "x -> pick[x]",
     NULL,
     1, "Pick window with desired x coordinates.", NULL },

   { pxydv_x_to_unit,
     "x -> [0..1]",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_unit_rescale_y,
     "x -> [0..1] (rescale y)",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_unit_rescale_shift_y,
     "x -> [0..1] (rescale y, y[0] -> 0)",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_eps_times_sin_omega_x,
     "x -> x + e sin[w x]",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_scaled_x_power_p,
     "x -> x ^ p (scaled)",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_scaled_x_power_p_gen,
     "x -> x ^ p (scaled, gen.)",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_ordinal,
     "x -> 1, 2, 3, ...",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_dvumsh,
     "x -> uniform mesh",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_dvumsh_local,
     "x -> local uniform mesh",
     NULL,
     0, NULL, NULL },

   { pxydv_x_to_dvgmsh,
     "x -> graded mesh",
     NULL,
     0, NULL, NULL },

   { pxydv_2_to_1_linear,
     "-> 2:1 linear interp.",
     NULL,
     0, NULL, NULL }
                                         };

APPLY1_TYPE0      Apply1_trans_y_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_y_plus_c,
     "y + c",
     "%s + c",
     0, NULL, NULL },

   { pxydv_y_times_c,
     "c y",
     "c %s",
     0, NULL, NULL },

   { pxydv_y_dev_about_mean,
     "y - Mean[y]",
     "%s[bar]",
     0, NULL, NULL },

   { pxydv_y_to_unit,
     "y -> [0..1]",
     NULL,
     0, NULL, NULL },

   { pxydv_each_y_to_unit,
     "each y -> [0..1]",
     NULL,
     0, NULL, NULL },

   { pxydv_y_threshold,
     "y threshold",
     NULL,
     0, NULL, NULL },

   { pxydv_y_to_x,
     "y -> x",
     "x",
     0, NULL, NULL },

   { pxydv_y_to_y_minus_x,
     "y -> y - x",
     "%s - x",
     0, NULL, NULL },

   { pxydv_y_to_dx,
     "y -> dx",
     NULL,
     0, NULL, NULL },

   { pxydv_y_to_dy,
     "y -> dy",
     NULL,
     0, NULL, NULL },

   { pxydv_y_to_1m21,
     "y -> [1 -2 1] y",
     NULL,
     0, NULL, NULL },

   { pxydv_y_to_y_best_linear_fit,
     "y -> ax + b (l.s. fit)",
     "Linear_fit[%s]",
     0, NULL, NULL },

   { pxydv_y_to_dev_from_best_linear_fit,
     "y -> dev from l.s. fit",
     "Dev_fit[%s]",
     0, NULL, NULL },

   { pxydv_y_time_average,
     "y -> time average",
     "Time average[%s]",
     0, NULL, NULL },

   { pxydv_y_t_y,
     "y -> t y",
     "t %s",
     0, NULL, NULL }
                                         };
              
APPLY1_TYPE0      Apply1_trans_t_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_t_plus_c,
     "t + c",
     NULL,
     0, NULL, NULL },

   { pxydv_t_times_c,
     "c t",
     NULL,
     0, NULL, NULL },

   { pxydv_t_to_ordinal,
     "t -> 1, 2, 3, ...",
     NULL,
     0, NULL, NULL },

   { pxydv_t_to_unit_interval,
     "t -> [0..1]",
     NULL,
     0, NULL, NULL },

   { pxydv_cpt_to_tau,
     "T_0 -> tau",
     NULL,
     0, NULL, NULL },

   { pxydv_t_ln_t_minus_tstar,
     "sign(t - t*) ln(t - t*)",
     NULL,
     0, NULL, NULL },

   { pxydv_t_to_pick_t,
     "t -> pick[t]",
     NULL,
     1, "Pick window with relabelling times.", NULL },

   { pxydv_t_to_pick_y0,
     "t -> pick[y(0)[t]]",
     NULL,
     1, "Pick source window.", NULL },

   { pxydv_t_to_pick_int_dt,
     "t -> pick[Int[y(0)] dt]",
     NULL,
     1, "Pick source window.", NULL },

   { pxydv_t_interpolate_t2_x2,
     "dt -> dx / rho (xint = 2)",
     NULL,
     0, NULL, NULL },

   { pxydv_t_interpolate_t2_x4,
     "dt -> dx / rho (xint = 4)",
     NULL,
     0, NULL, NULL }
                                         };
              
APPLY1_TYPE0      Apply1_trans_xy_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_xyun,
     "X, Y -> [0..1] x [0..1]",
     NULL,
     0, NULL, NULL },

   { pxydv_xyun_symm,
     "X, Y -> [-1..1] x [-1..1]",
     NULL,
     0, NULL, NULL },

   { pxydv_xy_to_dquad_input,
     "X, Y -> ?dquad",
     NULL,
     0, NULL, NULL },

   { pxydv_xy_to_yx,
     "Y vs X -> X vs Y",
     NULL,
     0, NULL, NULL },

   { pxydv_xy_to_mxmy,
     "Y vs X -> -Y vs -X",
     NULL,
     0, NULL, NULL },

   { pxydv_xy_to_vw,
     "Y vs X -> W vs V",
     NULL,
     0, NULL, NULL },

   { pxydv_xy_rotate,
     "X , Y rotate",
     NULL,
     0, NULL, NULL },

   { pxydv_overlay,
     "overlay",
     NULL,
     0, NULL, NULL }
 
                                         };

APPLY1_TYPE0      Apply1_trans_xt_table[] = {
   
   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_xt_transpose,
     "x <--> t",
     NULL,
     0, NULL, NULL }

                                             };
              
APPLY1_TYPE0      Apply1_trans_xyt_table[] = {
   
   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_xytun,
     "X, Y, t -> [0..1] x [0..1]",
     NULL,
     0, NULL, NULL },

   { pxydv_xytun_and_lintseg_fixed,
     "'' and filter",
     NULL,
     0, NULL, NULL }

                                             };
              
/* Fitting functions ... */

APPLY1_TYPE0      Apply1_fit_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_cheby_fit_and_generate_f77,
     "generate f77",
     NULL,
     0, NULL, NULL },

   { pxydv_cheby_fit_and_generate_f77_d,
     "generate f77 (D)",
     NULL,
     0, NULL, NULL },

   { pxydv_cheby_fit_and_generate_ortho_phi,
     "generate ortho_phi",
     NULL,
     0, NULL, NULL },

   { pxydv_cheby_fit_and_generate_f77_x,
     "generate f77 (* x)",
     NULL,
     0, NULL, NULL },

   { pxydv_cheby_fit_and_replace,
     "replace",
     "Cheby[%s]",
     0, NULL, NULL },

   { pxydv_cheby_fit_and_append,
     "append",
     NULL,
     0, NULL, NULL } 
                                         };
/* Functions for adding, imposing, deleting periodic extensions ... */

APPLY1_TYPE0      Apply1_pbc_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_pbc_impose,
     "impose",
     NULL,
     0, NULL, NULL },

   { pxydv_pbc_add,
     "add",
     NULL,
     0, NULL, NULL },

   { pxydv_pbc_delete,
     "delete",
     NULL,
     0, NULL, NULL },

   { pxydv_pbc_extend,
     "extend",
     NULL,
     0, NULL, NULL }

                                         };
              
/* Discrete Fourier Transforms ... */

APPLY1_TYPE0      Apply1_dft_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_dft_fftf,
     "forward FFT",
     "FFT[%s]",
     0, NULL, NULL },

   { pxydv_dft_fftr,
     "reverse FFT",
     "Inverse FFT[%s]",
     0, NULL, NULL },

   { pxydv_dft_fftp,
     "power FFT",
     "power FFT[%s]",
     0, NULL, NULL }

                                         };
              
/* Wavelet transforms ... */

APPLY1_TYPE0      Apply1_wavelet_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_wavelet_daub4f,
     "daub4 forward",
     NULL,
     0, NULL, NULL },

   { pxydv_wavelet_daub4r,
     "daub4 reverse",
     NULL,
     0, NULL, NULL }
 
                                         };
              
/* Temporal derivatives ... */

APPLY1_TYPE0      Apply1_d_dt_table[] = {
 
   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_d_dt_y,
     "dy/dt",
     "d%s/dt",
     0, NULL, NULL },

   { pxydv_pairwise_d_dt_y,
     "pairwise dy/dt",
     NULL,
     0, NULL, NULL },

   { pxydv_pairwise_average,
     "pairwise average",
     NULL,
     0, NULL, NULL },

   { pxydv_d_dt_xy,
     "dy/dt, dx/dt",
     NULL,
     0, NULL, NULL }

                                         };
              
/* Filters ... */

APPLY1_TYPE0      Apply1_filter_table[] = {
 
   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_filter_every_mth,
     "every mth",
     NULL,
     0, NULL, NULL },

   { pxydv_filter_thin,
     "thin",
     NULL,
     0, NULL, NULL },

   { pxydv_filter_lintseg_fixed,
     "linear segmented",
     NULL,
     0, NULL, NULL },

   { pxydv_filter_lintseg_general,
     "linear segmented (general)",
     NULL,
     0, NULL, NULL },

   { pxydv_filter_c2_fixed,
     "2 fixed",
     NULL,
     0, NULL, NULL },

   { pxydv_filter_c4_fixed,
     "4 fixed",
     NULL,
     0, NULL, NULL },

   { pxydv_filter_c2_general,
     "2 general",
     NULL,
     0, NULL, NULL },

   { pxydv_filter_c4_general,
     "4 general",
     NULL,
     0, NULL, NULL }

                                         };
              
/* Pulse Massagers ...*/

APPLY1_TYPE0      Apply1_pulse_massage_table[] = {
 
   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_y_make_gaussian_pulse,
     "make gaussian pulse",
     NULL,
     0, NULL, NULL },

   { pxydv_y_make_poly_pulse,
     "make poly. pulse",
     NULL,
     0, NULL, NULL },

   { pxydv_y_exp_damp_tail,
     "exp(-(x-x0)/dx) y (tail)",
     NULL,
     0, NULL, NULL },

   { pxydv_y_exp_damp_head,
     "exp(-(x-x0)/dx) y (head)",
     NULL,
     0, NULL, NULL },

   { pxydv_y_poly_roll_off,
     "rolloff[x^p] y <TAB>",
     NULL,
     0, NULL, NULL },

   { pxydv_y_poly_roll_off_both,
     "quadratic rolloff both",
     NULL,
     0, NULL, NULL },

   { pxydv_pulse_isolate_and_reflect,
     "pulse isolate and reflect",
     NULL,
     0, NULL, NULL },

   { pxydv_phi_r_to_phi_t,
     "ph(r) -> ph(t)",
     NULL,
     0, NULL, NULL }

                                         };
              
/* Functions specific to study of self-gravitating systems in sph. sym ... */

APPLY1_TYPE0      Apply1_sssg_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_reflect,
     "reflect",
     ">%s<",
     0, NULL, NULL },

   { pxydv_mofa,
     "m(a,r)",
     "m",
     0, NULL, NULL },

   { pxydv_2mbyrofa,
     "2m / r (a,r)",
     "2m / r",
     0, NULL, NULL },

   { pxydv_dmdrofa,
     "dm / dr (a,r)",
     "m'",
     0, NULL, NULL },

   { pxydv_dmdrof2mbyr,
     "dm / dr (2m / r,r)",
     "m'",
     0, NULL, NULL },

   { pxydv_aofm,
     "a(m,r)",
     "a",
     0, NULL, NULL },

   { pxydv_laplacian_sph_sym,
     "Laplacian",
     "Laplacian[%s]",
     0, NULL, NULL },

   { pxydv_r2_laplacian_sph_sym,
     "r^2 Laplacian",
     "r^2 Laplacian[%s]",
     0, NULL, NULL },

   { pxydv_v_plus_r_dvdr,
     "V + r V'",    
     "V + r V'"         ,
     0, NULL, NULL },

   { pxydv_lofa, 
     "lapse(a,r)",
     "lapse",
     0, NULL, NULL },

   { pxydv_zeta_of_phi,
     "zeta(phi)",
     "zeta",
     0, NULL, NULL },
   
   { pxydv_w_minus_w0_over_r,
     "(W - W_0) / r",
     "(W - W_0) / r",
     0, NULL, NULL },

   { pxydv_wsq_minus_w0_sq_over_rsq,
     "(W^2 - W_0)^2 / r^2",
     "(W^2 - W_0)^2 / r^2",
     0, NULL, NULL },

   { pxydv_a_of_u,
     "a(u)",
     "a",
      0, NULL, NULL }
                                        };

/* Miscellaneous second-level functions ... */

APPLY1_TYPE0      Apply1_odds_table[] = {

   { NULL, NULL, NULL, 0, NULL, NULL},

   { pxydv_sort_x,
     "sort x",
     NULL,
      0, NULL, NULL },

   { pxydv_sort_pamr,
     "sort pamr",
     NULL,
      0, NULL, NULL },

   { pxydv_y_x_by_1mx,
     "y x / (1 - x)",
     "%s x / (1 - x)",
      0, NULL, NULL },

   { pxydv_t_log,
     "t log",
     NULL,
      0, NULL, NULL },

   { pxydv_cheby_dy_dx,
     "dy/dx (cheb)",
     "%s'",
      0, NULL, NULL },

   { pxydv_xy_curvature,
     "xy curvature",
     NULL,
      0, NULL, NULL },

   { pxydv_xy_curvature_s,
     "xy curv. sm.",
     NULL,
      0, NULL, NULL },

   { pxydv_y_sig,
     "sign y",
     "sign(%s)",
      0, NULL, NULL },

   { pxydv_dy_dx_sig,
     "sign dy/dx",
     "sign(%s')",
      0, NULL, NULL },

   { pxydv_y_inner_norm,
     "y[1] -> 1",
     NULL,
      0, NULL, NULL },

   { pxydv_y_outer_norm,
     "y[N] -> 1",
     NULL,
      0, NULL, NULL }

                                        };

/* Functions of type double including f77 intrinsics. */

APPLY1_TYPE1      Apply1_intrinsic_table[] = {
 
   { NULL, NULL, NULL, 0, NULL, NULL }, 

   { D_ABS,
     "abs",
     "|%s|",
      0, NULL, NULL },

   { dminus_,
     "-",
     "-%s",
      0, NULL, NULL },

   { drecip_,
     "^(-1)",
    "1/%s",
      0, NULL, NULL },

   { D_SQRT,
     "sqrt", 
     "sqrt(%s)",
      0, NULL, NULL },

   { ldexp_,
     "exp",
     "exp(%s)",
      0, NULL, NULL },

   { D_LOG,
     "log",
     "ln(%s)",
      0, NULL, NULL },

   { D_LG10,
     "log10",
     "log(%s)",
      0, NULL, NULL },

   { D_SIN,
     "sin ",
     "sin(%s)",
      0, NULL, NULL },

   { D_COS,
     "cos",
     "cos(%s)",
      0, NULL, NULL },

   { D_TAN,
     "tan",
     "tan(%s)",
      0, NULL, NULL },

   { D_ACOS,
     "acos",
     "acos(%s)",
      0, NULL, NULL },

   { D_ASIN,
     "asin",
     "asin(%s)",
      0, NULL, NULL },

   { D_ATAN,
     "atan",
     "atan(%s)",
      0, NULL, NULL },

   { D_SINH,
     "sinh",
     "sinh(%s)",
      0, NULL, NULL },

   { D_COSH,
     "cosh",
     "cosh(%s)",
      0, NULL, NULL },

   { D_TANH,
     "tanh",
     "tanh(%s)",
      0, NULL, NULL }

                                         };
              
int               N_Apply1_intrinsic_table =
                     sizeof(Apply1_intrinsic_table) / sizeof(APPLY1_TYPE0);

/* Tagging functions ... */

APPLY1_TYPE0      Apply1_tag_table[] =   {
 
   { pxydv_tag_by_dx,
     "tag by dx",
     NULL,
      0, NULL, NULL },

   { pxydv_tag_with_constant,
     "tag by constant",
     NULL,
      0, NULL, NULL },

   { pxydv_tag_delete,
     "delete",
     NULL,
      0, NULL, NULL }

                                         };
              
int               N_Apply1_tag_table =
                     sizeof(Apply1_tag_table) / sizeof(APPLY1_TYPE0);


/* Structure for all apply sub-menus ... */

#define TABLE(a) a, sizeof(a) / sizeof(APPLY1_TYPE0)

APPLY1_SUBMENU_TYPE0  Apply_submenu_table0[] = {

   { "x trans.",
     TABLE(Apply1_trans_x_table) },

   { "y trans.",
     TABLE(Apply1_trans_y_table) },

   { "xy trans.",
     TABLE(Apply1_trans_xy_table) },

   { "t trans.",
     TABLE(Apply1_trans_t_table) },

   { "xt trans.",
     TABLE(Apply1_trans_xt_table) },

   { "xyt trans.",
     TABLE(Apply1_trans_xyt_table) },

   { "d/dt",
     TABLE(Apply1_d_dt_table) },

   { "filter",
     TABLE(Apply1_filter_table) },

   { "pulse massage",
     TABLE(Apply1_pulse_massage_table) },

   { "Cheby fit",
     TABLE(Apply1_fit_table) },

   { "Periodic bc",
     TABLE(Apply1_pbc_table) },

   { "Fourier trans.",
     TABLE(Apply1_dft_table) },

   { "Wavelet trans.",
     TABLE(Apply1_wavelet_table) },

   { "Sph. sym. grav.",
      TABLE(Apply1_sssg_table) },

   { "Miscellaneous",
      TABLE(Apply1_odds_table) }

                                              };

#undef  TABLE

int  N_Apply_submenu_table0 = sizeof(Apply_submenu_table0) / 
                              sizeof(APPLY1_SUBMENU_TYPE0);
int  Apply_submenu_encode   = 1000;

/* Defaults for segment based filtering ... */

double            Mindseg_default = 0.01;
double            Maxdseg_default = 0.02;

#define           SAVE             int ip; PXYDVBIND      lp = p
#define           FOR              for( p = lp, ip = 1; p != NULL ; p = p->next, ip++ )
#define           RETURN           return lp
#define           X                p->data->x
#define           Y                p->data->y
#define           N                p->data->n
#define           T                p->time
#define           TAG              p->tag
#define           X_NEXT           (p->next)->data->x
#define           Y_NEXT           (p->next)->data->y
#define           N_NEXT           (p->next)->data->n
#define           T_NEXT           (p->next)->time
#define           TAG_NEXT         (p->next)->TAG
#define           VTAG             p->tdata
#define           VTAGTAG          p->tdata->tag

#define GETP(p,s) scope_mess_perm(s); p = x_mouse_after_button(); scope_clear()

void maintain_Apply1_history_table(APPLY1_TYPE0 entry) {
   APPLY1_TYPE0    *Apply1_history_table_tmp = NULL;
   int              nold,    nnew,     i,     j;
   int              ltrace = Ltrace;

   nold = N_Apply1_history_table;
   if( ltrace ) {
      fprintf(stderr,"maintain_Apply1_history_table: Old length %d\n",nold);
   }
   if( nold > 0 ) {
      FREEVEC(APPLY1_TYPE0,Apply1_history_table_tmp);
      Apply1_history_table_tmp = MAKEVEC(APPLY1_TYPE0,nold);
      for( nnew = 1, i = 0; i < nold; i++ ) {
         Apply1_history_table_tmp[i] = Apply1_history_table[i];
         if( nnew < MAXN_Apply1_history_table  &&
             Apply1_history_table[i].apply_fcn != entry.apply_fcn ) nnew++;
      }
   } else {
      nnew = 1;
   }
   if( ltrace ) {
      fprintf(stderr,"maintain_Apply1_history_table: New length %d\n",nnew);
   }
   if( nnew > 0 ) {
      FREEVEC(APPLY1_TYPE0,Apply1_history_table);
      Apply1_history_table = MAKEVEC(APPLY1_TYPE0,nnew);
      Apply1_history_table[0] = entry;
      for( i = 1, j = 0; i < nnew; j++ ) {
         if( Apply1_history_table_tmp[j].apply_fcn != entry.apply_fcn ) {
            Apply1_history_table[i] = Apply1_history_table_tmp[j];
            i++;
         }
      }
   }
   Remake_main_menu = ON;
   N_Apply1_history_table = nnew;
}

#define           HEAD             wds[wt].pf.pxyf->xyhead
#define           LXY              wds[wt].pf.pxyf->lxy
#define           LRETURN(a)       restore_ring_state(wt); return a;

int wt_is_time_compressible(WT wt) {
   PXYDVBIND       p;
   DVEC            X1;
   int             N1;
   double          max_abrd, max_allowable_abrd = 1.0e-6;
   int             i;
   int             ltrace = OFF;

   if( !is_active_wt(wt) ) {
      LRETURN(FALSE); 
   }
   if( LXY == 1 ) {
      LRETURN(TRUE); 
   }

   unmake_xy_ring(wt);
   for( p = HEAD->next, X1 = HEAD->data->x, N1 = HEAD->data->n, i = 0; 
        p != NULL; p = p->next, ++i ) {
      DVEC     DX;
      if( N != N1 ) {
         LRETURN(FALSE);
      }
      DX = make_DVEC(N);
      dvabrd_(X,X1,DX,&N);
      max_abrd = dvmax_(DX,&N);
      free_DVEC(DX);
      if( ltrace ) {
         fprintf(stderr,"xy vector %d: Max relative diff %g\n",i,max_abrd);
      }
      if( max_abrd > max_allowable_abrd ) {
         LRETURN(FALSE);
      }
   }
   LRETURN(TRUE);
}
#undef            LRETURN 
#undef            LXY
#undef            HEAD

PXYDVBIND pxydv_blurb(p)
   PXYDVBIND        p; 
{
   int i = 0;

   SAVE;
   FOR {
      sprintf(O_buf,"XY Vector %d: %d events",++i,N);
      scope_mess(O_buf,1);
   }
   RETURN;
}

PXYDVBIND pxydv_x_plus_c(p)
   PXYDVBIND        p; 
{
   double    c = 0.0;

   SAVE;
   GET_DOUBLE(c,c,"c");
   FOR {
      (void) dvsa_(X,&c,X,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_x_times_c(p)
   PXYDVBIND        p; 
{
   double    c = 0.0;

   SAVE;
   GET_DOUBLE(c,c,"c");
   FOR {
      (void) dvsm_(X,&c,X,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_x_dev_about_mean(p)
   PXYDVBIND        p;
{
   double    minus_xmean;

   SAVE;
   FOR {
      minus_xmean = -0.5 * (dvmin_(X,&N) + dvmax_(X,&N));
      dvsa_(X,&minus_xmean,X,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_x_to_x_plus_it_dx(p)
   PXYDVBIND        p;
{
   double           dx = 0.0,    tot_dx = 0.0;

   SAVE;
   GET_DOUBLE(dx,dx,"dx");
   FOR {
      dvsa_(X,&tot_dx,X,&N);
      tot_dx += dx;
   }
   RETURN;
}

PXYDVBIND pxydv_x_to_x_plus_t(PXYDVBIND p) {
   SAVE;
   FOR {
      dvsa(X, T,X,N);
   }
   RETURN;
}

PXYDVBIND pxydv_x_to_x_minus_t(PXYDVBIND p) {
   SAVE;
   FOR {
      dvsa(X,-T,X,N);
   }
   RETURN;
}

PXYDVBIND pxydv_interpolate_x_to_pick_x(PXYDVBIND p) {
   int              ltrace = OFF;
   PXYDVBIND        picked_p;
   int              re_x_wt,  picked_wt;
   
   SAVE;

   re_x_wt = Menu_deferred_wt;
   if( ltrace ) {
      printf("pxydv_interpolate_x_to_pick_x: %d vectors to be interpolated.\n",
         n_PXYDVBIND(p));
      ivecn_dump(Picked_wt_list,"pxydv_interpolate_x_to_pick_x");
   }
   picked_wt = Picked_wt_list.v[0];
   if( re_x_wt == picked_wt ) {
      scope_mess_and_bell("Target and source windows are identical. Operation aborted.",2);
      return lp;
   }

   if( ltrace ) {
      printf("pxydv_interpolate_x_to_pick_x: Interpolating %d to %d's coordinates.\n",
              re_x_wt,picked_wt);
   }
   scope_clear();
   unmake_xy_ring(picked_wt);
   picked_p = wds[picked_wt].pf.pxyf->xyhead;
   if( compatible_PXYDVBIND_lists_t(p,picked_p) ) {
      DVEC    NEW_X,       NEW_Y;
      int     f77_intord = 4;
      double  f77_def_value = 0.0;
#define       PICKED_X    (picked_p->data)->x
#define       PICKED_N    (picked_p->data)->n
      if( ltrace ) {
         scope_mess_and_bell("Windows are compatible.",2);
      }
      FOR {
         if( (NEW_X = make_DVEC(PICKED_N))  &&  
             (NEW_Y = make_DVEC(PICKED_N)) ) {
            dvcopy_(PICKED_X,NEW_X,&PICKED_N);
            dvinqn_(Y,X,NEW_Y,NEW_X,&N,&PICKED_N,&f77_def_value,&f77_def_value,
                    &f77_intord);
            N = PICKED_N;
            free(X);  X = NEW_X;
            free(Y);  Y = NEW_Y;
            picked_p = picked_p->next;
         } else {
            scope_mess_and_bell("make_DVEC failure in pxydv_interpolate_x_to_pick_x.",2);
         }
      }
      set_must_redraw(re_x_wt);
#undef        PICKED_X
#undef        PICKED_N
   } else {
      sprintf(O_buf,"Windows %d and %d not compatible.",re_x_wt,picked_wt);
      scope_mess_and_bell(O_buf,1);
   }
Abort:
   restore_ring_state(picked_wt);
Return:
   RETURN;
}

PXYDVBIND pxydv_x_to_pick_x(PXYDVBIND p) {
   int              ltrace = OFF;
   PXYDVBIND        picked_p;
   int              re_x_wt,  picked_wt;
   
   SAVE;

   re_x_wt = Menu_deferred_wt;
   if( ltrace ) {
      printf("pxydv_x_to_pick_x: %d vectors to be interpolated.\n",
         n_PXYDVBIND(p));
   }
   picked_wt = Picked_wt_list.v[0];
   if( re_x_wt == picked_wt ) {
      scope_mess_and_bell("Target and source windows are identical. Operation aborted.\n",2);
      return lp;
   }
   if( ltrace ) {
      printf("pxydv_x_to_pick_x: Interpolating %d to %d's coordinates.\n",
              re_x_wt,picked_wt);
   }
   scope_clear();
   unmake_xy_ring(picked_wt);
   picked_p = wds[picked_wt].pf.pxyf->xyhead;
   if( compatible_PXYDVBIND_lists_data_n(p,picked_p) ) {
#define       PICKED_X    (picked_p->data)->x
#define       PICKED_N    (picked_p->data)->n
      if( ltrace ) {
         scope_mess_and_bell("Windows are compatible.",2);
      }
      FOR {
            dvcopy_(PICKED_X,X,&N);
            picked_p = picked_p->next;
      }
      set_must_redraw(re_x_wt);
#undef        PICKED_X
#undef        PICKED_N
   } else {
      sprintf(O_buf,"Windows %d and %d not compatible.",re_x_wt,picked_wt);
      scope_mess_and_bell(O_buf,1);
   }
Abort:
   restore_ring_state(picked_wt);
Return:
   RETURN;
}

PXYDVBIND pxydv_x_to_unit(p)
   PXYDVBIND        p;
{
   double           xmin,    xmax,    xrange,
                    f77_zero = 0.0;

   SAVE;
   xmin = xmin_wt(S_wt); xmax = xmax_wt(S_wt); xrange = xmax - xmin;
   if( xrange > 0.0 ) {
      xrange = 1.0 / xrange;
      FOR {
         dvlt_(X,X,&N,&f77_zero,&xrange,&xmin);
      }
   } else {
      scope_mess_and_bell("Degenerate xrange.",1);   
   }
   RETURN;
}

PXYDVBIND pxydv_x_to_unit_rescale_y(PXYDVBIND p)
{
   double           xmin,    xmax,    xrange,
                    ymin, 
                    f77_zero = 0.0;

   SAVE;
   xmin = xmin_wt(S_wt); xmax = xmax_wt(S_wt); xrange = xmax - xmin;
   ymin = ymin_wt(S_wt); 
   if( xrange > 0.0 ) {
      xrange = 1.0 / xrange;
      FOR {
         dvlt_(X,X,&N,&f77_zero,&xrange,&xmin);
         dvlt_(Y,Y,&N,&f77_zero,&xrange,&ymin);
      }
   } else {
      scope_mess_and_bell("Degenerate xrange.",1);   
   }
   RETURN;
}

PXYDVBIND pxydv_x_to_unit_rescale_shift_y(PXYDVBIND p) {
   double           xmin,    xmax,    xrange,
                    ymin, 
                    f77_zero = 0.0;

   SAVE;
   xmin = xmin_wt(S_wt); xmax = xmax_wt(S_wt); xrange = xmax - xmin;
   ymin = ymin_wt(S_wt); 
   if( xrange > 0.0 ) {
      xrange = 1.0 / xrange;
      FOR {
         dvlt_(X,X,&N,&f77_zero,&xrange,&xmin);
         dvlt_(Y,Y,&N,&f77_zero,&xrange,&ymin);
         dvsa(Y,-Y[0],Y,N);
      }
   } else {
      scope_mess_and_bell("Degenerate xrange.",1);   
   }
   RETURN;
}

PXYDVBIND  pxydv_x_to_eps_times_sin_omega_x(PXYDVBIND p) {
   double     eps = .001,  omega = 1.0;
   DVEC       TX;

   SAVE;
   GET_DOUBLE(eps,eps,"eps");
   GET_DOUBLE(omega,omega,"omega");
   FOR {
      TX = make_DVEC(N);
      (void) dvsm(X,omega,TX,N);
      (void) dvfapl_(TX,TX,D_SIN,&N);
      (void) dvsm(TX,eps,TX,N);
      (void) dvva(X,TX,X,N);
      free_DVEC(TX);
   }
   RETURN;
}

PXYDVBIND  pxydv_x_to_scaled_x_power_p(PXYDVBIND p) {
   double     power,   default_power = 2.0;
   DVEC       TX;

   SAVE;
   sprintf(O_buf,"p (%3.1f)",default_power);
   GET_DOUBLE(power,default_power,O_buf);
   FOR {
      TX = make_DVEC(N);
      (void) dvpowtr_(X,TX,&N,&power);
      (void) dvcopy_(TX,X,&N);
      free_DVEC(TX);
   }
   RETURN;
}

PXYDVBIND  pxydv_x_to_scaled_x_power_p_gen(PXYDVBIND p) {
   double     power,   default_power = 2.0;
   double     rx1min,  rx1max;
   DVEC       TX,      TY;

   SAVE;
   sprintf(O_buf,"p (%3.1f)",default_power);
   GETP(rx1min,"Pick minimum x with mouse ...");
   GETP(rx1max,"Pick maximum x with mouse ...");
   GET_DOUBLE(power,default_power,O_buf);
   FOR {
      TX = make_DVEC(N);       TY = make_DVEC(N);
      (void) dvvpowtr_(Y,X,TY,TX,&N,&power,&rx1min,&rx1max);
      (void) dvcopy_(TX,X,&N); (void) dvcopy_(TY,Y,&N);
      free_DVEC(TX);           free_DVEC(TY);
   }
   RETURN;
}

PXYDVBIND  pxydv_x_to_ordinal(PXYDVBIND p) {

   double  f77_one = 1.0;

   SAVE;
   FOR {
      dvramp_(X,&f77_one,&f77_one,&N);
   }
   RETURN;
}

/* Interplolates to uniform mesh on max(min(X)) .. min(max(X)) ... */

PXYDVBIND  pxydv_x_to_dvumsh(PXYDVBIND p) {

   char   *PromptS;
   int     n;
   int     f77_intord = 4;

   DVEC    NEW_X,   NEW_Y;
   double  xmaxmin,    xminmax;

   double  f77_def_value = 0.0;

   int     tab_state;
   int     ltrace = OFF;

   SAVE;

   tab_state = tab_key_pressed();
   if( ltrace ) {
      fprintf(stderr,"pxydv_x_to_dvumsh: Tab state: %s\n",
              tab_state ? "ON" : "OFF");
   }

Prompt:
      sprintf(O_buf,"Enter n, interp. ord (%d)",f77_intord);
      GET_STRING(&PromptS,O_buf);
      if( ltrace ) fprintf(stderr,"pxydv_x_to_dvumsh: PromptS='%s'\n",
         PromptS ? PromptS : "NULL");
      if( !PromptS ) goto Prompt;
      if( sscanf(PromptS,"%d %d",&n,&f77_intord) < 1 ) goto Prompt;
      if( n < 1 || f77_intord < 1 ) goto Prompt;
      free(PromptS);
   
   if( ltrace ) {
      fprintf(stderr,
              "pxydv_x_to_dvumsh: Order %d interpolation to length %d mesh.\n",
              f77_intord,n);
   }

   if( tab_state ) {
      xmaxmin = xmin_wt(wt_from_xyhead(lp));
      xminmax = xmax_wt(wt_from_xyhead(lp));
   } else {
      FOR {
         if( ip == 1 ) {
            xmaxmin = dvmin_(X,&N);
            xminmax = dvmax_(X,&N);
         } else {
            xmaxmin = dmax(xmaxmin,dvmin_(X,&N));
            xminmax = dmin(xminmax,dvmax_(X,&N));
         }
      }
   }
   if( ltrace ) {
      fprintf(stderr,"pxydv_x_to_dvumsh: Uniform mesh domain: %g .. %g.\n",
              xmaxmin,xminmax);
   }
   FOR {
      if( (NEW_X = make_DVEC(n))  &&  (NEW_Y = make_DVEC(n)) ) {
         dvumsh_(NEW_X,&n,&xmaxmin,&xminmax);
         dvinqn_(Y,X,NEW_Y,NEW_X,&N,&n,&f77_def_value,&f77_def_value,
                 &f77_intord);
         N = n;
         free(X);  X = NEW_X;
         free(Y);  Y = NEW_Y;
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_x_to_dvumsh.",2);
      }
   }
   RETURN;
}

PXYDVBIND  pxydv_2_to_1_linear(PXYDVBIND p) {

   DVEC    NEW_X,   NEW_Y;
   int     NEW_N;

   int     f77_2 = 2;

   int     ltrace = OFF;

   SAVE;

   FOR {
      NEW_N = 2 * N - 1;
      if( (NEW_X = make_DVEC(NEW_N))  &&  (NEW_Y = make_DVEC(NEW_N)) ) {
         dvprln_(X,NEW_X,&f77_2,&N);
         dvav2_(NEW_X,&NEW_N);
         dvprln_(Y,NEW_Y,&f77_2,&N);
         dvav2_(NEW_Y,&NEW_N);
         N = NEW_N;
         free(X);  X = NEW_X;
         free(Y);  Y = NEW_Y;
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_2_to_1_linear.",2);
      }
   }
   RETURN;
}

/* Interplolates to uniform mesh on min(X)) ... max(X) ... */

PXYDVBIND  pxydv_x_to_dvumsh_local(PXYDVBIND p) {

   char   *PromptS;
   int     n;
   int     f77_intord = 4;

   DVEC    NEW_X,   NEW_Y;
   double  xmin,    xmax;

   double  f77_def_value = 0.0;

   int     ltrace = OFF;

   SAVE;

Prompt:
      sprintf(O_buf,"Enter n, interp. ord (%d)",f77_intord);
      GET_STRING(&PromptS,O_buf);
      if( !PromptS ) goto Prompt;
      if( sscanf(PromptS,"%d %d",&n,&f77_intord) < 1 ) goto Prompt;
      if( n < 1 || f77_intord < 1 ) goto Prompt;
      free(PromptS);
   
   if( ltrace ) {
      fprintf(stderr,
         "pxydv_x_to_dvumsh_local: Order %d interpolation to length %d mesh.\n",
         f77_intord,n);
   }

   FOR {
      xmin = X[0];
      xmax = X[N-1];
      if( (NEW_X = make_DVEC(n))  &&  (NEW_Y = make_DVEC(n)) ) {
         dvumsh_(NEW_X,&n,&xmin,&xmax);
         dvinqn_(Y,X,NEW_Y,NEW_X,&N,&n,&f77_def_value,&f77_def_value,
                 &f77_intord);
         N = n;
         free(X);  X = NEW_X;
         free(Y);  Y = NEW_Y;
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_x_to_dvumsh_local.",2);
      }
   }
   RETURN;
}


PXYDVBIND  pxydv_x_to_dvgmsh(PXYDVBIND p) {

   char   *PromptS;
   int     n;
   double  rho;

   DVEC    NEW_X,   NEW_Y;
   double  xmin,    xmax;

   int     f77_intord = 4;
   double  f77_def_value = 0.0;

   int     ltrace = OFF;
   int     skip_prompt = OFF;

   SAVE;

   FOR {
      if( !skip_prompt ) {
Prompt:
         sprintf(O_buf,"Enter n, rho (group %d)",ip);
         GET_STRING(&PromptS,O_buf);
         if( ltrace ) {
            fprintf(stderr,"pxydv_x_to_dvgmsh: Read <%s>.\n",PromptS);
         }
         if( !PromptS ) {
            if( ip > 1 ) {
               skip_prompt = ON;
               goto SkipPrompt;
            } else {
               goto Prompt;
            }
         } else {
            if( sscanf(PromptS,"%d %lf",&n,&rho) != 2 ) goto Prompt;
         }
         if(  PromptS ) free(PromptS);
         rho = -rho;
      }
SkipPrompt:
      if( ltrace ) {
         fprintf(stderr,"pxydv_x_to_dvgmsh: Vector %d. n: %d  rho: %lf.\n",
                        ip, n, rho);
      }
      if( (NEW_X = make_DVEC(n))  &&  (NEW_Y = make_DVEC(n)) ) {
         xmin = dvmin_(X,&N); xmax = dvmax_(X,&N);
         dvgmsh_(NEW_X,&n,&xmin,&xmax,&rho);
         dvinqn_(Y,X,NEW_Y,NEW_X,&N,&n,&f77_def_value,&f77_def_value,
                 &f77_intord);
         N = n;
         free(X);  X = NEW_X;
         free(Y);  Y = NEW_Y;
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_x_to_dvgmsh.",2);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_plus_c(p)
   PXYDVBIND        p; 
{
   double    c = 0.0;

   SAVE;
   GET_DOUBLE(c,c,"c");
   FOR {
      (void) dvsa_(Y,&c,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_y_times_c(p)
   PXYDVBIND        p; 
{
   double    c = 0.0;

   SAVE;
   GET_DOUBLE(c,c,"c");
   FOR {
      (void) dvsm_(Y,&c,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_y_dev_about_mean(p)
   PXYDVBIND        p;
{
   double    minus_ymean;

   SAVE;
   FOR {
      minus_ymean = -dvsum_(Y,&N) / (double) N;
      dvsa_(Y,&minus_ymean,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_y_to_unit(PXYDVBIND p) {
   double           ymin,    ymax,    yrange,
                    f77_zero = 0.0;

   SAVE;
   ymin = ymin_wt(S_wt); ymax = ymax_wt(S_wt); yrange = ymax - ymin;
   if( yrange > 0.0 ) {
      yrange = 1.0 / yrange;
      FOR {
         dvlt_(Y,Y,&N,&f77_zero,&yrange,&ymin);
      }
   } else {
      scope_mess_and_bell("Degenerate yrange.",1);   
   }
   RETURN;
}

PXYDVBIND pxydv_each_y_to_unit(PXYDVBIND p) {
   double           ymin,    ymax,    yrange,
                    f77_zero = 0.0;

   SAVE;
   FOR {
      ymin = dvmin_(Y,&N); ymax = dvmax_(Y,&N); yrange = ymax - ymin;
      if( yrange != 0.0 ) {
         yrange = 1.0 / yrange;
         dvlt_(Y,Y,&N,&f77_zero,&yrange,&ymin);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_threshold(p)
   PXYDVBIND        p; 
{
   double    thresh = 1.0e-3;

   SAVE;
   sprintf(O_buf,"threshold (%g)",thresh);
   GET_DOUBLE(thresh,thresh,O_buf);
   FOR {
      (void) dvthresh_(Y,Y,&N,&thresh);
   }
   RETURN;
}

PXYDVBIND pxydv_y_to_x(PXYDVBIND  p) {
   SAVE;
   FOR {
      dvcopy_(X,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_y_to_y_minus_x(PXYDVBIND  p) {
   SAVE;
   FOR {
      dvvs_(Y,X,Y,&N);
   }
   RETURN;
}
PXYDVBIND pxydv_y_to_dx(PXYDVBIND p)
{
   DVEC   NEW_X,     NEW_Y;
   int    n;
   
   double f77_one = 1.0;

   SAVE;
   FOR {
      n = N - 1;
      if( (NEW_X = make_DVEC(n))  &&  (NEW_Y = make_DVEC(n)) ) {
         dvcopy_(X,NEW_X,&n);
         dvdd1_(X,NEW_Y,&f77_one,&N);
         N = n;
         free(X);  X = NEW_X;
         free(Y);  Y = NEW_Y;
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_y_to_dx.",2);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_to_dy(PXYDVBIND p)
{
   DVEC   NEW_Y;
   int    n;
   
   double f77_one = 1.0;

   SAVE;
   FOR {
      if( NEW_Y = make_DVEC(N) ) {
         dvdd1_(Y,NEW_Y,&f77_one,&N);
         NEW_Y[N-1] = 0.0;
         free(Y);  Y = NEW_Y;
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_y_to_dy.",2);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_to_1m21(PXYDVBIND p)
{
   DVEC   NEW_Y;
   int    n;
   
   double f77_one = 1.0;

   SAVE;
   FOR {
      if( NEW_Y = make_DVEC(N) ) {
         dvdd02_(Y,NEW_Y,&f77_one,&N);
         NEW_Y[0] = 0.0;
         NEW_Y[N-1] = 0.0;
         free(Y);  Y = NEW_Y;
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_y_to_1m21.",2);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_to_y_best_linear_fit(PXYDVBIND p)
{
   DVEC  TY;
   SAVE;
   FOR {
      if( (TY = make_DVEC(N)) ) {
         dvlls_(X,Y,TY,&N);
         free(Y);
         Y = TY;
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_to_dev_from_best_linear_fit(PXYDVBIND p)
{
   DVEC  TY;
   SAVE;
   FOR {
      if( (TY = make_DVEC(N)) ) {
         dvdlls_(X,Y,TY,&N);
         free(Y);
         Y = TY;
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_time_average(PXYDVBIND p) {
   WT          lwt;
   int         ltrace = OFF;
   int         lxy;
   PXYDVBIND   tp;
   SAVE;

   lwt = wt_from_xyhead(lp);
   lxy = get_lxy_wt(lwt);
   
   if(  wt_is_time_compressible(lwt) ) {
      if( ltrace ) fprintf(stderr,
         "pxydv_y_time_average: Window is time compressible\n");
      for( p = lp; p != NULL; ) {
#define    X1  lp->data->x
#define    Y1  lp->data->y
#define    N1  lp->data->n
         if( p != lp ) {
            dvva(Y1,Y,Y1,N1);
            tp = p->next;
            free_XYDVEC(p->data);
            if( p->tdata ) free_XYTAGVEC(p->tdata);
         } else {
            tp = p->next;
            p->next = NULL;
            p->prev = NULL;
         }
         p = tp;
      }
      dvsm(Y1,1.0 / ((double) lxy),Y1,N1);
      reindex_XYDVlist(lp,1);
      return(lp);
#undef     X1 
#undef     Y1  
#undef     N1
   } else {
      scope_mess_and_bell("Window is not time compressible\n",1);
      if( ltrace ) fprintf(stderr,
         "pxydv_y_time_average: Window is not time compressible\n");
      return(lp);
   }
}

PXYDVBIND pxydv_y_t_y(PXYDVBIND p)
{
   DVEC  TY;
   SAVE;
   FOR {
      if( (TY = make_DVEC(N)) ) {
         dvsm_(TY,&(T),TY,&N);
         free(Y);
         Y = TY;
      }
   }
   RETURN;
}


PXYDVBIND pxydv_xy_to_dquad(PXYDVBIND p,DQUAD dq) {
   double           xmin,    xmax,    old_xrange,   mx,
                    ymin,    ymax,    old_yrange,   my;

   SAVE;
   xmin = xmin_wt(S_wt); xmax = xmax_wt(S_wt); old_xrange = xmax - xmin;
   ymin = ymin_wt(S_wt); ymax = ymax_wt(S_wt); old_yrange = ymax - ymin;
   if( old_xrange > 0.0  && old_yrange > 0.0 ) {
      mx = (dq.x2 - dq.x1) / old_xrange;
      my = (dq.y2 - dq.y1) / old_yrange;
      FOR {
         dvlt_(X,X,&N,&dq.x1,&mx,&xmin);
         dvlt_(Y,Y,&N,&dq.y1,&my,&ymin);
      }
   } else {
      scope_mess_and_bell("Degenerate xrange and/or yrange.",1);
   }
   RETURN;
}

PXYDVBIND pxydv_xyun(PXYDVBIND p) {
   return(pxydv_xy_to_dquad(p,make_dquad(0.0,0.0,1.0,1.0)));
}

PXYDVBIND pxydv_xyun_symm(PXYDVBIND p) {
   return(pxydv_xy_to_dquad(p,make_dquad(-1.0,-1.0,1.0,1.0)));
}

PXYDVBIND pxydv_xytun(PXYDVBIND p) {
   return(pxydv_t_to_unit_interval(pxydv_xyun(p)));
}

PXYDVBIND pxydv_xytun_and_lintseg_fixed(PXYDVBIND p) {
   return(pxydv_filter_lintseg_fixed(pxydv_t_to_unit_interval(pxydv_xyun(p))));
}

PXYDVBIND pxydv_xy_to_dquad_input(PXYDVBIND p) {
   DQUAD  input_dquad,  default_dquad = make_dquad(0.0,0.0,1.0,1.0);
   
   GET_DQUAD(input_dquad,default_dquad,"Enter x0 y0 x1 y1");
   return(pxydv_xy_to_dquad(p,input_dquad));
}

PXYDVBIND old_pxydv_xyun(p)
   PXYDVBIND        p; 
{
   double           xmin,    xmax,    xrange,
                    ymin,    ymax,    yrange,
                    f77_zero = 0.0;

   SAVE;
   xmin = xmin_wt(S_wt); xmax = xmax_wt(S_wt); xrange = xmax - xmin;
   ymin = ymin_wt(S_wt); ymax = ymax_wt(S_wt); yrange = ymax - ymin;
   if( xrange > 0.0  && yrange > 0.0 ) {
      xrange = 1.0 / xrange;
      yrange = 1.0 / yrange;
      FOR {
         dvlt_(X,X,&N,&f77_zero,&xrange,&xmin);
         dvlt_(Y,Y,&N,&f77_zero,&yrange,&ymin);
      }
   } else {
      scope_mess_and_bell("Degenerate xrange and/or yrange.",1);
   }
   RETURN;
}

PXYDVBIND  pxydv_t_to_ordinal(PXYDVBIND p) {
   SAVE;
   FOR {
      T = (double) ip;
   }
   RETURN;
}

PXYDVBIND  pxydv_t_to_unit_interval(PXYDVBIND p) {
   SAVE;

   double  tmin,  tmax,  dtm1;
   FOR {
      if( ip == 1 ) {
         tmin = T;
         tmax = T;
      } else {
         tmin = dmin(tmin,T);
         tmax = dmax(tmax,T);
      }
   }
   if( tmax != tmin ) {
      dtm1 = 1.0 / (tmax - tmin);
      FOR {
         T = dtm1 * (T - tmin);
      }
   } else {
      scope_mess_and_bell("Degenerate trange.",1);
   }
   RETURN;
}

PXYDVBIND pxydv_t_plus_c(p)
   PXYDVBIND        p; 
{
   double    c = 0.0;

   SAVE;
   GET_DOUBLE(c,c,"c");
   FOR {
      T += c;
   }
   RETURN;
}

PXYDVBIND pxydv_t_times_c(p)
   PXYDVBIND        p; 
{
   double    c = 1.0;

   SAVE;
   GET_DOUBLE(c,c,"c");
   FOR {
      T *= c;
   }
   RETURN;
}

PXYDVBIND pxydv_cpt_to_tau(PXYDVBIND p)
{
   double    cptstar = -1.0, kappa;

   SAVE;
Prompt:
   GET_DOUBLE(cptstar,cptstar,"critical c.p.t");
   if( cptstar < 0 ) goto Prompt;
   kappa = -log(cptstar - T);
   FOR {
      T = log(cptstar - T) + kappa;
   }
   RETURN;
}

PXYDVBIND pxydv_t_ln_t_minus_tstar(PXYDVBIND p)
{
   double    tstar = 0.0;

   SAVE;
   GET_DOUBLE(tstar,tstar,"tstar");
   FOR {
      T = dsign(T - tstar) * log(fabs(T - tstar));
   }
   RETURN;
}

#undef            TAG_NEXT

PXYDVBIND pxydv_t_to_y0(p)
   PXYDVBIND        p;
{
   int              ltrace = OFF;
   int              ln;
   DVEC             tvec,       new_tvec;

   SAVE;
   if( ltrace ) {
      printf("pxydv_t_to_y0: %d vectors to be relabelled.\n",
             n_PXYDVBIND(p));
   }
   if( (tvec = make_tvec(p)) && (new_tvec = make_ith_yvec(p,0)) ) {
      int           i = 0;
      FOR {
         T = new_tvec[i++];
      }
      free(tvec); free(new_tvec);
   } else {
      printf("pxydv_t_to_y0: make_dvec() failed.\n");
   }
   RETURN;
}


PXYDVBIND pxydv_t_to_int_dt(p)
   PXYDVBIND        p;
{
   int              ltrace = OFF;
   int              ln;
   DVEC             tvec,       yvec,     new_tvec;

   SAVE;
   if( ltrace ) {
      printf("pxydv_t_to_int_dt: %d vectors to be relabelled.\n",
             n_PXYDVBIND(p));
   }
   if( (tvec = make_tvec(p)) && (yvec = make_ith_yvec(p,0)) &&
       (new_tvec = make_DVEC(ln = n_PXYDVBIND(p))) ) {
      int           i = 0;
      dvmint_(yvec,tvec,new_tvec,&ln);
      FOR {
         T = new_tvec[i++];
      }
      free(tvec); free(yvec); free(new_tvec);
   } else {
      printf("pxydv_t_to_int_dt: make_dvec() failed.\n");
   }
   RETURN;
}

PXYDVBIND pxydv_t_to_pick_t(p)
   PXYDVBIND        p;
{
   int              ltrace = OFF;
   PXYDVBIND        picked_p;
   int              relabel_wt,  picked_wt;
   
   SAVE;

   relabel_wt = Menu_deferred_wt;
   if( ltrace ) {
      printf("pxydv_t_to_pick_t: %d vectors to be relabelled.\n",
         n_PXYDVBIND(p));
      ivecn_dump(Picked_wt_list,"pxydv_interpolate_x_to_pick_x");
   }
   picked_wt = Picked_wt_list.v[0];
   if( relabel_wt == picked_wt ) {
      scope_mess_and_bell("Target/source windows identical. Operation aborted.",2);
      return lp;
   } 
   if( ltrace ) {
      printf("pxydv_t_to_pick_t: Relabelling %d with %d's times.\n",
              relabel_wt,picked_wt);
   }
   scope_clear();
   unmake_xy_ring(picked_wt);
   picked_p = wds[picked_wt].pf.pxyf->xyhead;
   if( n_PXYDVBIND(p) == n_PXYDVBIND(picked_p) ) {
      FOR {
         T = picked_p->time;
         picked_p = picked_p->next;
      }
      set_must_redraw(relabel_wt);
   } else {
      sprintf(O_buf,"Windows %d and %d not compatible.",S_wt,picked_wt);
      scope_mess_and_bell(O_buf,1);
   }
   restore_ring_state(picked_wt);
Return:
   RETURN;
}

PXYDVBIND pxydv_t_to_pick_y0(p)
   PXYDVBIND        p;
{
   int              ltrace = OFF;
   PXYDVBIND        picked_p;
   int              relabel_wt,  picked_wt;

   DVEC             new_tvec;

   DVEC             v1, v2;
   
   SAVE;

   relabel_wt = Menu_deferred_wt;
   if( ltrace ) {
      printf("pxydv_t_to_pick_int_dt: %d vectors to be relabelled.\n",
         n_PXYDVBIND(p));
   }
   picked_wt = Picked_wt_list.v[0];
   if( relabel_wt == picked_wt ) {
      scope_mess_and_bell("Target/source windows identical. Operation aborted.",2);
      return lp;
   } 
   if( ltrace ) {
      printf(
         "pxydv_t_to_pick_int_dt: Relabelling %d with %d's central values.\n",
          relabel_wt,picked_wt);
   }
   unmake_xy_ring(picked_wt);
   picked_p = wds[picked_wt].pf.pxyf->xyhead;

   if( n_PXYDVBIND(p) == n_PXYDVBIND(picked_p) ) {
      if( (new_tvec = make_ith_yvec(picked_p,0)) ) {
         int        i = 0;

         FOR {
            T = new_tvec[i++];
         }
         free(new_tvec);
      }
      set_must_redraw(relabel_wt);
   } else {
      sprintf(O_buf,"Windows %d and %d not compatible.",S_wt,picked_wt);
      scope_mess_and_bell(O_buf,1);
   }

   restore_ring_state(picked_wt);
   RETURN;
}

PXYDVBIND pxydv_t_to_pick_int_dt(PXYDVBIND p) {
   int              ltrace = OFF;
   PXYDVBIND        picked_p;
   int              relabel_wt,  picked_wt, ln;

   DVEC             tvec,        yvec,      new_tvec;
   
   SAVE;

   relabel_wt = Menu_deferred_wt;
   if( ltrace ) {
      printf("pxydv_t_to_pick_int_dt: %d vectors to be relabelled.\n",
         n_PXYDVBIND(p));
   }
   picked_wt = Picked_wt_list.v[0];
   if( relabel_wt == picked_wt ) {
      scope_mess_and_bell("Target/source windows identical. Operation aborted.",2);
      return lp;
   } 
   if( ltrace ) {
      printf("pxydv_t_to_pick_int_dt: Relabelling %d with %d's ",
              relabel_wt,picked_wt);
      printf("integrated central values.\n");
   }
   unmake_xy_ring(picked_wt);
   picked_p = wds[picked_wt].pf.pxyf->xyhead;
   if( n_PXYDVBIND(p) == n_PXYDVBIND(picked_p) ) {
      if( (tvec = make_tvec(picked_p)) && (yvec = make_ith_yvec(picked_p,0)) &&
          (new_tvec = make_DVEC(ln = n_PXYDVBIND(p))) ) {
         int        i = 0;
         dvmint_(yvec,tvec,new_tvec,&ln);
         FOR {
            T = new_tvec[i++];
         }
         free(tvec); free(yvec); free(new_tvec);
      }
      set_must_redraw(relabel_wt);
   } else {
      sprintf(O_buf,"Windows %d and %d not compatible.",S_wt,picked_wt);
      scope_mess_and_bell(O_buf,1);
   }
   restore_ring_state(picked_wt);
   RETURN;
}

PXYDVBIND pxydv_t_interpolate_t2_x2(PXYDVBIND p) {
   SAVE;
   fprintf(stderr,"pxydv_t_interpolate_t2_x2: Not implemented yet.\n");
   RETURN;
}

PXYDVBIND pxydv_t_interpolate_t2_x4(PXYDVBIND p) {
   SAVE;
   fprintf(stderr,"pxydv_t_interpolate_t2_x4: Not implemented yet.\n");
   RETURN;
}


PXYDVBIND pxydv_xy_to_yx(p)
   PXYDVBIND        p; 
{
   DVEC             T_DVEC;

   SAVE;
   FOR {
      T_DVEC = X; X = Y; Y = T_DVEC;
   }
   RETURN;
}

PXYDVBIND pxydv_xy_to_mxmy(PXYDVBIND p) {
   double    f77_m_one = -1.0;

   SAVE;
   FOR {
      dvsm_(X,&f77_m_one,X,&N);
      dvsm_(Y,&f77_m_one,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_xy_to_vw(p)
   PXYDVBIND        p; 
{
   DVEC             TX,       TY;
   double           root2i =  0.7071067811865476,
                   mroot2i = -0.7071067811865476;

   SAVE;
   FOR {
      if( (TX = make_DVEC(N))  &&  (TY = make_DVEC(N)) ) {
         (void) dvsvsa_(X,Y,TX,&root2i,&root2i,&N);
         (void) dvsvsa_(X,Y,TY,&root2i,&mroot2i,&N);
         (void) dvcopy_(TX,X,&N);
         (void) dvcopy_(TY,Y,&N);
         free(TX);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_xy_rotate(p)
   PXYDVBIND        p; 
{
   DVEC             TX,       TY;
   double           cxx,      cxy,     cyx,     cyy,
                    theta = 45.0;

   SAVE;
   sprintf(O_buf,"%s",(Angular_unit == DEGREES) ? "rotation angle (degrees)" :
                      (Angular_unit == RADIANS) ? "rotation angle (radians)" :
                      "rotation angle (?)");
   GET_DOUBLE(theta,theta,O_buf);
   if( Angular_unit == DEGREES ) theta *= DEGREES_TO_RADIANS;
   cxx =  D_COS(&theta); cxy = -D_SIN(&theta);
   cyx =  D_SIN(&theta); cyy =  D_COS(&theta);
   FOR {
      if( (TX = make_DVEC(N))  &&  (TY = make_DVEC(N)) ) {
         (void) dvsvsa_(X,Y,TX,&cxx,&cxy,&N);
         (void) dvsvsa_(X,Y,TY,&cyx,&cyy,&N);
         (void) dvcopy_(TX,X,&N);
         (void) dvcopy_(TY,Y,&N);
         free(TX);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_flow_field_rescale(p)
   PXYDVBIND        p; 
{
   DVEC             TX,       TY,      TX1,      TY1;
   double           scale = 1.0;
   int              Nby2;

   SAVE;
   FOR {
      if( N % 2 ) {
         scope_mess_and_bell("All vectors must be even length.",1);
         goto Abort_exit;
      }
   }
   GET_DOUBLE(scale,scale,"scale");
   FOR {
      Nby2 = N / 2;
      if( (TX = make_DVEC(Nby2)) && (TX1 = make_DVEC(Nby2)) &&
          (TY = make_DVEC(Nby2)) && (TY1 = make_DVEC(Nby2)) ) {

          dvumrg_(X,TX,TX1,&Nby2);
          dvvs_(TX1,TX,TX1,&Nby2);
          dvsm_(TX1,&scale,TX1,&Nby2);
          dvva_(TX,TX1,TX1,&Nby2);
          dvmrg_(TX,TX1,X,&Nby2);
          free(TX); free(TX1);

          dvumrg_(Y,TY,TY1,&Nby2);
          dvvs_(TY1,TY,TY1,&Nby2);
          dvsm_(TY1,&scale,TY1,&Nby2);
          dvva_(TY,TY1,TY1,&Nby2);
          dvmrg_(TY,TY1,Y,&Nby2);
          free(TY); free(TY1);
      }
   }
Abort_exit:
   RETURN;
}

PXYDVBIND pxydv_overlay(p)
   PXYDVBIND        p; 
{
   PXYDVBIND        new_p;
#define             NEW_X      (new_p->data)->x
#define             NEW_Y      (new_p->data)->y
#define             NEW_N      (new_p->data)->n
#define             OLD_N      (wds[S_wt].pf.pxyf)->nevents
   DVEC             LX,        LY;

   SAVE;
   new_p = make_XYDVBIND();
   new_p->data = make_XYDVEC(OLD_N);
   LX = NEW_X;   LY = NEW_Y;
   FOR {
      dvcopy_(X,LX,&N); 
      dvcopy_(Y,LY,&N);
      LX += N;
      LY += N;
   }
   free_XYDVLIST(lp);
   new_p->index = 1;
   new_p->time = lp->time;
   new_p->next = NULL;
   new_p->prev = NULL;

   return new_p;
#undef              NEW_X
#undef              NEW_Y
#undef              NEW_N
#undef              OLD_N
}

PXYDVBIND pxydv_xt_transpose(PXYDVBIND p) {
   int      ltrace = Ltrace;
   if(  wt_is_time_compressible(wt_from_xyhead(p)) ) {
      if( ltrace ) fprintf(stderr,"pxydv_xt_transpose: Can transpose data\n");
   } else {
      if( ltrace ) fprintf(stderr,"pxydv_xt_transpose: Cannot transpose data\n");
   }
   return( p );
}

PXYDVBIND pxydv_cheby_fit_and_generate_f77(PXYDVBIND p) {
   return( pxydv_cheby_fit(p,FIT_AND_GENERATE_F77,S_wt) );
}

PXYDVBIND pxydv_cheby_fit_and_generate_f77_d(PXYDVBIND p) {
   return( pxydv_cheby_fit(p,FIT_AND_GENERATE_F77_D,S_wt) );
}

PXYDVBIND pxydv_cheby_fit_and_generate_ortho_phi(PXYDVBIND p) {
   return( pxydv_cheby_fit(p,FIT_AND_GENERATE_ORTHO_PHI,S_wt) );
}

PXYDVBIND pxydv_cheby_fit_and_generate_f77_x(PXYDVBIND p) {
   return( pxydv_cheby_fit(p,FIT_AND_GENERATE_F77_X,S_wt) );
}

PXYDVBIND pxydv_cheby_fit_and_replace(PXYDVBIND p) {
   return( pxydv_cheby_fit(p,FIT_AND_REPLACE,S_wt) );
}

PXYDVBIND pxydv_cheby_fit_and_append(PXYDVBIND p) {
   return( pxydv_cheby_fit(p,FIT_AND_APPEND,S_wt) );
}

/* Chebyshev fitting routines ... FOR ... RETURN dangerous here    */
/* Modification ... added new "nested" fit routines ... <TAB> down */
/* when menu selection made selects.                               */
/* Deprecated old routines (old_pxydv_cheby_fit) ...               */
/* Nested fit always used now ...                                  */

#define             DEFAULT_DVMCHFT_NC    30
#define             DEFAULT_DVNESTCF_NC    8
#define             MAX_SEG              256

PXYDVBIND pxydv_cheby_fit(PXYDVBIND p,int code,WT s_wt) {
   int              nc,
                    nseg = MAX_SEG;
   DVEC             T1,     T2,     T3,    xseg;
   DVEC             c,      tc;
   PXYDVEC          NEW;
   
   int              f77_zero = 0,   f77_one = 1;

   int              ltrace = OFF;

   SAVE;

   nc = DEFAULT_DVNESTCF_NC;

   if( (xseg = make_DVEC(nseg + 1)) && 
       (c    = make_DVEC(nseg * (nc + 1)))  ) {

      int i  = 0;
#define          ABORT_EXIT free(T1); free(T2); goto Abort_FOR
      FOR {
         if( (T1   = make_DVEC(N))  &&
             (T2   = make_DVEC(N)) ) {

            switch( code ) {
            case FIT_AND_REPLACE:
               if( ltrace ) {
                  printf("pxydv_cheby_fit: Invoking dvnestcfdn_.\n");
               }
               dvnestcfdn_(X,Y,T1,&N,&f77_zero);
               dvcopy_(T1,Y,&N);
               break;
            case FIT_AND_APPEND:
               if( ltrace ) {
                  printf("pxydv_cheby_fit: Invoking dvnestcfdn_.\n");
               }
               dvnestcfdn_(X,Y,T1,&N,&f77_zero);
               dvcopy_(T1,Y,&N);
               if( NEW = make_XYDVEC(N) ) {
                  dvcopy_(X,NEW->x,&N);
                  dvcopy_(T1,NEW->y,&N);
                  (void) insert_with_merge_xydvec(s_wt,NEW,T,TAG);
                  free(NEW);
                  safe_set_pxy_wt(s_wt);
               } else {
                  sprintf(O_buf,"make_XYDVEC(%d) failed.",N);
                  scope_mess(O_buf,1);
               }
               break;
            case FIT_AND_GENERATE_F77:
            case FIT_AND_GENERATE_F77_D:
            case FIT_AND_GENERATE_ORTHO_PHI:
            case FIT_AND_GENERATE_F77_WT_NAME:
            case FIT_AND_GENERATE_F77_X:
               if( p == wds[s_wt].pf.pxyf->xycurr ) {
                  char  *f77_file_name    = (char *) NULL, 
                        *f77_routine_name = (char *) NULL;

                  if( ltrace ) {
                     sprintf(O_buf,"Found current data at %d.",
                             wds[s_wt].pf.pxyf->xycurr->index);
                     scope_mess(O_buf,1);
                  }

                  if( code == FIT_AND_GENERATE_ORTHO_PHI ) {
                     f77_routine_name = strdup("ortho_phi");
                  goto Skip_Get_routine_name;
                  }
                  if( code == FIT_AND_GENERATE_F77_WT_NAME ) {
                     f77_routine_name = str2f77id(wds[s_wt].name);
                     if( !f77_routine_name ) {
                        sprintf(O_buf,"Can't convert %s to f77 identifier.",
                                wds[s_wt].name);
                        scope_mess_and_bell(O_buf,1);
                        scope_mess("Code generation aborted.",1); ABORT_EXIT;
                     } else {
                        if( ltrace ) {
                           fprintf(stderr,
                                   "pxydv_cheby_fit: Routine name <%s>.\n",
                                   f77_routine_name);
                        }
                     }
                  goto Skip_Get_routine_name;
                  }
Get_routine_name:
                  if( (f77_routine_name = 
                         get_string_from_window(scope_sgi_winno,fh_prompt,
                            GREEN,BLACK,CYAN,"Routine name: ",0.01,0.20)) ) {
                     if( !is_f77_id(f77_routine_name) ) {
                        sprintf(O_buf,
                                "Routine name %s is invalid.",f77_routine_name);
                        scope_mess_and_bell(O_buf,1);
                        free(f77_routine_name);
                  goto Get_routine_name;
                     }
Skip_Get_routine_name:

                     if( !(T3 = make_DVEC(N)) ) {ABORT_EXIT;}
                     switch( code ) {
                     case FIT_AND_GENERATE_F77:
                     case FIT_AND_GENERATE_F77_D:
                     case FIT_AND_GENERATE_ORTHO_PHI:
                     case FIT_AND_GENERATE_F77_WT_NAME:
                        dvcopy_(Y,T3,&N);
                        break;
                     case FIT_AND_GENERATE_F77_X:
                        dvvm_(Y,X,T3,&N);
                        break;
                     default:
                        printf("pxydv_cheby_fit:: Should not be here!\n");
                        break;
                     }
                     if( ltrace ) {
                        printf("pxydv_cheby_fit: Invoking dvnestcf_.\n");
                     }
                     dvnestcf_(X,T3,&N,c,&nc,xseg,&nseg);    
                     free(T3);
                     if( nseg ) {
                        sprintf(O_buf,"%s/%s.f",wds[s_wt].wd,f77_routine_name);
                        if( confirm_overwrite(O_buf,
                               "Overwrite existing .f file? ") ) {
                           switch( code ) {
                           case  FIT_AND_GENERATE_F77_WT_NAME:
                           case  FIT_AND_GENERATE_F77:
                              generate_multi_segment_code(O_buf,
                                 f77_routine_name,"dvmechb",c  ,nc,xseg,nseg);
                              break;
                           case FIT_AND_GENERATE_F77_D:
                           case FIT_AND_GENERATE_ORTHO_PHI:
                              generate_multi_segment_code_dn(O_buf,
                                 f77_routine_name,"dvmechb",c  ,nc,xseg,nseg);
                              break;
                           case FIT_AND_GENERATE_F77_X:
                              generate_multi_segment_code_x(O_buf,
                                 f77_routine_name,"dvmechb",c  ,nc,xseg,nseg);
                              break;
                           }
                           sprintf(O_buf,"Output to %s/%s.f.",wds[s_wt].wd,
                                   f77_routine_name);
                           printf("%s/%s.f\n",wds[s_wt].wd,f77_routine_name);
                           scope_mess_1(O_buf,15.0,2,WHITE);
                           if( code != FIT_AND_GENERATE_F77_WT_NAME ) {
                              sprintf(O_buf,"%s/prad.timeid",wds[s_wt].wd);
                              write_timeid_file(O_buf,T);
                           }
                        } else {
                           scope_mess("Code generation aborted.",1);
                        }
                        free(f77_routine_name);
                     } else {
                        scope_mess("Code generation aborted.",1); ABORT_EXIT;
                     }
                  } else {
                     scope_mess("Code generation aborted.",1); ABORT_EXIT;
                  }
               }
               break;
            default:
               sprintf(O_buf,"Unimplemented opcode: %d",code);
               scope_mess(O_buf,1);
               break;
            }
         }
         free(T1);    
         free(T2);
      }
#undef           ABORT_EXIT
Abort_FOR:
      free(xseg); 
      free(c);
   } else {
      scope_mess("malloc failure in pxydv_cheby_fit",2);
   }
   return wds[s_wt].pf.pxyf->xyhead;
}

PXYDVBIND old_pxydv_cheby_fit(PXYDVBIND p,int code) {
   int              nc,
                    nseg = MAX_SEG;
   DVEC             T1,     T2,     T3,    xseg;
   DVEC             c,      tc;
   PXYDVEC          NEW;
   
   int              f77_zero = 0,   f77_one = 1;

   int              tab_state,  ltrace = OFF;

/* Use local value of S_wt since scope_mess routines have side-effects ... */

   int              s_wt = S_wt;

   SAVE;

   tab_state = tab_key_pressed();
   if( tab_state && ltrace ) {
      printf("pxydv_cheby_fit: Tab key depressed.\n");
   }

   nc = tab_state ? DEFAULT_DVNESTCF_NC : DEFAULT_DVMCHFT_NC;

   if( (xseg = make_DVEC(nseg + 1)) && 
       (c    = make_DVEC(nseg * (nc + 1)))  ) {

      int i  = 0;
#define          ABORT_EXIT free(T1); free(T2); goto Abort_FOR
      FOR {
         if( (T1   = make_DVEC(N))  &&
             (T2   = make_DVEC(N)) ) {
            if( !tab_state ) {
               axseg0_(X,Y,T1,T2,&N,xseg,&nseg);
               if( ltrace ) {
                  sprintf(O_buf,"Frame %d: Fitting on %d segments.",++i,nseg);
                  scope_mess(O_buf,1);
               }
            }
            switch( code ) {
            case FIT_AND_REPLACE:
               if( tab_state ) {
                  if( ltrace ) {
                     printf("pxydv_cheby_fit: Invoking dvnestcfdn_.\n");
                  }
                  dvnestcfdn_(X,Y,T1,&N,&f77_zero);
                  dvcopy_(T1,Y,&N);
               } else {
                  dvmchft_(X,Y,T1,T2,&N,c  ,&nc,&nc,xseg,&nseg);     
                  if( nseg ) {
                     dvmechb_(X,Y,&N,xseg,&nseg,c  ,&nc,&nc); 
                  } else {
                     scope_mess("Fit and replace aborted.",1); ABORT_EXIT;
                  }
               }
               break;
            case FIT_AND_APPEND:
               if( tab_state ) {
                  if( ltrace ) {
                     printf("pxydv_cheby_fit: Invoking dvnestcfdn_.\n");
                  }
                  dvnestcfdn_(X,Y,T1,&N,&f77_zero);
                  dvcopy_(T1,Y,&N);
               } else {
                  dvmchft_(X,Y,T1,T2,&N,c  ,&nc,&nc,xseg,&nseg);     
                  if( nseg ) {
                     dvmechb_(X,T1,&N,xseg,&nseg,c  ,&nc,&nc); 
                  } else {
                     scope_mess("Fit and append aborted.",1); ABORT_EXIT;
                  }
               }
               if( NEW = make_XYDVEC(N) ) {
                  dvcopy_(X,NEW->x,&N);
                  dvcopy_(T1,NEW->y,&N);
                  (void) insert_with_merge_xydvec(s_wt,NEW,T,TAG);
                  free(NEW);
                  safe_set_pxy_wt(s_wt);
               } else {
                  sprintf(O_buf,"make_XYDVEC(%d) failed.",N);
                  scope_mess(O_buf,1);
               }
               break;
            case FIT_AND_GENERATE_F77:
            case FIT_AND_GENERATE_F77_D:
            case FIT_AND_GENERATE_ORTHO_PHI:
            case FIT_AND_GENERATE_F77_X:
               if( p == wds[s_wt].pf.pxyf->xycurr ) {
                  char  *f77_file_name, *f77_routine_name;

                  if( ltrace ) {
                     sprintf(O_buf,"Found current data at %d.",
                             wds[s_wt].pf.pxyf->xycurr->index);
                     scope_mess(O_buf,1);
                  }

                   if( code == FIT_AND_GENERATE_ORTHO_PHI ) {
                     f77_routine_name = strdup("ortho_phi");
                  goto Skip_Get_routine_name;
                  }
Get_routine_name:
                  if( (f77_routine_name = 
                         get_string_from_window(scope_sgi_winno,fh_prompt,
                            GREEN,BLACK,CYAN,"Routine name: ",0.01,0.20)) ) {
                     if( !is_f77_id(f77_routine_name) ) {
                        sprintf(O_buf,
                                "Routine name %s is invalid.",f77_routine_name);
                        scope_mess_and_bell(O_buf,1);
                        free(f77_routine_name);
                  goto Get_routine_name;
                     }
Skip_Get_routine_name:

                     if( !(T3 = make_DVEC(N)) ) {ABORT_EXIT;}
                     switch( code ) {
                     case FIT_AND_GENERATE_F77:
                     case FIT_AND_GENERATE_F77_D:
                     case FIT_AND_GENERATE_ORTHO_PHI:
                        dvcopy_(Y,T3,&N);
                        break;
                     case FIT_AND_GENERATE_F77_X:
                        dvvm_(Y,X,T3,&N);
                        break;
                     default:
                        printf("pxydv_cheby_fit:: Should not be here!\n");
                        break;
                     }
                     if( tab_state ) {
                        if( ltrace ) {
                           printf("pxydv_cheby_fit: Invoking dvnestcf_.\n");
                        }
                          dvnestcf_(X,T3,&N,c,&nc,xseg,&nseg);    
                     } else {
                        dvmchft_(X,T3,T1,T2,&N,c  ,&nc,&nc,xseg,&nseg);     
                     }
                     free(T3);
                     if( nseg ) {
                        sprintf(O_buf,"%s/%s.f",wds[s_wt].wd,f77_routine_name);
                        if( confirm_overwrite(O_buf,
                               "Overwrite existing .f file? ") ) {
                           switch( code ) {
                           case  FIT_AND_GENERATE_F77:
                              generate_multi_segment_code(O_buf,
                                 f77_routine_name,"dvmechb",c  ,nc,xseg,nseg);
                              break;
                           case FIT_AND_GENERATE_F77_D:
                           case FIT_AND_GENERATE_ORTHO_PHI:
                              generate_multi_segment_code_dn(O_buf,
                                 f77_routine_name,"dvmechb",c  ,nc,xseg,nseg);
                              break;
                           case FIT_AND_GENERATE_F77_X:
                              generate_multi_segment_code_x(O_buf,
                                 f77_routine_name,"dvmechb",c  ,nc,xseg,nseg);
                              break;
                           }
                           sprintf(O_buf,"Output to %s/%s.f.",wds[s_wt].wd,
                                   f77_routine_name);
                           printf("%s/%s.f\n",wds[s_wt].wd,f77_routine_name);
                           scope_mess_1(O_buf,15.0,2,WHITE);
                           sprintf(O_buf,"%s/prad.timeid",wds[s_wt].wd);
                           write_timeid_file(O_buf,T);
                        } else {
                           scope_mess("Code generation aborted.",1);
                        }
                        free(f77_routine_name);
                     } else {
                        scope_mess("Code generation aborted.",1); ABORT_EXIT;
                     }
                  } else {
                     scope_mess("Code generation aborted.",1); ABORT_EXIT;
                  }
               }
               break;
            default:
               sprintf(O_buf,"Unimplemented opcode: %d",code);
               scope_mess(O_buf,1);
               break;
            }
         }
         free(T1);    
         free(T2);
      }
#undef           ABORT_EXIT
Abort_FOR:
      free(xseg); 
      free(c);
   } else {
      scope_mess("malloc failure in pxydv_cheby_fit",2);
   }
   return wds[s_wt].pf.pxyf->xyhead;
}

void write_timeid_file(file_name,time)
   char            *file_name;
   double           time;
{
   FILE            *file;

   if( confirm_overwrite(file_name,"Overwrite existing .timeid file? ") ) {
      fprintf(file=fopen(file_name,"w"),"%30.16E\n",time);
      fclose(file);
   }
}

#undef              DEFAULT_NC
#undef              MAX_SEG


PXYDVBIND pxydv_sort_x(PXYDVBIND p) {
   SAVE;

   FOR {
      dv2sort(X,Y,N,SORT_UP);
   }
   RETURN;
}

PXYDVBIND pxydv_sort_pamr(PXYDVBIND p) {
   SAVE;

   DVEC    TX1, TY1, TX2, TY2, NEW_X, NEW_Y;
   int     N_uniq;
   double  uniq_fuzz = 1.0e-5;
   int     first_mess = 1;

   FOR {
      if( (TX1 = make_DVEC(N))  &&  (TY1 = make_DVEC(N)) &&
          (TX2 = make_DVEC(N))  &&  (TY2 = make_DVEC(N)) ) {
         dvcopy_(X,TX1,&N);
         dvcopy_(Y,TY1,&N);
         dv2sort(TX1,TY1,N,SORT_UP);
         dvvcopyuniq(TX1,TY1,TX2,TY2,N,&N_uniq,uniq_fuzz);
         if( (NEW_X = make_DVEC(N_uniq)) && 
             (NEW_Y = make_DVEC(N_uniq)) ) {
            dvcopy_(TX2,NEW_X,&N_uniq);
            dvcopy_(TY2,NEW_Y,&N_uniq);
            N = N_uniq;
            free(X);  X = NEW_X;
            free(Y);  Y = NEW_Y;
         } else {
            scope_mess_and_bell("make_DVEC failure in pxydv_sort_pamr.",2);
         }
         free(TX1); 
         free(TY1);
         free(TX2); 
         free(TY2); 
      } else {
         scope_mess_and_bell("make_DVEC failure in pxydv_sort_pamr.",2);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_x_by_1mx(PXYDVBIND p) {
   double f77_zero = 0.0;

   SAVE;

   FOR {
      (void) dvyxby1mx_(Y,X,Y,&f77_zero,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_x_log(p)
   PXYDVBIND        p; 
{
   double           x0;

   SAVE;

   if( alt_key_pressed() ) {
      GET_DOUBLE(x0,xmin_wt(S_wt) - M_E,"Subtraction point");
   } else {
      scope_mess("Enter subtraction point using mouse.",1);
      x0 = 2.0 * xmin_wt(S_wt) - x_mouse_after_button();
   }
   sprintf(O_buf,"Subtraction point: %G",x0);
   scope_mess(O_buf,1);
   fprintf(stderr,"Subtraction point: %g\n",x0);
   FOR {
      (void) dvlnt_(X,X,&x0,&N);
   }

   RETURN;
}

PXYDVBIND pxydv_x_log_one_plus_x(PXYDVBIND p) {
   double    c = 1.0;

   SAVE;
   FOR {
      (void) dvsa_(X,&c,X,&N);
      (void) dvfapl_(X,X,D_LOG,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_x_log_c_plus_x(PXYDVBIND p) {
   static double    c = 1.0;

   SAVE;
   GET_DOUBLE(c,c,"c");
   FOR {
      (void) dvsa_(X,&c,X,&N);
      (void) dvfapl_(X,X,D_LOG,&N);
   }
   RETURN;
}


PXYDVBIND pxydv_y_log(p)
   PXYDVBIND        p; 
{
   double           y0;

   SAVE;

   if( alt_key_pressed() ) {
      GET_DOUBLE(y0,ymin_wt(S_wt) - M_E,"Subtraction point");
   } else {
      scope_mess("Enter subtraction point using mouse.",1);
      y0 = 2.0 * ymin_wt(S_wt) - y_mouse_after_button();
   }
   sprintf(O_buf,"Subtraction point: %G",y0);
   scope_mess(O_buf,1);
   FOR {
      (void) dvlnt_(Y,Y,&y0,&N);
   }

   RETURN;
}

PXYDVBIND pxydv_dy_dx(PXYDVBIND p)
{
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvd1nu_(Y,X,TY,&N);
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_dy_dx_mid(PXYDVBIND p)
{
   DVEC             NEW_X,     NEW_Y;
   int              NEW_N;

   SAVE;
   FOR {
      NEW_N = N - 1;
      if( (NEW_X = make_DVEC(NEW_N)) && (NEW_Y = make_DVEC(NEW_N)) ) {
         dvdd1nu_(Y,X,&N,NEW_Y,NEW_X,&NEW_N);
         free(X); X = NEW_X;
         free(Y); Y = NEW_Y;
         N = NEW_N;
      }
   }
   RETURN;
}

PXYDVBIND pxydv_cheby_dy_dx(PXYDVBIND p)
{
   DVEC             TY,     W;
   int              f77_one = 1;

   SAVE;
   FOR {
      if( (TY = make_DVEC(N)) && (W = make_DVEC(3 * N)) ) {
         if( tab_key_pressed() ) {
            (void) dvnestcfdn_(X,Y,TY,&N,&f77_one);
         } else {
            (void) dvchebdn_(X,Y,TY,W,&N,&f77_one);
         }
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}


PXYDVBIND pxydv_x_dy_dx(p)
   PXYDVBIND        p; 
{
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvd1nu_(Y,X,TY,&N);
         (void) dvvm_(TY,X,TY,&N);
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_inner_norm(p)
   PXYDVBIND        p;
{
   double           scale_factor;

#define             Y0      Y[0]
   SAVE;
   FOR {
      scale_factor = Y0 ? 1.0 / Y0 : 1.0;
      dvsm_(Y,&scale_factor,Y,&N);
   }
   RETURN;
#undef              Y0
}

PXYDVBIND pxydv_y_outer_norm(p)
   PXYDVBIND        p;
{
   double           scale_factor;

   SAVE;
   FOR {
      scale_factor = 1.0 / Y[N-1];
      dvsm_(Y,&scale_factor,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_int_dx(PXYDVBIND p) {
   double           res0 = 0.0;
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
#ifndef __ 
         (void) dvmint_dx_sense_(Y,X,TY,&N,&res0);
#else
         (void) dvmint_dx_sense__(Y,X,TY,&N,&res0);
#endif
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_rint_dx(PXYDVBIND p) {
   double           res0 = 0.0;
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
#ifndef __ 
         (void) dvrmint_dx_sense_(Y,X,TY,&N,&res0);
#else
         (void) dvrmint_dx_sense__(Y,X,TY,&N,&res0);
#endif
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_x_times_y(p)
   PXYDVBIND        p; 
{
   SAVE;
   FOR {
      dvvm_(Y,X,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_y_divide_x(p)
   PXYDVBIND        p; 
{
   SAVE;
   FOR {

/*    dvvdxx computes 0/0 via extrapolation/interpolation. */

      dvvdxx_(Y,X,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_int_dx_divide_x(PXYDVBIND p) {
   DVEC             TY;
   double           res0 = 0.0;
   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
#ifndef __ 
         (void) dvmint_dx_sense_(Y,X,TY,&N,&res0);
#else
         (void) dvmint_dx_sense__(Y,X,TY,&N,&res0);
#endif
         (void) dvcopy_(TY,Y,&N);
         (void) dvvdxx_(Y,X,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_int_x_p_y_dx(PXYDVBIND p) {
   double           res0 = 0.0;
   DVEC             TX,      TY;
   double           pow,     default_pow = 2.0;

   SAVE;

   sprintf(O_buf,"power (%g)",default_pow);
   GET_DOUBLE(pow,default_pow,O_buf);
   FOR {
      if( (TX = make_DVEC(N)) && (TY = make_DVEC(N)) ) {
         dvfap2_(X,TX,dpowr_,&pow,&N);
         dvvm_(TX,Y,Y,&N);
#ifndef __ 
         (void) dvmint_dx_sense_(Y,X,TY,&N,&res0);
#else
         (void) dvmint_dx_sense__(Y,X,TY,&N,&res0);
#endif
         (void) dvcopy_(TY,Y,&N);
         free(TX);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_x_p(PXYDVBIND p)
{
   DVEC             TX;
   double           pow,     default_pow = 2.0;

   SAVE;

   sprintf(O_buf,"power (%g)",default_pow);
   GET_DOUBLE(pow,default_pow,O_buf);
   FOR {
      TX = make_DVEC(N);
      dvfap2_(X,TX,dpowr_,&pow,&N);
      dvcopy_(TX,X,&N);
      free(TX);
   }
   RETURN;
}

PXYDVBIND pxydv_x_p_times_y(p)
   PXYDVBIND        p; 
{
   DVEC             TX;
   double           pow,     default_pow = 1.0;

   SAVE;
   GET_DOUBLE(pow,default_pow,"x power");
   FOR {
      TX = make_DVEC(N);
      dvfap2_(X,TX,dpowr_,&pow,&N);
      dvvm_(Y,TX,Y,&N);
      free(TX);
   }
   RETURN;
}

PXYDVBIND pxydv_y_p(p)
   PXYDVBIND        p; 
{
   double           pow,     default_pow = 1.0;

   SAVE;
   GET_DOUBLE(pow,default_pow,"p");
   FOR {
      dvfap2_(Y,Y,dpowr_,&pow,&N);
   }
   RETURN;
}


PXYDVBIND   pxydv_y_make_gaussian_pulse(PXYDVBIND p) {
   double      r0, r0_plus_del, del, dpow, default_dpow = 2.0, y0 = 1.0;
   int         pow, scale = 0;
   
   SAVE;
   if(  wds[S_wt].pf.pxyf->lxy != 1 ) {
      scope_mess_and_bell("Function operates on single group only.",1);
      RETURN;
   }
   FOR {
Get_parameters:
      GETP(r0,"Pick centre point with mouse ...");
      GETP(r0_plus_del,"Pick 1/e point ...");
      del = fabs(r0_plus_del - r0);
      if( del == 0.0 ) goto Get_parameters;
      GET_DOUBLE(dpow,default_dpow,"p (2)");
      pow = dpow;
      dvggpr_(Y,X,&y0,&r0,&del,&pow,&scale,&N);
   }
   RETURN;
}

PXYDVBIND   pxydv_y_make_poly_pulse(PXYDVBIND p) {
   double      r0, r0_plus_del, del, dpow, default_dpow = 2.0, y0 = 1.0;
   double      alo, ahi, blo, bhi;
   int         pow;
   
   SAVE;
   if(  wds[S_wt].pf.pxyf->lxy != 1 ) {
      scope_mess_and_bell("Function operates on single group only.",1);
      RETURN;
   }
   FOR {
Get_parameters:
      GETP(r0,"Pick centre point with mouse ...");
      GETP(r0_plus_del,"Pick roll off point ...");
      del = fabs(r0_plus_del - r0);
      if( del == 0.0 ) goto Get_parameters;
      GET_DOUBLE(dpow,default_dpow,"p (2)");
      pow = dpow;
      alo = r0 - del; ahi = r0;
      blo = r0;       bhi = r0 + del;
      if( alo < dvmin(X,N) || bhi > dvmax(X,N) ) goto Get_parameters;
      (void) dvls(Y,y0,N);
      (void) dvrollboth_(Y,Y,X,&N,&alo,&blo,&pow,&ahi,&bhi,&pow);
   }
   RETURN;
}

PXYDVBIND pxydv_y_exp_damp_tail(p)
   PXYDVBIND        p; 
{
   double           xcut,       default_xcut = MAXDOUBLE;
   double           dx,         default_dx = -1.0;

   SAVE;
   GET_DOUBLE(xcut,default_xcut,"xcut");
   GET_DOUBLE(dx,default_dx,"dx");
   FOR {
      dvedtl_(X,Y,Y,&N,&xcut,&dx);
   }
   RETURN;
}

PXYDVBIND pxydv_y_exp_damp_head(p)
   PXYDVBIND        p; 
{
   double           xcut,       default_xcut = MAXDOUBLE;
   double           dx,         default_dx = -1.0;

   SAVE;
   GET_DOUBLE(xcut,default_xcut,"xcut");
   GET_DOUBLE(dx,default_dx,"dx");
   FOR {
      dvedhd_(X,Y,Y,&N,&xcut,&dx);
   }
   RETURN;
}

PXYDVBIND pxydv_y_poly_roll_off(p)
   PXYDVBIND        p; 
{
   double           xcut,       default_xcut = MAXDOUBLE;
   double           dx,         default_dx = -1.0;
   int              pow,        default_pow = 2;
   double           double_pow, default_double_pow = default_pow;

   double           a,          b;
   int              tab_state;

   SAVE;
   tab_state = tab_key_pressed();
   GET_DOUBLE(xcut,default_xcut,"xcut");
   GET_DOUBLE(dx,default_dx,"dx");
   GET_DOUBLE(double_pow,default_double_pow,"p"); pow = (int) double_pow;
   a = xcut - 0.5 * dx;
   b = xcut + 0.5 * dx;
   FOR {
      if( tab_state ) {
         dvrollup_  (Y,Y,X,&N,&a,&b,&pow);
      } else {
         dvrolldown_(Y,Y,X,&N,&a,&b,&pow);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y_poly_roll_off_both(PXYDVBIND p) {
   double       rmin,        rmax,       rroff;
   double       alo,         ahi,        blo,        bhi;
   int          default_roffp = 2;

   SAVE;
   if(  wds[S_wt].pf.pxyf->lxy != 1 ) {
      scope_mess_and_bell("Function operates on single group only.",1);
      RETURN;
   }
   FOR {
Get_parameters:
      GETP(rmin,"Pick rmin with mouse ...");
      GETP(rmax,"Pick rmax ...");
      if( rmax <= rmin ) goto Get_parameters;
      GETP(rroff,"Pick upper roll-off point ...");
      if( rroff <= rmax ) goto Get_parameters;
      alo = rmin - (rroff - rmax);
      if( alo < dvmin(X,N) ) goto Get_parameters;
      blo = rmin;
      ahi = rmax;
      bhi = rroff;
      dvrollboth_(Y,Y,X,&N,&alo,&blo,&default_roffp,
                           &ahi,&bhi,&default_roffp);
   }
   RETURN;
}

PXYDVBIND pxydv_pulse_isolate_and_reflect(PXYDVBIND p) {
   DVEC         TX,          TY;
   double       rmin,        rmax,       rroff,       rmin1;
   int          default_roffp = 2;

   int          nrout;

   SAVE;
   if(  wds[S_wt].pf.pxyf->lxy != 1 ) {
      scope_mess_and_bell("Function operates on single group only.",1);
      RETURN;
   }
   FOR {
      TX = make_DVEC(2 * N); TY = make_DVEC(2 * N);
Get_parameters:
      GETP(rmin,"Pick rmin with mouse ..."); 
      GETP(rmax,"Pick rmax ...");
      if( rmax <= rmin ) goto Get_parameters;
      GETP(rroff,"Pick roll-off point ...");
      if( rroff <= rmax ) goto Get_parameters;
      GETP(rmin1,"Pick reflection minimum ...");
      if( rmin1 <= rroff ) goto Get_parameters;
      if( !(nrout = dvpulse_reflect(Y,X,N,TY,TX,rmin,rmax,rroff-rmax,
                                    default_roffp,rmin1-rroff)) ) {
         scope_mess_and_bell("dvpulse_reflect(...) failed.",1);
         goto Get_parameters;
      }     
      free_DVEC(X);
      free_DVEC(Y);
      N = nrout;
      X = Dvcopy(TX,N);
      Y = Dvcopy(TY,N);
      free_DVEC(TX);
      free_DVEC(TY);
   }
   RETURN;
}

PXYDVBIND pxydv_phi_r_to_phi_t(PXYDVBIND p) {
   DVEC         TOUT,        XOUT,      YOUT;
   DVEC         TY;
   double       rmax_gl,     rout,      ntout_d;
   double       tmin,        tmax;
   int          ntout;

   int          default_nt       = 1000;
   double       default_rho      = 1.0;

   int          f77_intord       = 4;
   double       f77_def_value    = 0.0;
   double       f77_rho,     f77_cons;

   SAVE;

   rmax_gl = xmax_wt(S_wt);
Get_rout:
   sprintf(W_buf,"radius > %g",rmax_gl);
   GET_DOUBLE(rout,rmax_gl,W_buf);
   if( rout < rmax_gl ) goto Get_rout;
Get_ntout:
   sprintf(W_buf,"nt (%d)",default_nt);
   GET_DOUBLE(ntout_d,(double) default_nt,W_buf);
   ntout = ntout_d;
   if( ntout < 1 ) goto Get_ntout;
Get_rho:
   sprintf(W_buf,"rho (%g)",default_rho);
   GET_DOUBLE(f77_rho,default_rho,W_buf);
   if( f77_rho <= 0.0 ) goto Get_rho;
   f77_rho = -1.0 / f77_rho;
   
   FOR {
      TOUT = make_DVEC(ntout); XOUT = make_DVEC(ntout); YOUT = make_DVEC(ntout);
      tmin = T + (rout - X[N-1]);
      tmax = T + (rout - X[0]);
      dvgmsh_(TOUT,&ntout,&tmin,&tmax,&f77_rho);
      f77_cons = -1.0;
      dvsm_(TOUT,&f77_cons,XOUT,&ntout);
      f77_cons = rout + T;
      dvsa_(XOUT,&f77_cons,XOUT,&ntout);
      dvrevp_(XOUT,&ntout);

      TY = make_DVEC(N);
      dvvm_(X,Y,TY,&N);

      dvinqn_(TY,X,YOUT,XOUT,&N,&ntout,
              &f77_def_value,&f77_def_value,&f77_intord);

      f77_cons = 1.0 / rout;
      dvsm_(YOUT,&f77_cons,YOUT,&ntout);
      dvrevp_(YOUT,&ntout);
      
      free(XOUT); free(X); free(Y); free(TY);    
      X = TOUT;

      Y = YOUT;
      T = rout;
      N = ntout;
   }

   RETURN;
}

PXYDVBIND pxydv_xy_curvature(p)
   PXYDVBIND       p;
{
   DVEC            TX,         TY,
                   XD,         XDD,
                   YD,         YDD;

#define            MDV(a)      (a = make_DVEC(N))

   SAVE;
   FOR {
      if( MDV(TX) && MDV(TY) && MDV(XD) && MDV(XDD) && MDV(YD) && MDV(YDD) ) {
         dvcopy_(X,TX,&N); dvcopy_(Y,TY,&N);
         dvxycv_(TX,TY,X,Y,XD,XDD,YD,YDD,&N);
         free(TX); free(TY); free(XD); free(XDD); free(YD); free(YDD);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_xy_curvature_s(p)
   PXYDVBIND       p;
{
   DVEC            TX,         TY,
                   XD,         XDD,
                   YD,         YDD,      W;

#define            M3DV(a)     (a = make_DVEC(3 * N))

   SAVE;
   FOR {
      if( MDV(TX) && MDV(TY) && MDV(XD) && MDV(XDD) && MDV(YD) && MDV(YDD) &&
          M3DV(W) ) {
         dvcopy_(X,TX,&N); dvcopy_(Y,TY,&N);
         dvxycvs_(TX,TY,X,Y,XD,XDD,YD,YDD,W,&N);
         free(TX); free(TY); free(XD); free(XDD); free(YD); free(YDD); free(W);
      }
   }
   RETURN;
#undef             MDV
}

PXYDVBIND pxydv_mofa(PXYDVBIND p) {
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvmofa_(X,Y,TY,&N);
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_reflect(PXYDVBIND p) {
   int              newN;
   DVEC             TX,     TY;
   int              j;

   SAVE;
   FOR {
      newN = 2 * N;
      if( (TX = make_DVEC(newN)) && (TY = make_DVEC(newN)) ) {
         for( j = 0; j < N; j++ ) {
            TX[N + j]      =  X[j];
            TY[N + j]      =  Y[j];
            TX[N - j - 1]  = -X[j];
            TY[N - j - 1]  =  Y[j];
         }
         free(X); free(Y); X = TX; Y = TY; N = newN;
      }
   }
   RETURN;
}

PXYDVBIND pxydv_2mbyrofa(PXYDVBIND p) {
   DVEC             TY;
   double           f77_cons = 2;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvmofa_(X,Y,TY,&N);
         (void) dvvdxx_(TY,X,Y,&N);
         (void) dvsm_(Y,&f77_cons,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_dmdrofa(PXYDVBIND p) {
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvmofa_(X,Y,TY,&N);
         (void) dvd1nu_(TY,X,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_dmdrof2mbyr(PXYDVBIND p) {
   DVEC             TY;
   double           f77_cons = 0.5;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvsm_(Y,&f77_cons,TY,&N);
         (void) dvvm_(TY,X,TY,&N);
         (void) dvd1nu_(TY,X,Y,&N);
         free(TY);
      }
   }
   RETURN;
}


PXYDVBIND pxydv_aofm(p)
   PXYDVBIND        p; 
{
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvaofm_(X,Y,TY,&N);
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_laplacian_sph_sym(PXYDVBIND p) {
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         dvd1nu_(Y,X,TY,&N);
         dvvm_(TY,X,TY,&N);
         dvvm_(TY,X,TY,&N);
         dvd1nu_(TY,X,Y,&N);
         dvvdxx_(Y,X,Y,&N);
         dvvdxx_(Y,X,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_r2_laplacian_sph_sym(PXYDVBIND p) {
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         dvd1nu_(Y,X,TY,&N);
         dvvm_(TY,X,TY,&N);
         dvvm_(TY,X,TY,&N);
         dvd1nu_(TY,X,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_v_plus_r_dvdr(PXYDVBIND p) {
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         dvd1nu_(Y,X,TY,&N);
         dvvm_(TY,X,TY,&N);
         dvva_(TY,Y,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_lofa(p)
   PXYDVBIND        p; 
{
   DVEC             TY1,      TY2;

   SAVE;
   FOR {
      if( (TY1 = make_DVEC(N))  &&  (TY2 = make_DVEC(N)) ) {
         (void) dvlofa_(X,Y,TY1,TY2,&N);
         (void) dvcopy_(TY1,Y,&N);
         free(TY1);
         free(TY2);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_zeta_of_phi(p)
   PXYDVBIND        p; 
{
   DVEC             TY;
   double           xi = 0.0;

   SAVE;
   GET_DOUBLE(xi,xi,"xi");
   if( xi < -1.0 ) xi = 1.0 / -xi;
   FOR {
      if( TY = make_DVEC(N) ) {
#ifndef __ 
         (void) dvzeta_of_phi_(Y,TY,&xi,&N);
#else
         (void) dvzeta_of_phi__(Y,TY,&xi,&N);
#endif
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_w_minus_w0_over_r(PXYDVBIND p) {
   SAVE;
   FOR {

      dvsa(Y,-Y[0],Y,N);

/*    dvvdxx computes 0/0 via extrapolation/interpolation. */
      dvvdxx_(Y,X,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_wsq_minus_w0_sq_over_rsq(PXYDVBIND p) {
   SAVE;
   FOR {

      dvvm(Y,Y,Y,N);
      dvsa(Y,-Y[0],Y,N);
      dvvm(Y,Y,Y,N);

/*    dvvdxx computes 0/0 via extrapolation/interpolation. */
      dvvdxx_(Y,X,Y,&N);
      dvvdxx_(Y,X,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_a_of_u(PXYDVBIND p) {
   SAVE;
   FOR {

      dvsa(Y,1.0,Y,N);
      dvfapl_(Y,Y,D_SQRT,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_y_sig(p)
   PXYDVBIND        p; 
{
   SAVE;
   FOR {
      (void) dvsig_(Y,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_dy_dx_sig(p)
   PXYDVBIND        p; 
{
   DVEC             TY;

   SAVE;
   FOR {
      if( TY = make_DVEC(N) ) {
         (void) dvdsig_(Y,TY,&N);
         (void) dvcopy_(TY,Y,&N);
         free(TY);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_pbc_impose(p)
   PXYDVBIND         p;
{
   int               Nm1;

   SAVE;
   FOR {
      Nm1 = N - 1;
      dvpbc_(Y,&Nm1);
   }
   RETURN;
}

PXYDVBIND pxydv_pbc_add(p)
   PXYDVBIND         p;
{
   DVEC              NEW_X,     NEW_Y;
   int               NEW_N,     NEW_Nm1;

   SAVE;
   FOR {
      NEW_N = N + 2; NEW_Nm1 = NEW_N - 1;
      if( (NEW_X = make_DVEC(NEW_N)) && (NEW_Y = make_DVEC(NEW_N)) ) {
         dvcopy_(X,NEW_X + 1,&N); dvpbc_(NEW_X,&NEW_Nm1);
         dvcopy_(Y,NEW_Y + 1,&N); dvpbc_(NEW_Y,&NEW_Nm1);
         free_DVEC(X); X = NEW_X;
         free_DVEC(Y); Y = NEW_Y;
         N = NEW_N;
      }
   }
   RETURN;
}

PXYDVBIND pxydv_pbc_delete(p)
   PXYDVBIND         p;
{
   DVEC              NEW_X,     NEW_Y;
   int               NEW_N;

   SAVE;
   FOR {
      NEW_N = N - 2;
      if( (NEW_X = make_DVEC(NEW_N)) && (NEW_Y = make_DVEC(NEW_N)) ) {
         dvcopy_(X + 1,NEW_X,&NEW_N);
         dvcopy_(Y + 1,NEW_Y,&NEW_N);
         free_DVEC(X); X = NEW_X;
         free_DVEC(Y); Y = NEW_Y;
         N = NEW_N;
      }
   }
   RETURN;
}

PXYDVBIND pxydv_pbc_extend(PXYDVBIND p) {
   DVEC              NEW_X,     NEW_Y;
   int               NEW_N;

   SAVE;
   FOR {
      if( N > 1 ) {
         NEW_N = N + 1;
         if( (NEW_X = make_DVEC(NEW_N)) && (NEW_Y = make_DVEC(NEW_N)) ) {
            DVcopy(X,NEW_X,N);
            DVcopy(Y,NEW_Y,N);
            free_DVEC(X); X = NEW_X;
            free_DVEC(Y); Y = NEW_Y;
            N = NEW_N;
            X[N - 1] = 2.0 * X[N - 2] - X[N - 3];
            Y[N - 1] = Y[0];
         }
      }
   }
   RETURN;
}

/* Direction > < = 0 for forward, reverse, power, uses fftpack
   routines, may need to fix up normalization, also need to  
   consider padding ... */

PXYDVBIND pxydv_dft_fft(PXYDVBIND p,int direction) {
   DVEC             NEW_X,      NEW_Y,    NEW_W,    WORK = (DVEC) NULL;
   int              OLD_Nm1,    NEW_N,    NEW_Nm1;
 
   int              iisu1g_();
   double           uniform_fuzz = 1.0e-5;
   static int       FFT_N = -1;

   SAVE;
   FOR { 
/*    Check that all data is defined on uniform meshes ... */
      if( !iisu1g_(X,&N,&uniform_fuzz) ) {
         scope_mess_and_bell("One or more datasets non-uniform in x",1);
         RETURN;
      }
   }
   FOR {
      if( FFT_N != N ) {
/*       Initialize FFT routines for this value of N ... */
         FFT_N = N;
         if( WORK ) free(WORK);
         if( !(WORK = make_DVEC(2*FFT_N + 15)) ) {
            fprintf(stderr,"pxydv_dft_fft: Could not allocate work array\n");
            goto Bail_out;
         }
         drffti_(&FFT_N,WORK);
      }
      if( NEW_Y = make_DVEC(N) ) {
         (void) DVcopy(Y,NEW_Y,N);
         if(  direction  > 0 ) {
/*           Forward transform ... */
             drfftf_(&N,NEW_Y,WORK);

         } else if ( direction < 0 ) {
/*           Reverse transform ... Normalize so that forward(reverse()) is 
             identity ... */
             drfftb_(&N,NEW_Y,WORK);
             dvsm(NEW_Y,1.0/((double) N),NEW_Y,N);

         } else {
/*         Power ... */
             drfftf_(&N,NEW_Y,WORK);
             dvvm(NEW_Y,NEW_Y,NEW_Y,N);
         }
         free_DVEC(Y);
         Y = NEW_Y;
      } else {
         fprintf(stderr,"pxydv_dft_fft: Could not copy Y (%d)\n",N);
      }
   }
Bail_out:
   if( WORK ) free(WORK);
   FFT_N = -1;
   RETURN;
}

PXYDVBIND pxydv_dft_fftf(PXYDVBIND p) {
   return pxydv_dft_fft(p,1);
}

PXYDVBIND pxydv_dft_fftr(PXYDVBIND p) {
   return pxydv_dft_fft(p,-1);
}

PXYDVBIND pxydv_dft_fftp(PXYDVBIND p) {
   return pxydv_dft_fft(p,0);
}

PXYDVBIND pxydv_wavelet_daub4(p,dvdaub4_routine)
   PXYDVBIND        p;
   PFV_GENERIC      dvdaub4_routine;
{
   DVEC             NEW_X,      NEW_Y,    NEW_W;
   int              OLD_Nm1,    NEW_N,    NEW_Nm1;

   SAVE;
   FOR {
      OLD_Nm1 = N - 1;
      NEW_Nm1 = nnpbc_(&OLD_Nm1); NEW_N = NEW_Nm1 + 1;
      if( (NEW_X = make_DVEC(NEW_N)) && (NEW_Y = make_DVEC(NEW_N)) &&
          (NEW_W = make_DVEC(NEW_N)) ) {
         (dvdaub4_routine)(Y,X,NEW_Y,NEW_X,NEW_W,&OLD_Nm1,&NEW_Nm1);
         if( NEW_Nm1 < 0 ) {
            free_DVEC(NEW_X); free_DVEC(NEW_Y); free_DVEC(NEW_W);
            scope_mess_and_bell("Function non--periodic.",1);
            goto Bail_out;
         } else {
            free_DVEC(X); X = NEW_X;
            free_DVEC(Y); Y = NEW_Y;
            free_DVEC(NEW_W);
            N = NEW_Nm1 + 1;
         }
      }
   }
Bail_out:
   RETURN;
}

PXYDVBIND pxydv_wavelet_daub4f(p)
   PXYDVBIND        p;
{
   return pxydv_wavelet_daub4(p,dvdaub4f_);
}

PXYDVBIND pxydv_wavelet_daub4r(p)
   PXYDVBIND        p;
{
   return pxydv_wavelet_daub4(p,dvdaub4r_);
}

PXYDVBIND pxydv_t_log(p)
   PXYDVBIND        p;
{
   double           t0,    default_t0;
   double           DEFAULT_FOR_t0 = 1.0e-6;

#define             XYF  wds[S_wt].pf.pxyf->xyhead
#define             XYL  wds[S_wt].pf.pxyf->xytail

   SAVE;

   if( wds[S_wt].pf.pxyf->lxy < 2 ) RETURN;
   default_t0 = XYL->time + DEFAULT_FOR_t0 * (XYL->time - XYF->time);
   sprintf(O_buf,"Subtraction point %20G",default_t0);
   GET_DOUBLE(t0,default_t0,O_buf);
   FOR {
      T = -log(t0 - T);
   }
   RETURN;

#undef              XYF
#undef              XYL
}

PXYDVBIND  pxydv_x_negate(p)
   PXYDVBIND         p;
{
   double            f77_m1 = 1.0;

   SAVE;
   FOR {
      (void) dvsm_(X,&f77_m1,X,&N);
   }
   RETURN;
}

PXYDVBIND  pxydv_y_negate(p)
   PXYDVBIND         p;
{
   double            f77_m1 = 1.0;

   SAVE;
   FOR {
      (void) dvsm_(Y,&f77_m1,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_d_dt_y(p)
   PXYDVBIND          p;
{
   DVEC               TX,       TY;
   double             f77_0 = 0.0,   f77_dtm1;
   int                f77_intord = 4;

   int                ltrace = OFF;

   SAVE;
   if( ltrace ) {
      fprintf(stderr,"pxydv_d_dt_y: In routine.\n");
   }
   if( !p->next ) {
      scope_mess("Need more than one frame for this function.",1);
   } else {
      FOR {
         if( p->next ) {
            if( ltrace ) {
               fprintf(stderr,"pxydv_d_dt_y: Loop 1: Vector %d.\n",ip);
            }
            TY = make_DVEC(N);
            (void) dvinqn_(Y_NEXT,X_NEXT,TY,X,&N_NEXT,&N,
                           &f77_0,&f77_0,&f77_intord);
            f77_dtm1 = 1.0 / (T_NEXT - T);
            (void) dvvssm_(Y,TY,Y,&f77_dtm1,&N);
            free_DVEC(TY);
         }
      }
      FOR {
         if( p->next ) {
            if( ltrace ) {
               fprintf(stderr,"pxydv_d_dt_y: Loop 2: Vector %d.\n",ip);
            }
            T = 0.5 * (T + T_NEXT);
         }
      }
      FOR {
         if( !p->next ) {
            if( ltrace ) {
               fprintf(stderr,"pxydv_d_dt_y: Loop 3: Vector %d.\n",ip);
            }
            (p->prev)->next = NULL;
            free_XYDVEC(p->data);
            free(p);
         }
      }
   }
   RETURN;
}

PXYDVBIND pxydv_pairwise_d_dt_y(p)
   PXYDVBIND          p;
{
   PXYDVBIND          tp;
   DVEC               TY;
   int                nvec;
   double             f77_0 = 0.0,   f77_dtm1;
   int                f77_intord = 4;

   SAVE;
   nvec = n_PXYDVBIND(p);
   if( nvec % 2 ) {
      scope_mess_and_bell("Need even number of frames for this function.",1);
   } else {
      for( p = lp; p != NULL; ) {
         TY = make_DVEC(N);
         (void) dvinqn_(Y_NEXT,X_NEXT,TY,X,&N_NEXT,&N,
                        &f77_0,&f77_0,&f77_intord);
         f77_dtm1 = 1.0 / (T_NEXT - T);
         (void) dvvssm_(Y,TY,Y,&f77_dtm1,&N);
         free_DVEC(TY);
         T = 0.5 * (T + T_NEXT);
         tp = p->next;
         p->next = (p->next)->next;
         if( p->next ) (p->next)->prev = p;
         free_XYDVEC(tp->data);
         free(tp);
         p = p->next;
      }
      assert( n_PXYDVBIND(lp) == nvec / 2 );
      reindex_XYDVlist(lp,1);
   }
   RETURN;
}

PXYDVBIND pxydv_pairwise_average(p)
   PXYDVBIND          p;
{
   PXYDVBIND          tp;
   DVEC               TY;
   int                nvec;
   double             f77_0 = 0.0,    f77_half = 0.5;
   int                f77_intord = 4;

   SAVE;
   nvec = n_PXYDVBIND(p);
   if( nvec % 2 ) {
      scope_mess_and_bell("Need even number of frames for this function.",1);
   } else {
      for( p = lp; p != NULL; ) {
         TY = make_DVEC(N);
         (void) dvinqn_(Y_NEXT,X_NEXT,TY,X,&N_NEXT,&N,
                        &f77_0,&f77_0,&f77_intord);
         (void) dvsvsa_(Y,TY,Y,&f77_half,&f77_half,&N);
         free_DVEC(TY);
         T = 0.5 * (T + T_NEXT);
         tp = p->next;
         p->next = (p->next)->next;
         if( p->next ) (p->next)->prev = p;
         free_XYDVEC(tp->data);
         free(tp);
         p = p->next;
      }
      assert( n_PXYDVBIND(lp) == nvec / 2 );
      reindex_XYDVlist(lp,1);
   }
   RETURN;
}

PXYDVBIND pxydv_d_dt_xy(p)
   PXYDVBIND          p;
{
   DVEC               TX,        TY;

   SAVE;
   if( !p->next ) {
      scope_mess("Need more than one frame for this function.",1);
   } else {
   }
   RETURN;
}

PXYDVBIND pxydv_filter_every_mth(PXYDVBIND p) {
   DVEC               NEW_X,      NEW_Y;
   IVEC               NEW_VTAGTAG;
   double             dinc;
   int                NEW_N,      inc,       default_inc = 2;

   SAVE;
Prompt:
   sprintf(O_buf,"m (%d)",default_inc);
   GET_DOUBLE(dinc,(double) default_inc,O_buf);
   if( dinc < 1 ) goto Prompt;

   inc = dinc;
   FOR {
      NEW_N = 1 + (N - 1) / inc;
      if( (NEW_X = make_DVEC(NEW_N)) && (NEW_Y = make_DVEC(NEW_N) ) ) {
         if( VTAG ) NEW_VTAGTAG = make_IVEC(NEW_N);
         dvinj_(X,NEW_X,&inc,&N);
         dvinj_(Y,NEW_Y,&inc,&N);
         if( VTAG ) {
            ivinj_(VTAGTAG,NEW_VTAGTAG,&inc,&N);
            free_IVEC(VTAGTAG);
            VTAGTAG = NEW_VTAGTAG;
            VTAG->n = NEW_N;
         }
         free_DVEC(X);
         free_DVEC(Y);
         X = NEW_X;
         Y = NEW_Y;
         N = NEW_N;
      }
   }
   RETURN;
}


/* Doesn't handle tags properly ... */ 

PXYDVBIND pxydv_filter_thin(PXYDVBIND p) {
   DVEC               TX,         TY,      
                      NEW_X,      NEW_Y,    bbox = NULL;
   double             dinc;
   double             f77_frmnds, 
                      f77_default_frmnds = 0.003, 
                      f77_aspect = 1.0;
   int                NEW_N,      inc,       default_inc = 2;

   int                auto_bbox = ON;

   int                ltrace = OFF;


   SAVE;
Prompt:
   sprintf(O_buf,"thinning parameter (%g)",f77_default_frmnds);
   GET_DOUBLE(f77_frmnds,(double) f77_default_frmnds,O_buf);
   if( f77_frmnds <  0 ) goto Prompt;

   bbox = make_DVEC(4); 
   if( auto_bbox ) {
      bbox[0] = xmin_wt(S_wt);
      bbox[1] = xmax_wt(S_wt);
      bbox[2] = ymin_wt(S_wt);
      bbox[3] = ymax_wt(S_wt);
   } else {
      bbox[0] = 0.0;
      bbox[1] = 1.0;
      bbox[2] = 0.0;
      bbox[3] = 1.0;
   }
   FOR {
      if( (TX = make_DVEC(N)) && (TY = make_DVEC(N) ) ) {
#ifndef __ 
         dvthin_bbox_(X,Y,&N, TX,TY,&NEW_N, bbox,&f77_aspect,&f77_frmnds);
#else
         dvthin_bbox__(X,Y,&N, TX,TY,&NEW_N, bbox,&f77_aspect,&f77_frmnds);
#endif
         free_DVEC(TX);
         free_DVEC(TY);
         if( ltrace ) {
            fprintf(stderr,
               "pxydv_filter_thin: f77_aspect %g  f77_frmnds %g\n",
               f77_aspect,f77_frmnds);
            fprintf(stderr,"pxydv_filter_thin: N %d NEW_N %d\n",N,NEW_N);
         }
         if( (NEW_X = make_DVEC(NEW_N)) && (NEW_Y = make_DVEC(NEW_N) ) ) {
#ifndef __ 
            dvthin_bbox_(X,Y,&N, NEW_X,NEW_Y,&NEW_N, bbox,&f77_aspect,&f77_frmnds);
#else
            dvthin_bbox__(X,Y,&N, NEW_X,NEW_Y,&NEW_N, bbox,&f77_aspect,&f77_frmnds);
#endif
            free_DVEC(X);
            free_DVEC(Y);
            X = NEW_X;
            Y = NEW_Y;
            N = NEW_N;
         }
      }
   }
   if( bbox ) free_DVEC(bbox);
   RETURN;
}

PXYDVBIND pxydv_filter_lintseg_general(PXYDVBIND p) {
   char              *PromptS;
   double             mindseg,    maxdseg;

Prompt:
   GET_STRING(&PromptS,"Enter mindseg, maxdseg");
   if( !PromptS ) goto Prompt;
   if( sscanf(PromptS,"%lf %lf",&mindseg,&maxdseg) < 2 ) goto Prompt;
   if( mindseg > maxdseg ) goto Prompt;
   free(PromptS);

   return( pxydv_filter_lintseg_0(p,mindseg,maxdseg) );

}

PXYDVBIND pxydv_filter_lintseg_fixed(PXYDVBIND p) {

   return( pxydv_filter_lintseg_0(p,Mindseg_default,Maxdseg_default) );

}

PXYDVBIND pxydv_filter_lintseg_0(PXYDVBIND p,double mindseg,double maxdseg) {
   PDVECN             New,      Old;
   double             xscale,   yscale;

   SAVE;

   FOR {
      if( VTAG ) {
         free_IVEC(VTAGTAG);
      }
      Old.n  = N;
      Old.v1 = X;
      Old.v2 = Y;
      xscale = dvmax(X,N) - dvmin(X,N);
      if( xscale != 0.0 ) {
         yscale = dvmax(Y,N) - dvmin(Y,N);
         if( yscale == 0.0 ) yscale = xscale;
         New =  PDVECN_lintseg(Old,xscale,yscale,mindseg,maxdseg);
         if( New.n ) {
            if( X ) free( X );
            if( Y ) free( Y );
            X = New.v1;
            Y = New.v2;
            N = New.n;
         }
      }
   }
   RETURN;
}

PXYDVBIND pxydv_filter_c2_fixed(PXYDVBIND p) {
   return pxydv_filter_c(p,2,APPLY_FILTER_FIXED);
}

PXYDVBIND pxydv_filter_c4_fixed(PXYDVBIND p) {
   return pxydv_filter_c(p,4,APPLY_FILTER_FIXED);
}

PXYDVBIND pxydv_filter_c2_general(PXYDVBIND p) {
   return pxydv_filter_c(p,2,APPLY_FILTER_GENERAL);
}

PXYDVBIND pxydv_filter_c4_general(PXYDVBIND p) {
   return pxydv_filter_c(p,4,APPLY_FILTER_GENERAL);
}

PXYDVBIND pxydv_filter_c(PXYDVBIND p,int order,int code)
{
   DVEC               TY,                    DX;
   IVEC               ST;
   double             uniform_fuzz = 1.0e-5,
                      eps = 1.0;
   int                n_not_filtered = 0,    nmesh;

   int                ltrace = OFF;

   SAVE;
   switch( code ) {
   case APPLY_FILTER_GENERAL:
      GET_DOUBLE(eps,eps,"eps");
      break;
   case APPLY_FILTER_FIXED:
      break;
   default:
      break;
   }
   FOR {
      int  i,  n, st;

      TY = make_DVEC(N); DX = make_DVEC(N); ST = make_IVEC(N+1);
      dvumfcn_(X,&N,DX,ST,&nmesh,&uniform_fuzz); 
      if( ltrace ) {
         fprintf(stderr,"pxydv_filter_c: Group %d: %d component meshes.\n",
                 ip,nmesh);
      }
      for( i = 0; i < nmesh; i++ ) {
         st = ST[i] - 1;  n = ST[i+1] - ST[i] + 1;
         if( ltrace ) {
            fprintf(stderr,"pxydv_filter_c: %d %d.\n",st,n);
         }
         switch( order ) {
         case 2:
            dvcf2_(Y + st,TY + st,&n,&eps);
            break;
         case 4:
            dvcf4_(Y + st,TY + st,&n,&eps);
            break;
         default:
            dvcopy_(Y + st,TY + st,&n);
            ++n_not_filtered;
         } 
      }
      dvcopy_(TY,Y,&N); 
      free_DVEC(TY); free_DVEC(DX); free_IVEC(ST);
   }
   if( n_not_filtered ) {
      sprintf(O_buf,"%d groups not filtered.",n_not_filtered);
      scope_mess_and_bell(O_buf,1);
   }
   RETURN;
}

PXYDVBIND pxydv_yi_fcn(p,which_fcn)
   PXYDVBIND        p; 
   int              which_fcn;
{
   SAVE;
   FOR {
      (void) dvfapl_(Y,Y,Apply1_intrinsic_table[which_fcn].apply_fcn,&N);
   }
   RETURN;
}

/* pxydv_xi_fcn uses pxydv_yi_fcn data. */

PXYDVBIND pxydv_xi_fcn(p,which_fcn)
   PXYDVBIND        p; 
   int              which_fcn;
{
   SAVE;
   FOR {
      (void) dvfapl_(X,X,Apply1_intrinsic_table[which_fcn].apply_fcn,&N);
   }
   RETURN;
}

/* Tagging functions ... */


PXYDVBIND pxydv_tag_dummy(PXYDVBIND p) {
   int    col = Min_marker_color;

   SAVE;
   FOR {
      if( VTAG ) {
         free_XYTAGVEC(VTAG);
      } else {
         VTAG = make_XYTAGVEC(N);
         (void) ivls_(VTAGTAG,&col,&N);
         col = inc_ring(col,Min_marker_color,Max_marker_color);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_tag_by_dx(PXYDVBIND p) {
   DVEC     DX1,    DX2,    DX3,   DXMESH;
   IVEC     ST;
   int      nmesh, nmesh1, nmesh2, nmesh3;
   double   uniform_fuzz = 1.0e-5;
   double   f77_one = 1.0;

   int      ltrace = OFF;

   SAVE;
   FOR {
      if( ip == 1 ) {
         DX2 = make_DVEC(N); ST = make_IVEC(N + 1);
         dvumfcn_(X,&N,DX2,ST,&nmesh2,&uniform_fuzz);
         DX1 = make_DVEC(nmesh2);
         dvsortdownuniq(DX2,nmesh2,DX1,&nmesh1,uniform_fuzz);
         if( ltrace ) {
            sprintf(O_buf,"mesh increments after vec. %d",ip);
            dvdump(DX1,nmesh1,O_buf);
         }
         free_DVEC(DX2);
         free_IVEC(ST);
      } else {
         DX2 = make_DVEC(N); ST = make_IVEC(N + 1);
         dvumfcn_(X,&N,DX2,ST,&nmesh2,&uniform_fuzz);
         DX3 = make_DVEC(nmesh1+nmesh2);
         dvvmergedown(DX1,nmesh1,DX2,nmesh2,DX3,&nmesh3,uniform_fuzz);
         free_DVEC(DX1); DX1 = Dvcopy(DX3,nmesh3); nmesh1 = nmesh3;
         free_DVEC(DX2); 
         free_DVEC(DX3);
         free_IVEC(ST);
         if( ltrace ) {
            sprintf(O_buf,"mesh increments after vec. %d",ip);
            dvdump(DX1,nmesh1,O_buf);
         }
      }
   }
   DXMESH = Dvcopy(DX1,nmesh1); free_DVEC(DX1);
   nmesh = nmesh1;
   FOR {
      if( VTAG ) free_XYTAGVEC(VTAG);
      VTAG = make_XYTAGVEC(N);
      free_IVEC(VTAGTAG);
      DX1 = make_DVEC(N);
      dvdd1_(X,DX1,&f77_one,&N);
      DX1[N-1] = DX1[N-2];
      VTAGTAG = Dvlsindex(DXMESH,nmesh,DX1,N,uniform_fuzz);
      if( ltrace ) {
         dvdump(DXMESH,nmesh,"Tag mesh increments");
         dvdump(DX1,N,"Vector mesh increments");
         sprintf(O_buf,"Tag vector %d",ip);
         ivdump(VTAGTAG,N,O_buf);
      }
      free_DVEC(DX1);
   }
   free_DVEC(DXMESH);
   if( wt_from_xyhead(lp) > 0 ) {
      set_marker_multi_mode(wt_from_xyhead(lp));
   }
   RETURN;
}

/* Version of pxydv_tag_by_dx which operates on single data set for use 
   in auto-tagging ... */

PXYDVBIND pxydv_tag_by_dx_single(PXYDVBIND p) {
   DVEC     DX1,    DX2,    DX3,   DXMESH;
   IVEC     ST;
   int      nmesh, nmesh1, nmesh2, nmesh3;
   double   uniform_fuzz = 1.0e-5;
   double   f77_one = 1.0;

   int      ltrace = OFF;

   DX2 = make_DVEC(N); ST = make_IVEC(N + 1);
   dvumfcn_(X,&N,DX2,ST,&nmesh2,&uniform_fuzz);
   DX1 = make_DVEC(nmesh2);
   dvsortdownuniq(DX2,nmesh2,DX1,&nmesh1,uniform_fuzz);
   if( ltrace ) {
      sprintf(O_buf,"mesh increments");
      dvdump(DX1,nmesh1,O_buf);
   }
   free_DVEC(DX2);
   free_IVEC(ST);
   DXMESH = Dvcopy(DX1,nmesh1); free_DVEC(DX1);
   nmesh = nmesh1;
   if( VTAG ) free_XYTAGVEC(VTAG);
   VTAG = make_XYTAGVEC(N);
   free_IVEC(VTAGTAG);
   DX1 = make_DVEC(N);
   dvdd1_(X,DX1,&f77_one,&N);
   DX1[N-1] = DX1[N-2];
   VTAGTAG = Dvlsindex(DXMESH,nmesh,DX1,N,uniform_fuzz);
   if( ltrace ) {
      dvdump(DXMESH,nmesh,"Tag mesh increments");
      dvdump(DX1,N,"Vector mesh increments");
      sprintf(O_buf,"Tag vector");
      ivdump(VTAGTAG,N,O_buf);
   }
   free_DVEC(DX1);
   free_DVEC(DXMESH);
   if( wt_from_xyhead(p) > 0 ) {
      set_marker_multi_mode(wt_from_xyhead(p));
   }
   return p;
}

PXYDVBIND pxydv_tag_with_constant(PXYDVBIND p) {
   int    constant;

   SAVE;
   GET_DOUBLE(constant,0,"tag");
   FOR {
      if( VTAG ) {
         free_XYTAGVEC(VTAG);
      }     
      VTAG = make_XYTAGVEC(N);
      ivls_(VTAGTAG,&constant,&N); 
   }
   set_marker_multi_mode(S_wt);
   RETURN;
}

PXYDVBIND pxydv_tag_delete(PXYDVBIND p) {
   SAVE;
   int     ltrace = OFF;
   FOR {
      if( VTAG ) {
         free_XYTAGVEC(VTAG);
         VTAG = NULL;
      } else {
         if( ltrace ) {
            fprintf(stderr,"Vector %d has no vtag.\n",ip);
         }
      }
   }
   unset_marker_multi_mode(S_wt);
   RETURN;
}

#undef            SAVE
#undef            FOR
#undef            RETURN
#undef            X
#undef            Y
#undef            N
#undef            T
#undef            TAG
#undef            X_NEXT
#undef            Y_NEXT
#undef            N_NEXT
#undef            T_NEXT
#undef            TAG_NEXT
#undef            VTAG
#undef            VTAGTAG

#undef            GETP
