#include "project.h"               

/* Applicators, etc. */
/* Modified to consolidate applicator info. in single table entry  ... */

APPLY2_TYPE0      Apply2_table[] = { 

   { NULL, NULL,  NULL,  NULL,  NULL,  NULL },

   { pxydv_add,
     "[ 1 ]  +  [ 2 ] ",
     "first window",
     "second window",
     wts_are_merge_compatible, 
     "%s + %s" },

   { pxydv_subtract,
     "[ 1 ]  -  [ 2 ]",
     "first window",
     "second window",
     wts_are_merge_compatible,
     "%s - %s" },

   { pxydv_multiply,
     "[ 1 ]  *  [ 2 ] ",
     "first window",
     "second window",
     wts_are_merge_compatible,
     "%s %s"},

   { pxydv_divide,
     "[ 1 ]  /  [ 2 ] ",
     "first window",
     "second window",
     wts_are_merge_compatible,
     "%s / %s"},

   { pxydv_average,
     "([ 1 ]  +  [ 2 ]) / 2 %l",
     "first window",
     "second window",
     wts_are_merge_compatible,
     "(%s + %s)/2"},

   { pxydv_pyth2,
     "[ 1 ]^2 + [ 2 ]^2",
     "first window",
     "second window",
     wts_are_fully_compatible,
     "%s^2 + %s^2" },

   { pxydv_pyth,
     "sqrt([ 1 ]^2 + [ 2 ]^2)",
     "first window",
     "second window",
     wts_are_fully_compatible,
     "%s^2 + %s^2" },

   { pxydv_mpyth2,
     "[ 1 ]^2 - [ 2 ]^2",
     "first window",
     "second window",
     wts_are_fully_compatible,
     "%s^2 - %s^2" },

   { pxydv_pyth2_int,
     "Int[[ 1 ]^2 + [ 2 ]^2 dx] %l",
     "first window",
     "second window",
     wts_are_fully_compatible,
     "Int[%s^2 + %s^2]" },

   { pxydv_absolute_difference,
     "abs([ 1 ]  -  [ 2 ])",
     "first window",
     "second window",
     wts_are_fully_compatible,
     "| %s - %s |" },

   { pxydv_relative_difference,
     "abs([ 1 ]  -  [ 2 ] / [ 1 ]) %l",
     "first window",
     "second window",
     wts_are_fully_compatible,
     NULL },

   { pxydv_mask,
     "mask %l",
     "mask",
     "data",
     wts_are_fully_compatible,
     NULL },

   { pxydv_y1_by_sqrt_y1_2_y2_2,
     "[ 1 ] / sqrt([ 1 ]^2 + [ 2 ]^2)",
     "first window",
     "second window",
     wts_are_fully_compatible,
     NULL },

   { pxydv_y1_vs_x2,
     "y[ 2 ] vs x[ 1 ]",
     "window with desired x coordinates",
     "other window",
     wts_are_merge_compatible,
     NULL },

   { pxydv_richardson_extrapolate_Oh2,
     "O(h^2) Rich. extrap.",
     "first window",
     "second window",
     wts_are_fully_compatible,
     NULL },

   { pxydv_merge,
     "merge",
     "first window",
     "second window",
     wts_are_merge_compatible,
     "%s & %s" },

   { pxydv_merge_single,
     "merge single",
     "first window (single)",
     "second window",
     wts_are_merge_single_compatible,
     "%s(single) & %s" },

   { pxydv_subtract_single,
     "subtract single",
     "first window (single)",
     "second window",
     wts_are_subtract_single_compatible,
     "-%s(single) + %s" },

   { pxydv_best_scale_single,
     "best scale single",
     "first window (single)",
     "second window",
     wts_are_best_scale_single_compatible,
     "best scale[%s] %l" },

   { pxydv_mofxy,
     "m(X,Y)",
     "X",
     "Y",
     wts_are_fully_compatible,
     "m" },

   { pxydv_aofxy,
     "a(X,Y) %l",
     "X",
     "Y",
     wts_are_fully_compatible,
     "a" },

   { pxydv_make_xy,
     "Y vs X",
     "X",
     "Y",
     wts_are_fully_compatible,
     "xy" },

   { pxydv_xy_to_flow_field,
     "X , Y -> flow field",
     "X",
     "Y",
     wts_are_fully_compatible,
     NULL },

   { pxydv_xy_to_flow_field_auto,
     "X , Y -> flow field (a) %l",
     "X",
     "Y",
     wts_are_fully_compatible,
     NULL },

   { pxydv_ppofxy,
     "pp(X,Y)",
     "X",
     "Y",
     wts_are_fully_compatible,
     "pp" },

   { pxydv_piofxy,
     "pi(X,Y)",
     "X",
     "Y",
     wts_are_fully_compatible,
     "pi" },

   { pxydv_xofppa,
     "X(pp,a)",
     "pp",
     "a",
     wts_are_fully_compatible,
     "X" },

   { pxydv_yofpia,
     "Y(pi,a) %l",
     "pi",
     "a",
     wts_are_fully_compatible,
     "Y" },

   { pxydv_xofpsiphi,
     "x(psi,phi)",
     "psi",
     "phi",
     wts_are_fully_compatible,
     "x" },

   { pxydv_yofpsiphi,
     "y(psi,phi)",
     "psi",
     "phi",
     wts_are_fully_compatible,
     "y" },

   { pxydv_zofpsiphi,
     "z(psi,phi) %l",
     "psi",
     "phi",
     wts_are_fully_compatible,
     "z" },

   { pxydv_divide_0,
     "[ 1 ] / [ 2[0] ]",
     "first window",
     "second window",
     wts_are_fully_compatible,
     "%s / %s[0]" },

   { pxydv_dt_to_dtau,
     "d/dt -> d/d[ tau ]",
     "d/dt window",
     "lapse",
     wts_are_merge_compatible,
     NULL }

                                   };

int               N_Apply2_table =
                     sizeof(Apply2_table) / sizeof(APPLY2_TYPE0);

#define           SAVE             PXYDVBIND    lp = p;
#define           FOR              for( p = lp; p != NULL; p = p->next, p1 = p1->next, p2 = p2->next )
#define           RETURN           return lp;

#define           X                p->data->x
#define           Y                p->data->y
#define           N                p->data->n
#define           T                p->time
#define           T_NEXT           (p->next)->time
#define           TAG              p->tag
#define           VTAG             p->tdata
#define           VTAGTAG          p->tdata->tag

#define           LXY1             wds[wt1].pf.pxyf->lxy
#define           NEVENTS1         wds[wt1].pf.pxyf->nevents
#define           HEAD1            wds[wt1].pf.pxyf->xyhead
#define           X1               p1->data->x
#define           Y1               p1->data->y
#define           N1               p1->data->n
#define           T1               p1->time
#define           TAG1             p1->tag
#define           VTAG1            p1->tdata
#define           VTAGTAG1         p1->tdata->tag

#define           LXY2             wds[wt2].pf.pxyf->lxy
#define           NEVENTS2         wds[wt2].pf.pxyf->nevents
#define           HEAD2            wds[wt2].pf.pxyf->xyhead
#define           X2               p2->data->x
#define           Y2               p2->data->y
#define           N2               p2->data->n
#define           T2               p2->time
#define           TAG2             p2->tag
#define           VTAG2            p2->tdata
#define           VTAGTAG2         p2->tdata->tag

int wts_are_fully_compatible(wt1,wt2)
   WT            wt1,     wt2;
{
#define          LRETURN(a)         restore_ring_state(wt1); restore_ring_state(wt2); return a;

   PXYDVBIND     p1,      p2;
   DVEC          DX;

   int           i, ltrace = OFF;

   double        max_abrd, max_allowable_abrd = 1.0e-6;

   if( !is_active_wt(wt1) || !is_active_wt(wt2) || 
       (LXY1 != LXY2) || (NEVENTS1 != NEVENTS2) ) {
      return FALSE;
   }
   unmake_xy_ring(wt1);     unmake_xy_ring(wt2);
   for( p1 = HEAD1, p2 = HEAD2, i = 1; p1 != NULL && p2 != NULL;    
        p1 = p1->next, p2 = p2->next, i++ ) {
      if( N1 != N2 ) {
         LRETURN(FALSE);
      }
      DX = make_DVEC(N1);
      dvabrd_(X1,X2,DX,&N1);
      max_abrd = dvmax_(DX,&N1);
      free_DVEC(DX);
      if( ltrace ) {
         printf("xy vector %d: Max relative diff %g.\n",i,max_abrd);
      }
      if( max_abrd > max_allowable_abrd ) {
         LRETURN(FALSE);
      }
   }
   LRETURN(TRUE);

#undef           LRETURN
}

int wts_are_merge_compatible(WT wt1, WT wt2) {
   return LXY1 == LXY2;
}

int wts_are_merge_single_compatible(WT wt1, WT wt2) {
   return ( LXY1 > 0 ) && ( LXY2 > 0 );
}

int wts_are_subtract_single_compatible(WT wt1, WT wt2) {
   return ( wts_are_merge_single_compatible(wt1,wt2) );
}

int wts_are_best_scale_single_compatible(WT wt1, WT wt2) {
   return ( wts_are_merge_single_compatible(wt1,wt2) );
}

/* Old check simply called compare_t which didn't unmake/reset ring state ... */

int wts_are_time_compatible(WT wt1,WT wt2) {
#define          LRETURN(a)         restore_ring_state(wt1); restore_ring_state(wt2); return a;

   PXYDVBIND     p1,      p2;

   int           i;

   if( !is_active_wt(wt1) || !is_active_wt(wt2) || (LXY1 != LXY2)  ) {
      return FALSE;
   }
   unmake_xy_ring(wt1);     unmake_xy_ring(wt2);
   for( p1 = HEAD1, p2 = HEAD2, i = 1; p1 != NULL && p2 != NULL;    
        p1 = p1->next, p2 = p2->next, i++ ) {
      if( T1 != T2 && ((fabs(T1 - T2) / dmax(fabs(T1),fabs(T2)) ) > Compare_fuzz) ) {
         LRETURN(FALSE);
      }
   }
   LRETURN(TRUE);

#undef           LRETURN
}

int wts_are_cvtest_compatible(WT wt1, WT wt2) {
   double dx1, dx2;

   return wts_are_time_compatible(wt1,wt2) &&
          is_uniform_dx_wt(wt1,&dx1) &&
          is_uniform_dx_wt(wt2,&dx2) && 
          dx1 != dx2 && dx1 > 0.0;
}

int wts_are_always_compatible(WT wt1,WT wt2) {
   return(1);
}

/* Routine doesn't check that times are same ... */

/* Temporary fix for fact that dvinqn doesn't do fuzzy compare 
   on x-values, will pass in extremal values rather than 0.0 */

PXYDVBIND  pxydv_interpolate_x1_to_x2(PXYDVBIND p1, PXYDVBIND p2) {
   PXYDVBIND        lp1 = p1;

   if( n_PXYDVBIND(p1) &&  n_PXYDVBIND(p2) ) { 
      for( ; p1 ; p1 = p1->next, p2 = p2->next ) {
         DVEC    NEW_X1,      NEW_Y1;
         int     f77_intord = 4;
         double  f77_def_value = 0.0;

         if( (NEW_X1 = make_DVEC(N2)) && (NEW_Y1 = make_DVEC(N2)) ) {
            dvcopy_(X2,NEW_X1,&N2);
            dvinqn_(Y1,X1,NEW_Y1,NEW_X1,&N1,&N2,
                    &(Y1[0]),&(Y1[N1-1]),
                    &f77_intord);
            N1 = N2;
            free(X1);  X1 = NEW_X1;
            free(Y1);  Y1 = NEW_Y1;
         }
      }
   }
   return( lp1 );
}

/* Adds data, first interpolating p to p1's coords; assumes 
   p has been cloned from p2 ... */

PXYDVBIND pxydv_add(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   p = pxydv_interpolate_x1_to_x2(p,p1);
   FOR {
      dvva_(Y1,Y,Y,&N);
   }
   RETURN;
}

/* Subtracts data, first interpolating p to p1's coords; assumes 
   p has been cloned from p2 ... */

PXYDVBIND pxydv_subtract(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   p = pxydv_interpolate_x1_to_x2(p,p1);
   FOR {
      dvvs_(Y1,Y,Y,&N);
   }
   RETURN;
}

/* Subtracts data, first interpolating p to p1's coords; assumes 
   p has been cloned from p2 ... */

PXYDVBIND pxydv_subtract_interpolate(PXYDVBIND p, PXYDVBIND p1, PXYDVBIND p2) {
   SAVE
   p = pxydv_interpolate_x1_to_x2(p,p1);
   FOR {
      dvvs_(Y1,Y,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_multiply(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   p = pxydv_interpolate_x1_to_x2(p,p1);
   FOR {
      dvvm_(Y1,Y,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_divide(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   p = pxydv_interpolate_x1_to_x2(p,p1);
   FOR {

/*    dvvdxx_ computes 0/0 via interpolation/extrapolation.    */

      dvvdxx_(Y1,Y,Y,&N); 
   }
   RETURN;
}

PXYDVBIND pxydv_average(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   double            f77_half = 0.5;
   SAVE
   p = pxydv_interpolate_x1_to_x2(p,p1);
   FOR {
      dvsvsa_(Y1,Y,Y,&f77_half,&f77_half,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_divide_0(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   double            f77_scalar;
   SAVE
   FOR {
      f77_scalar = (Y2[0] == 0) ? 1.0 : 1.0 / Y2[0];
      dvsm_(Y1,&f77_scalar,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_pyth2(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   SAVE
   FOR {
      dvsofs_(Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_pyth(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   SAVE
   FOR {
      dvpyth_(Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_mpyth2(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   SAVE
   FOR {
      dvdofs_(Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_pyth2_int(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   SAVE
   double res0 = 0.0;
   DVEC   TY;
   FOR {
      if( (TY = make_DVEC(N)) ) {
         dvsofs_(Y1,Y2,TY,&N);
#ifndef __ 
         dvmint_dx_sense_(TY,X,Y,&N,&res0);
#else
         dvmint_dx_sense__(TY,X,Y,&N,&res0);
#endif
         free(TY);
      } else {
         fprintf(stderr,"pxydv_pyth2_int: Could not allocate %d doubles\n",
                 N);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_absolute_difference(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   SAVE
   FOR {
      dvabd_(Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_relative_difference(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   SAVE
   FOR {
      dvabrd_(Y1,Y2,Y,&N);
   }
   RETURN;
}

int ndvnesc(double *v,int n,double sc) {
   int      i, rc = 0;
   for( i = 0; i < n; i++ ) {
      if( v[i] != sc ) rc++;
   }
   return rc;
}

/* Kludge: If all elements in a given group are masked, retain first 
   element to avoid complexities associated with deleting groups ... */

PXYDVBIND pxydv_mask(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   int  i, j;
   DVEC NEW_X,  NEW_Y;
   int  NEW_N;
   SAVE
   for( p = lp; p != NULL; p = p->next, p1 = p1->next, p2 = p2->next ) {
/*    Always free destination tag vectors ... */
      if( VTAG ) VTAG = free_XYTAGVEC( VTAG );

      NEW_N = ndvnesc(Y1,N1,0.0);

      if( NEW_N ) { 
         if( (NEW_X = make_DVEC(NEW_N))  && (NEW_Y = make_DVEC(NEW_N)) ) {
            for( i = 0, j = 0; i < N1; i++ ) {
               if( Y1[i] != 0.0 ) {
                  NEW_X[j] = X2[i];
                  NEW_Y[j] = Y2[i];
                  j++;
               }
            }
            N = NEW_N;
            free(X);  X = NEW_X;
            free(Y);  Y = NEW_Y;
         } else {
            fprintf(stderr,"pxydv_mask: make_DVEC(%d) failed\n",NEW_N);
         }
      } else {
         NEW_N = 1;
         if( (NEW_X = make_DVEC(NEW_N))  && (NEW_Y = make_DVEC(NEW_N)) ) {
            NEW_X[0] = X2[0];
            NEW_Y[0] = Y2[0];
            N = NEW_N;
            free(X);  X = NEW_X;
            free(Y);  Y = NEW_Y;
         } else {
            fprintf(stderr,"pxydv_mask: make_DVEC(%d) failed\n",NEW_N);
         }
      }
   }
   RETURN;
}

PXYDVBIND pxydv_y1_by_sqrt_y1_2_y2_2(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   SAVE
   FOR {
      dvpyth_(Y1,Y2,Y,&N);
      dvvdxx_(Y1,Y,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_y1_vs_x2(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   SAVE
   FOR {
      dvcopy_(X1,X,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_richardson_extrapolate_Oh2
             (PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   double     h1_over_h2, default_h1_over_h2 = 2.0, c0, c1, c2;

   SAVE
Prompt:
      sprintf(O_buf,"Enter h[1] / h[2] (%g)",default_h1_over_h2);
      GET_DOUBLE(h1_over_h2,default_h1_over_h2,O_buf);  
      if( h1_over_h2 == 0.0 ) goto Prompt;
   
   c0 = h1_over_h2 * h1_over_h2;
   c2 = c0 / (c0 - 1.0);
   c1 = -1 / (c0 - 1.0);
   FOR {
      dvsvsa_(Y1,Y2,Y,&c1,&c2,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_merge(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   FOR {
      p = expand_PXYDVBIND_by_n(p,N1);
      dvcopy_(X1,X     ,&N1);
      dvcopy_(Y1,Y     ,&N1);
      dvcopy_(X2,X + N1,&N2);
      dvcopy_(Y2,Y + N1,&N2);
      if( VTAG  && VTAG1 && VTAG2 ) {
         ivcopy_(VTAGTAG1,VTAGTAG     ,&N1);
         ivcopy_(VTAGTAG2,VTAGTAG + N1,&N2);
      }
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_merge_single(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   PXYDVBIND    lp = p,  singlep;
   double       d_single;
   int          n1,      single;

#define         XS       singlep->data->x
#define         YS       singlep->data->y
#define         NS       singlep->data->n
#define         VTAGS    singlep->tdata
#define         VTAGTAGS singlep->tdata->tag

   n1 = n_PXYDVBIND(p1);
   if( (n1 = n_PXYDVBIND(p1)) > 1 ) {
Prompt:
      sprintf(O_buf,"Enter merge index (1:%d)",n1);
      GET_DOUBLE(d_single,-1.0,O_buf);  single = (int) d_single;
      if( d_single < 0.0 || ( (single < 1) || (single > n1) ) ) goto Prompt;
   } else {
      single = 1;
   }

   if( ! (singlep = nth_PXYDVBIND(p1,single)) ) {
      fprintf(stderr,"pxydv_merge_single: Unexpected null return from ");
      fprintf(stderr,"nth_PXYDVBIND(p1,%d).\n",single);
      return lp;
   }

   for( p = lp; p != NULL; p = p->next, p2 = p2->next ) {
      p = expand_PXYDVBIND_by_n(p,NS);
      dvcopy_(XS,X     ,&NS);
      dvcopy_(YS,Y     ,&NS);
      dvcopy_(X2,X + NS,&N2);
      dvcopy_(Y2,Y + NS,&N2);
      if( VTAG && VTAG2 && VTAGS ) {
         ivcopy_(VTAGTAGS,VTAGTAG     ,&NS);
         ivcopy_(VTAGTAG2,VTAGTAG + NS,&N2);
      }
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
#undef          VTAGTAGS
#undef          VTAGS
#undef          NS
#undef          YS
#undef          XS
}


PXYDVBIND pxydv_subtract_single(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   PXYDVBIND    lp = p,  singlep;
   double       d_single;
   int          n1,      single;

   int          ltrace = OFF;

#define         XS       singlep->data->x
#define         YS       singlep->data->y
#define         NS       singlep->data->n
#define         VTAGS    singlep->tdata
#define         VTAGTAGS singlep->tdata->tag

   if( (n1 = n_PXYDVBIND(p1)) > 1 ) {
Prompt:
      sprintf(O_buf,"Enter subtract index (1:%d)",n1);
      GET_DOUBLE(d_single,-1.0,O_buf);  single = (int) d_single;
      if( d_single < 0.0 || ( (single < 1) || (single > n1) ) ) goto Prompt;
   } else {
      single = 1;
   }

   if( ! (singlep = nth_PXYDVBIND(p1,single)) ) {
      fprintf(stderr,"pxydv_subtract_single: Unexpected null return from ");
      fprintf(stderr,"nth_PXYDVBIND(p1,%d).\n",single);
      return lp;
   }

   if( ltrace ) {
      fprintf(stderr,"pxydv_subtract_single: Single vector length %d\n",
              NS);
      fprintf(stderr,"pxydv_subtract_single: Single vector range: %g -- %g\n",
              XS[0],XS[NS-1]);
   }

   for( p = lp; p != NULL; p = p->next, p2 = p2->next ) {
      DVEC    NEW_X,       NEW_Y;
      int     f77_intord = 4;
      double  f77_def_value = 0.0;

/*    Always free destination tag vectors ... */
      if( VTAG ) VTAG = free_XYTAGVEC( VTAG );

      if( (NEW_X = make_DVEC(NS))  && (NEW_Y = make_DVEC(NS)) ) {
/*       Interpolate source to single x-coordinates ... */
         dvcopy_(XS,NEW_X,&NS);
         dvinqn_(Y,X,NEW_Y,NEW_X,&N,&NS,&f77_def_value,&f77_def_value,
                 &f77_intord);

/*       ... subtract single data ... */
         dvvs_(NEW_Y,YS,NEW_Y,&NS);    

/*       ... and replace old data with new. */
         N = NS;
         free(X);  X = NEW_X;
         free(Y);  Y = NEW_Y;
      }
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
#undef          VTAGTAGS
#undef          VTAGS
#undef          NS
#undef          YS
#undef          XS
}

PXYDVBIND pxydv_best_scale_single(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   PXYDVBIND    lp = p,  singlep;
   double       d_single;
   int          n1,      single;

   int          ltrace = OFF;

#define         XS       singlep->data->x
#define         YS       singlep->data->y
#define         NS       singlep->data->n
#define         VTAGS    singlep->tdata
#define         VTAGTAGS singlep->tdata->tag

   if( (n1 = n_PXYDVBIND(p1)) > 1 ) {
Prompt:
      sprintf(O_buf,"Enter target index (1:%d)",n1);
      GET_DOUBLE(d_single,-1.0,O_buf);  single = (int) d_single;
      if( d_single < 0.0 || ( (single < 1) || (single > n1) ) ) goto Prompt;
   } else {
      single = 1;
   }

   if( ! (singlep = nth_PXYDVBIND(p1,single)) ) {
      fprintf(stderr,"pxydv_best_scale_single: Unexpected null return from ");
      fprintf(stderr,"nth_PXYDVBIND(p1,%d).\n",single);
      return lp;
   }

   if( ltrace ) {
      fprintf(stderr,"pxydv_best_scale_single: Single vector length %d\n",
              NS);
      fprintf(stderr,"pxydv_best_scale_single: Single vector range: %g -- %g\n",
              XS[0],XS[NS-1]);
   }

   for( p = lp; p != NULL; p = p->next, p2 = p2->next ) {
      DVEC    SCALE_X,       SCALE_Y;
      int     f77_intord = 4;
      double  f77_def_value = 0.0;
      double  sum_yy,  sum_yY,  sigma;
      int     ii = 0;

/*    Always free destination tag vectors ... */
      if( VTAG ) VTAG = free_XYTAGVEC( VTAG );

      if( (SCALE_X = make_DVEC(NS))  && (SCALE_Y = make_DVEC(NS)) ) {
/*       Interpolate source to single x-coordinates ... */
         dvcopy_(XS,SCALE_X,&NS);
         dvinqn_(Y,X,SCALE_Y,SCALE_X,&N,&NS,&f77_def_value,&f77_def_value,
                 &f77_intord);
/*       Compute sums for least squares scaling fit ... */
         sum_yy = dvvsum(SCALE_Y,SCALE_Y,NS);
         sum_yY = dvvsum(SCALE_Y,YS,NS);
         if( sum_yy != 0.0 ) {
            sigma = sum_yY / sum_yy;
         } else {
            sigma = 1.0;
         }
         if( ltrace ) {
            fprintf(stderr,"pxydv_best_scale_single: group %d: best scale %g\n",                    ii,sigma);
         }
/*       Save best scale as time variable and rescale data ... */
         T = sigma;
         dvsm(Y,sigma,Y,N);

         free(SCALE_X); 
         free(SCALE_Y);  
      }
      ii++;
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
#undef          VTAGTAGS
#undef          VTAGS
#undef          NS
#undef          YS
#undef          XS
}


PXYDVBIND pxydv_mofxy(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   FOR {
      dvmofxy_(X,Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_aofxy(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   FOR {
      dvmofxy_(X,Y1,Y2,Y,&N);
      dvaofm_(X,Y,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_make_xy(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   SAVE
   FOR {
      dvcopy_(Y1,X,&N);
      dvcopy_(Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_xy_to_flow_field(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
#define               X1_NEXT           (p1->next)->data->x
#define               Y1_NEXT           (p1->next)->data->y
#define               N1_NEXT           (p1->next)->data->n
#define               X2_NEXT           (p2->next)->data->x
#define               Y2_NEXT           (p2->next)->data->y
#define               N2_NEXT           (p2->next)->data->n

   PXYDVBIND          tp;
   DVEC               NEW_X,            NEW_Y,
                      TX,               TY;
   int                nvec;
   double             scale = 1.0,      
                      f77_0 = 0.0,      f77_1 = 1.0;              
   int                f77_intord = 4;

   SAVE;
   nvec = n_PXYDVBIND(p);
   if( nvec % 2 ) {
      scope_mess_and_bell("Need even number of frames for this function.",1);
   } else {
      GET_DOUBLE(scale,scale,"scale");
      for( p = lp; p != NULL; ) {
         TX = make_DVEC(N1);
         TY = make_DVEC(N2);
         (void) dvinqn_(Y1_NEXT,X1_NEXT,TX,X1,&N1_NEXT,&N1,
                        &f77_0,&f77_0,&f77_intord);
         (void) dvinqn_(Y2_NEXT,X2_NEXT,TY,X2,&N2_NEXT,&N2,
                        &f77_0,&f77_0,&f77_intord);
         (void) dvvs_(Y1,TX,TX,&N1); 
         (void) dvsvsa_(Y1,TX,TX,&f77_1,&scale);
         (void) dvvs_(Y2,TY,TY,&N2);
         (void) dvsvsa_(Y2,TY,TY,&f77_1,&scale);
         NEW_X = make_DVEC(2 * N1);
         NEW_Y = make_DVEC(2 * N2);
         (void) dvmrg_(Y1,TX,NEW_X,&N1);
         (void) dvmrg_(Y2,TY,NEW_Y,&N2);
         N = 2 * N ;
         free(X); free(Y);
         X = NEW_X; Y = NEW_Y;
         free_DVEC(TX);
         free_DVEC(TY);

         T = 0.5 * (T + T_NEXT);
         tp = p->next;
         p->next = (p->next)->next;
         if( p->next ) (p->next)->prev = p;
         free_XYDVEC(tp->data);
         free(tp);
         p = p->next;
         p1 = (p1->next)->next;
         p2 = (p2->next)->next;
      }
      assert( n_PXYDVBIND(lp) == nvec / 2 );
      reindex_XYDVlist(lp,1);
   }
   RETURN;
#undef                X1_NEXT           
#undef                Y1_NEXT          
#undef                N1_NEXT         
#undef                X2_NEXT        
#undef                Y2_NEXT       
#undef                N2_NEXT      
}

PXYDVBIND pxydv_xy_to_flow_field_auto(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
#define               X1_NEXT           (p1->next)->data->x
#define               Y1_NEXT           (p1->next)->data->y
#define               N1_NEXT           (p1->next)->data->n
#define               X2_NEXT           (p2->next)->data->x
#define               Y2_NEXT           (p2->next)->data->y
#define               N2_NEXT           (p2->next)->data->n

   PXYDVBIND          tp;
   DVEC               NEW_X,            NEW_Y,
                      TX,               TY;
   DQUAD              x_limits,         y_limits;
   int                nvec;
   double             scale = 0.02,     delx,              dely,      
                      f77_0 = 0.0,      f77_1 = 1.0;              
   int                f77_intord = 4;

   SAVE;
   nvec = n_PXYDVBIND(p);
   if( nvec % 2 ) {
      scope_mess_and_bell("Need even number of frames for this function.",1);
   } else {
      x_limits = dq_xydv_list(p1);
      y_limits = dq_xydv_list(p2);
      delx = x_limits.y2 - x_limits.y1;
      dely = y_limits.y2 - y_limits.y1;
      GET_DOUBLE(scale,scale,"frac. vector length");
      for( p = lp; p != NULL; ) {
         TX = make_DVEC(N1);
         TY = make_DVEC(N2);
         (void) dvinqn_(Y1_NEXT,X1_NEXT,TX,X1,&N1_NEXT,&N1,
                        &f77_0,&f77_0,&f77_intord);
         (void) dvinqn_(Y2_NEXT,X2_NEXT,TY,X2,&N2_NEXT,&N2,
                        &f77_0,&f77_0,&f77_intord);
         (void) dvvs_(Y1,TX,TX,&N1); 
         (void) dvvs_(Y2,TY,TY,&N2);
         (void) dvnpyth_(TX,TY,TX,TY,&N1,&delx,&dely,&scale);
         (void) dvva_(Y1,TX,TX,&N1);
         (void) dvva_(Y2,TY,TY,&N1);
         NEW_X = make_DVEC(2 * N1);
         NEW_Y = make_DVEC(2 * N2);
         (void) dvmrg_(Y1,TX,NEW_X,&N1);
         (void) dvmrg_(Y2,TY,NEW_Y,&N2);
         N = 2 * N ;
         free(X); free(Y);
         X = NEW_X; Y = NEW_Y;
         free_DVEC(TX);
         free_DVEC(TY);

         T = 0.5 * (T + T_NEXT);
         tp = p->next;
         p->next = (p->next)->next;
         if( p->next ) (p->next)->prev = p;
         free_XYDVEC(tp->data);
         free(tp);
         p = p->next;
         p1 = (p1->next)->next;
         p2 = (p2->next)->next;
      }
      assert( n_PXYDVBIND(lp) == nvec / 2 );
      reindex_XYDVlist(lp,1);
   }
   RETURN;
#undef                X1_NEXT           
#undef                Y1_NEXT          
#undef                N1_NEXT         
#undef                X2_NEXT        
#undef                Y2_NEXT       
#undef                N2_NEXT      
}


PXYDVBIND pxydv_ppofxy(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   DVEC              A;

   SAVE
   FOR {
      A = make_DVEC(N);
      dvmofxy_(X,Y1,Y2,A,&N);
      dvaofm_(X,A,A,&N);
      dvppfx_(Y1,A,X,Y,&N);
      free_DVEC(A);
   }
   RETURN;
}

PXYDVBIND pxydv_piofxy(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   DVEC              A;

   SAVE
   FOR {
      A = make_DVEC(N);
      dvmofxy_(X,Y1,Y2,A,&N);
      dvaofm_(X,A,A,&N);
      dvpify_(Y2,A,X,Y,&N);
      free_DVEC(A);
   }
   RETURN;
}

PXYDVBIND pxydv_xofppa(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   double            Rt2pi = 2.506628274631000;

   SAVE
   FOR {
      dvvd_(Y1,Y2,Y,&N);
      dvvsm_(Y,X,Y,&Rt2pi,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_yofpia(p,p1,p2)
   PXYDVBIND         p,     p1,    p2;
{
   double            Rt2pi = 2.506628274631000;

   SAVE
   FOR {
      dvvd_(Y1,Y2,Y,&N);
      dvvsm_(Y,X,Y,&Rt2pi,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_xofpsiphi(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   double         rsq;
   SAVE
   FOR {
      dvc2tos2x_(Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_yofpsiphi(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   double         rsq;
   SAVE
   FOR {
      dvc2tos2y_(Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_zofpsiphi(PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2) {
   double         rsq;
   SAVE
   FOR {
      dvc2tos2z_(Y1,Y2,Y,&N);
   }
   RETURN;
}

PXYDVBIND pxydv_dt_to_dtau
             (PXYDVBIND p,PXYDVBIND p1,PXYDVBIND p2)
{
   double     tstar, tstar_never = -1.0, scale;

   SAVE
Prompt:
      GET_DOUBLE(tstar,tstar_never,"Enter critical time");  
      if( tstar < 0.0 ) goto Prompt;
   
   FOR {
      scale = (tstar - T1) / Y2[0];
      dvsm_(Y1,&scale,Y,&N);
   }
   RETURN;
}

#undef            SAVE             
#undef            FOR             
#undef            RETURN              

#undef            X              
#undef            Y              
#undef            N              
#undef            T              
#undef            TAG              
#undef            VTAG             
#undef            VTAGTAG         

#undef            LXY1             
#undef            NEVENTS1         
#undef            HEAD1            
#undef            X1               
#undef            Y1               
#undef            N1               
#undef            T1               
#undef            TAG1             
#undef            VTAG1
#undef            VTAGTAG1

#undef            LXY2             
#undef            NEVENTS2         
#undef            HEAD2            
#undef            X2               
#undef            Y2               
#undef            N2               
#undef            T2               
#undef            TAG2             
#undef            VTAG2
#undef            VTAGTAG2
