#include "project.h"

/* Applicators, etc. */
/* Modified to consolidate applicator info. in single table entry  ... */

APPLY6_TYPE0      Apply6_table[] = { 

   { NULL, NULL,  NULL,  NULL,  NULL,  NULL,  NULL,  NULL,  NULL,  NULL },

   { pxydv_mmief_hcres,
     "hc residual",
     "a",
     "s",
     "K[th,th]",
     "K[r,r]",
     "Phi",
     "Pi",
     wts_are_fully_compatible, 
     "hc residual" },

   { pxydv_mmief_momcres,
     "momc residual",
     "a",
     "s",
     "K[th,th]",
     "K[r,r]",
     "Phi",
     "Pi",
     wts_are_fully_compatible, 
     "momc residual" } 
                                   };

int               N_Apply6_table =
                     sizeof(Apply6_table) / sizeof(APPLY6_TYPE0);
 
#define           SAVE             PXYDVBIND    lp = p;
#define           FOR              for( p = lp; p != NULL; p = p->next, p1 = p1->next, p2 = p2->next, p3 = p3->next, p4 = p4->next, p5 = p5->next, p6 = p6->next  )
#define           RETURN           return lp;

#define           X                p->data->x
#define           Y                p->data->y
#define           N                p->data->n
#define           T                p->time
#define           TAG              p->tag

#define           LXY1             wds[wt1].pf.pxyf->lxy
#define           NEVENTS1         wds[wt1].pf.pxyf->nevents
#define           HEAD1            wds[wt1].pf.pxyf->xyhead
#define           X1               p1->data->x
#define           Y1               p1->data->y
#define           N1               p1->data->n
#define           T1               p1->time
#define           TAG1             p1->tag

#define           LXY2             wds[wt2].pf.pxyf->lxy
#define           NEVENTS2         wds[wt2].pf.pxyf->nevents
#define           HEAD2            wds[wt2].pf.pxyf->xyhead
#define           X2               p2->data->x
#define           Y2               p2->data->y
#define           N2               p2->data->n
#define           T2               p2->time
#define           TAG2             p2->tag

#define           LXY3             wds[wt3].pf.pxyf->lxy
#define           NEVENTS3         wds[wt3].pf.pxyf->nevents
#define           HEAD3            wds[wt3].pf.pxyf->xyhead
#define           X3               p3->data->x
#define           Y3               p3->data->y
#define           N3               p3->data->n
#define           T3               p3->time
#define           TAG3             p3->tag

#define           LXY4             wds[wt4].pf.pxyf->lxy
#define           NEVENTS4         wds[wt4].pf.pxyf->nevents
#define           HEAD4            wds[wt4].pf.pxyf->xyhead
#define           X4               p4->data->x
#define           Y4               p4->data->y
#define           N4               p4->data->n
#define           T4               p4->time
#define           TAG4             p4->tag

#define           LXY5             wds[wt5].pf.pxyf->lxy
#define           NEVENTS5         wds[wt5].pf.pxyf->nevents
#define           HEAD5            wds[wt5].pf.pxyf->xyhead
#define           X5               p5->data->x
#define           Y5               p5->data->y
#define           N5               p5->data->n
#define           T5               p5->time
#define           TAG5             p5->tag

#define           LXY6             wds[wt6].pf.pxyf->lxy
#define           NEVENTS6         wds[wt6].pf.pxyf->nevents
#define           HEAD6            wds[wt6].pf.pxyf->xyhead
#define           X6               p6->data->x
#define           Y6               p6->data->y
#define           N6               p6->data->n
#define           T6               p6->time
#define           TAG6             p6->tag

/* Y1 --> a    
   Y2 --> s
   Y3 --> k[th,th]
   Y4 --> k[r,r]
   Y5 --> Phi
   Y6 --> Pi
*/

#define           A     Y1
#define           S     Y2
#define           KT    Y3
#define           KR    Y4
#define           PH    Y5
#define           PI    Y6

PXYDVBIND pxydv_mmief_hcres(p,p1,p2,p3,p4,p5,p6) 
   PXYDVBIND      p,  p1,  p2,  p3,  p4, p5, p6;
{
   int            j;
   DVEC           DA;

   int            ltrace = OFF;

   SAVE;
   if( ltrace ) fprintf(stderr,"pxydv_mmief_hcres: Invoked\n");
   FOR {
      if( (DA = make_DVEC(N)) ) {
         dvd1nu_(A,X,DA,&N);
         for( j = 0; j < N; j++ ) {
            Y[j] = DA[j] - 0.5 * A[j] * ( 1.0 - A[j] * A[j] ) / S[j] -
                           0.5 * S[j] * (
                                 4.0 * M_PI * A[j] * (
                                     PH[j] * PH[j] + PI[j] * PI[j] ) 
                               - A[j] * A[j] * A[j] * KT[j] * 
                                     ( KT[j] + 2.0 * KR[j] )
                                         );
         }
         free(DA);
      }
   }
   RETURN;
}

PXYDVBIND pxydv_mmief_momcres(p,p1,p2,p3,p4,p5,p6) 
   PXYDVBIND      p,  p1,  p2,  p3,  p4, p5, p6;
{
   int            j;
   DVEC           DKT;

   int            ltrace = OFF;

   SAVE;
   if( ltrace ) fprintf(stderr,"pxydv_mmief_momcres: Invoked\n");
   FOR {
      if( (DKT = make_DVEC(N)) ) {
         dvd1nu_(KT,X,DKT,&N);
         for( j = 0; j < N; j++ ) {
            Y[j] = DKT[j] + (KT[j] - KR[j]) / S[j] -
                   4.0 * M_PI * PH[j] * PI[j] / A[j];
         }
         free(DKT);
      }
   }
   RETURN;

}


#undef            A
#undef            S
#undef            KT  
#undef            KR  
#undef            PH 
#undef            PI

#undef            SAVE             
#undef            FOR             
#undef            RETURN              

#undef            X              
#undef            Y              
#undef            N              
#undef            T              
#undef            TAG              

#undef            LXY1             
#undef            NEVENTS1         
#undef            HEAD1            
#undef            X1               
#undef            Y1               
#undef            N1               
#undef            T1               
#undef            TAG1             

#undef            LXY2             
#undef            NEVENTS2         
#undef            HEAD2            
#undef            X2               
#undef            Y2               
#undef            N2               
#undef            T2               
#undef            TAG2             

#undef            LXY3             
#undef            NEVENTS3         
#undef            HEAD3            
#undef            X3               
#undef            Y3               
#undef            N3               
#undef            T3               
#undef            TAG3             

#undef            LXY4             
#undef            NEVENTS4         
#undef            HEAD4            
#undef            X4               
#undef            Y4               
#undef            N4               
#undef            T4               
#undef            TAG4             

#undef            LXY5             
#undef            NEVENTS5         
#undef            HEAD5            
#undef            X5               
#undef            Y5               
#undef            N5               
#undef            T5               
#undef            TAG5             

#undef            LXY6             
#undef            NEVENTS6         
#undef            HEAD6            
#undef            X6               
#undef            Y6               
#undef            N6               
#undef            T6               
#undef            TAG6             
