#include "project.h"

/* Multi-window applicators ...  */
/* Modified to consolidate applicator info. in single table entry  ... */
/* Append %l in name for menu-line after entry ... */

APPLYN_TYPE0      Applyn_table[] = { 

   {NULL, NULL, NULL, 0, 0}, 

   { pxydv_mergen,
     "merge",
     wts_are_merge_compatible,
     0,
     2 },

   { pxydv_mergen_by_t_general,
     "tag & merge (general by t)",
     wts_are_always_compatible,
     0,
     2 },

   { pxydv_tag_and_mergen,
     "tag & merge",
     wts_are_merge_compatible,
     0,
     2 },

   { pxydv_yrescale_and_mergen,
     "merge (y -> [0..1]) %l",
     wts_are_merge_compatible,
     0,
     2 },

   { pxydv_mergen,
     "merge all",
     wts_are_merge_compatible,
     1,
     2 },

   { pxydv_mergen_by_t_general,
     "tag & merge all (general by t)",
     wts_are_always_compatible,
     1,
     2 },

   { pxydv_tag_and_mergen,
     "tag & merge all",
     wts_are_merge_compatible,
     1,
     2 },

   { pxydv_yrescale_and_mergen,
     "merge all (y -> [0..1]) %l",
     wts_are_merge_compatible,
     1,
     2 },

   { pxydv_cvtest_h2_n,
     "O(h^2) convergence test",
     wts_are_cvtest_compatible,
     0,
     3 },

   { pxydv_cvtest_h1_n,
     "O(h) convergence test",
     wts_are_cvtest_compatible,
     0,
     3 },

   { pxydv_cvtest_hp_n,
     "O(h^p) convergence test %l",
     wts_are_cvtest_compatible,
     0,
     3 },

   { pxydv_cvtest_h2_n,
     "O(h^2) convergence test all",
     wts_are_cvtest_compatible,
     1,
     3 },

   { pxydv_cvtest_h1_n,
     "O(h) convergence test all",
     wts_are_cvtest_compatible,
     1,
     3 },

   { pxydv_cvtest_hp_n,
     "O(h^p) convergence test all %l",
     wts_are_cvtest_compatible,
     1,
     3 },

   { pxydv_cvtest_res_h2_n,
     "O(h^2) res. conv. test",
     wts_are_cvtest_compatible,
     0,
     2 },

   { pxydv_cvtest_res_h1_n,
     "O(h) res. conv. test",
     wts_are_cvtest_compatible,
     0,
     2 },

   { pxydv_cvtest_res_hp_n,
     "O(h^p) res. conv. test %l",
     wts_are_cvtest_compatible,
     0,
     2 },

   { pxydv_cvtest_res_h2_n,
     "O(h^2) res. conv. test all",
     wts_are_cvtest_compatible,
     1,
     2 },

   { pxydv_cvtest_res_h1_n,
     "O(h) res. conv. test all",
     wts_are_cvtest_compatible,
     1,
     2 },

   { pxydv_cvtest_res_hp_n,
     "O(h^p) res. conv. test all %l",
     wts_are_cvtest_compatible,
     1,
     2 },

   { pxydv_differencen,
     "[ n ] - [ 1 ]",
     wts_are_fully_compatible,
     0,
     2 },

   { pxydv_absolute_differencen,
     "abs([ n ] - [ 1 ])",
     wts_are_fully_compatible,
     0,
     2 },

   { pxydv_relative_differencen,
     "abs([ n ] - [ 1 ] / [ 1 ]) %l",
     wts_are_fully_compatible,
     0,
     2 },

   { pxydv_catenaten,
     "catenate",
     wts_are_always_compatible,
     0,
     2 },

   { pxydv_catenaten_ordinal_t,
     "catenate (t -> 1, 2, 3, ...)",
     wts_are_always_compatible,
     0,
     2 },

   { pxydv_catenaten_yrescale_ordinal_t,
     "\"\" (y -> [0..1]) %l",
     wts_are_always_compatible,
     0,
     2 },

   { pxydv_catenaten,
     "catenate all",
     wts_are_always_compatible,
     1,
     2 },

   { pxydv_catenaten_ordinal_t,
     "catenate all (t -> 1, 2, 3, ...)",
     wts_are_always_compatible,
     1,
     2 },

   { pxydv_catenaten_yrescale_ordinal_t,
     "\"\" (y -> [0..1]) %l",
     wts_are_always_compatible,
     1,
     2 },

   { pxydv_sumn,
     "sum",
     wts_are_fully_compatible,
     0,
     2 }
     
                                   };

int               N_Applyn_table =
                     sizeof(Applyn_table) / sizeof(APPLYN_TYPE0);
 
#define           SAVE             int  newn, ip, i, o, all_tag; PXYDVBIND    lp = p;
#define           FORV             for( i = 0; i < vp.n; i++ )
#define           FORVO            for( o = 0, i = 0; i < vp.n; o += N_I, i++ )
#define           FORV_1           for( i = 1; i < vp.n; i++ )
#define           FORVO_1          for( o = 0, i = 1; i < vp.n; o += N_I, i++ )
#define           INCV             FORV { vp.v[i] = vp.v[i]->next;}
#define           FOR              for( ip = 0, p = lp; p != NULL; p = p->next, ip++)
#define           CALC_NEWN        newn = 0; FORV {newn += N_I;}
#define           CALC_NEWN_1      newn = 0; FORV_1 {newn += N_I;}
#define           ALL_TAG          all_tag = 1; FORV { all_tag = all_tag && VTAG_I;}
#define           RETURN           return lp

#define           X                p->data->x
#define           Y                p->data->y
#define           N                p->data->n
#define           T                p->time
#define           TAG              p->tag
#define           VTAG             p->tdata
#define           VTAGTAG          p->tdata->tag

#define           X_0              vp.v[0]->data->x
#define           Y_0              vp.v[0]->data->y
#define           N_0              vp.v[0]->data->n
#define           T_0              vp.v[0]->time
#define           TAG_0            vp.v[0]->tag
#define           VTAG_0           vp.v[0]->tdata
#define           VTAGTAG_0        vp.v[0]->tdata->tag

#define           X_I              vp.v[i]->data->x
#define           Y_I              vp.v[i]->data->y
#define           N_I              vp.v[i]->data->n
#define           T_I              vp.v[i]->time
#define           TAG_I            vp.v[i]->tag
#define           VTAG_I           vp.v[i]->tdata
#define           VTAGTAG_I        vp.v[i]->tdata->tag

PXYDVBIND pxydv_dummyn(PXYDVBIND p,PXYDVBIND_VECN vp) {
   DVECN   xmin = {NULL,0}, xmax = {NULL,0}, ymin = {NULL,0}, ymax = {NULL,0};
   SAVE;

   fprintf(stderr,"pxydv_dummyn: PXYDVBIND_VECN vp is length %d.\n",vp.n);
   FORV {
      xmin = dvecn_append(xmin,xmin_PXYDVBIND(vp.v[i]));
      xmax = dvecn_append(xmax,xmax_PXYDVBIND(vp.v[i]));
      ymin = dvecn_append(ymin,ymin_PXYDVBIND(vp.v[i]));
      ymax = dvecn_append(ymax,ymax_PXYDVBIND(vp.v[i]));
   }
   dvdump(xmin.v,xmin.n,"xmin");
   dvdump(xmax.v,xmax.n,"xmax");
   dvdump(ymin.v,ymin.n,"ymin");
   dvdump(ymax.v,ymax.n,"ymax");
   FOR {
      FORV {
         fprintf(stderr,"pxydv_dummyn: Source window %d, vec. %d length %d.\n",
                 i,ip,N_I);
      }
      CALC_NEWN;
      ALL_TAG;
      fprintf(stderr,"pxydv_dummyn: Dest. vec. %d length %d %s have tag.\n",
              i,newn,all_tag ? "will" : "will not");
      INCV;
   }
   RETURN;
}

PXYDVBIND pxydv_mergen(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   FOR {
      CALC_NEWN;
      ALL_TAG;
      p = resize_PXYDVBIND_to_n(p,newn);
      if( !all_tag ) {
         free_XYTAGVEC(VTAG);
         VTAG = NULL;
      }
      FORVO {
         dvcopy_(X_I,X + o,&N_I);
         dvcopy_(Y_I,Y + o,&N_I);
         if( all_tag ) {
            ivcopy_(VTAGTAG_I,VTAGTAG + o,&N_I);
         }
      }
      INCV;
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_mergen_by_t_general(PXYDVBIND p,PXYDVBIND_VECN vp) {
   PXYDVBIND newhead = NULL,  lp = NULL,  pp;
   DVEC      ALLT = (DVEC) NULL,      UNIQT = (DVEC) NULL;
   IVEC      NUNIQT = (IVEC) NULL,    OFFSET = (IVEC) NULL;                 
   int                               nuniqt;
   double    fuzz = Insert_xy_fuzz;
   int       i,      ngroups,      igroup,    ikey;

   int       ltrace = OFF;

   int       save_wt;

   newhead = p;
   save_wt = wt_from_xyhead(p);

   if( ltrace ) {
      fprintf(stderr,"Scanning vp structure.\n");
   }

/* Determine total number of time groups in merge structure ... */

   for( ngroups = 0, i = 0; i < vp.n; i++ ) {
      for( p = vp.v[i]; p != NULL; p = p->next ) {
         ++ngroups;
      }
   }
   if( ltrace ) {
      fprintf(stderr,"\nTotal number of groups: %d\n",ngroups);
   }

/* Allocate storage for times, unique times and determine unique times ... */

   if( !(ALLT = make_DVEC(ngroups)) ) {
      fprintf(stderr," pxydv_mergen_by_t_general: make_DVEC(%d) failed\n",
              ngroups);
      goto Exit;
   }
   if( !(UNIQT = make_DVEC(ngroups)) ) {
      fprintf(stderr," pxydv_mergen_by_t_general: make_DVEC(%d) failed\n",
              ngroups);
      goto Exit;
   }
   for( igroup = 0, i = 0; i < vp.n; i++ ) {
      for( p = vp.v[i]; p != NULL; p = p->next ) {
         ALLT[igroup] = p->time;
         ++igroup;
      }
   }
   if( ltrace ) {
      dvdump(ALLT,ngroups,"All times");
   }
   dvsortupuniq(ALLT,ngroups,UNIQT,&nuniqt,fuzz);
   if( ltrace ) {
      sprintf(O_buf,"Unique times (%d) (fuzz: %g)",nuniqt,fuzz);
      dvdump(UNIQT,nuniqt,O_buf);
   }
   if( !(NUNIQT = make_IVEC(nuniqt)) ) {
      fprintf(stderr,"pxydv_mergen_by_t_general: make_IVEC(%d) failed\n",
              nuniqt);
      goto Exit;
   }
   if( !(OFFSET = make_IVEC(nuniqt)) ) {
      fprintf(stderr,"pxydv_mergen_by_t_general: make_IVEC(%d) failed\n",
              nuniqt);
      goto Exit;
   }

/* Determine how much storage is needed for each unique time ... */

   ivls(NUNIQT,0,nuniqt);
   ivls(OFFSET,0,nuniqt);
   for( i = 0; i < vp.n; i++ ) {
      for( p = vp.v[i]; p != NULL; p = p->next ) {
         if( (ikey = dvlookup_linear(UNIQT,nuniqt,p->time,fuzz)) < 0 ) {
            fprintf(stderr,"pxydv_mergen_by_t_general:  Panic ... ");
            fprintf(stderr,"Time %g not found in All times array.\n",p->time);
            goto Exit;
         }
         NUNIQT[ikey] += p->data->n;
      }
   }
   if( ltrace ) { 
      ivdump(NUNIQT,nuniqt,"Required storage");
   }

/* Free storage associated with incoming output window, allocate 
   necessary amount of (new) storage and build output list ... */

   free_XYDVLIST(p);
   for( i = 0, lp = NULL; i < nuniqt; i++ ) {
      lp = link_PXYDVBIND(lp,make_XYDVBIND());
      lp->time = UNIQT[i];
      lp->data = make_XYDVEC(NUNIQT[i]);
      lp->tdata = make_XYTAGVEC(NUNIQT[i]);
      if( i == 0 ) {
         newhead = lp;
      }
   }

/* Copy data from merge structure to output list ... */ 

   for( i = 0; i < vp.n; i++ ) {
      for( p = vp.v[i]; p != NULL; p = p->next ) {
         if( (ikey = dvlookup_linear(UNIQT,nuniqt,p->time,fuzz)) < 0 ) {
            fprintf(stderr,"pxydv_mergen_by_t_general:  Panic ... ");
            fprintf(stderr,"Time %g not found in All times array.\n",p->time);
            goto Exit;
         }
         if( !(pp = nth_PXYDVBIND(newhead,ikey+1)) ) {
            fprintf(stderr,"pxydv_mergen_by_t_general:  Panic ... ");
            fprintf(stderr,"Could not find node %d in new list.\n",ikey);
            goto Exit;
         }
         if( ltrace ) {
            fprintf(stderr,"pxydv_mergen_by_t_general: Copying ");
            fprintf(stderr,"%d, offset %d\n",p->data->n,OFFSET[ikey]);
         }

         DVcopy(p->data->x,pp->data->x + OFFSET[ikey],p->data->n);
         DVcopy(p->data->y,pp->data->y + OFFSET[ikey],p->data->n);
         ivls(pp->tdata->tag + OFFSET[ikey],i,p->data->n);
         OFFSET[ikey] += p->data->n;
      }
   }

/* Reindex output list, free temporary storage and exit ... */

Exit:
   reindex_XYDVlist(newhead, 1);
   if( ALLT )  free(ALLT);
   if( UNIQT ) free(UNIQT);
   if( NUNIQT ) free(NUNIQT);
   if( OFFSET ) free(OFFSET);

   set_marker_multi_mode(save_wt);
   return( newhead );
}

PXYDVBIND pxydv_tag_and_mergen(PXYDVBIND p,PXYDVBIND_VECN vp) {
   int    f77_const;
   SAVE;

   FOR {
      CALC_NEWN;
      p = resize_PXYDVBIND_to_n(p,newn);
      f77_const = 0;
      FORVO {
         dvcopy_(X_I,X + o,&N_I);
         dvcopy_(Y_I,Y + o,&N_I);
         ivls_(VTAGTAG + o,&f77_const,&N_I);
         ++f77_const;
      }
      INCV;
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_yrescale_and_mergen(PXYDVBIND p,PXYDVBIND_VECN vp) {
   DVECN   ymin = {NULL,0}, ymax = {NULL,0};
   double  f77_zero = 0.0,  f77_ymin,  f77_yrange;
   SAVE;

   FORV {
      ymin = dvecn_append(ymin,ymin_PXYDVBIND(vp.v[i]));
      ymax = dvecn_append(ymax,ymax_PXYDVBIND(vp.v[i]));
   }
   FOR {
      CALC_NEWN;
      ALL_TAG;
      p = resize_PXYDVBIND_to_n(p,newn);
      if( !all_tag ) {
         free_XYTAGVEC(VTAG);
         VTAG = NULL;
      }
      FORVO {
         f77_ymin = ymin.v[i];
         f77_yrange = ymax.v[i] - f77_ymin;
         dvcopy_(X_I,X + o,&N_I);
         if( f77_yrange > 0.0 ) {
            f77_yrange = 1.0 / f77_yrange;
            dvlt_  (Y_I,Y + o,&N_I,&f77_zero,&f77_yrange,&f77_ymin);
         } else {
            dvls_  (Y + o,&f77_zero,&N_I);
         }
         if( all_tag ) {
            ivcopy_(VTAGTAG_I,VTAGTAG + o,&N_I);
         }
      }
      INCV;
   }
   free_DVECN(ymin);
   free_DVECN(ymax);
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_cvtest_h2_n(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   pxydv_cvtest_n(p,vp,2.0);

   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_cvtest_h1_n(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   pxydv_cvtest_n(p,vp,1.0);

   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_cvtest_hp_n(PXYDVBIND p,PXYDVBIND_VECN vp) {
   double     power,   default_power = 2.0;
   SAVE;

   GET_DOUBLE(power,default_power,"p");

   pxydv_cvtest_n(p,vp,power);

   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_cvtest_res_h2_n(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   pxydv_cvtest_res_n(p,vp,2.0);

   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_cvtest_res_h1_n(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   pxydv_cvtest_res_n(p,vp,1.0);

   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_cvtest_res_hp_n(PXYDVBIND p,PXYDVBIND_VECN vp) {
   double     power,   default_power = 2.0;
   SAVE;

   GET_DOUBLE(power,default_power,"p");

   pxydv_cvtest_res_n(p,vp,power);

   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_cvtest_n(PXYDVBIND p,PXYDVBIND_VECN vp,double power) {
   static char R[] = "pxydv_cvtest_n";

   PXYDVBIND   lp = p;
   int         ip;

   int         ltrace = Ltrace;
   int         n = vp.n,     i,      j;
   PXYDVBIND   tpdv;
   double     *vh  = (double *) NULL, th;
   double     *vhu = (double *) NULL;
   double     *vdh = (double *) NULL;
   double     *vsc = (double *) NULL;
   int         nu, newn, o;
   int         f77_intord = 4;
   double      f77_def_value = 0.0;


   if( Ltrace ) fprintf(stderr,"%s: n=%d power=%d\n",R,n,(int) power);
   assert(n > 2);

   if( !(vh  = make_DVEC(n)) ) goto Return;
   if( !(vhu = make_DVEC(n)) ) goto Return;
   if( !(vdh = make_DVEC(n-1)) ) goto Return;
   if( !(vsc = make_DVEC(n-1)) ) goto Return;

   for( i = 0; i < n; i++ ) (void) is_uniform_dx_pxydv(vp.v[i],vh+i);
   if( ltrace ) dvdump(vh,n,"pxydv_cvtest_n: vh pre-sort");

   dvsortupuniq(vh,n,vhu,&nu,Compare_fuzz);
   if( nu != n ) {
      sprintf(O_buf,"Mesh spacings are not distinct");
      scope_mess(O_buf,1);
      goto Return;
   }

   for( i = 0; i < n - 1; i++ ) {
      for( j = 0; j < n - i - 1; j ++ ) {
         if( vh[j] < vh[j+1] ) {
            tpdv = vp.v[j];
            vp.v[j] = vp.v[j+1];
            vp.v[j+1] = tpdv;
            th = vh[j];
            vh[j] = vh[j+1];
            vh[j+1] = th;    
         }
      }
   }
   if( ltrace ) dvdump(vh,n,"pxydv_cvtest_n: vh pst-sort");
   for( i = 0; i < n - 1; i++ ) {
      vdh[i] = pow(vh[i+1],power) - pow(vh[i],power);
      vsc[i] = vdh[0] / vdh[i];
   }
   if( ltrace ) dvdump(vdh,n-1,"pxydv_cvtest_n: vdh");
   if( ltrace ) dvdump(vsc,n-1,"pxydv_cvtest_n: vsc");

   for( ip = 0, p = lp; p != NULL; p = p->next, ip++) {
      for( i = 0, newn = 0; i < n - 1; i++ ) newn += vp.v[i]->data->n;
      if( ltrace ) fprintf(stderr,"%s: i=%d newn=%d\n",R,ip,newn);
      if( p->tdata ) free(p->tdata);
      p = resize_PXYDVBIND_to_n(p,newn);
      p->tdata = NULL;
      for( o = 0, i = 0; i < n - 1; o += vp.v[i]->data->n, i++ ) {
         if( ltrace ) {
            fprintf(stderr,"  i=%d o=%d vp.v[i]->data->n=%d\n",
               i,o,vp.v[i]->data->n);
         }
         dvcopy_(vp.v[i]->data->x,p->data->x + o,&(vp.v[i]->data->n));
         dvinqn_(vp.v[i+1]->data->y,vp.v[i+1]->data->x,
                 p->data->y + o,p->data->x + o,
                 &(vp.v[i+1]->data->n),
                 &(vp.v[i]->data->n),
                 &((vp.v[i+1]->data->y)[0]),
                 &((vp.v[i+1]->data->y)[(vp.v[i+1]->data->n)-1]),
                 &f77_intord);
         dvvs(p->data->y + o,vp.v[i]->data->y,p->data->y + o,vp.v[i]->data->n);
         dvsm(p->data->y + o,vsc[i],p->data->y + o,vp.v[i]->data->n);
      }
      for( i = 0; i < vp.n; i++ ) vp.v[i] = vp.v[i]->next;
   }

Return:
   if( vh  ) free(vh);
   if( vhu ) free(vhu);
   if( vdh ) free(vdh);
   if( vsc ) free(vsc);

   set_marker_multi_mode(wt_from_xyhead(lp));

   return lp;
}

/* Modified version of pxydv_cvtest_n for convergence checking of 
   residual quantities 
   TODO: Needs mods. so that all n rescaled diff vectors are output */

PXYDVBIND pxydv_cvtest_res_n(PXYDVBIND p,PXYDVBIND_VECN vp,double power) {
   static char R[] = "pxydv_cvtest_res_n";

   PXYDVBIND   lp = p;
   int         ip;

   int         ltrace = 0;
   int         n = vp.n,     i,      j;
   PXYDVBIND   tpdv;
   double     *vh  = (double *) NULL, th;
   double     *vhu = (double *) NULL;
   double     *vsc = (double *) NULL;
   int         nu, newn, o;
   int         f77_intord = 4;
   double      f77_def_value = 0.0;


   if( Ltrace ) fprintf(stderr,"%s: n=%d power=%d\n",R,n,(int) power);
   assert(n > 1);

   if( !(vh  = make_DVEC(n)) ) goto Return;
   if( !(vhu = make_DVEC(n)) ) goto Return;
   if( !(vsc = make_DVEC(n)) ) goto Return;

   for( i = 0; i < n; i++ ) (void) is_uniform_dx_pxydv(vp.v[i],vh+i);
   if( ltrace ) dvdump(vh,n,"pxydv_cvtest_n: vh pre-sort");

   dvsortupuniq(vh,n,vhu,&nu,Compare_fuzz);
   if( nu != n ) {
      sprintf(O_buf,"Mesh spacings are not distinct");
      scope_mess(O_buf,1);
      goto Return;
   }

   for( i = 0; i < n - 1; i++ ) {
      for( j = 0; j < n - i - 1; j ++ ) {
         if( vh[j] < vh[j+1] ) {
            tpdv = vp.v[j];
            vp.v[j] = vp.v[j+1];
            vp.v[j+1] = tpdv;
            th = vh[j];
            vh[j] = vh[j+1];
            vh[j+1] = th;    
         }
      }
   }
   if( ltrace ) dvdump(vh,n,"pxydv_cvtest_n: vh pst-sort");
   for( i = 0; i < n; i++ ) {
      vsc[i] = pow(vh[0] / vh[i],power);
   }

   if( ltrace ) dvdump(vsc,n,"pxydv_cvtest_n: vsc");

   for( ip = 0, p = lp; p != NULL; p = p->next, ip++) {
      for( i = 0, newn = 0; i < n; i++ ) newn += vp.v[i]->data->n;
      if( ltrace ) fprintf(stderr,"%s: i=%d newn=%d\n",R,ip,newn);
      if( p->tdata ) free(p->tdata);
      p = resize_PXYDVBIND_to_n(p,newn);
      p->tdata = NULL;
      for( o = 0, i = 0; i < n; o += vp.v[i]->data->n, i++ ) {
         if( ltrace ) {
            fprintf(stderr,"  i=%d o=%d vp.v[i]->data->n=%d\n",
               i,o,vp.v[i]->data->n);
         }
         dvcopy_(vp.v[i]->data->x,p->data->x + o,&(vp.v[i]->data->n));
         dvcopy_(vp.v[i]->data->y,p->data->y + o,&(vp.v[i]->data->n));
         dvsm(p->data->y + o,vsc[i],p->data->y + o,vp.v[i]->data->n);
      }
      for( i = 0; i < vp.n; i++ ) {
         vp.v[i] = vp.v[i]->next;
      }
   }

Return:
   if( vh  ) free(vh);
   if( vhu ) free(vhu);
   if( vsc ) free(vsc);

   set_marker_multi_mode(wt_from_xyhead(lp));

   return lp;
}

PXYDVBIND pxydv_differencen(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   FOR {
      CALC_NEWN_1;
      ALL_TAG;
      p = resize_PXYDVBIND_to_n(p,newn);
      if( !all_tag ) {
         free_XYTAGVEC(VTAG);
         VTAG = NULL;
      }
      FORVO_1 {
         dvcopy_(X_I,X + o,&N_I);
         dvvs_  (Y_I,Y_0,Y + o,&N_I);
         if( all_tag ) {
            ivcopy_(VTAGTAG_I,VTAGTAG + o,&N_I);
         }
      }
      INCV;
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
 RETURN;
}

PXYDVBIND pxydv_absolute_differencen(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   FOR {
      CALC_NEWN_1;
      ALL_TAG;
      p = resize_PXYDVBIND_to_n(p,newn);
      if( !all_tag ) {
         free_XYTAGVEC(VTAG);
         VTAG = NULL;
      }
      FORVO_1 {
         dvcopy_(X_I,X + o,&N_I);
         dvabd_ (Y_I,Y_0,Y + o,&N_I);
         if( all_tag ) {
            ivcopy_(VTAGTAG_I,VTAGTAG + o,&N_I);
         }
      }
      INCV;
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_relative_differencen(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   FOR {
      CALC_NEWN_1;
      ALL_TAG;
      p = resize_PXYDVBIND_to_n(p,newn);
      if( !all_tag ) {
         free_XYTAGVEC(VTAG);
         VTAG = NULL;
      }
      FORVO_1 {
         dvcopy_(X_I,X + o,&N_I);
         dvabrd_(Y_I,Y_0,Y + o,&N_I);
         if( all_tag ) {
            ivcopy_(VTAGTAG_I,VTAGTAG + o,&N_I);
         }
      }
      INCV;
   }
   set_marker_multi_mode(wt_from_xyhead(lp));
   RETURN;
}

PXYDVBIND pxydv_catenaten(PXYDVBIND p,PXYDVBIND_VECN vp) {
   PXYDVBIND    newhead  = NULL,  lp = NULL,  pp;
   int          i,   n_p = 0;

   int          ltrace = OFF;

   if( ltrace ) {
      fprintf(stderr,"pxydv_catenaten: Would catenate %d windows.\n",vp.n);
   }
   free_XYDVLIST(p);

   for( i = 0; i < vp.n; i++ ) {
      for( pp = vp.v[i]; pp != NULL; pp = pp->next, ++n_p ) {
         lp = link_PXYDVBIND(lp,copy_PXYDVBIND(pp));
         if( n_p == 0 ) {
            newhead = lp;
         } 
      }
   }

   if( ltrace ) {
      fprintf(stderr,"pxydv_catenaten: Catenated total of %d groups.\n",n_p);
      scan_pxydvbind(newhead,"pxydv_catenaten");
   }
   reindex_XYDVlist(newhead,1);
   return(newhead);
}

PXYDVBIND pxydv_catenaten_ordinal_t(PXYDVBIND p,PXYDVBIND_VECN vp) {
   PXYDVBIND    newhead  = NULL,  lp = NULL,  pp;
   int          i,   n_p = 0;

   free_XYDVLIST(p);

   for( i = 0; i < vp.n; i++ ) {
      for( pp = vp.v[i]; pp != NULL; pp = pp->next, ++n_p ) {
         lp = link_PXYDVBIND(lp,copy_PXYDVBIND(pp));
         lp->time = (double) (n_p + 1);
         if( n_p == 0 ) {
            newhead = lp;
         } 
      }
   }

   reindex_XYDVlist(newhead,1);
   return(newhead);
}

PXYDVBIND pxydv_catenaten_yrescale_ordinal_t(PXYDVBIND p,PXYDVBIND_VECN vp) {
   PXYDVBIND    newhead  = NULL,  lp = NULL,  pp;
   int          i,   n_p = 0;

   DVECN        ymin = {NULL,0}, ymax = {NULL,0};
   double       f77_zero = 0.0,  f77_ymin,  f77_yrange;

   free_XYDVLIST(p);

   FORV {
      ymin = dvecn_append(ymin,ymin_PXYDVBIND(vp.v[i]));
      ymax = dvecn_append(ymax,ymax_PXYDVBIND(vp.v[i]));
   }
   for( i = 0; i < vp.n; i++ ) {
      f77_ymin = ymin.v[i];
      f77_yrange = ymax.v[i] - f77_ymin;
      if( f77_yrange > 0.0 ) {
         f77_yrange = 1.0 / f77_yrange;
      } 
      for( pp = vp.v[i]; pp != NULL; pp = pp->next, ++n_p ) {
         lp = link_PXYDVBIND(lp,copy_PXYDVBIND(pp));
         lp->time = (double) (n_p + 1);
         if( f77_yrange > 0.0 ) {
            dvlt_(lp->data->y,lp->data->y,&lp->data->n,
                  &f77_zero,&f77_yrange,&f77_ymin);
         }
         if( n_p == 0 ) {
            newhead = lp;
         } 
      }
   }

   free_DVECN(ymin);
   free_DVECN(ymax);

   reindex_XYDVlist(newhead,1);
   return(newhead);
}

PXYDVBIND pxydv_sumn(PXYDVBIND p,PXYDVBIND_VECN vp) {
   SAVE;

   FOR {
      free_XYTAGVEC(VTAG);
      VTAG = NULL;
      dvls(Y,0.0,N);
      FORV {
         dvva(Y,Y_I,Y,N);
      }
      INCV;
   }
   RETURN;
}

#undef            SAVE             
#undef            FORV            
#undef            FORVO          
#undef            FORV_1
#undef            FORVO_1
#undef            INCV          
#undef            FOR          
#undef            CALC_NEWN   
#undef            CALC_NEWN_1
#undef            ALL_TAG    
#undef            RETURN    

#undef            X        
#undef            Y       
#undef            N      
#undef            T     
#undef            TAG  
#undef            VTAG
#undef            VTAGTAG  

#undef            X_0
#undef            Y_0
#undef            N_0
#undef            T_0
#undef            TAG_0
#undef            VTAG_0
#undef            VTAGTAG_0

#undef            X_I     
#undef            Y_I    
#undef            N_I   
#undef            T_I  
#undef            TAG_I  
#undef            VTAG_I
#undef            VTAGTAG_I 
