#include "project.h"

/*=========================================================================
See also: cbio.[ch]
=========================================================================*/
igeom     Xvsf_geom_prev;
igeom     Xvsf_geom_curr;

XFontStruct  *font_info;
XCharStruct  xcs;
char font9x15[] = "9x15";
char str[] = "Breakfast time!";

int Curr_p;
int Save_p;
int Single_p = 0;

int Split_dir = UNDEF;

int        Form_state;
int        Form_state_prev;
int        Form_motion_state = FORM_MOTION_STATE_NORMAL;
int        Form_size_state = FORM_SIZE_STATE_NORMAL;
raster_pos Form_pos = {-1,-1};
raster_pos Form_pos_prev = {-1,-1};
int        Form_w_min;
int        Form_h_min;
int        Pick_type;
int        Picked_wt;
IVECN      Picked_wt_list =  {(IVEC) NULL, 0};
STRINGVECN Pick_prompts = {NULL, 0};
int        N_pick_prompts;
int        Apply_no_clone = 0;
int        Menu_deferred = 0;
int        Menu_deferred_wt = -1;
int        Menu_picking = 0;
int        All = 0;
int        Apply_all = 0;

int        Clone_mouse_nwt = ON;

char      *Sdf_name = (char *) NULL;

int        Color_dqc = RED;
char       Fmt_dqc[] = "%9.2e";

int        Color_mouse_pos = RED;
char       Fmt_mouse_pos[] = "%9.2e";

int        Dform_opt  = DFORM_UP;
int        Dform_size = 50;

int        Mpeg_wt;
char      *Mpeg_dir   = (char *) NULL;
char      *Mpeg_name  = (char *) NULL;
char      *Mpeg_fname = (char *) NULL;
char      *Mpeg_playback_cmd = (char *) NULL;
char       Mpeg_def_playback_cmd[] = "mpeg_play -dither color %s";

char      *Browse_fmt = (char *) NULL;
char       Browse_def_fmt[] = "%18.8e";

int        Control_folder_number_prev = UNDEF;
int        Control_folder_close = 0;

int        Force_update_browser_file = 0;

/* Enabled while soliciting user input ... */
int        Xvs_get_input             = 0;

/* For general purpose string, format string, command etc. construction ... */
char       B[BUFLEN];
char       B1[BUFLEN];
char       B2[BUFLEN];
char       F[BUFLEN];

/* For storing working directory ... */
char       WD[BUFLEN];

int        Ndisplay = 1;

APPLY1_TYPE0 *Deferred_apply1_generic0_table = (APPLY1_TYPE0 *) NULL;
int           Deferred_apply1_generic0_code = -1;

/* Replacement for non-finite values ... */
double     Nonfinite_val = -1.0;

/* Enables kill windown via Ctrl-space ... */
int        Ctrl_space_kill = ON;

/* For fixing control/ops bug when auto mode enabled, set to -1 when mode
   widget needs updating, and to S_wt when widget for active window has 
   been updated ... */
int        Auto_wt = -1;

/*=========================================================================
Template callback
=========================================================================*/
void cb_template(FL_OBJECT *ob, long val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
   int    ltrace = ON;
   static char R[] = "cb_template";
   int    ival;
   double dval;

   if( ltrace ) {
      fprintf(stderr,"%s: In routine: S_wt=%d val=%d\n",R,S_wt,(int) val);
   }

   switch( (int) val ) {
   case 0:
      break;
   case 1:
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }
   set_must_redraw(S_wt);
#undef  PP
}

/*=========================================================================
at_close routine for main which prompts user for exit confirmation.
=========================================================================*/
int at_close_main(FL_FORM *form, void *data) {
   if( fl_show_question("Are you sure you want to exit?",1) ) { 
      exit(1);
   } else {
/*    Recurse to stay alive, potential stack problem ... */
      fl_do_forms();
   }
   return FL_IGNORE;
}

/*=========================================================================
Generic at_close routine which hides form
=========================================================================*/
int at_close_hide(FL_FORM *form, void *data) {
   int ltrace = OFF;
   if( ltrace ) fprintf(stderr,"at_close_hide: In routine\n");
   fl_hide_form(form);
   Form_state = FORM_STATE_NORMAL;
   return FL_IGNORE;
}

/*=========================================================================
Hides marker form and resets form state.
=========================================================================*/
int at_close_markers(FL_FORM *form, void *data) {
   int ltrace = OFF;
   if( ltrace ) fprintf(stderr,"at_close_markers: In routine\n");
   fl_hide_form(form);
   Form_state = FORM_STATE_NORMAL;
   return FL_IGNORE;
}

/*=========================================================================
Hides control form and resets some global variables.
=========================================================================*/
int at_close_control(FL_FORM *form, void *data) {
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"at_close_control: In routine S_wt=%d\n",S_wt);
   if( ltrace ) fprintf(stderr,"at_close_control: Form_state=%d\n",Form_state);
   if( Form_state == FORM_STATE_CONTROL ) {
      Control_folder_number_prev = 
         fl_get_active_folder_number(Xvsf_control->tabfolder_control);
      fl_hide_form(form);
      Form_state = FORM_STATE_NORMAL;
      widgets_reset_all();
      Force_centre_mouse_in_wt = ON;
      centre_mouse_in_wt(S_wt);
   }
   return FL_IGNORE;
}

/*=========================================================================
Hides mpeg form and resets mpeg global variables.
=========================================================================*/
int at_close_mpeg(FL_FORM *form, void *data) {
   int ltrace = Ltrace;
   if( ltrace ) fprintf(stderr,"at_close_mpeg: In routine\n");
   fl_hide_form(form);
   Form_state = FORM_STATE_NORMAL;
   if( Mpeg_dir ) free(Mpeg_dir);
   Mpeg_dir = (char *) NULL;    
   if( Mpeg_name ) free(Mpeg_name);  
   Mpeg_name = (char *) NULL; 
   return FL_IGNORE;
}

/*=========================================================================
Hides sm form ...
=========================================================================*/
int at_close_sm(FL_FORM *form, void *data) {
   int ltrace = Ltrace;
   if( ltrace ) fprintf(stderr,"at_close_sm: In routine\n");
   fl_hide_form(form);
   Form_state = FORM_STATE_NORMAL;
   return FL_IGNORE;
}

/*=========================================================================
Hides browse form ...
=========================================================================*/
int at_close_browse(FL_FORM *form, void *data) {
   int ltrace = Ltrace;
   if( ltrace ) fprintf(stderr,"at_close_browse: In routine\n");
   fl_hide_form(form);
   Form_state = FORM_STATE_NORMAL;
   return FL_IGNORE;
}

/*=========================================================================
Returns number of selected lines in browser.
=========================================================================*/
int xfl_get_browser_nselected(FL_OBJECT *obj) {
   static char R[] = "xfl_get_browser_nselected";
   int         ltrace = Ltrace;
   int         i, rval = 0;
   int  nlines = fl_get_browser_maxline(obj);
   if( ltrace ) fprintf(stderr,"xfl_get_browser_nselected: nlines=%d\n",nlines);
   for( i = 1; i <= nlines; i++ ) {
      if( fl_isselected_browser_line(obj,i) ) rval++;
   }
   if( ltrace ) fprintf(stderr,"xfl_get_browser_nselected: return val=%d\n",rval);
   return rval;
}

/*=========================================================================
Resets some widget character variables.
=========================================================================*/
void widgets_reset_all(void) {
   if( Mpeg_dir ) free(Mpeg_dir);
   Mpeg_dir = (char *) NULL;
   if( Mpeg_name ) free(Mpeg_name);
   Mpeg_name = (char *) NULL;
   /* Should probably only do this if have changed window ... */
   if( Sm_xname ) free(Sm_xname); 
   Sm_xname = (char *) NULL;
   if( Sm_yname ) free(Sm_yname); 
   Sm_yname = (char *) NULL;
}

/*=========================================================================
Prompt user for character input and get it.  NOTE:  This routine allocates 
memory for the returned string via "strdup".
=========================================================================*/
void GET_STRING(char **s, char *prompt) {
   int     ltrace = OFF;
   char   *input;

   input = (char *) fl_show_simple_input(prompt,(char *) NULL);
   *s = input ? strdup(input) : input;
   if( ltrace ) {
      fprintf(stderr,"GET_STRING: s='%s'\n",*s ? *s : "NULL");
   }
}

char *get_string(char *prompt) {
   FL_OBJECT *obj;
   char *the = (char *) NULL;
   scope_mess_perm(prompt);
   fprintf(stderr,"invoking fl_do_forms()\n");
   obj = fl_do_forms();
   fprintf(stderr,"get_string: fl_do_forms() returns %x\n",obj);
   while( (obj = fl_do_forms()) ) {
      fprintf(stderr,"get_string: fl_do_forms() returns %x\n",obj);
   }
   scope_clear();
   return the;
}

/*=========================================================================
Prompt user for input and get it.  
=========================================================================*/
char *xvs_get_string(char *prompt,char *def) {
   int     ltrace = Ltrace;
   char   *input;
   char    B1[BUFLEN];
   char    B[BUFLEN];
   char   *val;

   sprintf(B,"Enter %s (default=%s)",prompt,def);
   Xvs_get_input = 1;
   input = (char *) fl_show_simple_input(B,(char *) NULL);
   Xvs_get_input = 0;
   if( input && (sscanf(input,"%s",B1) == 1) ) {
      val = strdup(input);
   } else {
      val = strdup(def);
   }
   if( ltrace ) {
      fprintf(stderr,"xvs_get_string: def=%s val=%s\n",def,val);
   }
   return val;
}

double xvs_get_double(char *prompt,double def) {
   int     ltrace = OFF;
   char   *input;
   double  val;
   char    B[BUFLEN];

   sprintf(B,"Enter %s (default=%g)",prompt,def);
   Xvs_get_input = 1;
   input = (char *) fl_show_simple_input(B,(char *) NULL);
   Xvs_get_input = 0;
   if( !input || (sscanf(input,"%lf",&val) != 1) ) {
      val = def;
   } 
   if( ltrace ) {
      fprintf(stderr,"xvs_get_double: def=%g val=%g\n",def,val);
   }
   return val;
}

int xvs_get_int(char *prompt,int def) {
   int     ltrace = OFF;
   char   *input;
   int     val;
   char    B[BUFLEN];
   sprintf(B,"Enter %s (default=%d)",prompt,def);
   Xvs_get_input = 1;
   input = (char *) fl_show_simple_input(B,(char *) NULL);
   Xvs_get_input = 0;
   if( !input || (sscanf(input,"%d",&val) != 1) ) {
      val = def;
   } 
   if( ltrace ) {
      fprintf(stderr,"xvs_get_double: def=%d val=%d\n",def,val);
   }
   return val;
}

/*=========================================================================
Prompt user for vector of doubles and retrieves it (incomplete)
=========================================================================*/
double *xvs_get_vdouble(char *prompt,double *vdef,int n) {
   int     ltrace = Ltrace;
   char   *input;
   double  val;
   char    B[BUFLEN];
   sprintf(B,"Enter %s (default=%g)",prompt,vdef[0]);
   Xvs_get_input = 1;
   input = (char *) fl_show_simple_input(B,(char *) NULL);
   Xvs_get_input = 0;
   if( !input || (sscanf(input,"%lf",&val) != 1) ) {
      val = vdef[0];
   } 
   if( ltrace ) {
      fprintf(stderr,"xvs_get_vdouble: def=%g val=%g\n",vdef[0],val);
   }
   return vdef;
}

enum {
   CB_MAIN_NONE = 0,
   CB_MAIN_ALL  = 1,
   CB_MAIN_KILL_ALL  = 2
};

/*=========================================================================
Callback for main form
=========================================================================*/
void cb_main(FL_OBJECT *ob, long val) {
   int    ltrace = Ltrace;
   static char R[] = "cb_main";
   static char B[BUFLEN];

   switch( (int) val ) {
   case CB_MAIN_ALL:
      set_All(fl_get_button(Xvsf->button_main_all));
      break;
   case CB_MAIN_KILL_ALL:
      xvs_close_all_wt(NO);
      fl_set_button(Xvsf->button_main_kill_all,0);
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

   widgets_set_main();
   widgets_set_All();
}

/*=========================================================================
Handles All on/off.
=========================================================================*/
void set_All(int val) {
   All = val;
   Synch_mode = val;
   widgets_set_All();
}

/*=========================================================================
Synchs various All buttons.
=========================================================================*/
void widgets_set_All(void) {
   int    ltrace = Ltrace;
   static char R[] = "widgets_set_All";

   if( ltrace ) fprintf(stderr,"%s: All=%d\n",R,All);

   if( fl_form_is_visible(Xvsf->main) ) 
      fl_set_button(Xvsf->button_main_all,All);
   if( fl_form_is_visible(Xvsf_ops->ops) ) 
      fl_set_button(Xvsf_ops->button_ops_all,All);
   if( fl_form_is_visible(Xvsf_view->view) ) 
      fl_set_button(Xvsf_view->button_view_all,All);
   if( fl_form_is_visible(Xvsf_file->file) ) 
      fl_set_button(Xvsf_file->button_file_all,All);
}

void widgets_set_main(void) {
   fl_set_button(Xvsf->button_main_all,All);
   return;
}

enum {
   CB_MARKERS_TYPE = 0,
   CB_MARKERS_COLOR = 1,
   CB_MARKERS_LINE_COLOR = 2,
   CB_MARKERS_MARKER_SIZE = 3,
   CB_MARKERS_POINT_SIZE = 4,
   CB_MARKERS_LINE_WIDTH = 5,
   CB_MARKERS_NPOLY = 6,
   CB_MARKERS_MULTI_MODE = 7,
   CB_MARKERS_AUTO_TAG_BY_DX_ON  = 20,
   CB_MARKERS_AUTO_TAG_BY_DX_OFF = 21,
   CB_MARKERS_APPLY_ALL = 98
};

/*=========================================================================
Mouse position (text) callback
Note manual admonition against using box-less dynamic text
=========================================================================*/
void cb_text_mouse_pos(FL_OBJECT *ob, long val) {
   int         ltrace = OFF;
   static char R[] = "cb_text_mouse_pos";
   double      xmouse, ymouse;

   if( ltrace ) 
      fprintf(stderr,"%s: Mouse_position_display=%d\n",R,Mouse_position_display);
   if( !Mouse_position_display ) return;

   if( is_active_wt(S_wt) ) {
      if( ltrace ) fprintf(stderr,"%s: S_wt=%d is active\n",R,S_wt);
      xymouse_w_wt(S_wt,&xmouse,&ymouse);
      sprintf(F,"%s %s",Fmt_mouse_pos,Fmt_mouse_pos);
      if( ltrace ) fprintf(stderr,"%s: Mouse pos fmt='%s'\n",R,F);
      sprintf(B,F,xmouse,ymouse);
      if( ltrace ) fprintf(stderr,"%s: Displaying mouse pos='%s'\n",R,B);
      fl_set_object_label(ob,B);
   } else {
      if( ltrace ) fprintf(stderr,"%s: Mouse_position_display is OFF\n",R);
   }
}

/*=========================================================================
Markers form callback
=========================================================================*/
void cb_markers(FL_OBJECT *ob, long val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
   int    ltrace = Ltrace;
   static char R[] = "cb_markers";
   static char B[BUFLEN];
   int    ival;
   double dval;

   if( ltrace ) {
      fprintf(stderr,"%s: In routine: S_wt=%d val=%d\n",R,S_wt,(int) val);
      if( is_active_wt(S_wt) ) {
         fprintf(stderr,"%s:    marker_type=%d\n",R,PP->marker_color);
         fprintf(stderr,"%s:    marker_color=%d\n",R,PP->marker_color);
         fprintf(stderr,"%s:    marker_size=%g\n",R,PP->marker_size);
         fprintf(stderr,"%s:    point_size=%d\n",R,PP->point_size);
         fprintf(stderr,"%s:    marker_npoly=%d\n",R,PP->marker_npoly);
         fprintf(stderr,"%s:    marker_multi_mode=%d\n",R,PP->marker_multi_mode);
         fprintf(stderr,"%s:    marker_line_auto_break=%d\n",
            R,PP->marker_line_auto_break);
         fprintf(stderr,"%s:    line_color=%d\n",R,PP->line_color);
         fprintf(stderr,"%s:    line_width=%d\n",R,PP->line_width);
      }
   }

   switch( (int) val ) {
   case CB_MARKERS_AUTO_TAG_BY_DX_ON:
      Auto_tag_by_dx = ON;
      if( Ltrace ) fprintf(stderr,"%s: Auto_tag_by_dx=%d\n",R,Auto_tag_by_dx);
      break;
   case CB_MARKERS_AUTO_TAG_BY_DX_OFF:
      Auto_tag_by_dx = OFF;
      if( Ltrace ) fprintf(stderr,"%s: Auto_tag_by_dx=%d\n",R,Auto_tag_by_dx);
      break;
   }

   if( !is_active_wt(S_wt) ) return;

   switch( (int) val ) {
   case CB_MARKERS_TYPE:
      PP->marker_type = fl_get_choice(Xvsf_markers->choice_markers_type);
      break;
   case CB_MARKERS_COLOR:
      PP->marker_color = fl_get_choice(Xvsf_markers->choice_markers_color) - 1;
   case CB_MARKERS_LINE_COLOR:
      PP->line_color = 
         fl_get_choice(Xvsf_markers->choice_markers_line_color) - 1;
      break;
   case CB_MARKERS_MARKER_SIZE:
      if( sscanf(fl_get_input(Xvsf_markers->input_markers_marker_size),
                 "%lf",&dval) == 1 ) {
         PP->marker_size = dval * DEFAULT_MARKER_SIZE;
      } else {
         fl_set_input(Xvsf_markers->input_markers_marker_size,B);
      }
      break;
   case CB_MARKERS_POINT_SIZE:
      if( sscanf(fl_get_input(Xvsf_markers->input_markers_point_size),
                 "%d",&ival) == 1 ) {
         ival = iclamp(ival,MIN_POINT_SIZE,MAX_POINT_SIZE,PP->point_size);
      } else {
         ival = PP->point_size;
      }
      PP->point_size = ival;
      sprintf(B,"%d",ival);
      fl_set_input(Xvsf_markers->input_markers_point_size,B);
      break;
   case CB_MARKERS_LINE_WIDTH:
      if( sscanf(fl_get_input(Xvsf_markers->input_markers_line_width),
                 "%d",&ival) == 1 ) {
         ival = iclamp(ival,MIN_LINE_WIDTH,MAX_LINE_WIDTH,PP->line_width);
      } else {
         ival = PP->line_width;
      }
      PP->line_width = ival;
      sprintf(B,"%d",ival);
      fl_set_input(Xvsf_markers->input_markers_line_width,B);
      break;
   case CB_MARKERS_NPOLY:
      if( sscanf(fl_get_input(Xvsf_markers->input_markers_npoly),
                 "%d",&ival) == 1 ) {
         ival = iclamp(ival,MIN_NPOLY,MAX_NPOLY,PP->marker_npoly);
      } else {
         ival = PP->marker_npoly;
      }
      PP->marker_npoly = ival;
      sprintf(B,"%d",ival);
      fl_set_input(Xvsf_markers->input_markers_npoly,B);
      break;
   case CB_MARKERS_MULTI_MODE:
      PP->marker_multi_mode = 
         fl_get_choice(Xvsf_markers->choice_markers_multi_mode) - 1;
      break;
   case CB_MARKERS_APPLY_ALL:
      if( ltrace ) {
         fprintf(stderr,"%s: CB_MARKERS_APPLY_ALL\n",R);
         fprintf(stderr,"%s:    marker_type=%d\n",R,PP->marker_color);
         fprintf(stderr,"%s:    marker_color=%d\n",R,PP->marker_color);
         fprintf(stderr,"%s:    marker_size=%g\n",R,PP->marker_size);
         fprintf(stderr,"%s:    point_size=%d\n",R,PP->point_size);
         fprintf(stderr,"%s:    marker_npoly=%d\n",R,PP->marker_npoly);
         fprintf(stderr,"%s:    marker_multi_mode=%d\n",R,PP->marker_multi_mode);
         fprintf(stderr,"%s:    marker_line_auto_break=%d\n",
            R,PP->marker_line_auto_break);
         fprintf(stderr,"%s:    line_color=%d\n",R,PP->line_color);
         fprintf(stderr,"%s:    line_width=%d\n",R,PP->line_width);
      }
      apply_all_wt_1(set_marker_type,PP->marker_type);
      apply_all_wt_1(set_marker_color,PP->marker_color);
      apply_all_wt_1(set_line_color,PP->line_color);
      apply_all_wt_d(set_marker_size,PP->marker_size);
      apply_all_wt_1(set_point_size,PP->point_size);
      apply_all_wt_1(set_line_width,PP->line_width);
      apply_all_wt_1(set_marker_npoly,PP->marker_npoly);
      apply_all_wt_0((PFV_I) (PP->marker_multi_mode ? 
         set_marker_multi_mode : unset_marker_multi_mode));
      break;
   case CB_MARKERS_AUTO_TAG_BY_DX_ON:
   case CB_MARKERS_AUTO_TAG_BY_DX_OFF:
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }
   set_must_redraw(S_wt);
#undef  PP
}

int xvs_compute_control_form_posn(void) {
   int    mx, my, mw, mh;
   int    cx, cy, cw, ch;
   int    dw = 15, dh = 18, dwr = 7;

   mx = Xvsf->main->x; my = Xvsf->main->y; 
   mw = Xvsf->main->w; mh = Xvsf->main->h; 
   cx = Xvsf_control->control->x; cy = Xvsf_control->control->y; 
   cw = Xvsf_control->control->w; ch = Xvsf_control->control->h; 

/* Check for room to left of main form ... */
   if( mx >= (cw + dw) ) {
      fl_set_form_geometry(Xvsf_control->control,
         mx - (cw + dw),my-dh,cw,ch);
      return 1;
   }
/* Check for room to right of main form ... */
   if( (fl_scrw - (mx + mw + dw)) >= (cw + dw) ) {
      Xvsf_control->control->x = mx + mw + dw;
      Xvsf_control->control->y = my;
      fl_set_form_geometry(Xvsf_control->control,
         mx + mw + dw - dwr ,my - dh,cw,ch);
      return 1;
   }
   return 0;
}

/*=========================================================================
Updates widgets which might otherwise have been missed.
=========================================================================*/
void cb_control(FL_OBJECT *ob, long val) {
   widgets_set_all(S_wt);
}

/*=========================================================================
Control button callback
=========================================================================*/
void cb_button_control(FL_OBJECT *ob, long val) {
   if( fl_form_is_visible(Xvsf_control->control) ) {
      at_close_control(Xvsf_control->control, NULL);
   } else {
      form_do_control(FOLDER_PREVIOUS);
   }
}

void form_do_control(int val) {
   static char R[] = "form_do_control";
   int    ltrace = Ltrace; 

   if( ltrace ) {
      fprintf(stderr,"%s: In routine val=%d.\n",R,val);
      fprintf(stderr,"%s: Screen %d x %d\n",R,fl_scrw,fl_scrh);
      fprintf(stderr,"%s: Main form geometry: (%d,%d) %d x %d\n",
         R,Xvsf->main->x,Xvsf->main->y,Xvsf->main->w,Xvsf->main->h);
   }
   if( !Xvsf_control ) {
      fprintf(stderr,"%s: FATAL: Xvsf_control form has not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_control->control) ) {
      fl_raise_form(Xvsf_control->control);
      return;
   }

   if( is_active_wt(S_wt) ) set_must_redraw(S_wt);

   Form_state = FORM_STATE_CONTROL;
   switch( val ) {
   case FOLDER_OPS:
      fl_set_folder_byname(Xvsf_control->tabfolder_control,"Ops");
      break;
   case FOLDER_VIEW:
      fl_set_folder_byname(Xvsf_control->tabfolder_control,"View");
      break;
   case FOLDER_FILE:
      fl_set_folder_byname(Xvsf_control->tabfolder_control,"File");
      break;
   case FOLDER_MARKERS:
      fl_set_folder_byname(Xvsf_control->tabfolder_control,"Markers");
      break;
   case FOLDER_PREVIOUS:
      if( Control_folder_number_prev != UNDEF ) {
         fl_set_folder_bynumber(Xvsf_control->tabfolder_control,
            Control_folder_number_prev);
      } else {
         fl_set_folder_byname(Xvsf_control->tabfolder_control,"Ops");
      }
   default:
      break;
   }
   if( xvs_compute_control_form_posn() ) { 
      fl_show_form(Xvsf_control->control,FL_PLACE_SIZE,FL_FULLBORDER,
         "control");
   } else {
      fl_show_form(Xvsf_control->control,FL_PLACE_HOTSPOT,FL_FULLBORDER,
         "control");
   }
   fl_redraw_form(Xvsf_control->control);
   fl_set_mouse(Xvsf_control->control->x + Xvsf_control->control->w / 2,
                Xvsf_control->control->y + Xvsf_control->control->h / 2);

/* Update widgets in all panels */
   if( ltrace ) {
      fprintf(stderr,"%s: Calling widgets_set_all(%d)\n",R,S_wt);
   }
   Auto_wt = -1;
   widgets_set_all(S_wt);
}


/* This routine might benefit from some optimization; previously
   if( !wt ) {
      if( !cleared ) {
         widgets_clear_all();
         cleared = ON;
      }
      return;
   }
   cleared = OFF;
*/

/*=========================================================================
Raw callback for control-form
=========================================================================*/
int raw_cb_control(FL_FORM *form, void *xev_void) {
   int        shift, alt, ctrl;
   char      *keystring;
   XEvent    *xev = (XEvent *) xev_void;

   switch( xev->type ) {
   case KeyPress:
      fprintf(stderr,"raw_cb_control: Key pressed\n");
      shift     = fl_keysym_pressed(XK_Shift_L) || fl_keysym_pressed(XK_Shift_R);
      alt       = fl_keysym_pressed(XK_Alt_L) || fl_keysym_pressed(XK_Alt_R);
      ctrl      = fl_keysym_pressed(XK_Control_L) || fl_keysym_pressed(XK_Control_R);
      keystring = XKeysymToString(XKeycodeToKeysym(fl_display,xev->xkey.keycode,shift));
      if( !keystring ) break;
      if(        !strcmp(keystring,"space") ) {
         if( shift )  {
            Control_folder_close = 1;
         }
         return 0;
      }

      break;
   default:
      break;
   }
   return 0;
}

void widgets_set_all(WT wt) {
   static  WT  wt_prev = UNDEF;
   static  int cleared = OFF;
   int         ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"widgets_set_all: wt=%d\n",wt);

   if( wt == UNDEF ) wt = 0;

   if( !wt ) {
      widgets_clear_all();
   }

   if( wt != wt_prev ) {
      widgets_reset_all();
   }

/* Certain widget sets make sense in absence of data windows ... */
   widgets_set_main();

   widgets_set_file(wt);
   widgets_set_mpeg(wt);
   widgets_set_markers(wt);

   if( !is_active_wt(wt) ) return;

   widgets_set_view(wt);
   widgets_set_ops(wt);
   widgets_set_sm(wt);
   widgets_set_browse(wt);
   widgets_set_label(wt);

   wt_prev = wt;
}


void widgets_set_visible(WT wt) {
   int         ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"widgets_set_visible: wt=%d\n",wt);

   if( wt == UNDEF ) wt = 0;

/* Certain widget sets make sense in absence of data windows ... */
   if( fl_form_is_visible(Xvsf_file->file) ) widgets_set_file(wt);
   if( fl_form_is_visible(Xvsf_mpeg->mpeg) ) widgets_set_mpeg(wt);

   if( !is_active_wt(wt) ) return;

   if( fl_form_is_visible(Xvsf_view->view) ) widgets_set_view(wt);
   if( fl_form_is_visible(Xvsf_ops->ops) ) widgets_set_ops(wt);
   if( fl_form_is_visible(Xvsf_markers->markers) ) widgets_set_markers(wt);
   if( fl_form_is_visible(Xvsf_sm->sm) ) widgets_set_sm(wt);
   if( fl_form_is_visible(Xvsf_browse->browse) ) widgets_set_browse(wt);
   if( fl_form_is_visible(Xvsf_label->label) ) widgets_set_label(wt);
}

void form_do_markers(int val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
   static char R[] = "form_do_markers";
   static char B[BUFLEN];
   int    ltrace = OFF;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_markers ) {
      fprintf(stderr,"%s: FATAL: Xvsf_markers form has not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_markers->markers) ) return;

   Form_state = FORM_STATE_MARKERS;
   fl_show_form(Xvsf_markers->markers,FL_PLACE_HOTSPOT,FL_FULLBORDER,"markers");
   fl_redraw_form(Xvsf_markers->markers);

   if( ltrace ) {
      fprintf(stderr,"%s: In routine: S_wt=%d\n",R,S_wt);
      fprintf(stderr,"%s:    marker_type=%d\n",R,PP->marker_type);
      fprintf(stderr,"%s:    marker_color=%d\n",R,PP->marker_color);
      fprintf(stderr,"%s:    marker_size=%g\n",R,PP->marker_size);
      fprintf(stderr,"%s:    marker_npoly=%d\n",R,PP->marker_npoly);
      fprintf(stderr,"%s:    marker_multi_mode=%d\n",R,PP->marker_multi_mode);
      fprintf(stderr,"%s:    marker_line_auto_break=%d\n",
         R,PP->marker_line_auto_break);
      fprintf(stderr,"%s:    line_color=%d\n",R,PP->line_color);
      fprintf(stderr,"%s:    line_width=%d\n",R,PP->line_width);
   }

   widgets_set_markers(S_wt);
#undef  PP
}

void widgets_set_markers(WT wt) {
#define        PP    wds[wt].winf.pwf.pxywinf
   static char R[] = "widgets_set_markers";
   int         ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( ltrace ) fprintf(stderr,"%s: Auto_tag_by_dx=%d\n",R,Auto_tag_by_dx);
   if( is_active_wt(wt) ) {
      fl_set_choice(Xvsf_markers->choice_markers_color,PP->marker_color+1);
      fl_set_choice(Xvsf_markers->choice_markers_type,PP->marker_type);
      fl_set_choice(Xvsf_markers->choice_markers_line_color,PP->line_color+1);
      sprintf(B,"%g",PP->marker_size / DEFAULT_MARKER_SIZE);
      fl_set_input(Xvsf_markers->input_markers_marker_size,B);
      sprintf(B,"%d",PP->point_size);
      fl_set_input(Xvsf_markers->input_markers_point_size,B);
      sprintf(B,"%d",PP->line_width);
      fl_set_input(Xvsf_markers->input_markers_line_width,B);
      sprintf(B,"%d",PP->marker_npoly);
      fl_set_input(Xvsf_markers->input_markers_npoly,B);
      fl_set_choice(Xvsf_markers->choice_markers_multi_mode,
         PP->marker_multi_mode+1);
   }
   if( Auto_tag_by_dx ) {
      fl_set_button(Xvsf_markers->button_markers_auto_tag_by_dx_on,ON);
      fl_set_button(Xvsf_markers->button_markers_auto_tag_by_dx_off,OFF);
   } else {
      fl_set_button(Xvsf_markers->button_markers_auto_tag_by_dx_on,OFF);
      fl_set_button(Xvsf_markers->button_markers_auto_tag_by_dx_off,ON);
   }
#undef  PP
}

enum {
   CB_VIEW_NONE = 0,
   CB_VIEW_XMIN = 1,
   CB_VIEW_XMAX = 2,
   CB_VIEW_YMIN = 3,
   CB_VIEW_YMAX = 4,
   CB_VIEW_PUSH_DQ = 5,
   CB_VIEW_POP_DQ = 6,
   CB_VIEW_SET_DQ = 7,
   CB_VIEW_SET_AND_RESCALE_DQ = 8,
   CB_VIEW_RESCALE_DQ = 9,
   CB_VIEW_DOMAIN = 10,
   CB_VIEW_FULL_SCALE = 11,
   CB_VIEW_BORDER = 12,
   CB_VIEW_INDEX = 13,
   CB_VIEW_NAME = 14,
   CB_VIEW_CLIP = 15,
   CB_VIEW_ALL  = 16
};

/*=========================================================================
View form routines
=========================================================================*/
void form_do_view(int val) {
   static char R[] = "form_do_view"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_view ) {
      fprintf(stderr,"%s: FATAL: Xvsf_view form has not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_view->view) ) return;

   Form_state = FORM_STATE_VIEW;
   fl_show_form(Xvsf_view->view,FL_PLACE_HOTSPOT,FL_FULLBORDER,"view");   
   fl_redraw_form(Xvsf_view->view); 

   widgets_set_view(S_wt);
}

void widgets_set_view(WT wt) {
#define        PP    wds[wt].winf.pwf.pxywinf
#define        FP    wds[wt].pf.pxyf
#define        CO    wds[wt].pf.pxyf->dqc->dq
   int         index_max;
   int         index_curr;
   static char R[] = "widgets_set_view"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine is_active_wt(%d)=%d \n",R,wt,is_active_wt(wt));


   fl_set_button(Xvsf_view->button_view_all,All);
   if( !is_active_wt(wt) ) return;
   sprintf(B,"%.10g",CO.x1);
   fl_set_input(Xvsf_view->input_view_xmin,B);
   sprintf(B,"%.10g",CO.x2);
   fl_set_input(Xvsf_view->input_view_xmax,B);
   sprintf(B,"%.10g",CO.y1);
   fl_set_input(Xvsf_view->input_view_ymin,B);
   sprintf(B,"%.10g",CO.y2);
   fl_set_input(Xvsf_view->input_view_ymax,B);
   if( PP->domain_mode == FIXED_DOMAIN ) {
      fl_set_choice(Xvsf_view->choice_view_domain,1);
   } else {
      fl_set_choice(Xvsf_view->choice_view_domain,2);
   }
   if( PP->full_scale_mode == OFF ) {
      fl_set_choice(Xvsf_view->choice_view_full_scale,1);
   } else {
      fl_set_choice(Xvsf_view->choice_view_full_scale,2);
   }
   sprintf(B,"%d",get_display_index(wt));
   fl_set_input(Xvsf_view->input_view_index,B);
   fl_set_input(Xvsf_view->input_view_name,wds[wt].name);
   update_browser_view_stack(wt);
#undef         PP
#undef         FP
#undef         CO
}

void cb_view(FL_OBJECT *ob, long val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
#define        FP    wds[S_wt].pf.pxyf
#define        CO    wds[S_wt].pf.pxyf->dqc->dq

#define        PPWT  wds[p->wt].winf.pwf.pxywinf
#define        COWT  wds[p->wt].pf.pxyf->dqc->dq

   int     ltrace = Ltrace;
   static  char R[] = "cb_view";
   static  char B[BUFLEN];
   double  xmin,  xmax,  ymin,  ymax;
   double  oxmin,  oxmax,  oymin,  oymax;
   int     ival, index_max, index_curr;
   char   *new_name;
   PWTBIND p;

   if( val == CB_VIEW_ALL ) {
      set_All(fl_get_button(Xvsf_view->button_view_all));
   }

   if( !is_active_wt(S_wt) ) return;

   update_browser_view_stack(S_wt);

   oxmin = CO.x1; oxmax = CO.x2; oymin = CO.y1; oymax = CO.y2;
   if( ltrace ) {
      fprintf(stderr,"%s: In routine: S_wt=%d val=%d\n",R,S_wt,(int) val);
      fprintf(stderr,"%s: Current limits: [%g .. %g] [%g .. %g]\n",
         R,oxmin,oxmax,oymin,oymax);
   }

   switch( (int) val ) {
   case CB_VIEW_XMIN:
      if( sscanf(fl_get_input(Xvsf_view->input_view_xmin),
                 "%lf",&xmin) == 1 ) {
         if( xmin < CO.x2 ) {
            if( All ) {
               for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
                  set_xmin_xmax_wt(p->wt,xmin,-1);
                  set_ymin_ymax_wt(p->wt,COWT.y1,-1);
                  set_ymin_ymax_wt(p->wt,COWT.y2,1);
               }
            } else {
               set_xmin_xmax_wt(S_wt,xmin,-1);
               set_ymin_ymax_wt(S_wt,oymin,-1);
               set_ymin_ymax_wt(S_wt,oymax,1);
            }
         } else {
            sprintf(B,"X min must be <= X max");
            fl_set_focus_object(ob->form,ob);
            fl_set_input_cursorpos(ob,0,0);
            scope_mess_and_bell(B,1);
         }
      } 
      break;
   case CB_VIEW_XMAX:
      if( sscanf(fl_get_input(Xvsf_view->input_view_xmax),
                 "%lf",&xmax) == 1 ) {
         if( xmax > CO.x1 ) {
            if( All ) {
               for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
                  set_xmin_xmax_wt(p->wt,xmax,1);
                  set_ymin_ymax_wt(p->wt,COWT.y1,-1);
                  set_ymin_ymax_wt(p->wt,COWT.y2,1);
               }
            } else {
               set_xmin_xmax_wt(S_wt,xmax,1);
               set_ymin_ymax_wt(S_wt,oymin,-1);
               set_ymin_ymax_wt(S_wt,oymax,1);
            }
         } else {
            sprintf(B,"X max must be >= X min");
            scope_mess_and_bell(B,1);
         }
      } 
      break;
   case CB_VIEW_YMIN:
      if( sscanf(fl_get_input(Xvsf_view->input_view_ymin),
                 "%lf",&ymin) == 1 ) {
         if( ymin < CO.y2 ) {
            if( All ) {
               for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
                  PPWT->domain_mode = FIXED_DOMAIN;
                  PPWT->full_scale_mode = OFF;
                  set_ymin_ymax_wt(p->wt,ymin,-1);
               }
            } else {
               PP->domain_mode = FIXED_DOMAIN;
               PP->full_scale_mode = OFF;
               set_ymin_ymax_wt(S_wt,ymin,-1);
            }
         } else {
            sprintf(B,"Y min must be <= Y max");
            scope_mess_and_bell(B,1);
         }
      } 
      break;
   case CB_VIEW_YMAX:
      if( sscanf(fl_get_input(Xvsf_view->input_view_ymax),
                 "%lf",&ymax) == 1 ) {
         if( ymax > CO.y1 ) {
            if( All ) {
               for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
                  PPWT->domain_mode = FIXED_DOMAIN;
                  PPWT->full_scale_mode = OFF;
                  set_ymin_ymax_wt(p->wt,ymax,1);
               }
            } else {
               PP->domain_mode = FIXED_DOMAIN;
               PP->full_scale_mode = OFF;
               set_ymin_ymax_wt(S_wt,ymax,1);
            }
         } else {
            sprintf(B,"Y max must be >= Y min");
            scope_mess_and_bell(B,1);
         }
      } 
      break;
   case CB_VIEW_PUSH_DQ:
      handle_control_menu(CONTROL_PUSH_DQ);
      break;
   case CB_VIEW_POP_DQ:
      handle_control_menu(CONTROL_POP_DQ);
      break;
   case CB_VIEW_SET_DQ:
      handle_control_menu(CONTROL_SET_DQ);
      break;
   case CB_VIEW_SET_AND_RESCALE_DQ:
      handle_control_menu(CONTROL_SET_FULL_SCALE_DQ);
      break;
   case CB_VIEW_RESCALE_DQ:
      handle_control_menu(CONTROL_RESCALE);
      break;
   case CB_VIEW_CLIP:
      if( All ) {
         apply_all_wt_0((PFV_I) clip_wt);
      } else {
         clip_wt(S_wt);
      }
      break;
   case CB_VIEW_DOMAIN:
      ival = fl_get_choice(Xvsf_view->choice_view_domain);
      if( All ) {
         for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
            PPWT->domain_mode = (ival == 1) ? FIXED_DOMAIN : FLOATING_DOMAIN;
         }
      } else {
         PP->domain_mode = (ival == 1) ? FIXED_DOMAIN : FLOATING_DOMAIN;
      }
      break;
   case CB_VIEW_FULL_SCALE:
      ival = fl_get_choice(Xvsf_view->choice_view_full_scale);
      if( All ) {
         if( ival == 1 ) {
            apply_all_wt_0((PFV_I) unset_full_scale_mode);
         } else {
            apply_all_wt_0((PFV_I) set_full_scale_mode);
         }
      } else {
         if( ival == 1 ) {
            unset_full_scale_mode(S_wt);
         } else {
            set_full_scale_mode(S_wt);
         }
      }
      break;
   case CB_VIEW_BORDER:
      ival = fl_get_choice(Xvsf_view->choice_view_border); 
      switch( ival ) {
      case 1:
         handle_control_menu(CONTROL_RESCALE);
         break;
      case 2:
         if( All ) {
            apply_all_wt_0((PFV_I) auto_border_x_wt);
         } else {
            auto_border_x_wt(S_wt);
         }
         break;
      case 3:
         if( All ) {
            apply_all_wt_0((PFV_I) auto_border_xy_wt);
         } else {
            auto_border_xy_wt(S_wt);
         }
         break;
      default:
         break;
      } 
   case CB_VIEW_INDEX:

      index_max = n_XYDV(S_wt);
      index_curr = get_display_index(S_wt);
      if( sscanf(fl_get_input(Xvsf_view->input_view_index),
                 "%d",&ival) == 1 ) {
         if( 1 <= ival && ival <= index_max ) {
            if( control_apply_all_wt() ) {
               apply_all_wt_1((PFV_II) set_xycurr_nth, ival);
            } else {
               set_xycurr_nth(S_wt,ival);
         }
         } 
      } 
      break;
   case CB_VIEW_NAME:
      new_name = (char * ) fl_get_input(Xvsf_view->input_view_name);
      if( new_name && valid_name(new_name) && check_dup_name(S_wt,new_name) && 
          wds[S_wt].name ) {
         free(wds[S_wt].name); 
         wds[S_wt].name = strdup(new_name);
      }
      break;
   case CB_VIEW_ALL:
      set_All(fl_get_button(Xvsf_view->button_view_all));
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

   widgets_set_view(S_wt);
   set_must_redraw(S_wt);
#undef         PP
#undef         FP
#undef         CO
}

int valid_name(char *name) {
   if( name && (strspn((const char *) name," ") == strlen(name)) ) {
      return 0;
   } else {
      return 1;
   }
}

int valid_name_old(char *name) {
   static char valid[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_";
   char   schar;
   int    i, lenv = strlen(valid);
   if( !name ) return 0;
   if( !strlen(name)  ) return 0;
   for( i = 0; i < lenv; i++ ) {
      if( strchr(name,valid[i]) ) return 1;
   }
   return 0;
}

void update_browser_view_stack(WT wt) {
#define        PP    wds[wt].pf.pxyf
   static char R[] = "update_browser_view_stack";
   int         ltrace = Ltrace;
   PDQBIND     pwt;
   PDQBIND     p   = Dq_stack;

   pwt = PP->dqc;
   if( ltrace ) fprintf(stderr,"%s:  In routine\n",R);

// if( !fl_form_is_visible(Xvsf_view->view) ) return;  

   fl_freeze_form(Xvsf_view->browser_view_stack->form);
   fl_clear_browser(Xvsf_view->browser_view_stack); 

   if( is_active_wt(wt) ) {
/*    Print wt's current dquad in fixed, bold (order important) Color_dqc. */
      sprintf(F,"@f@b@C%d %s %s %s %s",Color_dqc,Fmt_dqc,Fmt_dqc,Fmt_dqc,Fmt_dqc);
      if( ltrace ) fprintf(stderr,"%s: 'Current fmt'='%s'\n",R,F);
      sprintf(B,F,pwt->dq.x1,pwt->dq.x2,pwt->dq.y1,pwt->dq.y2);
      fl_add_browser_line(Xvsf_view->browser_view_stack,B);

/*    Print the dq stack in fixed, normal, foreground */
      sprintf(F,"@f %s %s %s %s",Fmt_dqc,Fmt_dqc,Fmt_dqc,Fmt_dqc);
      while( p ) {
         if( ltrace ) fprintf(stderr,"%s: 'Current fmt'='%s'\n",R,F);
         sprintf(B,F,p->dq.x1, p->dq.x2, p->dq.y1, p->dq.y2);
         if( ltrace ) fprintf(stderr,"%s: Adding '%s' to browser\n",R,B);
         fl_add_browser_line(Xvsf_view->browser_view_stack,B);
         p = p->prev;
      }
   }
   fl_unfreeze_form(Xvsf_view->browser_view_stack->form);
#undef         PP
}

/*=========================================================================
Info browser callback. 
=========================================================================*/
void cb_browser_view_stack(FL_OBJECT *ob, long val) {
   fprintf(stderr,"cb_browser_view_stack:  In routine\n");
}

/*=========================================================================
Info browser callback. 
=========================================================================*/
void cb_browser_info(FL_OBJECT *ob, long val) {
   fprintf(stderr,"cb_browser_info:  In routine\n");
}

/*=========================================================================
Status window timer callback.
=========================================================================*/
void cb_timer_text_status(FL_OBJECT *ob, long val) {
   fl_set_object_label(Xvsf->text_status,"");
}

/*=========================================================================
Status window callback.
=========================================================================*/
void cb_input_status(FL_OBJECT *ob, long val) {
   char *input = (char *) fl_get_input(ob);

   fprintf(stderr,"cb_input_status: input='%s(%d)'\n",
         input ? input : "NULL",input ? strlen(input) : 0);
}

/*=========================================================================
Ignore WM_DELETE_WINDOW when closing status form.
=========================================================================*/
int at_close_status(FL_FORM *form, void *data) {
   int ltrace = OFF;
   if( ltrace ) fprintf(stderr,"at_close_status: In routine\n");
   fl_hide_form(form);
   return FL_IGNORE;
}

/*=========================================================================
File menu callback.
=========================================================================*/
enum {
   MENU_FILE_NONE,
   MENU_FILE_EXIT
};

void cb_button_exit(FL_OBJECT *ob, long val) {
   if( fl_show_question("Are you sure you want to exit?",1) ) {
      exit(1);
   }
}

/*=========================================================================
Miscellaneous menu callback.
=========================================================================*/
enum {
   MENU_MISC_NONE,
   MENU_MISC_SET_INSERT_FUZZ,
   MENU_MISC_RESET_INSERT_FUZZ,
   MENU_MISC_AMRD_SORT,
   MENU_MISC_CTRL_SPACE_KILLS_WINDOW,
   MENU_MISC_LTRACE,
   MENU_MISC_LTRACE_CB_GLCANVAS_MAIN,
   MENU_MISC_DUMP,
};

PFV_I l_set_auto_mode(WT wt) {
   wds[wt].winf.pwf.pxywinf->display_mode = AUTO_MODE;
   set_must_redraw(wt);
   return 0;
}

PFV_I l_set_freeze_mode(WT wt) {
   wds[wt].winf.pwf.pxywinf->display_mode = FREEZE_MODE;
   set_must_redraw(wt);
   return 0;
}

void cb_menu_misc(FL_OBJECT *ob, long val) {
   int  choice = fl_get_menu(ob);
   int  auto_mode;

   switch( choice ) { 
   case MENU_MISC_SET_INSERT_FUZZ:
      Insert_xy_fuzz = xvs_get_double("insert fuzz",Insert_xy_fuzz);
      sprintf(O_buf,"Insert fuzz: %g",Insert_xy_fuzz);
      scope_mess_and_bell(O_buf,2);
      break;
   case MENU_MISC_RESET_INSERT_FUZZ:
      Insert_xy_fuzz = DEFAULT_INSERT_XY_FUZZ;
      sprintf(O_buf,"Insert fuzz: %g",Insert_xy_fuzz);
      scope_mess_and_bell(O_buf,2);
      break;
   case MENU_MISC_AMRD_SORT:
      Auto_pamr_sort = 
         fl_get_menu_item_mode(ob,MENU_MISC_AMRD_SORT) == FL_PUP_CHECKED;
      break;
   case MENU_MISC_CTRL_SPACE_KILLS_WINDOW:
      Ctrl_space_kill = 
         fl_get_menu_item_mode(ob,MENU_MISC_CTRL_SPACE_KILLS_WINDOW) == FL_PUP_CHECKED;
      break;
   case MENU_MISC_LTRACE:
      Ltrace = fl_get_menu_item_mode(ob,MENU_MISC_LTRACE) ==
         FL_PUP_CHECKED;
      if( Ltrace ) fprintf(stderr,"cb_menu_options: Ltrace %s checked\n",
         Ltrace ? "is" : "is not");
      break;   
   case MENU_MISC_LTRACE_CB_GLCANVAS_MAIN:
      Ltrace_cb_glcanvas_main = fl_get_menu_item_mode(ob,MENU_MISC_LTRACE_CB_GLCANVAS_MAIN) ==
         FL_PUP_CHECKED;
      if( Ltrace ) fprintf(stderr,"cb_menu_options: Ltrace_cb_glcanvas_main %s checked\n",
            Ltrace_cb_glcanvas_main ? "is" : "is not");
      break;   
   case MENU_MISC_DUMP:
      xvs_dump("cb_menu_misc: choice=MENU_MISC_DUMP");
      break;
   default:
      fprintf(stderr,"cb_menu_misc: Unexpected menu selection: %d\n",choice);
      break;
   }
}

/*=========================================================================
Help menu callback.
=========================================================================*/
void cb_button_help(FL_OBJECT *ob, long val) {
   xvs_help_www();
}

void xvs_resize_main_form(int new_w, int new_h, int opcode) {
   static  char R[] = "xvs_resize_main_form";
   int     ltrace = Ltrace;
   static  int prev_w = UNDEF, prev_h = UNDEF;

   if( ltrace ) {
      fprintf(stderr,"%s: new_w=%d new_h=%d opcode=%d Pnl=%d\n",
         R,new_w,new_h,opcode,Pnl);
   }
   switch( opcode ) {
   case RESIZE_SET:
      prev_w = Xvsf->main->w;
      prev_h = Xvsf->main->h;
      if( ltrace ) {
         fprintf(stderr,"%s: RESIZE_SET prev_w=%d prev_h=%d\n",
            R,prev_w,prev_h);
      }
      fl_set_form_geometry(Xvsf->main,Xvsf->main->x,Xvsf->main->y,
         new_w,new_h);
      break;
   case RESIZE_SET_DELTAS:
      prev_w = Xvsf->main->w;
      prev_h = Xvsf->main->h;
      if( ltrace ) {
         fprintf(stderr,"%s: RESIZE_DELTAS prev_w=%d prev_h=%d\n",
            R,prev_w,prev_h);
      }
      if( !new_w  && !new_h ) goto Return;
      fl_set_form_geometry(Xvsf->main,Xvsf->main->x,Xvsf->main->y,
         Xvsf->main->w+new_w,Xvsf->main->h+new_h);
      break;
   case RESIZE_RESTORE:
      if( prev_w > 0 && prev_h > 0 ) {
         if( ltrace ) {
            fprintf(stderr,"%s: RESIZE_RESTORE prev_w=%d prev_h=%d\n",
               R,prev_w,prev_h);
         }
         fl_set_form_geometry(Xvsf->main,Xvsf->main->x,Xvsf->main->y,
            prev_w,prev_h);
      }
      break;
   case RESIZE_NOOP:
      break;
   default:
      fprintf(stderr,"%s: opcode=%d unimplmented\n",R,opcode);
      break;
   }

   if(         Dform_opt == DFORM_UP ) {
      mfl_adjust_main_geom_up();
   } else if ( Dform_opt == DFORM_DOWN ) {
      mfl_adjust_main_geom_down();
   }
   if( Pnl < 0 ) {
      mfl_resize_gl_panels(get_dpy_obdr(),get_dpy_ibdr());
      mfl_resize_main_form();
   } else {
      mfl_resize_gl_panels(get_dpy_obdr(),get_dpy_ibdr());
      mfl_resize_main_form();
      xvs_resense();
      fl_redraw_form(Xvsf->main);
      apply_all_wt_0((PFV_I) set_must_remap);
      apply_all_wt_0((PFV_I) set_must_redraw);
   }
   widgets_set_all(S_wt);


Return:
   Form_size_state = FORM_SIZE_STATE_NORMAL;

   if( ltrace ){
      fprintf(stderr,"%s: Exiting routine\n",R);
   }
}

/*=========================================================================
Idle callback.
=========================================================================*/
int cb_idle(XEvent *ev, void *data) {
   static char R[] = "cb_idle";
   int        fl_rc;
   static int n_cb_idle = 0;
   static int freq_cb_idle = 100;
   int        form_pos_changed, form_size_changed, left_mouse_down;
   int        ltrace = 0;
   int        new_w, new_h;
   static int cleared = OFF;

   igeom      geom_dpy;

   int        i;


   n_cb_idle++;

   if( ltrace && freq_cb_idle && !(n_cb_idle % freq_cb_idle) ) {
      fprintf(stderr,"cb_idle: In routine %d\n",n_cb_idle);
      fprintf(stderr,"   Form_state=%d\n",Form_state);
      fprintf(stderr,"   Menu_deferred=%d\n",Menu_deferred);
      fprintf(stderr,"   Menu_picking=%d\n",Menu_picking);
      fprintf(stderr,"   Active window=%d\n",S_wt);
      fprintf(stderr,"   Mouse %s in active window\n",
         is_mouse_in_wt(S_wt) ? "is" : "is not");
      fprintf(stderr,"   Xvs window %s focus\n",
         xvs_has_focus() ? "has" : "does not have");
      sleep(1);
   }

/*-------------------------------------------------------------------------
   Handle I/O on connections via poll.
-------------------------------------------------------------------------*/
// xvs_poll_connections();
/*-------------------------------------------------------------------------
   Return immediately if handling pop up or if xvs does not have focus
-------------------------------------------------------------------------*/
   if( In_pup ) return -1;

/* Capture current form geometry ... */

   Xvsf_geom_curr.x = Xvsf->main->x;
   Xvsf_geom_curr.y = Xvsf->main->y;
   Xvsf_geom_curr.w = Xvsf->main->w;
   Xvsf_geom_curr.h = Xvsf->main->h;  

/* Check for form motion ... */

   form_pos_changed = (n_cb_idle > 1) &&
                      (Xvsf_geom_curr.x != Xvsf_geom_prev.x) ||
                      (Xvsf_geom_curr.y != Xvsf_geom_prev.y);
   switch( Form_motion_state ) {
   case FORM_MOTION_STATE_NORMAL:
      if( form_pos_changed ) Form_motion_state = FORM_MOTION_STATE_MOVING;
      break;
   case FORM_MOTION_STATE_MOVING:
      if( !mfl_mouse_any(fl_root) ) {
         if( ltrace ) fprintf(stderr,"cb_idle: Main form has moved\n");
         Form_motion_state = FORM_MOTION_STATE_NORMAL;
         apply_all_wt_0((PFV_I) set_must_remap);
         apply_all_wt_0((PFV_I) set_must_redraw);
      }
      break;
   default:
      break;
   }

/* Check for form size change  ... */

   form_size_changed = (n_cb_idle > 1) &&
                       (Xvsf_geom_curr.w != Xvsf_geom_prev.w) ||
                       (Xvsf_geom_curr.h != Xvsf_geom_prev.h); 

   switch( Form_size_state ) {
   case FORM_SIZE_STATE_NORMAL:
      if( form_size_changed ) Form_size_state =  FORM_SIZE_STATE_RESIZING;
      break;
   case FORM_SIZE_STATE_RESIZING:
      if( !mfl_mouse_any(fl_root) ) {
         geom_dpy = mfl_get_dpy_geom();
         if( ltrace ) {
            fprintf(stderr,"cb_idle: Main form has resized.\n");
            fprintf(stderr,"cb_idle: New display geometry: (%d,%d) %d x %d\n",
               geom_dpy.x,geom_dpy.y,geom_dpy.w,geom_dpy.h);
               dump_Xvsf(Ixvsf,"cb_idle: Original");
               dump_Xvsf(Xvsf,"cb_idle: Current");
         }
         xvs_resize_main_form(0,0,RESIZE_NOOP);
      }
      break;
   case FORM_SIZE_STATE_UP:
      if( ltrace ) {
         fprintf(stderr,"%s: Would increase form size by %d pixels\n",R,Dform_size);
      }
      new_w = Xvsf->main->w + Dform_size;
      new_h = Xvsf->main->h + Dform_size;
      xvs_resize_main_form(new_w,new_h,RESIZE_SET);
      break;
   case FORM_SIZE_STATE_DOWN:
      if( ltrace ) {
         fprintf(stderr,"%s: Would decrease form size by %d pixels\n",R,Dform_size);
      }
      new_w = Xvsf->main->w - Dform_size;
      new_h = Xvsf->main->h - Dform_size;
      if( (new_w >= Ixvsf->main->w) && (new_h >= Ixvsf->main->h) ) {
         xvs_resize_main_form(new_w,new_h,RESIZE_SET);
      } else {
         scope_mess_and_bell("Can't shrink GUI further.",2);
         Form_size_state = FORM_SIZE_STATE_NORMAL;
      }
      break;
   case FORM_SIZE_STATE_ORIG:
      xvs_resize_main_form(Ixvsf->main->w,Ixvsf->main->h,RESIZE_SET);
      break;
   default:
      break;
   }

   igeom_cpy(&Xvsf_geom_prev,&Xvsf_geom_curr);

   switch( Form_state ) {
   case FORM_STATE_NORMAL:
      activate_window_with_mouse();
/* Update mouse position ... */
//    cb_text_mouse_pos(Xvsf->text_mouse_pos,0);
      break;
   case FORM_STATE_PICKING:
   case FORM_STATE_MPICKING:
      activate_window_with_mouse();
//    cb_text_mouse_pos(Xvsf->text_mouse_pos,0);
      break;
   case FORM_STATE_PICKED:
   case FORM_STATE_MPICKED:
      if( Menu_picking ) {
         Menu_picking = MENU_PICKING_OFF;
      }
      if( fl_form_is_visible(Xvsf_control->control) ) {
         Form_state = FORM_STATE_CONTROL;
      } else {
         Form_state = FORM_STATE_NORMAL;
      }
      break;
   case FORM_STATE_CONTROL:
      if( !n_windows() ) {
         if( !cleared ) {
            widgets_set_all(0);
            cleared = ON;
         }
      } else {
         cleared = OFF;
      }
/*    Analogous code is also in activate_window_with_mouse ... */
      if( wt_from_mouse() == S_wt ) {
         cb_text_mouse_pos(Xvsf->text_mouse_pos,0);
         left_mouse_down = left_mouse_down_in_wt(S_wt);
         if( left_mouse_down ) {
            switch( get_display_mode(S_wt) ) {
            case FREEZE_MODE:
               set_must_redraw(S_wt);
               break;
            default:
               break;
            }
         }
      } else {
         fl_set_object_label(Xvsf->text_mouse_pos,"");
      }  
      break;
   case FORM_STATE_SPLITTING:
      if( ltrace ) {
         fprintf(stderr,"%s: Form_state=FORM_STATE_SPLITTING\n",R);
      }
      break;
   case FORM_STATE_MPEG_PENDING:
      if( !(xvs_get_wt_w(Mpeg_wt) % 16) && 
           Form_size_state == FORM_SIZE_STATE_NORMAL ) {
         Form_state = FORM_STATE_MPEG_RECORDING;
         set_xycurr_nth(Mpeg_wt,1);
         fprintf(stderr,"%s: Set Mpeg_wt=%d display index to 1\n",R,Mpeg_wt);
         set_auto_mode(AUTO_MENU_FORWARD);
      }
      break;
   default:
      break;
   }

   if( Menu_deferred && !Menu_picking ) {
      handle_menu_deferred();
      Menu_deferred = MENU_DEFERRED_OFF;
      Menu_deferred_wt = -1;
   }

   for( i = 0; i < Ndisplay; i++ ) {
      (void)  process_wtal_PRE(lalhead->wtl); 
      (void)  process_wtal_POST(lalhead->wtl);
   }

   return 0;
}

/*=========================================================================
Handles deferred menu-initiated actions.
=========================================================================*/
void handle_menu_deferred(void) {
   int    ltrace = Ltrace;
   static char R[] = "handle_menu_deferred";
   int    mouse_state;

/* Must set Menu_deferred = MENU_DEFERRED_OFF before invoking any deferred
   handlers which do interaction ... */

   if( Menu_deferred ) {
      switch( Menu_deferred ) {
      case MENU_DEFERRED_APPLY1_MENU_GENERIC0:
         Menu_deferred = MENU_DEFERRED_OFF;
         if( ltrace ) {
            fprintf(stderr,"%s: Handling MENU_DEFERRED_APPLY1_MENU_GENERIC0\n",R);
         }
         (void) deferred_apply1_menu_generic0(NULL,0,1);
         if( ltrace ) {
            fprintf(stderr,"%s: is_active_wt(save_S_wt=%d)=%d.\n",R,save_S_wt,
                  is_active_wt(save_S_wt));
         }
         if( is_active_wt(save_S_wt) ) {
            mouse_state = Force_centre_mouse_in_wt;
            Force_centre_mouse_in_wt = ON;
            centre_mouse_in_wt(save_S_wt);
            Force_centre_mouse_in_wt = mouse_state;
         }
         break;
      case MENU_DEFERRED_APPLY2:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_apply2_menu_1(0,1);
         break;
      case MENU_DEFERRED_APPLY3:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_apply3_menu_1(0,1);
         break;
      case MENU_DEFERRED_APPLY4:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_apply4_menu_1(0,1);
         break;
      case MENU_DEFERRED_APPLY6:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_apply6_menu_1(0,1);
         break;
      case MENU_DEFERRED_APPLYN:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_applyn_menu_1(0,1);
         break;
      case MENU_DEFERRED_TAG:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_tag_fcn_menu_1(0,1);
         break;
      case MENU_DEFERRED_REDUCE:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_reduce_menu_1(0,1);
         break;
      case MENU_DEFERRED_COMPARE:
         handle_compare_menu_1(0,1);
         break;
      case MENU_DEFERRED_MOVE:
         move_window_1(1);
         break;
      case MENU_DEFERRED_KILL:
         kill_window_1(1);
         break;
      case MENU_DEFERRED_SET_INDEX:
         Menu_deferred = MENU_DEFERRED_OFF;
         set_display_index_wt_1(0,1);
         break;
      case MENU_DEFERRED_RENAME:
         Menu_deferred = MENU_DEFERRED_OFF;
         rename_wt_1(0,1);
         break;
      case MENU_DEFERRED_SM:
         Menu_deferred = MENU_DEFERRED_OFF;
         handle_sm_menu_1(0,1);
         break;
      default:
         break;
      }
/*    Rebuild main menu ... */
      make_main_menu();
   }
}

/*=========================================================================
Mouse utilities ....
=========================================================================*/

/* Not used ... */

int is_mouse_in_form(FL_FORM *the) {
      Window   win;
      FL_Coord mouse_x,  mouse_y;
      unsigned mouse_mask;
      int      ltrace = Ltrace;

      if( !the || !fl_form_is_visible(the) ) return 0;

      fl_get_win_mouse(the->window,&mouse_x,&mouse_y,&mouse_mask);
/*    Convert to absolute coords. */
      mouse_x += the->x;
      mouse_y += the->y;
      if( ltrace ) {
         fprintf(stderr,"is_mouse_in_form: Window=[%d .(%d). %d , %d .(%d). %d]\n",
            the->x,mouse_x,the->x+the->w,the->y,mouse_y,the->y+the->h);
      }
      return the->x <= mouse_x && mouse_x <= the->x + the->w &&
             the->y <= mouse_y && mouse_y <= the->y + the->h;
}

/*=========================================================================
Determines whether mouse is in gl canvas window.
=========================================================================*/
int is_mouse_in_glcanvas(FL_OBJECT *gl) {
   Window   win;
   FL_Coord mouse_x,  mouse_y;
   unsigned mouse_mask;
   int      ltrace = 0;

   if( !gl ) return 0;

   win = fl_get_real_object_window(gl);
   fl_get_win_mouse(win,&mouse_x,&mouse_y,&mouse_mask);
#ifndef XFORMS_OPEN
   if( ltrace ) {
      fprintf(stderr,"is_mouse_in_glcanvas: gl geometry: (%d,%d) %d x %d\n",
         gl->x,gl->y,gl->w,gl->h);
      fprintf(stderr,"is_mouse_in_glcanvas: Mouse is at (%d,%d)\n",
         mouse_x,mouse_y);
   }
   return (0 <= (mouse_x - gl->x))  && ((mouse_x - gl->x) <= (gl->w - 1))  &&
          (0 <= (mouse_y - gl->y))  && ((mouse_y - gl->y) <= (gl->h - 1));
#else
   if( ltrace ) {
      fprintf(stderr,"is_mouse_in_glcanvas: gl geometry: (%d,%d) %d x %d\n",
         gl->x,gl->y,gl->w,gl->h);
      fprintf(stderr,"is_mouse_in_glcanvas: Mouse is at (%d,%d)\n",
         mouse_x,mouse_y);
   }
   return (0 <= mouse_x  &&  mouse_x <= (gl->w - 1))  &&
          (0 <= mouse_y  &&  mouse_y <= (gl->h - 1));
#endif
}

int is_mouse_in_wt(WT wt) {
   return is_mouse_in_glcanvas(gl_from_wt(wt));
}

int left_mouse_down_in_wt(WT wt) {
   return is_mouse_in_wt(wt) && left_mouse_down_in_glcanvas(gl_from_wt(wt));
}

int middle_mouse_down_in_wt(WT wt) {
   return is_mouse_in_wt(wt) && middle_mouse_down_in_glcanvas(gl_from_wt(wt));
}

int right_mouse_down_in_wt(WT wt) {
   return is_mouse_in_wt(wt) && right_mouse_down_in_glcanvas(gl_from_wt(wt));
}

void xymouse_wt(WT wt, FL_Coord *pmouse_x, FL_Coord *pmouse_y) {
   xymouse_gl(gl_from_wt(wt),pmouse_x,pmouse_y);
}

void xymouse_gl(FL_OBJECT *gl, FL_Coord *pmouse_x, FL_Coord *pmouse_y) {
   static char R[] = "xymouse_gl";
   Window      win;
   unsigned    mouse_mask;
   int         ltrace = 0;
   int         rval;

   if( !gl ) return;

   win = fl_get_real_object_window(gl);
   fl_get_win_mouse(win,pmouse_x,pmouse_y,&mouse_mask);
   if( ltrace ) {
      fprintf(stderr,"%s: Mouse position=(%d,%d)\n",R,*pmouse_x,*pmouse_y);
   }
}

int left_mouse_down_in_glcanvas(FL_OBJECT *gl) {
   static char R[] = "left_mouse_down_in_glcanvas";
   Window      win;
   FL_Coord    mouse_x,  mouse_y;
   unsigned    mouse_mask;
   int         ltrace = Ltrace;
   int         rval;

   if( !gl ) return 0;

   win = fl_get_real_object_window(gl);
   fl_get_win_mouse(win,&mouse_x,&mouse_y,&mouse_mask);
   rval = (mouse_mask) & Button1Mask;
   if( ltrace ) {
      fprintf(stderr,"%s: %s button is %s.\n",R,"left",rval ? "down" : "up");
   }
   return rval;
}

int middle_mouse_down_in_glcanvas(FL_OBJECT *gl) {
   static char R[] = "middle_mouse_down_in_glcanvas";
   Window      win;
   FL_Coord    mouse_x,  mouse_y;
   unsigned    mouse_mask;
   int         ltrace = Ltrace;
   int         rval;

   if( !gl ) return 0;

   win = fl_get_real_object_window(gl);
   fl_get_win_mouse(win,&mouse_x,&mouse_y,&mouse_mask);
   rval = (mouse_mask) & Button2Mask;
   if( ltrace ) {
      fprintf(stderr,"%s: %s button is %s.\n",R,"middle",rval ? "down" : "up");
   }
   return rval;
}
int right_mouse_down_in_glcanvas(FL_OBJECT *gl) {
   static char R[] = "right_mouse_down_in_glcanvas";
   Window      win;
   FL_Coord    mouse_x,  mouse_y;
   unsigned    mouse_mask;
   int         ltrace = Ltrace;
   int         rval;

   if( !gl ) return 0;

   win = fl_get_real_object_window(gl);
   fl_get_win_mouse(win,&mouse_x,&mouse_y,&mouse_mask);
   rval = (mouse_mask) & Button2Mask;
   if( ltrace ) {
      fprintf(stderr,"%s: %s button is %s.\n",R,"right",rval ? "down" : "up");
   }
   return rval;
}

#define    DQ   (wds[wt].pf.pxyf->dqc)->dq
#define    IQ   wds[wt].winf.wiq

double xmouse_w_wt(WT wt) {
   double       xmouse, ymouse;

   xymouse_w_wt(wt,&xmouse,&ymouse);
   return xmouse;
}

double ymouse_w_wt(WT wt) {
   int           ltrace = Ltrace;

   double        xmouse, ymouse;

   xymouse_w_wt(wt,&xmouse,&ymouse); 
   return ymouse;
}

void xymouse_w_wt(WT wt, double *px, double *py) {
   static char R[] = "xymouse_w_wt";
   int          ltrace = OFF;
   FL_Coord     xmouse, ymouse;
   double       w, h;
   unsigned int keymask;

   if( is_active_wt(wt) ) {
      fl_get_win_mouse(Xvsf->main->window,&xmouse,&ymouse,&keymask);
#ifndef XFORMS_OPEN
      xmouse -= IQ.x1;
      ymouse -= IQ.y1;
#endif
      w = (double) (IQ.x2 - IQ.x1);
      h = (double) (IQ.y2 - IQ.y1);
      *px = DQ.x1 + ((double) xmouse / w) * (DQ.x2 - DQ.x1);
      *py = DQ.y2 - ((double) ymouse / h) * (DQ.y2 - DQ.y1);
      if( ltrace ) {
         fprintf(stderr,"%s: wt=%d  mouse=(%d,%d)  geometry=(%d,%d) %d x %d\n",
               R,wt,xmouse,ymouse,IQ.x1,IQ.y1,IQ.x2,IQ.y2);
         fprintf(stderr,"%s: xmin=%lf xmouse=%lf xmax=%lf\n",R,DQ.x1,*px,DQ.x2);
         fprintf(stderr,"%s: ymin=%lf ymouse=%lf ymax=%lf\n",R,DQ.y1,*py,DQ.y2);
      }
   }
}

#undef     DQ
#undef     IQ

void dump_xymouse_w_wt(WT wt) {
   double         x,       y;
   x = xmouse_w_wt(wt); y = ymouse_w_wt(wt);
   printf(       "%g      %g\n",x,y);
   sprintf(O_buf,"%g      %g\n",x,y);
   scope_mess(O_buf,1);
}

/*=========================================================================
Main canvas handler.
=========================================================================*/
int cb_glcanvas_main(FL_OBJECT *ob, Window win, int w, int h, 
                  XEvent *xev, void *gl_void) {

   static char  R[] = "cb_glcanvas_main";

   static int   expect_EnterNotify = 0;

   int          ltrace = Ltrace_cb_glcanvas_main;

   FL_OBJECT   *gl = (FL_OBJECT *) gl_void;
   WT           wt;
   int          shift, alt, ctrl;
   int          iwin;
   int          w_str,  h_str,  direction,  dc, f_ascent, f_descent;
   int          button;
   FL_Coord     mouse_x, mouse_y;
   XColor       blue, white, red, yellow, cyan, magenta, green, exact;
   unsigned     long valuemask;
   unsigned     int mouse_mask;
   XGCValues    values;
   char        *keystring;
   char        *newstring;

   XdbeBackBuffer  back;
   Status          status;

   int       s; 

   int       rc = 1, i;

   GC        gc;

   XVisualInfo  *vi;

   static int first = 1;


   if( first ) {
      if( gl == Xvsf->gl_main ) {
         if( ltrace ) {
            fprintf(stderr,
               "cb_glcanvas_main: Initializing font dl's using gl_main.\n");
         }
         (void) xvs_set_font(NULL,240);
      } else {
         fprintf(stderr,
            "cb_glcanvas_main: FATAL:  First call should be for gl_main.\n");
         exit(1);
      }
      first = 0;
      XUnmapWindow(fl_display,FL_ObjWin(gl));
      return 0;
   }
   if(  gl == Xvsf->gl_main ) {
      if( ltrace ) {
         fprintf(stderr,"cb_glcanvas_main: gl_main detected.\n");
         fprintf(stderr,"cb_glcanvas_main: Returning immediately.\n");
      }
      return 0;
   }


   vi = fl_get_glcanvas_xvisualinfo(gl);
   fl_activate_glcanvas(gl);
   wt = wt_from_gl(gl);

   if( wt < 0 ) {
      fprintf(stderr,"cb_glcanvas_main:: INFO: Could not find wt corresponding to gl\n");
      return 0;
   }

   if( Form_state == FORM_STATE_NORMAL ) {
      S_wt = wt;
   }

   if( Form_state == FORM_STATE_PICKING ) {
      if( scope_mode == SINGLE_MODE ) (void) scope_to_PANEL_MODE();
   }
   if( Form_state == FORM_STATE_MPICKING ) {
      if( scope_mode == SINGLE_MODE ) (void) scope_to_PANEL_MODE();
   }

   if( ltrace ) {
      fprintf(stderr,"\ncb_glcanvas_main: In routine\n");
      fprintf(stderr,"cb_glcanvas_main: xev->type=%d\n",xev->type);
      fprintf(stderr,"cb_glcanvas_main: visual depth: %d\n",vi->depth);
      fprintf(stderr,"cb_glcanvas_main: Window: %d  fl_winget(): %d Name: %s  XEvent: %s(%d)\n",
         (int) win, fl_winget(), gl->u_cdata, strXEvent(xev->type), xev->type);
      fprintf(stderr,"cb_glcanvas_main: Mouse %s in window\n",is_mouse_in_glcanvas(gl) ? "is" : "is not");
      fprintf(stderr,"cb_glcanvas_main: wt: %d\n",wt);
      fprintf(stderr,"cb_glcanvas_main: S_wt: %d\n",S_wt);
   }

   if( xev->type == EnterNotify && expect_EnterNotify ) {
      if( ltrace ) fprintf(stderr,"cb_glcanvas_main: Swallowed bogus LeaveNotify/EnterNotify pair\n");
      expect_EnterNotify = 0;
      goto Return;
   }
   if( xev->type == LeaveNotify && is_mouse_in_glcanvas(gl) ) {
      expect_EnterNotify = 1;
      if( ltrace ) fprintf(stderr,"cb_glcanvas_main: LeaveNotify detected while mouse is still in window\n");
      goto Return;
   } else {
      expect_EnterNotify = 0;
   }

#define NORMAL if( Form_state != FORM_STATE_NORMAL ) goto Return
   switch ( xev->type ) {
   case KeyPress:
      shift     = fl_keysym_pressed(XK_Shift_L) || fl_keysym_pressed(XK_Shift_R);
      alt       = fl_keysym_pressed(XK_Alt_L) || fl_keysym_pressed(XK_Alt_R);
      ctrl      = fl_keysym_pressed(XK_Control_L) || fl_keysym_pressed(XK_Control_R);

#ifdef DARWIN
      if( xev->xkey.keycode == 57 && shift ) {
         keystring = strdup("space");
      } else {
         keystring = XKeysymToString(XKeycodeToKeysym(fl_display,xev->xkey.keycode,shift));
      }
#else
      keystring = XKeysymToString(XKeycodeToKeysym(fl_display,xev->xkey.keycode,shift));
#endif

/*    Ignore those key-strokes that X doesn't know about (like the "Windows" key) ... */
      if( !keystring ) break;


      if( Ltrace ) {
         fprintf(stderr,"Keycode: %d\n",xev->xkey.keycode);
         fprintf(stderr,"KeySym: %d\n",(int) XKeycodeToKeysym(fl_display,xev->xkey.keycode,shift));
         fprintf(stderr,"String: '%s'\n",keystring ? keystring : "NULL");
         fprintf(stderr,"Shift %s pressed\n",shift ? "is" : "is not");
         fprintf(stderr,"Alt %s pressed\n",alt ? "is" : "is not");
         fprintf(stderr,"Ctrl %s pressed\n",ctrl ?  "is" : "is not");
      }

      if( strstr("0123456789",keystring) )  {
         if( Goto_string ) {
            newstring = (char *) malloc((strlen(Goto_string)+2)*sizeof(char));
            sprintf(newstring,"%s%s",Goto_string,keystring);
            free(Goto_string);
            Goto_string = newstring;
         } else {
            Goto_string = (char *) malloc(2 * sizeof(char));
            sprintf(Goto_string,"%s",keystring);
         }
         scope_mess_perm(Goto_string);
      } else if( !strcmp(keystring,"BackSpace") ||
                 !strcmp(keystring,"Delete") ||
                 !strcmp(keystring,"space") ) {
          if( Goto_string ) free(Goto_string);
         Goto_string = (char *) NULL;
         scope_mess_perm(" ");
      }


      if( ltrace ) {
         fprintf(stderr,"Into effective case statement\n");
      }

      if(        !strcmp(keystring,"A") ) {
         handle_AKEY();
      } else if( !strcmp(keystring,"B") ) {
         handle_BKEY();
      } else if( !strcmp(keystring,"C") ) {
         handle_CKEY();
      } else if( !strcmp(keystring,"D") ) {
         handle_DKEY();
      } else if( !strcmp(keystring,"E") ) {
         NORMAL;
         handle_EKEY();
      } else if( !strcmp(keystring,"F") ) {
         handle_FKEY();
      } else if( !strcmp(keystring,"G") ) {
         handle_GKEY();
      } else if( !strcmp(keystring,"K") ) {
         handle_KKEY();
      } else if( !strcmp(keystring,"L") ) {
         handle_LKEY();
      } else if( !strcmp(keystring,"M") ) {
         handle_MKEY();
      } else if( !strcmp(keystring,"N") ) {
         handle_NKEY();
      } else if( !strcmp(keystring,"O") ) {
         handle_OKEY();
      } else if( !strcmp(keystring,"P") ) {
         handle_PKEY();
      } else if( !strcmp(keystring,"Q") ) {
         handle_QKEY();
      } else if( !strcmp(keystring,"R") ) {
         handle_RKEY();
      } else if( !strcmp(keystring,"S") ) {
         handle_SKEY();
      } else if( !strcmp(keystring,"T") ) {
         handle_TKEY();
      } else if( !strcmp(keystring,"U") ) {
         qd_UKEY();
      } else if( !strcmp(keystring,"V") ) {
         handle_VKEY();
      } else if( !strcmp(keystring,"W") ) {
         handle_WKEY();
      } else if( !strcmp(keystring,"X") ) {
         NORMAL;
         handle_XKEY();
      } else if( !strcmp(keystring,"Y") ) {
         handle_YKEY();
      } else if( !strcmp(keystring,"Z") ) {
         handle_ZKEY();
      } else if( !strcmp(keystring,"space") ) {
         handle_SPACEKEY();
      } else if( !strcmp(keystring,"less") ) {
         handle_LESSKEY();
      } else if( !strcmp(keystring,"greater") ) {
         handle_GREATERKEY();
      } else if( !strcmp(keystring,"period") ) {
         handle_PERIODKEY();
      } else if( !strcmp(keystring,"comma") ) {
         handle_COMMAKEY();
      } else if( !strcmp(keystring,"quotedbl") ) {
         handle_QUOTEKEY();
      } else if( !strcmp(keystring,"Escape") ) {
         handle_ESCAPEKEY();
      } else if( !strcmp(keystring,"Insert") ) {
         NORMAL;
      } else if( !strcmp(keystring,"Delete") ) {
         NORMAL;
      } else if( !strcmp(keystring,"Right") ||
                 !strcmp(keystring,"KP_Right") ) {
         qd_RIGHTMOUSE();
      } else if( !strcmp(keystring,"Left") ||
                 !strcmp(keystring,"KP_Left") ) {
         qd_LEFTMOUSE();
      } else if( !strcmp(keystring,"Up") ) {
         NORMAL;
/*       qd_UPARROW(); */
      } else if( !strcmp(keystring,"Down") ) {
         NORMAL;
/*       qd_DOWNARROW();  */
      } else if( !strcmp(keystring,"F1") ) {
         handle_F1KEY();
      } else if( !strcmp(keystring,"F2") ) {
         handle_F2KEY();
      } else if( !strcmp(keystring,"Home") ||
                 !strcmp(keystring,"KP_Home") ) {
         handle_HOMEKEY();
      } else if( !strcmp(keystring,"End") ||
                 !strcmp(keystring,"KP_End") ) {
         handle_ENDKEY();
      } else if( !strcmp(keystring,"Prior") ||
                 !strcmp(keystring,"KP_Prior") ) {
         handle_PRIORKEY();
      } else if( !strcmp(keystring,"Next") ||
                 !strcmp(keystring,"KP_Next") ) {
         handle_NEXTKEY();
      } 
      break;

   case KeyRelease:
      if( !strcmp(gl->u_cdata,"Control") ) {
         fprintf(stderr,"Would render text in control window.\n");
         if( !(font_info = XLoadQueryFont(fl_display,font9x15)) ) {
            fprintf(stderr,"Cannot open '%s' font.\n",font9x15);
            rc = 0;
            goto Return;
         }
         gc = XCreateGC(fl_display,win,0,NULL);
         if( XAllocNamedColor(fl_display, fl_get_canvas_colormap(gl), "blue", &blue, &exact) ) {
            fprintf(stderr,"blue:  Pixel: %ld  Red: %d  Green: %d  Blue: %d\n",
               blue.pixel,(int) blue.red, (int) blue.green, (int) blue.blue);
         } else {
            fprintf(stderr,"Could not allocate 'blue'\n");
         }
         XSetForeground(fl_display,gc,blue.pixel);
         XSetFont(fl_display,gc,font_info->fid);
         XTextExtents(font_info,str,strlen(str),&direction,&f_ascent,&f_descent,&xcs);
         fprintf(stderr,"  font_ascent: %d  font_descent: %d  width: %d  ascent: %d  descent: %d\n",f_ascent,f_descent,
                 xcs.width,xcs.ascent,xcs.descent);
         w_str = xcs.width;
         h_str = xcs.ascent+xcs.descent;
/*
         XDrawString(fl_display,win,gc,(Ctl_gl_w - w_str)/2,(Ctl_gl_h + h_str)/2,str,strlen(str)); 
*/
      }
      
      break;

   case ButtonPress:
      (void) fl_get_win_mouse(win,&mouse_x,&mouse_y,&mouse_mask);
      button = xev->xbutton.button;
      if( Ltrace ) {
         fprintf(stderr,"  Mouse is at (%d,%d)\n",mouse_x,mouse_y);
         fprintf(stderr,"  Mouse button %d was pressed.\n",button);
      }
      switch( button ) {
      case 1:
         if( ltrace ) fprintf(stderr,"Left mouse button down. Calling qd_LEFTMOUSE()\n"); 
         qd_LEFTMOUSE();
         break;
      case 2:
         if( ltrace ) fprintf(stderr,"Middle mouse button down. Calling qd_MIDDLEMOUSE()\n"); 
         qd_MIDDLEMOUSE();
         break;
      case 3:
         if( ltrace ) fprintf(stderr,"Right mouse button down. Calling qd_RIGHTMOUSE()\n"); 
         qd_RIGHTMOUSE();
         break;
      case 4:
         if( ltrace ) fprintf(stderr,"Mouse roller forward. Calling qd_ROLL_FORWARD_MOUSE()\n"); 
         qd_ROLL_FORWARD_MOUSE();
         break;
      case 5:
         if( ltrace ) fprintf(stderr,"Mouse roller backward. Calling qd_ROLL_BACKWARD_MOUSE()\n"); 
         qd_ROLL_BACKWARD_MOUSE();
         break;
      default:
         fprintf(stderr,"%s: Unknown button=%d\n",R,button);
         break;
      }
      break;

   case ButtonRelease:
      (void) fl_get_win_mouse(win,&mouse_x,&mouse_y,&mouse_mask);
      button = xev->xbutton.button;
      switch( button ) {
      case 1:
         if( ltrace ) fprintf(stderr,"Left mouse button up.\n");
         Highlight_nearest = -1;
         set_must_redraw(wt);
         break;
      case 2:
         if( ltrace ) fprintf(stderr,"Middle mouse button up.\n");
         break;
      case 3:
         if( ltrace ) fprintf(stderr,"Right mouse button up.\n");
         break;
      case 4:
         break;
      case 5:
         break;
      default:
         fprintf(stderr,"%s: Unknown button=%d\n",R,button);
         break;
      }
      break;

   case MotionNotify:
      break;
   case EnterNotify:
      break;
   case LeaveNotify:
      set_must_redraw(wt);
      break;
   case FocusIn:
      break;
   case FocusOut:
      break;
   case Expose:
      set_must_redraw(wt);
      break;
   case GraphicsExpose:
      set_must_redraw(wt);
      break;
   case NoExpose:
      break;
   case VisibilityNotify:
      break;
   case CreateNotify:
      break;
   case DestroyNotify:
      break;
   case UnmapNotify:
      break;
   case MapNotify:
      break;
   case ResizeRequest:
      break;
   default:
      fprintf(stderr,"Unknown XEvent type %d\n",xev->type);
      break;
   }
Return:

   return rc;
}

/*========================================================================= 
Currently for testing purposes only. 
=========================================================================*/
void handle_YKEY(void) {
   char *s = (char *) NULL;
   
   return;
  
// GET_STRING(s,"handle_YKEY: Enter a string");
// display_XFonts();
// if( s ) free(s);
// pick_wt();
// s = get_string("Type in a number please");
// pick_wt_with_mess("Pick a window");
// mpick_wt(MPICK_START,-1);

   pick_prompts_init(6);
   pick_prompts_set("Pick window a");
   pick_prompts_set("Pick window b");
   pick_prompts_set("Pick window c");
   pick_prompts_set("Pick window d");
   pick_prompts_set("Pick window e");
   pick_prompts_set("Pick window f");
   mpick_wt(MPICK_START,6);

}

void pick_prompts_init(int n) {
   int  i;
   N_pick_prompts = n;
   if( n > 0 ) {
      if( Pick_prompts.n && Pick_prompts.v ) {
         for( i = 0; i < Pick_prompts.n; i++ ) {
            if( Pick_prompts.v[i] ) free(Pick_prompts.v[i]);
         }
      }
      Pick_prompts.n = 0;
      Pick_prompts.v = (char **) malloc(n * sizeof(char *));
   } else {
      fprintf(stderr,"pick_prompts_init: Invalid n=%d\n",n);
   }
}

void pick_prompts_set(char *s) {
   assert(s != NULL);
   assert(Pick_prompts.v != NULL);
   if( Pick_prompts.n == N_pick_prompts ) {
      fprintf(stderr,
         "pick_prompts_set: %d prompts already defined.\n",N_pick_prompts);
      fprintf(stderr,"pick_prompts_set: '%s' ignored.\n",s);
      return;
   }
   Pick_prompts.v[Pick_prompts.n] = strdup(s);
   ++Pick_prompts.n;
}


/*=========================================================================
Pops up marker form
=========================================================================*/
void handle_MKEY(void) {
   if( is_active_wt(S_wt) ) {
//    form_do_markers(0);
      form_do_control(FOLDER_MARKERS);
   }
}

/*=========================================================================
Initialize widgets.
=========================================================================*/
void Xvsf_widgets_init(void) {

   fl_set_menu_item_mode(Xvsf->menu_misc,MENU_MISC_CTRL_SPACE_KILLS_WINDOW,
      Ctrl_space_kill ? FL_PUP_CHECK : FL_PUP_BOX);
   fl_set_menu_item_mode(Xvsf->menu_misc,MENU_MISC_AMRD_SORT,
      Auto_pamr_sort ? FL_PUP_CHECK : FL_PUP_BOX);
   fl_set_menu_item_mode(Xvsf->menu_misc,MENU_MISC_CTRL_SPACE_KILLS_WINDOW,
      Ctrl_space_kill ? FL_PUP_CHECK : FL_PUP_BOX);
   fl_set_menu_item_mode(Xvsf->menu_misc,MENU_MISC_LTRACE,
      Ltrace ? FL_PUP_CHECK : FL_PUP_BOX);
   fl_set_menu_item_mode(Xvsf->menu_misc,MENU_MISC_LTRACE_CB_GLCANVAS_MAIN,
      Ltrace_cb_glcanvas_main ? FL_PUP_CHECK : FL_PUP_BOX);
   scope_mess("Welcome to xvs!",3);
}

/*=========================================================================
MPEG generation.
=========================================================================*/
void form_do_mpeg(int val) {
   static char R[] = "form_do_mpeg"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_mpeg ) {
      fprintf(stderr,"%s: FATAL: Form Xvsf_mpeg form not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_mpeg->mpeg) ) return;

   Form_state = FORM_STATE_VIEW;
   fl_show_form(Xvsf_mpeg->mpeg,FL_PLACE_HOTSPOT,FL_FULLBORDER,"mpeg");   
   fl_redraw_form(Xvsf_mpeg->mpeg); 

   widgets_set_mpeg(S_wt);
}

enum {
   CB_MPEG_NONE          = 0,
   CB_MPEG_NAME          = 1,
   CB_MPEG_RECORD        = 2,
   CB_MPEG_PLAYBACK      = 3,
   CB_MPEG_PLAYBACK_CMD  = 4,
   CB_MPEG_CWD           = 5,
   CB_MPEG_SIZE          = 6,
   CB_MPEG_CD_WIN        = 7,
   CB_MPEG_CSD           = 8,
};

void cb_mpeg(FL_OBJECT *ob, long val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
#define        FP    wds[S_wt].pf.pxyf
#define        CO    wds[S_wt].pf.pxyf->dqc->dq

   int    ltrace = Ltrace;
   static char R[] = "cb_mpeg";
   static char B[BUFLEN];
   int    ival;
   double dval;
   char  *dir, *name, *cmd, *size;
   int    w_xvs, w_mpeg, dw;

   if( ltrace ) fprintf(stderr,"%s: val=%d\n",R,val);
   switch( (int) val ) {
   case CB_MPEG_NAME:
      name = (char *) fl_get_input(Xvsf_mpeg->input_mpeg_mpeg_name);
      if( ltrace ) fprintf(stderr,"%s: case=CB_MPEG_NAME name=%s\n",
         R,name);
      if( Mpeg_name ) free(Mpeg_name);
      Mpeg_name = str2anu(name);
      if( !Mpeg_name && !strlen(Mpeg_name) ) {
         if( Mpeg_name ) free(Mpeg_name);
         Mpeg_name = str2anu(wds[S_wt].name);
      }
      break;
   case CB_MPEG_CWD:
      dir = (char *) fl_get_input(Xvsf_mpeg->input_mpeg_cwd);
      if( ltrace ) fprintf(stderr,"%s: case=CB_MPEG_CWD dir=%s\n",R,dir);
      if( is_dir(dir) ) {
         if( Mpeg_dir ) free(Mpeg_dir);
         Mpeg_dir = strdup(dir);
      } else {
         sprintf(B,"'%s' is not a directory",dir);
         scope_mess_and_bell(B,2);
      }
      break;
   case CB_MPEG_CD_WIN:
      if( wds[S_wt].wd ) {
         if( Mpeg_dir ) free(Mpeg_dir);
         Mpeg_dir = strdup(wds[S_wt].wd);
      }
      break;
   case CB_MPEG_CSD:
      dir = xvs_rd();
      if( is_dir(dir) ) {
         if( Mpeg_dir ) free(Mpeg_dir);
         Mpeg_dir = strdup(dir);
      } else {
         sprintf(B,"'%s' is not a directory",dir);
         scope_mess_and_bell(B,2);
      }
      if( dir ) free(dir);
      break;
   case CB_MPEG_RECORD:
      if( !xvs_push_wd_cd(Mpeg_dir) ) {
         sprintf(B,"Could not cd to '%s'",Mpeg_dir);
         scope_mess_and_bell(B,1);
         return;
      } 
      if( Mpeg_name ) {
         sprintf(B,"%s.mpg",Mpeg_name);
         if( Mpeg_fname ) free(Mpeg_fname);
         Mpeg_fname = strdup(B);
         if( file_exists(Mpeg_fname) ) {
            sprintf(B,"File '%s' already exists.  Overwrite?",Mpeg_fname);
            if( !fl_show_question(B,1) ) {
               scope_mess_and_bell("Mpeg generation cancelled.",2);
               free(Mpeg_fname); Mpeg_fname = (char *) NULL;
               goto Return;
            }
         }
      }
      if( is_active_wt(S_wt) ) {

/*       If necessary, enlarge form so that width of S_wt is a 
         multiple of 16 ... */

         w_xvs  = xvs_get_wt_w(S_wt);
         if( w_xvs % 16 ) {
            w_mpeg = ((w_xvs / 16) + 1) * 16;
         } else {
            w_mpeg = w_xvs;
         }
         if( ltrace ) {
            fprintf(stderr,"%s: Pnl=%d w_xvs=%d w_mpeg=%d\n",
               R,Pnl,w_xvs,w_mpeg);
         }
         dw = pnl_to_ncr(Pnl) * (w_mpeg - w_xvs);
         xvs_resize_main_form(dw,dw,RESIZE_SET_DELTAS);
         Mpeg_wt = S_wt;
         xvs_form_state_push(FORM_STATE_MPEG_PENDING);
      } else {
         scope_mess_and_bell("No data to record.",1);
         fprintf(stderr,"%s: S_wt=%d is not active\n",R,S_wt);
      }
      xvs_pop_wd();
      break;
   case CB_MPEG_SIZE:
      if( is_active_wt(S_wt) ) {
         w_xvs = xvs_get_wt_w(S_wt);
         size = (char *) fl_get_input(Xvsf_mpeg->input_mpeg_size);
         if( sscanf(size,"%d",&w_mpeg) != 1 ) goto Return;
         if( w_mpeg % 16 ) {
            w_mpeg = ((w_mpeg / 16) + 1) * 16;
         }
         dw = pnl_to_ncr(Pnl) * (w_mpeg - w_xvs);
         if( (Xvsf->main->w + dw) >= (Ixvsf->main->w) ) {
            xvs_resize_main_form(dw,dw,RESIZE_SET_DELTAS);
         } else {
            sprintf(B,"Requested size=%d shrinks GUI too much",w_mpeg);
            scope_mess_and_bell(B,2);
         }
      }
      break;
   case CB_MPEG_PLAYBACK:
      if( !xvs_push_wd_cd(Mpeg_dir) ) {
         sprintf(B,"Could not cd to '%s'",Mpeg_dir);
         scope_mess_and_bell(B,1);
         return;
      } 
      if( Mpeg_fname ) {
         if( !file_exists(Mpeg_fname) ) {
            sprintf(B,"File '%s' does not exist",Mpeg_fname);
            scope_mess_and_bell(B,1);
         } else {
            sprintf(B,Mpeg_playback_cmd,Mpeg_fname);
            sprintf(B1,"%s &",B);
            if( ltrace ) fprintf(stderr,"%s: Executing '%s'\n",R,B1);
            system(B1);
         }
      } else {
         scope_mess_and_bell("No mpeg file to playback.",1);
      }
      xvs_pop_wd();
      break;
   case CB_MPEG_PLAYBACK_CMD:
      cmd = (char *) fl_get_input(Xvsf_mpeg->input_mpeg_playback_cmd);
      if( ltrace ) fprintf(stderr,"%s: case=CB_MPEG_PLAYBACK_CMD cmd=%s\n",R,cmd);
      if( Mpeg_playback_cmd ) free(Mpeg_playback_cmd);
      Mpeg_playback_cmd = strdup(cmd);
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

Return:
   widgets_set_mpeg(S_wt);
   if( is_active_wt(S_wt) ) set_must_redraw(S_wt);
#undef         PP
#undef         FP
#undef         CO
}

void cb_browser_mpeg(FL_OBJECT *ob, long val) {
   fprintf(stderr,"cb_browser_mpeg: In routine val=%d\n",val);
}

void widgets_set_mpeg(WT wt) {
#define        PP    wds[wt].winf.pwf.pxywinf
#define        FP    wds[wt].pf.pxyf
#define        CO    wds[wt].pf.pxyf->dqc->dq
   int         index_max;
   int         index_curr;
   int         ltrace = Ltrace;

   if( wt == UNDEF ) wt = 0;

   if( !Mpeg_dir ) {
      Mpeg_dir = strdup(wds[wt].wd);
   }

   if( Mpeg_name ) free(Mpeg_name);
   Mpeg_name = str2anu(wds[wt].name);
   if( ltrace ) {
      fprintf(stderr,
         "widgets_set_mpeg: '%s' -> '%s'\n",wds[wt].name,Mpeg_name);
   }

   if( !Mpeg_playback_cmd ) {
      Mpeg_playback_cmd = strdup(Mpeg_def_playback_cmd);
   }
   fl_set_input(Xvsf_mpeg->input_mpeg_cwd,Mpeg_dir);
   fl_set_input(Xvsf_mpeg->input_mpeg_mpeg_name,Mpeg_name);
   fl_set_input(Xvsf_mpeg->input_mpeg_playback_cmd,Mpeg_playback_cmd);
   update_browser_mpeg(wt);
   if( is_active_wt(wt) ) {
      sprintf(B,"%d",xvs_get_wt_w(wt));
      fl_set_input(Xvsf_mpeg->input_mpeg_size,B);
   }
#undef         PP
#undef         FP
#undef         CO
}

int is_mpeg_file(struct direct *d) {
   return has_ext(d->d_name,".mpg")   || 
          has_ext(d->d_name,".MPG")   ||
          has_ext(d->d_name,".mpeg")  ||
          has_ext(d->d_name,".MPEG") 
     ;
}


/*=========================================================================
Memory leakage here; haven't figured out how to free storage allocated 
by scandir.
=========================================================================*/
void update_browser_mpeg(WT wt) {
   struct  dirent  **fnamelist = (struct dirent **) NULL;
   int     i, nfname;

   fl_freeze_form(Xvsf_mpeg->browser_mpeg->form);
   fl_clear_browser(Xvsf_mpeg->browser_mpeg); 
   if( !Mpeg_dir ) goto Return;
   if( !is_dir(Mpeg_dir) ) goto Return;
   nfname = scandir(Mpeg_dir,&fnamelist,is_mpeg_file,alphasort);
   if( nfname ) {
      for( i = 0; i < nfname; i++ ) {
         if( wt && Mpeg_fname && 
             !strcmp(Mpeg_fname,fnamelist[i]->d_name) &&
             Form_state != FORM_STATE_MPEG_PENDING    &&
             Form_state != FORM_STATE_MPEG_RECORDING  ) {
            sprintf(B,"@C1%s",fnamelist[i]->d_name);
         } else {
            sprintf(B,"%s",fnamelist[i]->d_name);
         }
         fl_add_browser_line(Xvsf_mpeg->browser_mpeg,B);
      }
   }
Return:
   fl_unfreeze_form(Xvsf_mpeg->browser_mpeg->form);
}

/*=========================================================================
SM generation.
=========================================================================*/
void form_do_sm(int val) {
   static char R[] = "form_do_sm"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_sm ) {
      fprintf(stderr,"%s: FATAL: Form Xvsf_sm form not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_sm->sm) ) return;

   Form_state = FORM_STATE_VIEW;
   fl_show_form(Xvsf_sm->sm,FL_PLACE_HOTSPOT,FL_FULLBORDER,"sm");   
   fl_redraw_form(Xvsf_sm->sm); 

   widgets_set_sm(S_wt);
}

enum {
   CB_SM_NONE            = 0,
   CB_SM_CWD             = 1,
   CB_SM_CSD             = 2,
   CB_SM_CD_DEFAULT      = 3,
   CB_SM_GENERATE        = 4,
   CB_SM_GENERATE_PS_LPR = 5,
   CB_SM_REFRESH         = 6,
   CB_SM_XNAME           = 7,
   CB_SM_YNAME           = 8
};

void cb_sm(FL_OBJECT *ob, long val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
#define        FP    wds[S_wt].pf.pxyf
#define        CO    wds[S_wt].pf.pxyf->dqc->dq

   int    ltrace = Ltrace;
   static char R[] = "cb_sm";
   static char B[BUFLEN];
   int    ival;
   double dval;
   char  *dir, *xname, *yname;

   if( ltrace ) fprintf(stderr,"%s: val=%d\n",R,val);

   if( !is_active_wt(S_wt) ) return;

   switch( (int) val ) {
   case CB_SM_CWD:
      dir = (char *) fl_get_input(Xvsf_sm->input_sm_cwd);
      if( ltrace ) fprintf(stderr,"%s: case=CB_SM_CWD dir=%s\n",R,dir);
      if( is_dir(dir) ) {
         if( Sm_dir ) free(Sm_dir);
         Sm_dir = strdup(dir);
      } else {
         sprintf(B,"'%s' is not a directory",dir);
         scope_mess_and_bell(B,2);
      }
      break;
   case CB_SM_CSD:
      dir = xvs_rd();
      if( ltrace ) {
         fprintf(stderr,"%s: '%s'\n",R,dir ? dir : NULL);
      }
      if( is_dir(dir) ) {
         if( Sm_dir ) free(Sm_dir);
         Sm_dir = strdup(dir);
      } else {
         sprintf(B,"'%s' is not a directory",dir);
         scope_mess_and_bell(B,2);
      }
      if( dir ) free(dir);
      break;
   case CB_SM_CD_DEFAULT:
      set_Sm_dir_default();
      fprintf(stderr,"%s: Sm_dir='%s'\n",R,Sm_dir);
      break;
   case CB_SM_GENERATE:
      handle_sm_menu(SM_GENERATE);
      break;
   case CB_SM_GENERATE_PS_LPR:
      handle_sm_menu(SM_GENERATE_EPS_AND_PRINT);
      break;
   case CB_SM_REFRESH:
      break;
   case CB_SM_XNAME:
      xname = (char *) fl_get_input(Xvsf_sm->input_sm_xname);
      if( xname ) {
         if( Sm_xname ) free(Sm_xname);
         Sm_xname = strdup(xname);
      }
      break;
   case CB_SM_YNAME:
      yname = (char *) fl_get_input(Xvsf_sm->input_sm_yname);
      if( yname ) {
         if( Sm_yname ) free(Sm_yname);
         Sm_yname = strdup(yname);
      }
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

Return:
   widgets_set_sm(S_wt);
   set_must_redraw(S_wt);
#undef         PP
#undef         FP
#undef         CO
}

void cb_browser_sm(FL_OBJECT *ob, long val) {
   fprintf(stderr,"cb_browser_sm: In routine val=%d\n",val);
}

void widgets_set_sm(WT wt) {
#define        PP    wds[wt].winf.pwf.pxywinf
#define        FP    wds[wt].pf.pxyf
#define        CO    wds[wt].pf.pxyf->dqc->dq
   int         index_max;
   int         index_curr;
   int         ltrace = Ltrace;

   if( is_active_wt(wt) ) {
      if( !Sm_dir ) set_Sm_dir_default();
      fl_set_input(Xvsf_sm->input_sm_cwd,Sm_dir);
      update_browser_sm(wt);
      if( !Sm_xname ) {
         Sm_xname = strdup(Sm_xname_default);
      }
      if( Sm_yname ) free(Sm_yname);
      Sm_yname = strdup(wds[wt].name);

      fl_set_input(Xvsf_sm->input_sm_xname,Sm_xname);
      fl_set_input(Xvsf_sm->input_sm_yname,Sm_yname);
   }
#undef         PP
#undef         FP
#undef         CO
}

int is_sm_file(struct direct *d) {
   return 1;
}


/*=========================================================================
Memory leakage here; haven't figured out how to free storage allocated 
by scandir.
=========================================================================*/
void update_browser_sm(WT wt) {
   struct  dirent  **fnamelist = (struct dirent **) NULL;
   int     i, nfname;

   fl_freeze_form(Xvsf_sm->browser_sm->form);
   fl_clear_browser(Xvsf_sm->browser_sm); 
   if( !Sm_dir ) goto Return;
   if( !is_dir(Sm_dir) ) goto Return;
   nfname = scandir(Sm_dir,&fnamelist,is_sm_file,alphasort);
   if( nfname ) {
      for( i = 0; i < nfname; i++ ) {
         sprintf(B,"%s",fnamelist[i]->d_name);
         fl_add_browser_line(Xvsf_sm->browser_sm,B);
      }
   }
Return:
   fl_unfreeze_form(Xvsf_sm->browser_sm->form);
}

/*=========================================================================
Data browser.
=========================================================================*/
void form_do_browse(int val) {
   static char R[] = "form_do_browse"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_browse ) {
      fprintf(stderr,"%s: FATAL: Form Xvsf_browse form not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_browse->browse) ) return;

   Form_state = FORM_STATE_VIEW;
   fl_show_form(Xvsf_browse->browse,FL_PLACE_HOTSPOT,FL_FULLBORDER,"browse");   
   fl_redraw_form(Xvsf_browse->browse); 

   widgets_set_browse(S_wt);
}

enum {
   CB_BROWSE_NONE      = 0,
   CB_BROWSE_NAME      = 1,
   CB_BROWSE_INDEX     = 2,
   CB_BROWSE_FMT       = 3,
   CB_BROWSE_FMT_RESET = 4
};


void cb_browse(FL_OBJECT *ob, long val) {
   int    ltrace = Ltrace;
   static char R[] = "cb_browse";
   static char B[BUFLEN];
   int    index;
   double dval;
   char  *name, *fmt, *new_name;
   int    wt = S_wt;

   if( !is_active_wt(S_wt) ) return;

   if( ltrace ) fprintf(stderr,"%s: val=%d\n",R,val);
   switch( (int) val ) {
   case CB_BROWSE_NAME:
      new_name = name = (char *) fl_get_input(Xvsf_browse->input_browse_name);
      if( new_name && valid_name(new_name) && check_dup_name(S_wt,new_name) && 
          wds[S_wt].name ) {
         free(wds[S_wt].name); 
         wds[S_wt].name = strdup(new_name);
      }
      break;
   case CB_BROWSE_INDEX:
      if( sscanf(fl_get_input(Xvsf_browse->input_browse_index),"%d",&index) != 1 ) 
         goto Return;
      if( 1 <= index && index <= n_XYDV(wt) ) {
         set_xycurr_nth(wt,index);
         set_must_redraw(wt);
      } 
      break;
   case CB_BROWSE_FMT:
      fmt = (char *) fl_get_input(Xvsf_browse->input_browse_fmt);
      if( Browse_fmt ) free(Browse_fmt);
      Browse_fmt = strdup(fmt);
      break;
   case CB_BROWSE_FMT_RESET:
      if( Browse_fmt ) free(Browse_fmt);
      Browse_fmt = strdup(Browse_def_fmt);
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

Return:
   widgets_set_browse(S_wt);
   set_must_redraw(S_wt);
}


void cb_browser_browse(FL_OBJECT *ob, long val) {
   fprintf(stderr,"cb_browser_browse: In routine val=%d\n",val);
}

void widgets_set_browse(WT wt) {

   if( !is_active_wt(wt) ) return;
   fl_set_input(Xvsf_browse->input_browse_name,wds[wt].name);
   sprintf(B,"%d",get_display_index(wt));
   fl_set_input(Xvsf_browse->input_browse_index,B);
   if( !Browse_fmt ) Browse_fmt = strdup(Browse_def_fmt);
   fl_set_input(Xvsf_browse->input_browse_fmt,Browse_fmt);
   update_browser_browse(wt);
}

/*=========================================================================
Memory leakage here; haven't figured out how to free storage allocated 
by scandir.
=========================================================================*/
void update_browser_browse(WT wt) {
   struct  dirent  **fnamelist = (struct dirent **) NULL;
   PXYDVBIND         p = (PXYDVBIND) NULL;
   int               i, n;
   DVEC              x, y;

   if( !is_active_wt(wt) ) return;
   if( !Browse_fmt ) {
      Browse_fmt = strdup(Browse_def_fmt);
   }
   p = wds[wt].pf.pxyf->xycurr;
   n = p->data->n;
   x = p->data->x;
   y = p->data->y;
   if(         n < 10 ) {
      sprintf(B,"@f@m %%1d: %s %s",Browse_fmt,Browse_fmt);
   } else if ( n < 100 ) {
      sprintf(B,"@f@m %%2d: %s %s",Browse_fmt,Browse_fmt);
   } else if ( n < 1000 ) {
      sprintf(B,"@f@m %%3d: %s %s",Browse_fmt,Browse_fmt);
   } else if ( n < 10000 ) {
      sprintf(B,"@f@m %%4d: %s %s",Browse_fmt,Browse_fmt);
   } else if ( n < 100000 ) {
      sprintf(B,"@f@m %%5d: %s %s",Browse_fmt,Browse_fmt);
   } else if ( n < 1000000 ) {
      sprintf(B,"@f@m %%6d: %s %s",Browse_fmt,Browse_fmt);
   } else {
      sprintf(B,"@f@m %%7d: %s %s",Browse_fmt,Browse_fmt);
   }
   fl_freeze_form(Xvsf_browse->browser_browse->form);
   fl_clear_browser(Xvsf_browse->browser_browse); 
   for( i = 0; i < n; i++ ) {
      sprintf(B1,B,i+1,x[i],y[i]);
      fl_add_browser_line(Xvsf_browse->browser_browse,B1); 
   }
   fl_unfreeze_form(Xvsf_browse->browser_browse->form);
}

/*=========================================================================
Annotations (labels).
=========================================================================*/
void form_do_label(int val) {
   static char R[] = "form_do_label"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_label ) {
      fprintf(stderr,"%s: FATAL: Form Xvsf_label form not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_label->label) ) return;

   Form_state = FORM_STATE_VIEW;
   fl_show_form(Xvsf_label->label,FL_PLACE_HOTSPOT,FL_FULLBORDER,"Labels");   
   fl_redraw_form(Xvsf_label->label); 

   widgets_set_label(S_wt);
}

enum {
   CB_LABEL_NONE            = 0,
   CB_LABEL_NAME            = 1,
   CB_LABEL_TIME            = 2,
   CB_LABEL_INDEX           = 3,
   CB_LABEL_LIMITS_UC       = 4,
   CB_LABEL_LIMITS_LC       = 5,
   CB_LABEL_DISPLAY_MODE    = 6,
   CB_LABEL_FULL_SCALE_MODE = 7,
   CB_LABEL_MOUSE_POSITION  = 8,
   CB_LABEL_DISPLAY_ON      = 10,
   CB_LABEL_DISPLAY_OFF     = 11,
   CB_LABEL_FORMAT          = 20,
   CB_LABEL_ALL_ON          = 30,
   CB_LABEL_ALL_OFF         = 31,
   CB_LABEL_RESET           = 32,
   CB_LABEL_RESET_ALL       = 33,
   CB_LABEL_COLOR           = 40,
   CB_LABEL_LOCK_LIMITS_ON  = 41,
   CB_LABEL_LOCK_LIMITS_OFF = 42,
};

void cb_label(FL_OBJECT *ob, long val) {
   int    ltrace = Ltrace;
   static char R[] = "cb_label";
   static char B[BUFLEN];
   int    ival;
   double dval;
   char  *fmt;
   int    i, button, lbutton, lock_limits, do_lock = 0;

   if( !is_active_wt(S_wt) ) return;

   button = which_label_button();
   lock_limits =  fl_get_button(Xvsf_label->button_label_lock_limits_on);
   if( lock_limits ) {
      if( button == CB_LABEL_LIMITS_UC ) {
         do_lock = 1;
         lbutton = CB_LABEL_LIMITS_LC;
      }
      if( button == CB_LABEL_LIMITS_LC ) {
         do_lock = 1;
         lbutton = CB_LABEL_LIMITS_UC;
      }
   }
   if( ltrace ) {
      fprintf(stderr,"%s: val=%d button=%d\n",R,val,which_label_button());
      fprintf(stderr,"%s:    on=%d\n",R,V_heads_up[button]->on);
      fprintf(stderr,"%s:    fmt=%s\n",R,V_heads_up[button]->fmt);
      fprintf(stderr,"%s:    lock_limits=%d\n",R,lock_limits);
   }
   switch( (int) val ) {
   case CB_LABEL_NAME:
   case CB_LABEL_TIME:
   case CB_LABEL_INDEX:
   case CB_LABEL_LIMITS_UC:
   case CB_LABEL_LIMITS_LC:
   case CB_LABEL_DISPLAY_MODE:
      break;
   case CB_LABEL_DISPLAY_ON:
      button = which_label_button();
      if( ltrace )
         fprintf(stderr,"%s: Turning %d on\n",R,button);
      V_heads_up[button]->on = ON;
      if( button == CB_LABEL_DISPLAY_MODE ) {
         (*V_heads_up[CB_LABEL_FULL_SCALE_MODE]).on = ON;
      }
      if( do_lock ) {
         V_heads_up[lbutton]->on = ON; 
      }
      break;
   case CB_LABEL_DISPLAY_OFF:
      button = which_label_button();
      if( ltrace ) 
         fprintf(stderr,"%s: Turning %d off\n",R,button);
      V_heads_up[button]->on = OFF;
      if( button == CB_LABEL_DISPLAY_MODE ) {
         (*V_heads_up[CB_LABEL_FULL_SCALE_MODE]).on = OFF;
      }
      if( do_lock ) {
         V_heads_up[lbutton]->on = OFF; 
      }
      break;
   case CB_LABEL_FORMAT:
      if( ltrace ) 
         fprintf(stderr,"%s: CB_LABEL_FORMAT\n",R);
      if( fmt = (char *) fl_get_input(Xvsf_label->input_label_format) ) {
         if( V_heads_up[button]->fmt ) free( V_heads_up[button]->fmt);
         V_heads_up[button]->fmt = strdup(fmt);
         if( do_lock ) {
            if( V_heads_up[lbutton]->fmt ) free( V_heads_up[lbutton]->fmt);
            V_heads_up[lbutton]->fmt = strdup(fmt);
         }
      }
      break;
   case CB_LABEL_ALL_ON:
      for( i = 1 ; i < N_heads_up; i++ ) {
         V_heads_up[i]->on = ON;
      }
      break;
   case CB_LABEL_ALL_OFF:
      for( i = 1 ; i < N_heads_up; i++ ) {
         V_heads_up[i]->on = OFF;
      }
      break;
   case CB_LABEL_RESET:
      *V_heads_up[button] = I_v_heads_up[button];
      if( I_v_heads_up[button].fmt ) {
         V_heads_up[button]->fmt = strdup(I_v_heads_up[button].fmt);
      }
      if( do_lock ) {
         if( I_v_heads_up[lbutton].fmt ) {
            V_heads_up[lbutton]->fmt = strdup(I_v_heads_up[lbutton].fmt);
         }
      }
      break;
   case CB_LABEL_RESET_ALL:
      for( i = 1; i < N_heads_up; i++ ) {
         *V_heads_up[i] = I_v_heads_up[i];
         if( I_v_heads_up[i].fmt ) {
            V_heads_up[i]->fmt = strdup(I_v_heads_up[i].fmt);
         }
      }
      break;
   case CB_LABEL_COLOR:
      V_heads_up[button]->col = 
         fl_get_choice(Xvsf_label->choice_label_color) - 1; 
      if( button == CB_LABEL_DISPLAY_MODE ) {
         V_heads_up[CB_LABEL_FULL_SCALE_MODE]->col = 
            V_heads_up[CB_LABEL_DISPLAY_MODE]->col;
            
      }
      if( do_lock ) {
         V_heads_up[lbutton]->col = V_heads_up[button]->col;
      }
      break;
   default:
      if( ltrace ) 
         fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

Return:
   widgets_set_label(S_wt);
   apply_all_wt_0((PFV_I) set_must_redraw); 
}

void widgets_set_label(WT wt) {
   int         ltrace = Ltrace;
   int         button;

   if( is_active_wt(wt) ) {
      button = which_label_button();
      if( V_heads_up[button]->on ) {
         fl_set_button(Xvsf_label->button_label_display_on,ON);
         fl_set_button(Xvsf_label->button_label_display_off,OFF);
      } else {
         fl_set_button(Xvsf_label->button_label_display_on,OFF);
         fl_set_button(Xvsf_label->button_label_display_off,ON);
      }
      if( V_heads_up[button]->fmt ) {
         fl_activate_object(Xvsf_label->input_label_format);
         fl_set_input(Xvsf_label->input_label_format,V_heads_up[button]->fmt);
      } else {
         fl_set_input(Xvsf_label->input_label_format,"");
         fl_deactivate_object(Xvsf_label->input_label_format);
      }
      fl_set_choice(Xvsf_label->choice_label_color,V_heads_up[button]->col+1);
   }
}

int which_label_button(void) {
   if( fl_get_button(Xvsf_label->button_label_name) ) 
      return CB_LABEL_NAME;
   if( fl_get_button(Xvsf_label->button_label_time) ) 
      return CB_LABEL_TIME;
   if( fl_get_button(Xvsf_label->button_label_index) ) 
      return CB_LABEL_INDEX;
   if( fl_get_button(Xvsf_label->button_label_limits_uc) ) 
      return CB_LABEL_LIMITS_UC;
   if( fl_get_button(Xvsf_label->button_label_limits_lc) ) 
      return CB_LABEL_LIMITS_LC;
   if( fl_get_button(Xvsf_label->button_label_display_mode) ) 
      return CB_LABEL_DISPLAY_MODE;
   if( fl_get_button(Xvsf_label->button_label_mouse_position) ) 
      return CB_LABEL_MOUSE_POSITION;
   return 0;
}

/*=========================================================================
Routines for handling file form.
=========================================================================*/
void form_do_file(int val) {
   static char R[] = "form_do_file"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_file ) {
      fprintf(stderr,"%s: FATAL: Form Xvsf_file form not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_file->file) ) return;

   Form_state = FORM_STATE_FILE;
   fl_show_form(Xvsf_file->file,FL_PLACE_HOTSPOT,FL_FULLBORDER,"file");   
   fl_redraw_form(Xvsf_file->file); 

   widgets_set_file(S_wt);
}

void widgets_set_file(WT wt) {
#define        PP    wds[wt].winf.pwf.pxywinf
#define        FP    wds[wt].pf.pxyf
#define        CO    wds[wt].pf.pxyf->dqc->dq
   int         index_max;
   int         index_curr;
   int         ltrace = Ltrace;


   if( ltrace ) {
      fprintf(stderr,"widgets_set_file: wt=%d\n",wt);
   }
   if( wt == UNDEF ) wt = 0;

   fl_set_button(Xvsf_file->button_file_all,All);
   fl_set_input(Xvsf_file->input_file_cwd,wds[wt].wd);
   update_browser_file(wt);
   if( is_active_wt(wt) ) {
      fl_set_object_label(Xvsf_file->text_file_save_name,
         gft_make_sdf_name(wds[wt].name));
      fl_set_input(Xvsf_file->input_file_name,wds[wt].name); 
   }
#undef         PP
#undef         FP
#undef         CO
}

enum {
   CB_FILE_NONE      = 0,
   CB_FILE_OPEN      = 1,
   CB_FILE_SAVE      = 2,
   CB_FILE_ALL       = 3,
   CB_FILE_NAME      = 4,
   CB_FILE_CWD_INPUT = 5,
   CB_FILE_CSD       = 6
};

void cb_file(FL_OBJECT *ob, long val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
#define        FP    wds[S_wt].pf.pxyf
#define        CO    wds[S_wt].pf.pxyf->dqc->dq

   int    ltrace = Ltrace;
   static char R[] = "cb_file";
   static char B[BUFLEN];
   int    ival;
   double dval;
   char  *new_name;

   int      wt;
   PWTBIND  p;

   if( ltrace ) {
      fprintf(stderr,"%s: val=%d  S_wt=%d\n",R,val,S_wt);
   }

   switch( (int) val ) {
   case CB_FILE_OPEN:
      xvs_open_wt(S_wt);
      break;
   case CB_FILE_SAVE:
      if( All ) {
         xvs_save_wt_all(NULL);
      } else {
         xvs_save_wt(S_wt,NULL);
      }
      break;
   case CB_FILE_ALL:
      set_All(fl_get_button(Xvsf_file->button_file_all));
      break;
   case CB_FILE_CWD_INPUT:
      if( Pnl > 0 && All ) {
         for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
            xvs_cd(p->wt,(char *) fl_get_input(Xvsf_file->input_file_cwd));
         }
      } else {
         xvs_cd(S_wt,(char *) fl_get_input(Xvsf_file->input_file_cwd));
      }
      break;
   case CB_FILE_CSD:
      if( Pnl > 0 && All ) {
         for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
            xvs_csd(p->wt);
         }
      } else {
         xvs_csd(S_wt);
      }
      break;
   case CB_FILE_NAME:
      if( Pnl > 0 ) {
         new_name = (char * ) fl_get_input(Xvsf_file->input_file_name);
         if( new_name && valid_name(new_name) && check_dup_name(S_wt,new_name) && 
             wds[S_wt].name ) {
            free(wds[S_wt].name); 
            wds[S_wt].name = strdup(new_name);
         }
      }
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

   widgets_set_file(S_wt);
   if( is_active_wt(S_wt) ) {
      set_must_redraw(S_wt);
   }
#undef         PP
#undef         FP
#undef         CO
}

void cb_browser_file(FL_OBJECT *ob, long val) {
   return;
}

/*=========================================================================
Memory leakage here; haven't figured out how to free storage allocated 
by scandir.
=========================================================================*/
void update_browser_file(WT wt) {
   static char R[] = "update_browser_file";
   struct  dirent  **fnamelist = (struct dirent **) NULL;
   int     i, nfname;
   int     ltrace = Ltrace;
   struct stat st; 
   time_t wd_mtime;
   static char *wd_prev = (char *) NULL;
   static time_t wd_prev_mtime;

   if( ltrace ) {
      fprintf(stderr,"%s: wt=%d wd=%s wd_prev=%s\n",R,wt,
              wds[wt].wd ? wds[wt].wd : "NULL",wd_prev ? wd_prev : "NULL");
      fprintf(stderr,"%s: fl_form_is_visible(Xvsf_file->file)=%d\n",
            R,fl_form_is_visible(Xvsf_file->file));
   }

   if( !Force_update_browser_file ) {
      if( !fl_form_is_visible(Xvsf_file->file) ||
          !wds[wt].wd                          ||
          !is_dir(wds[wt].wd) 
        ) return; 
      if( wd_prev && !strcmp(wd_prev,wds[wt].wd) ) {
         stat(wds[wt].wd,&st); 
         if( st.st_mtime == wd_prev_mtime ) return;
      }
   }

   fl_freeze_form(Xvsf_file->browser_file->form);
   fl_clear_browser(Xvsf_file->browser_file); 

   xvs_push_wd_cd(wds[wt].wd);
   nfname = scandir(wds[wt].wd,&fnamelist,is_1d_sdf_file,alphasort);
   if( nfname ) {
      for( i = 0; i < nfname; i++ ) {
         if( wt && !strcmp(gft_make_sdf_name(wds[wt].name),fnamelist[i]->d_name) ) {
            sprintf(B,"@C1 %s",fnamelist[i]->d_name);
         } else {
            sprintf(B," %s",fnamelist[i]->d_name);
         }
         fl_add_browser_line(Xvsf_file->browser_file,B);
      }
   }
   if( wd_prev ) free(wd_prev);
   wd_prev = strdup(wds[wt].wd);
   stat(wd_prev,&st);
   wd_prev_mtime = st.st_mtime;
   if( ltrace ) {
      fprintf(stderr,"%s: wd_prev_mtime=%ld\n",R,(int) wd_prev_mtime);
   }
   xvs_pop_wd();
Return:
   fl_unfreeze_form(Xvsf_file->browser_file->form);
}

int is_1d_sdf_file_old(struct direct *d) {
   static char R[] = "is_1d_sdf_file";
   int         ltrace = Ltrace;
   int         rank;

   if( ltrace ) {
      fprintf(stderr,"%s: Scanning file='%s'\n",R,d->d_name);
   }
   if( !has_ext(d->d_name,".sdf") ) return 0;
   if( gft_read_rank_first(d->d_name,&rank) ) {
      gft_close(d);
   }
   if( ltrace ) {
      fprintf(stderr,"%s: Return val=%d\n",R,rank == 1);
   }
   return rank == 1; 
}

/*=========================================================================
Scans a maximum of ncheck_max data sets, so routine may fail, particularly 
for state files containing many grid functions.
=========================================================================*/
int is_1d_sdf_file(struct direct *d) {
   static char         R[] = "is_1d_sdf_file";
   int                 ltrace = Ltrace;
   int                 rank;
   gft_sdf_file_data  *gp;
   PSDFDS              the = (PSDFDS) NULL;
   const int           ncheck_max = 1;
   int                 rval = 0, ncheck;

   if( ltrace ) {
      fprintf(stderr,"%s: Scanning file='%s'\n",R,d->d_name);
   }
   if( !has_ext(d->d_name,".sdf") ) return 0;

   if( (gp = gft_open_sdf_stream(d->d_name)) ) {
      for( ncheck = 0; ncheck < ncheck_max; ncheck++ ) {
         the = new_SDFDS();
         if( read_SDFDS(gp->fp,the) ) {
            if( the->rank != 1 ) goto Close;
            free_SDFDS(the);
         } else {
            goto Ok;
         }
      }
Ok:
      rval = 1;
Close:
      gft_close_sdf_stream(d->d_name);  
   }

   if( ltrace ) {
      fprintf(stderr,"%s: Checked %d datasets.  Return val=%d\n",R,ncheck,rval);
   }
   return rval;
}

/*=========================================================================
Routines for handling ops (mode) form.
=========================================================================*/
void form_do_ops(int val) {
   static char R[] = "form_do_ops"; 
   int ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine.\n",R);
   if( !Xvsf_ops ) {
      fprintf(stderr,"%s: FATAL: Form Xvsf_ops form not been created.\n",R);
      exit(1);
   }
   if( fl_form_is_visible(Xvsf_ops->ops) ) return;

   Form_state = FORM_STATE_OPS;
   fl_show_form(Xvsf_ops->ops,FL_PLACE_HOTSPOT,FL_FULLBORDER,"ops");   
   fl_redraw_form(Xvsf_ops->ops); 

   widgets_set_ops(S_wt);
}

void widgets_set_ops(WT wt) {
#define        PP    wds[wt].winf.pwf.pxywinf
#define        FP    wds[wt].pf.pxyf
#define        CO    wds[wt].pf.pxyf->dqc->dq
   int         index_max;
   int         index_curr;
   int         ltrace = Ltrace;
   static char R[] = "widgets_set_ops";

   if( !is_active_wt(wt) )  return;
   if( ltrace ) fprintf(stderr,"%s: In routine wt=%d\n",R,wt);
   if( ltrace ) fprintf(stderr,"%s: wt=%d display_mode=%d\n",R,wt,PP->display_mode);
   if( PP->display_mode == AUTO_MODE )  {
      if( Auto_wt != S_wt ) {
         fl_set_choice(Xvsf_ops->choice_ops_mode,PP->display_mode);
         Auto_wt = S_wt;
      }
   } else {
      fl_set_choice(Xvsf_ops->choice_ops_mode,PP->display_mode);
   }
   sprintf(B,(get_lxy_wt(wt) == 1) ? "%d" : "1-%d",get_lxy_wt(wt));
   fl_set_input(Xvsf_ops->input_ops_compress,B);
   sprintf(B,"%.2g",Thinning_angle);
   fl_set_input(Xvsf_ops->input_ops_thin_angle,B);
   sprintf(B,"%d",get_display_index(wt));
   fl_set_input(Xvsf_ops->input_ops_index,B);
   fl_set_input(Xvsf_ops->input_ops_name,wds[wt].name);
   fl_set_button(Xvsf_ops->button_ops_all,All);
#undef         PP
#undef         FP
#undef         CO
}

enum {
   CB_OPS_NONE = 0,
   CB_OPS_MODE = 1,
   CB_OPS_DIRECTION = 2,
   CB_OPS_BREAK = 3,
   CB_OPS_COMPRESS = 4,
   CB_OPS_TIME_REV = 5,
   CB_OPS_DEV_MEAN = 6,
   CB_OPS_SPLIT_LEFT = 7,
   CB_OPS_SPLIT_RIGHT = 8,
   CB_OPS_THIN = 9,
   CB_OPS_THIN_ANGLE = 10,
   CB_OPS_RESET_THIN_ANGLE = 11,
   CB_OPS_NAME = 12,
   CB_OPS_INDEX = 13,
   CB_OPS_TRIM  = 14,
   CB_OPS_ALL   = 15
};

enum {
   CB_OPS_DIRECTION_FORWARD = 1,
   CB_OPS_DIRECTION_REVERSE = 2
};

enum {
   CB_OPS_BREAK_OFF = 1,
   CB_OPS_BREAK_ON = 2
};

void cb_ops(FL_OBJECT *ob, long val) {
#define        PP    wds[S_wt].winf.pwf.pxywinf
#define        FP    wds[S_wt].pf.pxyf
#define        CO    wds[S_wt].pf.pxyf->dqc->dq
   int      ltrace = Ltrace;
   static   char R[] = "cb_ops";
   int      ival;
   double   dval, xsplit, xsplit_def;
   char    *s, *new_name;
   int      index_max, index_curr;
   int      rc, mxliv = MAX_LIV, inf = 1;

   int      wt;
   PWTBIND  p;

   if( ltrace ) fprintf(stderr,"cb_ops: S_wt=%d val=%d\n",S_wt,val);

   if( val == CB_OPS_ALL ) {
      set_All(fl_get_button(Xvsf_ops->button_ops_all));
   }

   if( !is_active_wt(S_wt) ) return;

   switch( (int) val ) {
   case CB_OPS_MODE:
      ival = fl_get_choice(Xvsf_ops->choice_ops_mode);
      if( ltrace ) fprintf(stderr,"cb_ops: CB_OPS_MODE ival=%d\n",ival);
      switch( ival ) {
      case AUTO_MODE:
         Auto_wt = -1;
         handle_AKEY();
         break;
      case SSTEP_MODE:
         handle_SKEY();
         break;
      case FREEZE_MODE:
         handle_FKEY();
         break;
      case X_ZOOM_MODE:
         handle_ZKEY();
         break;
      case EDIT_MODE:
         handle_EKEY();
         break;
      case Y_ZOOM_MODE:
      case XY_ZOOM_MODE:
         if( control_apply_all_wt() ) {
            apply_all_wt_1((PFV_II) Set_display_mode,ival); 
         } else {
            (void) Set_display_mode(S_wt,ival);
         }
         break;
      default:
         break;
      }
      break;
   case CB_OPS_DIRECTION:
      ival = fl_get_choice(Xvsf_ops->choice_ops_direction);
      if( ltrace ) fprintf(stderr,"cb_ops: CB_OPS_DIRECTION ival=%d\n",ival);
      switch( ival ) {
      case CB_OPS_DIRECTION_FORWARD:
         handle_AKEY();
         break;
      case CB_OPS_DIRECTION_REVERSE:
         handle_QUOTEKEY();
         break;
      default:
         break;
      }
      break;
   case CB_OPS_BREAK:
      ival = fl_get_choice(Xvsf_ops->choice_ops_break);
      if( ltrace ) fprintf(stderr,"cb_ops: CB_OPS_BREAK ival=%d\n",ival);
      switch( ival ) {
      case CB_OPS_BREAK_OFF:
         if( control_apply_all_wt() ) {
            apply_all_wt_1((PFV_II) Set_auto_mode,AUTO_MENU_BREAK_OFF); 
         } else {
            Set_auto_mode(S_wt,AUTO_MENU_BREAK_OFF);
         }
         break;
      case CB_OPS_BREAK_ON:
         if( control_apply_all_wt() ) {
            apply_all_wt_1((PFV_II) Set_auto_mode,AUTO_MENU_BREAK_ON); 
         } else {
            Set_auto_mode(S_wt,AUTO_MENU_BREAK_ON);
         }
         break;
      default:
         break;
      }
      break;
   case CB_OPS_COMPRESS:
      s = (char *) fl_get_input(Xvsf_ops->input_ops_compress);
      if( ltrace ) {
         fprintf(stderr,"cb_ops: Compression index vector='%s'\n",
               s ? s : "NULL");
      }
      if( !s || !strlen(s) ) {
         sprintf(B,(get_lxy_wt(S_wt) == 1) ? "%d" : "1-%d",get_lxy_wt(S_wt));
         fl_set_input(Xvsf_ops->input_ops_compress,B);
         s = (char *) fl_get_input(Xvsf_ops->input_ops_compress);
      }
      rc = irdivn_(Compress_iv,&Compress_liv,&mxliv,&inf,&(FP->lxy),
                   s,strlen(s));
      if( ltrace ) fprintf(stderr,"cb_ops: Index vector length=%d\n",Compress_liv);
      if( rc >= OK_IRDIVN ) {
         if( control_apply_all_wt() ) {
            for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
               compress_in_place_wt(p->wt,Compress_iv,Compress_liv);
            }
         } else {
            compress_in_place_wt(S_wt,Compress_iv,Compress_liv);
         }
      }
      break;
   case CB_OPS_TIME_REV:
      if( control_apply_all_wt() ) {
         apply_all_wt_0((PFV_I) time_reverse_wt);
      } else {
         time_reverse_wt(S_wt);
      }
      break;
   case CB_OPS_DEV_MEAN:
      if( control_apply_all_wt() ) {
         for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
            apply_func_0_wt(p->wt,mean_PXYDVBIND);
         }
      } else {
         apply_func_0_wt(S_wt,mean_PXYDVBIND);
      }
      break;
   case CB_OPS_SPLIT_LEFT:
      if( shift_key_pressed() ) {
         xsplit_def = 0.5 * (CO.x1 + CO.x2);
         xsplit = xvs_get_double("Enter x coordinate for split left",xsplit_def);
         (void) xvs_split_wt(S_wt,xsplit,SPLIT_LEFT,OFF);
      } else {
         scope_mess_perm("Enter split left point with mouse");
         xvs_form_state_push(FORM_STATE_SPLITTING);
         Split_dir = SPLIT_LEFT;
      }
      break;
   case CB_OPS_SPLIT_RIGHT:
      if( shift_key_pressed() ) {
         xsplit_def = 0.5 * (CO.x1 + CO.x2);
         xsplit = xvs_get_double("Enter x coordinate for split right",xsplit_def);
         (void) xvs_split_wt(S_wt,xsplit,SPLIT_RIGHT,OFF);
      } else {
         scope_mess_perm("Enter split right point with mouse");
         xvs_form_state_push(FORM_STATE_SPLITTING);
         Split_dir = SPLIT_RIGHT;
      }
      break;
   case CB_OPS_THIN:
      if( control_apply_all_wt() ) {
         apply_all_wt_d((PFV_ID) thin_wt,Thinning_angle);
      } else {
         thin_wt(S_wt,Thinning_angle);
      }
      break;
   case CB_OPS_THIN_ANGLE:
      s = (char *) fl_get_input(Xvsf_ops->input_ops_thin_angle);
      if( sscanf(s,"%lf",&dval) == 1 ) {
         if( 0.0 < dval && dval <= 1.0 ) {
            if( ltrace ) fprintf(stderr,"cb_ops: dval=%g\n",dval);
            Thinning_angle = dval;
         }
      } 
      break;
   case CB_OPS_RESET_THIN_ANGLE:
      Thinning_angle = DEFAULT_THINNING_ANGLE;
      break;
   case CB_OPS_INDEX:
      index_max = n_XYDV(S_wt);
      index_curr = get_display_index(S_wt);
      if( sscanf(fl_get_input(Xvsf_ops->input_ops_index),
                 "%d",&ival) == 1 ) {
         if( 1 <= ival && ival <= index_max ) {
            if( control_apply_all_wt() ) {
               apply_all_wt_1((PFV_II) set_xycurr_nth, ival); 
            } else {
               set_xycurr_nth(S_wt,ival);
            }
         } 
      } 
      break;
   case CB_OPS_TRIM:
      handle_TKEY();
      break;
   case CB_OPS_ALL:
      set_All(fl_get_button(Xvsf_ops->button_ops_all));
      break;
   case CB_OPS_NAME:
      new_name = (char * ) fl_get_input(Xvsf_ops->input_ops_name);
      if( new_name && valid_name(new_name) && check_dup_name(S_wt,new_name) && 
          wds[S_wt].name ) {
         free(wds[S_wt].name); 
         wds[S_wt].name = strdup(new_name);
      }
      break;
   default:
      fprintf(stderr,"%s: !!! DEFAULT CASE !!!\n",R);
      break;
   }

   widgets_set_ops(S_wt);
   set_must_redraw(S_wt);
#undef         PP
#undef         FP
#undef         CO
}

/*=========================================================================
Increase/decrease main form size via buttons
=========================================================================*/
void cb_button_size(FL_OBJECT *ob, long val) {
   switch( val ) {
   case 0:
      Form_size_state = FORM_SIZE_STATE_DOWN;
      break;
   case 1:
      Form_size_state = FORM_SIZE_STATE_UP;
      break;
   case 2:
      Form_size_state = FORM_SIZE_STATE_ORIG;
      break;
   default:
      break;
   }
}

/*=========================================================================
Tagging functions; originally implemented as menu
=========================================================================*/
void cb_button_tag(FL_OBJECT *ob, long val) {
   static char R[] = "cb_button_tag";
   int ltrace = Ltrace;

   if( !is_active_wt(S_wt) ) return;

   if( 0 <= val  && val <= 2 ) {
      if( ltrace ) {
         fprintf(stderr,"%s: Invoking handle_tag_fcn_menu(%d)\n",R,val);
      }
      handle_tag_fcn_menu(val);
   } else {
      fprintf(stderr,"%s: FATAL val=%d not implemented.\n",R,val);
   }
}


/*=========================================================================
Implements single-element stack for saving/restoring working directory.
=========================================================================*/
char *xvs_push_wd_cd(char *dir) {
   static char R[] = "xvs_push_wd_cd";
   char       *rval = (char *) NULL;
   int         ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine dir=%s\n",R,dir ? dir : "NULL");
   if( dir ) {
      xvs_push_wd();
      if( !chdir((const char *) dir) ) {
         if( ltrace ) fprintf(stderr,"%s: cd'ed to %s\n",R,dir);
         rval = dir;
      } else {
         fprintf(stderr,"%s: Could not cd to %s\n",R,dir);
      }
   }
   return rval;
}

char *xvs_push_wd_cd_wt(WT wt) {
   static char R[] = "xvs_push_wd_cd_wt";
   int         ltrace = Ltrace;

   if( ltrace ) fprintf(stderr,"%s: In routine wt=%d\n",R,wt);
   assert(wds[wt].wd);
   return xvs_push_wd_cd(wds[wt].wd);
}

char *xvs_push_wd(void) {
   return xvs_push_pop_wd(XVS_PUSH_WD);
}

char *xvs_pop_wd(void) {
   return xvs_push_pop_wd(XVS_POP_WD);
}

char *xvs_push_pop_wd(int opcode) {
   static char  R[] = "xvs_push_pop_wd";
   int          ltrace = Ltrace;
   static char *save_dirname = (char *) NULL;
   static char *dirname = (char *) NULL;

   switch( opcode ) {
   case XVS_PUSH_WD:
      if( save_dirname )  free(save_dirname);
      (void) getcwd(WD,BUFLEN);
      save_dirname = strdup(WD);
      break;
   case XVS_POP_WD:
      assert(save_dirname);
      if( is_dir(save_dirname) ) {
         if( chdir((const char *) save_dirname) ) {
            fprintf(stderr,"%s: Could not cd to %s\n",R,save_dirname);
            free(save_dirname); save_dirname = (char *) NULL;
         } 
      } else {
         fprintf(stderr,"%s: %s is not a directory.\n",R,save_dirname);
         free(save_dirname); save_dirname = (char *) NULL;
      }
      break;
   default:
      fprintf(stderr,"%s: Unrecognized opcode=%d\n",R,opcode);
      break;
   }
   if( ltrace ) {
      fprintf(stderr,"%s: opcode=%d  save_dirname=%s\n",
         R,opcode,save_dirname);
   }
   return save_dirname;
}

/*=========================================================================
Saves data associated with wt as .sdf file.
=========================================================================*/
int xvs_save_wt(WT wt,char *dir) {
   static char R[] = "xvs_save_wt";
   int    ltrace = Ltrace;

   char  *sdf_name = (char *) NULL;
   FILE  *sdf_out = (FILE *) NULL;
   int    save, i, n, nout;
   PSDFDS the = (PSDFDS) NULL;
   int    rc = 0;

   if( !is_active_wt(wt) ) return rc;

   if( dir ) {
      if( !xvs_push_wd_cd(dir) ) {
         fprintf(stderr,"%s: Could not cd to '%s'\n",R,dir);
         return rc;
      }
   } else {
      xvs_push_wd_cd_wt(wt);
   }

   sdf_name = gft_make_sdf_name(wds[wt].name);
   if( ltrace ) {
   fprintf(stderr,"%s: wt=%d name=%s sdfname=%s\n",
      R,wt,wds[wt].name,sdf_name ? sdf_name : "NULL");
   }
   if( file_exists(sdf_name) ) {
      getcwd(B1,BUFLEN);
      sprintf(B,"File '%s/%s' already exists. Overwrite?",B1,sdf_name);
      save = fl_show_question(B,1);
   } else {
      save = 1;
   }
   if( save ) {
      if( ltrace ) fprintf(stderr,"%s: Would save wt=%d data as '%s'\n",R,wt,sdf_name);
      sdf_out = fopen(sdf_name,"w");
      if( !sdf_out ) {
         if( ltrace ) {
            fprintf(stderr,"%s: Error opening '%s' for write\n",R,sdf_name);
         }
         sprintf(B,"Error opening '%s' for write",sdf_name);
         scope_mess_and_bell(B,1);
         goto Return;
      }
      n = wds[wt].pf.pxyf->lxy;
      for( i = 0, nout = 0; i < n; i++ ) {
         the = xvs_wt_index_to_SDFDS(wt,i+1);
         if( the ) {
            if( ltrace ) fprintf(stderr,"%s: Writing dataset %d of %d\n",
               R,i+1,n);
            write_SDFDS(sdf_out,the);
            free_SDFDS(the);
            nout++;
         } else {
            fprintf(stderr,"xvs_save_wt: xvs_wt_index_to_SDFDS(%d,%d) failed\n",
               wt,i+1);
         }
      }
      sprintf(B,"Wrote %d datasets to %s",nout,sdf_name);
      scope_mess(B,1);
      fclose(sdf_out);

      rc = 1;

   } else {
      scope_mess_and_bell("Save cancelled.",1);
   }
Return:
   /* Save a global version of filename ... */
   if( Sdf_name ) free(Sdf_name);
   Sdf_name = strdup(sdf_name);

   if( sdf_name ) free(sdf_name);

   xvs_pop_wd();

   return rc;
}

int xvs_save_wt_all(char *dir) {
   PWTBIND p; 

   for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
      xvs_save_wt(p->wt,dir);
   }

   return 1;
}

/*=========================================================================
Invokes 'sdftoxvs' to send .sdf file to server.

Now, if wt is UNDEFINED, loads with respect to wt=0 (global control).
=========================================================================*/
void xvs_open_wt(WT wt) {
   xvs_load_wt(wt);
}

void xvs_load_wt(WT wt) {
   int   ltrace = Ltrace;
   char *filename = (char *) NULL;
   int   nselected = xfl_get_browser_nselected(Xvsf_file->browser_file);
   int   i, nloaded = 0;

   if( ltrace ) {
      fprintf(stderr,"xvs_load_wt: wt=%d\n",wt);
      fprintf(stderr,"xvs_load_wt: Selected browser lines=%d\n",nselected);
   }

   if( wt == UNDEF ) wt = 0;

   if( ltrace ) {
      fprintf(stderr,"xvs_load_wt: wt=%d\n",wt);
   }

   assert(wds[wt].wd);
   xvs_push_wd_cd_wt(wt);
   if( Last_data_dir ) free(Last_data_dir);
   Last_data_dir = strdup(wds[wt].wd);

   for( i = 1; i <= fl_get_browser_maxline(Xvsf_file->browser_file); i++ ) {
      if( fl_isselected_browser_line(Xvsf_file->browser_file,i) ) {   
         sprintf(B,"sdftoxvs -d %s &",fl_get_browser_line(Xvsf_file->browser_file,i));
         if( ltrace ) {
            fprintf(stderr,"xvs_load_wt: Executing system(%s)\n",B);
            fprintf(stderr,"xvs_load_wt: Last_data_dir=%s\n",Last_data_dir);
         }
         system(B);
         nloaded++;
         Force_update_browser_file = 1;
      }
   }
   if( !nloaded ) {
      filename = 
         (char *) fl_show_fselector("Choose .sdf file",wds[wt].wd,"*.sdf",NULL);
      if( !filename || (strspn(filename," ") == strlen(filename)) ) {
         scope_mess_and_bell("File open aborted.",1);
         return;
      }
      sprintf(B,"sdftoxvs -d %s &",filename);
      if( ltrace ) {
         fprintf(stderr,"xvs_load_wt: Executing system(%s)\n",B);
      }
      system(B);
   }

   xvs_pop_wd();
}

/*=========================================================================
Doesn't appear to be an easy way to have file-browser return a directory.
=========================================================================*/
void xvs_cd(WT wt,char *dir) {
   static char R[] = "xvs_cd";
   int   ltrace = Ltrace;
   char  *buf = (char *) NULL;

   if( wt == UNDEF ) wt = 0;

   assert(wds[wt].wd);

   if( ltrace ) {
      fprintf(stderr,"%s: wds[%d].wd='%s' dir='%s'\n",R,wt,wds[wt].wd,dir ? dir : "NULL");
   }
   if( !dir ) {
      dir = (char *) fl_show_simple_input("Enter new directory",(char *) NULL);
   }
   if( is_dir(dir) ) {
      if( wds[wt].wd ) free(wds[wt].wd);
      wds[wt].wd = strdup(dir);
   } else {
      if( (buf = (char *) malloc(BUFLEN * sizeof(char))) ) {
         sprintf(buf,"Could not cd to %s",dir);
         scope_mess(buf,2);
         fprintf(stderr,"%s\n",buf);
      } else {
         fprintf(stderr,"%s: malloc(%d) failed\n",R,BUFLEN * sizeof(char));
      }
   }
   if( buf ) free(buf);
}

/*=========================================================================
Returns contents of $HOME/sd (should be in a utilio).
=========================================================================*/
char *xvs_rd(void) {
   FILE  *sd;
   char  *fname = (char *) NULL;
   char  *ldir   = (char *) NULL;
   char  *dir   = (char *) NULL;
   static int len = 1024;

   if( !(fname = (char *) malloc(len * sizeof(char))) ) goto Cleanup;
   if( !(ldir   = (char *) malloc(len * sizeof(char))) ) goto Cleanup;
   sprintf(fname,"%s/sd",getenv("HOME"));
   if( !(sd = fopen(fname,"r")) ) return NULL;
   if( fscanf(sd,"%s",ldir) == 1 ) {
      dir = strdup(ldir);
   }
   fclose(sd);

Cleanup:
   if( fname ) free(fname);
   if( ldir )  free(ldir);
   return dir;
}

/*=========================================================================
Sets wt's working directory to that stored in $HOME/sd.
=========================================================================*/
void xvs_csd(WT wt) {
   int    ltrace = ON;
   FILE  *sd; 

   if( wt == UNDEF ) wt = 0;

   if ( sd = fopen(Sd_name,"r") ) {
      fscanf(sd,"%s",B1);
      fclose(sd);
      if( is_dir(B1) ) {
         if( wds[wt].wd ) free(wds[wt].wd);
         wds[wt].wd = strdup(B1);
      } else {
         sprintf(B,"'%s' is not a directory",B1);
         scope_mess_and_bell(B,1);
      }
   } else {
      sprintf(B,"Could not open '%s' for read",Sd_name);
   }
}

/*=========================================================================
Sets all control panel widgets to "void" values ...
=========================================================================*/
void widgets_clear_all(void) {
/* widgets_set_view(wt); */
   fl_set_button(Xvsf_view->button_view_all,All);
   fl_set_input(Xvsf_view->input_view_xmin," ");
   fl_set_input(Xvsf_view->input_view_xmax," ");
   fl_set_input(Xvsf_view->input_view_ymin," ");
   fl_set_input(Xvsf_view->input_view_ymax," ");
   fl_set_choice(Xvsf_view->choice_view_domain,1);
   fl_set_choice(Xvsf_view->choice_view_full_scale,1);
   fl_set_input(Xvsf_view->input_view_index," ");
   fl_set_input(Xvsf_view->input_view_name," ");
   fl_freeze_form(Xvsf_view->browser_view_stack->form);
   fl_clear_browser(Xvsf_view->browser_view_stack); 
   fl_unfreeze_form(Xvsf_view->browser_view_stack->form);

/* widgets_set_file(wt); */
   fl_set_button(Xvsf_file->button_file_all,All);
   fl_set_input(Xvsf_file->input_file_cwd," ");
   fl_set_object_label(Xvsf_file->text_file_save_name," ");
   fl_set_input(Xvsf_file->input_file_name," ");
   fl_freeze_form(Xvsf_file->browser_file->form);
   fl_clear_browser(Xvsf_file->browser_file); 
   fl_unfreeze_form(Xvsf_file->browser_file->form);

/* widgets_set_ops(wt);*/
   fl_set_button(Xvsf_ops->button_ops_all,All);
   fl_set_choice(Xvsf_ops->choice_ops_mode,1);
   fl_set_input(Xvsf_ops->input_ops_compress," ");
   fl_set_input(Xvsf_ops->input_ops_thin_angle," ");
   fl_set_input(Xvsf_ops->input_ops_index," ");
   fl_set_input(Xvsf_ops->input_ops_name," ");

/* widgets_set_markers(wt);*/
   fl_set_choice(Xvsf_markers->choice_markers_color,1);
   fl_set_choice(Xvsf_markers->choice_markers_type,1);
   fl_set_choice(Xvsf_markers->choice_markers_line_color,1);
   fl_set_input(Xvsf_markers->input_markers_marker_size," ");
   fl_set_input(Xvsf_markers->input_markers_point_size," ");
   fl_set_input(Xvsf_markers->input_markers_line_width," ");
   fl_set_input(Xvsf_markers->input_markers_npoly," ");
   fl_set_choice(Xvsf_markers->choice_markers_multi_mode,1);

/*   widgets_set_mpeg(wt);*/
   fl_set_input(Xvsf_mpeg->input_mpeg_cwd," ");
   fl_set_input(Xvsf_mpeg->input_mpeg_mpeg_name," ");
   fl_set_input(Xvsf_mpeg->input_mpeg_playback_cmd," ");
   fl_set_input(Xvsf_mpeg->input_mpeg_size," ");
   fl_freeze_form(Xvsf_mpeg->browser_mpeg->form);
   fl_clear_browser(Xvsf_mpeg->browser_mpeg);
   fl_unfreeze_form(Xvsf_mpeg->browser_mpeg->form);

/* widgets_set_sm(wt);*/
   fl_set_input(Xvsf_sm->input_sm_cwd," ");
   fl_set_input(Xvsf_sm->input_sm_xname," ");
   fl_set_input(Xvsf_sm->input_sm_yname," ");
   fl_freeze_form(Xvsf_sm->browser_sm->form);
   fl_clear_browser(Xvsf_sm->browser_sm);
   fl_unfreeze_form(Xvsf_sm->browser_sm->form);

/* widgets_set_browse(wt);*/
   fl_set_input(Xvsf_browse->input_browse_name," ");
   fl_set_input(Xvsf_browse->input_browse_index," ");
   fl_set_input(Xvsf_browse->input_browse_fmt," ");
   fl_freeze_form(Xvsf_browse->browser_browse->form);
   fl_clear_browser(Xvsf_browse->browser_browse);
   fl_unfreeze_form(Xvsf_browse->browser_browse->form);

/* widgets_set_label(wt);*/
}
