#ifndef CB_DEF
#define CB_DEF

#include <apply_types.h>

extern   int               Curr_p;
extern   int               Save_p;
extern   int               Single_p;

extern   int               Split_dir;

enum {
   FORM_STATE_NORMAL,
   FORM_STATE_MARKERS,
   FORM_STATE_VIEW,
   FORM_STATE_FILE,
   FORM_STATE_OPS,
   FORM_STATE_CONTROL,
   FORM_STATE_PICKING,
   FORM_STATE_PICKED,
   FORM_STATE_MPICKING,
   FORM_STATE_MPICKED,
   FORM_STATE_SPLITTING,
   FORM_STATE_SPLIT,
   FORM_STATE_MPEG_PENDING,
   FORM_STATE_MPEG_RECORDING
};

enum {
   FORM_MOTION_STATE_NORMAL,
   FORM_MOTION_STATE_MOVING
};

enum {
   FORM_SIZE_STATE_NORMAL,
   FORM_SIZE_STATE_RESIZING,
   FORM_SIZE_STATE_UP,
   FORM_SIZE_STATE_DOWN,
   FORM_SIZE_STATE_ORIG
};

enum {
   MPICK_ADD,
   MPICK_END,
   MPICK_START
};

enum {
   MENU_DEFERRED_OFF,
   MENU_DEFERRED_APPLY1_MENU_GENERIC0,
   MENU_DEFERRED_APPLY2,
   MENU_DEFERRED_APPLY3,
   MENU_DEFERRED_APPLY4,
   MENU_DEFERRED_APPLY6,
   MENU_DEFERRED_APPLYN,
   MENU_DEFERRED_TAG,
   MENU_DEFERRED_REDUCE,
   MENU_DEFERRED_COMPARE,
   MENU_DEFERRED_MOVE,
   MENU_DEFERRED_KILL,
   MENU_DEFERRED_SET_INDEX,
   MENU_DEFERRED_RENAME,
   MENU_DEFERRED_SM
};

enum {
   MENU_PICKING_OFF,
   MENU_PICKING_ON
};

enum {
   XVS_PUSH_WD,
   XVS_POP_WD
};

enum {
   FOLDER_OPS,
   FOLDER_VIEW,
   FOLDER_FILE,
   FOLDER_MARKERS,
   FOLDER_PREVIOUS = -1
};

enum {
   DFORM_UP,
   DFORM_DOWN
};

enum {
   MPEG_STATE_NORMAL = 0,
   MPEG_STATE_RECORD = 1
};

enum {
   RESIZE_SET        = 0,
   RESIZE_SET_DELTAS = 1,
   RESIZE_RESTORE    = 2,
   RESIZE_NOOP       = 3
};

extern   int               Form_state;
extern   int               Form_state_prev;
extern   int               Form_motion_state;
extern   int               Form_size_state;
extern   raster_pos        Form_pos;
extern   raster_pos        Form_pos_prev;
extern   int               Form_w_min;
extern   int               Form_h_min;
extern   int               Pick_type; 
extern   int               Picked_wt;
extern   IVECN             Picked_wt_list;
extern   STRINGVECN        Pick_prompts;
extern   int               N_pick_prompts;
extern   int               Apply_no_clone;
extern   int               Menu_deferred;
extern   int               Menu_deferred_wt;
extern   int               Menu_picking;
extern   int               All;
extern   int               Apply_all;

extern   int               Clone_mouse_nwt;

extern   char             *Sdf_name;

extern   int               Color_dqc;
extern   char              Fmt_dqc[];

extern   int               Color_mouse_pos;
extern   char              Fmt_mouse_pos[];
extern   int               Dform_size;      
extern   int               Dform_opt;      

extern   int               Mpeg_wt;
extern   char             *Mpeg_dir;
extern   char             *Mpeg_name;
extern   char             *Mpeg_fname;
extern   char             *Mpeg_playback_cmd;
extern   char              Mpeg_def_playback_cmd[];

extern   char             *Browse_fmt;
extern   char              Browse_def_fmt[];

extern   int               Control_folder_number_prev;
extern   int               Control_folder_close;

extern   int               Force_update_browser_file;

extern   int               Xvs_get_input;

extern   char              B[];
extern   char              B1[];
extern   char              B2[];
extern   char              F[];

extern   APPLY1_TYPE0     *Deferred_apply1_generic0_table;
extern   int               Deferred_apply1_generic0_code;

extern   igeom             Xvsf_geom_prev;
extern   igeom             Xvsf_geom_curr;

extern   double            Nonfinite_val;

extern   int               Ctrl_space_kill;

extern   int               Ops_modified;
extern   int               Auto_wt;

extern   int               at_close_main(FL_FORM *form, void *data);
extern   int               at_close_hide(FL_FORM *form, void *data);
extern   int               at_close_markers(FL_FORM *form, void *data);
extern   int               at_close_mpeg(FL_FORM *form, void *data);
extern   int               at_close_sm(FL_FORM *form, void *data);
extern   int               at_close_browse(FL_FORM *form, void *data);
extern   int               at_close_control(FL_FORM *form, void *data);

extern   int               xfl_get_browser_nselected(FL_OBJECT *obj);

extern   void              cb_main(FL_OBJECT *ob, long val);
extern   void              widgets_set_main(void);
extern   void              set_All(int val);
extern   void              widgets_set_All(void);

extern   void              cb_markers(FL_OBJECT *ob, long val);
extern   int               xvs_compute_control_form_posn(void);
extern   void              form_do_control(int val);
extern   int               raw_cb_control(FL_FORM *form, void *xev);
extern   void              widgets_set_all(WT wt);
extern   void              widgets_set_visible(WT wt);
extern   void              form_do_markers(int val);
extern   void              widgets_set_markers(WT wt);
extern   void              form_do_view(int val);
extern   void              widgets_set_view(WT wt);
extern   void              cb_view(FL_OBJECT *ob, long val);
extern   void              widgets_reset_all(void);
extern   void              GET_STRING(char **s, char *prompt);
extern   char             *xvs_get_string(char *prompt,char *def);
extern   double            xvs_get_double(char *prompt,double def);
extern   int               xvs_get_int(char *prompt,int def);
extern   double           *xvs_get_vdouble(char *prompt,double *vdef,int n);
extern   void              update_browser_view_stack(WT wt);
extern   int               valid_name(char *name);
extern   void              cb_timer_text_status(FL_OBJECT *ob, long val);
extern   void              cb_input_status(FL_OBJECT *ob, long val);
extern   int               at_close_status(FL_FORM *form, void *data);
extern   void              cb_button_exit(FL_OBJECT *ob, long val);
extern   PFV_I             l_set_auto_mode(WT wt);
extern   PFV_I             l_set_freeze_mode(WT wt);
extern   void              cb_menu_misc(FL_OBJECT *ob, long val);
extern   void              cb_button_help(FL_OBJECT *ob, long val);
extern   void              xvs_resize_main_form(int new_w, int new_h, int opcode);
extern   int               cb_idle(XEvent *ev, void *data);
extern   void              handle_menu_deferred(void);
extern   int               is_mouse_in_glcanvas(FL_OBJECT *gl);
extern   int               is_mouse_in_wt(WT wt);
extern   void              xymouse_gl(FL_OBJECT *gl,
                             FL_Coord *pmouse_x, FL_Coord *pmouse_y);
extern   void              xymouse_wt(WT wt,
                              FL_Coord *pmouse_x, FL_Coord *pmouse_y);
extern   double            xmouse_w_wt(WT wt);
extern   double            ymouse_w_wt(WT wt);
extern   void              xymouse_w_wt(WT wt, double *px, double *py);
extern   void              dump_xymouse_w_wt(WT wt);
extern   int               cb_glcanvas_main(FL_OBJECT *ob, Window win, int w, int h, 
                              XEvent *xev, void *gl_void);
extern   void              handle_YKEY(void);

extern   void              form_do_mpeg(int val);
extern   void              cb_mpeg(FL_OBJECT *ob, long val);
extern   void              widgets_set_mpeg(WT wt);
extern   int               is_mpeg_file(struct direct *d);
extern   void              update_browser_mpeg(WT wt);

extern   void              form_do_sm(int val);
extern   void              cb_sm(FL_OBJECT *ob, long val);
extern   void              widgets_set_sm(WT wt);
extern   int               is_sm_file(struct direct *d);
extern   void              update_browser_sm(WT wt);

extern   void              form_do_browse(int val);
extern   void              cb_browse(FL_OBJECT *ob, long val);
extern   void              widgets_set_browse(WT wt);
extern   void              update_browser_browse(WT wt);

extern   void              form_do_label(int val);
extern   void              cb_label(FL_OBJECT *ob, long val);
extern   void              widgets_set_label(WT wt);
extern   int               which_label_button(void);

extern   void              form_do_file(int val);
extern   void              cb_file(FL_OBJECT *ob, long val);
extern   void              widgets_set_file(WT wt);
extern   void              update_browser_file(WT wt);
extern   int               is_1d_sdf_file(struct direct *d);

extern   void              form_do_ops(int val);
extern   void              cb_ops(FL_OBJECT *ob, long val);
extern   void              widgets_set_ops(WT wt);

extern   void              cb_button_size(FL_OBJECT *ob, long val);
extern   void              cb_button_tag(FL_OBJECT *ob, long val);

extern   void              pick_prompts_init(int n);
extern   void              pick_prompts_set(char *s);
extern   void              Xvsf_widgets_init(void);

extern   int               xvs_save_wt(WT wt,char *dir);
extern   void              xvs_open_wt(WT wt);
extern   void              xvs_load_wt(WT wt);
extern   void              xvs_cd(WT wt,char *dir);
extern   void              xvs_csd(WT wt);
extern   char             *xvs_rd(void);

extern   char             *xvs_push_wd_cd(char *dir);
extern   char             *xvs_push_wd_cd_wt(WT wt);

extern   char             *xvs_push_wd(void);
extern   char             *xvs_pop_wd(void);
extern   char             *xvs_push_pop_wd(int opcode);
extern   void              widgets_clear_all(void);

#endif
