#include "project.h"

/* Applicators comparing data in two windows ... */

COMPARE_TYPE0     Compare_table[] =       {
 

   { NULL, NULL, NULL, NULL}, 

   { compare_full_fuzz,
     "full fuzz",
     "All data equal",
     "All data not equal"
   },

   { compare_xy_fuzz,
     "xy fuzz",
     "X and Y data equal",
     "X and Y data not equal"
   },

   { compare_x_fuzz,
     "x fuzz",
     "X data equal",
     "X data not equal"
   },

   { compare_y_fuzz,
     "y fuzz",
     "Y data equal",
     "Y data not equal"
   },

   { compare_t_fuzz,
     "t fuzz",
     "T data equal",
     "T data not equal"
   },

   { compare_full_exact,
     "full exact",
     "All data equal",
     "All data not equal"
   },

   { compare_xy_exact,
     "xy exact",
     "X and Y data equal",
     "X and Y data not equal"
   },

   { compare_x_exact,
     "x exact",
     "X data equal",
     "X data not equal"
   },

   { compare_y_exact,
     "y exact",
     "Y data equal",
     "Y data not equal"
   },

   { compare_t_exact,
     "t exact",
     "T data equal",
     "T data not equal %l"
   }


                                         };
              
int        N_Compare_table =
                     sizeof(Compare_table) / sizeof(COMPARE_TYPE0);

#define    NOT_IMPLEMENTED scope_mess_and_bell("This compare option not implemented yet",1); return(0)
#define    T1     p1->time
#define    N1     p1->data->n
#define    X1     p1->data->x
#define    Y1     p1->data->y
#define    T2     p2->time
#define    N2     p2->data->n
#define    X2     p2->data->x
#define    Y2     p2->data->y

int compare_full(PXYDVBIND p1, PXYDVBIND p2,double tolerance) {
   return( compare_t(p1,p2,tolerance) && compare_xy(p1,p2,tolerance) );
}

int compare_xy(PXYDVBIND p1, PXYDVBIND p2,double tolerance) {
   return( compare_x(p1,p2,tolerance) && compare_y(p1,p2,tolerance) );
}

int compare_x(PXYDVBIND p1, PXYDVBIND p2,double tolerance) {
   while( p1  &&  p2 ) {
      if( N1 != N2 ) return( 0 );
      if( dvmaxrd_(X1,X2,&N1) > tolerance ) return( 0 );
      p1 = p1->next;
      p2 = p2->next;
   }
   if( p1 || p2 ) {
      return( 0 );
   } else {
      return( 1 );
   }
}

int compare_y(PXYDVBIND p1, PXYDVBIND p2,double tolerance) {
   while( p1  &&  p2 ) {
      if( N1 != N2 ) return( 0 );
      if( dvmaxrd_(Y1,Y2,&N1) > tolerance ) return( 0 );
      p1 = p1->next;
      p2 = p2->next;
   }
   if( p1 || p2 ) {
      return( 0 );
   } else {
      return( 1 );
   }
}


/* This routine previously checked that datasets were of equal length ... */

int compare_t(PXYDVBIND p1, PXYDVBIND p2,double tolerance) {
   while( p1  &&  p2 ) {
      if( T1 != T2 ) {
         if( ( fabs(T1 - T2) / dmax(fabs(T1),fabs(T2)) ) > tolerance )
            return( 0 );
      }
      p1 = p1->next;
      p2 = p2->next;
   }
   if( p1 || p2 ) {
      return( 0 );
   } else {
      return( 1 );
   }
}

int compare_full_exact(PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_full(p1,p2,0.0) );
}

int compare_full_fuzz (PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_full(p1,p2,Compare_fuzz) );
}

int compare_xy_exact(PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_xy(p1,p2,0.0) );
}

int compare_xy_fuzz (PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_xy(p1,p2,Compare_fuzz) );
}

int compare_x_exact(PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_x(p1,p2,0.0) );
}

int compare_x_fuzz (PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_x(p1,p2,Compare_fuzz) );
}

int compare_y_exact(PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_y(p1,p2,0.0) );
}

int compare_y_fuzz (PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_y(p1,p2,Compare_fuzz) );
}

int compare_t_exact(PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_t(p1,p2,0.0) );
}

int compare_t_fuzz (PXYDVBIND p1, PXYDVBIND p2) {
   return( compare_t(p1,p2,Compare_fuzz) );
}

#undef     NOT_IMPLEMENTED
#undef     T1
#undef     N1
#undef     X1
#undef     Y1
#undef     T2
#undef     N2
#undef     X2
#undef     Y2
