#include <sysincludes.h>
#include "wt.h"
#include "lal.h"

PLALBIND             lalroot;
PLALBIND             lalhead;

PLALBIND make_PLALBIND(wtl,next,prev)
   PWTBIND        wtl;
   PLALBIND       next,   prev;
{
   PLALBIND       p;

   p = (PLALBIND) malloc(sizeof(LALBIND));
   p->wtl = wtl; p->prev = prev; p->next = next;
   return p;
}

PLALBIND dup_PLALBIND(p)
   PLALBIND       p;
{
   PLALBIND       pp;

   pp = (PLALBIND) malloc(sizeof(LALBIND));
   *pp = *p;
   return pp;
}

void free_PLALBIND(p)
   PLALBIND       p;
{
   free(p);
}

void lal_init()
{
   lalroot = make_PLALBIND(wtal,(PLALBIND) NULL,(PLALBIND) NULL);
   lalhead = dup_PLALBIND(lalroot);
/* printf("lal_init: lal structure initialized.\n");  */
}

void  lal_set()
{
   lalroot->wtl = wtal;
   if( lalhead->prev == NULL ) {
      lalhead->wtl = wtal;
   }
}

void lal_replace(old_p,new_p)
   PWTBIND         old_p,     new_p;
{
   PLALBIND        p;

   for( p = lalhead; p != NULL; p = p->prev ) {
      if( (p->wtl) == old_p ) (p->wtl) = new_p;
   }
}

void lal_push(wtl)
PWTBIND            wtl;
{
   PLALBIND        p;

   p = make_PLALBIND(wtl,(PLALBIND) NULL,(PLALBIND) NULL);
   if( p != (PLALBIND) NULL ) {
      lalhead->next = p; p->prev = lalhead; lalhead = p;
   } else {
      err1("lal_push","lal_push: lal stack overflow.");
   }
}

void lal_pop()
{
   PLALBIND         p;

   if( (p = lalhead->prev) != (PLALBIND) NULL ) {
      p = lalhead;
      lalhead = lalhead->prev;
      lalhead->next = NULL;
      free(p);
   } else {
      err1("lal_pop","lal_pop: lal stack underflow.");
   }
}

void lal_dump()
{
   PLALBIND          p;
   PWTBIND           save_wtal;
   
   if( lalhead->wtl != NULL ) {
      printf("lal_dump: BEGIN DUMP...\n");
      save_wtal = wtal;
      for( p = lalhead; p != NULL; p = p->prev ) {
            printf("lal_dump: Dumping from %d.\n",(p->wtl)->wt);
            wtal = p->wtl; dump_wtal();
      }
      wtal = save_wtal;
      printf("lal_dump: END   DUMP...\n");
   } else {
      printf("lal_dump: No active list yet.\n");
   }
}

PWTBIND lal_wtal()
{
   return lalhead->wtl;
}
