#include "project.h"
#include <math.h>

/*=========================================================================
Modifications made to allow for some dynamic menu aspects ...

Modifications made for xforms
=========================================================================*/

int menu_choice(int choice) {
   fprintf(stderr,"menu_choice: choice=%d\n",choice);
   return choice;
}

int menu_choice1(int choice) {
   fprintf(stderr,"menu_choice1: choice=%d\n",choice);
   return choice;
}

int menu_choice2(int choice) {
   fprintf(stderr,"menu_choice2: choice=%d\n",choice);
   return choice;
}

int make_main_menu(void) {
static char R[] = "make_main_menu";

static
   int     auto_mode_menu,              display_mode_menu,      
           speed_menu,                  file_menu,
           marker_menu,                 tag_menu, 
           x_range_menu,                y_range_menu, 
           range_menu,                  main_menu, 
           stats_menu,                  status_menu, 
           status_window_menu,          accept_frequency_menu, 
           set_max_lxy_menu,            domain_menu, 
           range_gauge_menu,            control_menu, 
           apply_control_menu,          apply_menu, 
           apply1_history_menu,
           apply_sub_menu,              apply2_menu, 
           apply3_menu,                 apply4_menu, 
                                        apply6_menu, 
           applyn_menu,                 reduce_menu, 
           compare_menu,                title_menu, 
           sm_menu,
           video_menu,                  mpeg_menu, 
           var_dq_menu,                 cheby_fit_menu,
           kill_window_menu;

static 
   int     first_call = ON;

   int     i,  isub;
   
   int     ltrace = Ltrace;

#define    LTRACE(a) fprintf(stderr,"make_main_menu: After %s\n",a)
#define    W         Xvsf->main->window


   int     menu1, menu2;


   if( !Remake_main_menu ) return( main_menu );

   if( ltrace ) {
      fprintf(stderr,"make_main_menu: <Begin>.\n");
   }

   if( !first_call )  goto Per_call;

/* F I R S T - C A L L - O N L Y   S E C T I O N */

First_call: 

   stats_menu = fl_newpup(W);
   fl_addtopup(stats_menu,"brief|full %F",display_stats);

   if( ltrace ) fprintf(stderr,"%s: Building apply control menu\n",R);
   apply_control_menu = fl_newpup(W);
   fl_addtopup(apply_control_menu,"apply all on|apply all off %F",
            handle_apply_control_menu);

   apply_menu = fl_newpup(W);

   apply_sub_menu = fl_newpup(W);
   for( i = 1; i < N_Apply1_intrinsic_table; i++ ) {    
         sprintf(O_buf,"%s %%f %%x%d",Apply1_intrinsic_table[i].name,i);
         fl_addtopup(apply_sub_menu,O_buf,handle_yi_fcn_menu);    
   }
   fl_addtopup(apply_menu,"f(y(...)) %m",apply_sub_menu);

   apply_sub_menu = fl_newpup(W);
   for( i = 1; i < N_Apply1_intrinsic_table; i++ ) {    
         sprintf(O_buf,"%s %%f %%x%d",Apply1_intrinsic_table[i].name,i);
         fl_addtopup(apply_sub_menu,O_buf,handle_xi_fcn_menu);    
   }
   fl_addtopup(apply_menu,"f(x(...)) %m",apply_sub_menu);

   for( isub = 0; isub < N_Apply_submenu_table0; isub++ ) {
      apply_sub_menu = fl_newpup(W);
      for( i = 1; i < Apply_submenu_table0[isub].n; i++ ) {
         sprintf(O_buf,"%s %%f %%x%d",
                 Apply_submenu_table0[isub].table[i].name,
                 isub * Apply_submenu_encode + i);
         fl_addtopup(apply_sub_menu,O_buf,handle_apply1_submenu_generic0);
      }
      sprintf(O_buf,"%s %%m",Apply_submenu_table0[isub].title);
      fl_addtopup(apply_menu,O_buf,apply_sub_menu);
   }

   for( i = 1; i < N_Apply1_misc_table; i++ ) {    
      sprintf(O_buf,"%s %%f %%x%d",Apply1_misc_table[i].name,i);
      fl_addtopup(apply_menu,O_buf,handle_apply_menu);    
   }    

   apply2_menu = fl_newpup(W);
   for( i = 1; i < N_Apply2_table; i++ ) {    
      sprintf(O_buf,"%s %%f %%x%d",Apply2_table[i].name,i);
      fl_addtopup(apply2_menu,O_buf,handle_apply2_menu);    
   }    

   apply3_menu = fl_newpup(W);
   for( i = 1; i < N_Apply3_table; i++ ) {    
      sprintf(O_buf,"%s %%f %%x%d",Apply3_table[i].name,i);
      fl_addtopup(apply3_menu,O_buf,handle_apply3_menu);    
   }    

   apply4_menu = fl_newpup(W);
   for( i = 1; i < N_Apply4_table; i++ ) {    
      sprintf(O_buf,"%s %%f %%x%d",Apply4_table[i].name,i);
      fl_addtopup(apply4_menu,O_buf,handle_apply4_menu);    
   }    
   
   apply6_menu = fl_newpup(W);
   for( i = 1; i < N_Apply6_table; i++ ) {    
      sprintf(O_buf,"%s %%f %%x%d",Apply6_table[i].name,i);
      fl_addtopup(apply6_menu,O_buf,handle_apply6_menu);    
   }    
   
   applyn_menu = fl_newpup(W);
   for( i = 1; i < N_Applyn_table; i++ ) {    
      sprintf(O_buf,"%s %%f %%x%d",Applyn_table[i].name,i);
      fl_addtopup(applyn_menu,O_buf,handle_applyn_menu);    
   }    
   
   reduce_menu = fl_newpup(W);
   for( i = 1; i < N_Reduce_table; i++ ) {
      sprintf(O_buf,"%s %%f %%x%d",Reduce_table[i].name,i);
      fl_addtopup(reduce_menu,O_buf,handle_reduce_menu);
   }

   compare_menu = fl_newpup(W);
   for( i = 1; i < N_Compare_table; i++ ) {
      sprintf(O_buf,"%s %%f %%x%d",Compare_table[i].name,i);
      fl_addtopup(compare_menu,O_buf,handle_compare_menu);
   }

   title_menu = fl_newpup(W);
   fl_addtopup(title_menu,"load title|set border color|set border width|set back. color|set H. up col.|set H. up lim. col.|set H. up lim. fmt|set mouse pos. fmt %F",handle_title_menu);

   sm_menu = fl_newpup(W);
   fl_addtopup(sm_menu,
            "generate|gen. ps and print|cd|csd|cd <default>|pwd %F",
            handle_sm_menu);

   video_menu = fl_newpup(W);
   fl_addtopup(video_menu,
            "video|console|enable|disable|overstrike %F",handle_video_menu);

   mpeg_menu = fl_newpup(W);
   fl_addtopup(mpeg_menu,
            "record|play last recorded|play from list|remove .rgb files|keep .rgb files %F",
            handle_mpeg_menu);

   var_dq_menu = fl_newpup(W);
   fl_addtopup(var_dq_menu,"off|zoom %F",handle_var_dq_menu);

   cheby_fit_menu = fl_newpup(W);
   fl_addtopup(cheby_fit_menu,"single|all|selected %F",handle_cheby_fit);

   kill_window_menu = fl_newpup(W);
   fl_addtopup(kill_window_menu,"single|all|selected %F",handle_kill_window);

   apply1_history_menu = -1;

/* P E R - C A L L   S E C T I O N */

Per_call:

   if( first_call )  {
      main_menu = fl_newpup(W);
   } else {
      if( ltrace ) {
         fprintf(stderr,"make_main_menu: Reallocating main menu ...\n");
      }
      fl_freepup(main_menu);
      main_menu = fl_newpup(W);
   }

   if( ltrace ) {
      fprintf(stderr,"make_main_menu: Constructing dynamic menus ...\n");
   }
   if( N_Apply1_history_table > 0 ) { 
      if( apply1_history_menu >= 0 ) fl_freepup(apply1_history_menu);
      apply1_history_menu = fl_newpup(W);
      /* %x<n> bug fixed for this case by pushing "i+1", then indexing with 
       * "code-1" in handle_apply1_history */
      for( i = 0; i < N_Apply1_history_table; i++ ) {
         sprintf(O_buf,"%s %%f %%x%d",Apply1_history_table[i].name,i+1);
         fl_addtopup(apply1_history_menu,O_buf,handle_apply1_history_menu);
      }
   } else {
      if( ltrace ) {
         fprintf(stderr,"make_main_menu: No Apply1 history\n");
      } 
   }

/* Mode setting now handled via Ops form */
/* Range now handled via View form */
/* fl_addtopup(main_menu,"range %m",range_menu); */
/* fl_addtopup(main_menu,"ops (mode) %f",form_do_ops); */
/* fl_addtopup(main_menu,"view %f",form_do_view); */
/* addtopup(main_menu,"speed %m",speed_menu);  */
/* fl_addtopup(main_menu,"file %f",form_do_file); */
/* fl_addtopup(main_menu,"markers %f",form_do_markers); */
/* fl_addtopup(main_menu,"tag %m",tag_menu); */
   fl_addtopup(main_menu,"stats %m",stats_menu);
/* Status menu is obsolete */
/* fl_addtopup(main_menu,"status %m",status_menu); */
/* fl_addtopup(main_menu,"control %m",control_menu); */
   fl_addtopup(main_menu,"apply control %m",apply_control_menu);
   fl_addtopup(main_menu,"apply xy %m",apply_menu);
   if( N_Apply1_history_table > 0 ) {
      fl_addtopup(main_menu,"apply xy hist %m",apply1_history_menu);
   }
   fl_addtopup(main_menu,"apply2 xy %m",apply2_menu);
   fl_addtopup(main_menu,"apply3 xy %m",apply3_menu);
   fl_addtopup(main_menu,"apply4 xy %m",apply4_menu);
   fl_addtopup(main_menu,"apply6 xy %m",apply6_menu);
   fl_addtopup(main_menu,"applyn xy %m",applyn_menu);
   fl_addtopup(main_menu,"reduce %m",reduce_menu);
   fl_addtopup(main_menu,"compare %m",compare_menu);
/* fl_addtopup(main_menu,"title %m",title_menu); */
/* fl_addtopup(main_menu,"sm %m",sm_menu); */
/* fl_addtopup(main_menu,"video %m",video_menu); */
/* fl_addtopup(main_menu,"mpeg %m",mpeg_menu); */
/* fl_addtopup(main_menu,"var. dq %m",var_dq_menu); */
/* fl_addtopup(main_menu,"cheby fit (f77) %m",cheby_fit_menu); */
   fl_addtopup(main_menu,"kill window %m",kill_window_menu);

   if( ltrace ) {
      fprintf(stderr,"make_main_menu: <End>.\n");
   }
   first_call = OFF;
   Remake_main_menu = OFF;

   return(main_menu);

#undef   LTRACE
}
