#ifndef MFL_TYPES_DEF
#define MFL_TYPES_DEF

#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>
#include <forms.h>

#include "constants.h"

typedef struct {
   int     event;
   char   *label;
} LabelledXEvent;

typedef struct rgb_color {
   double r;
   double g;
   double b;
} rgb_color;

typedef struct color_translate {
   int       cindex;
   rgb_color rgb;
} color_translate;

typedef struct mfl_canvas_handler_event {
   FL_OBJECT     *ob;
   Window         win;
   int            w;
   int            h;
   XEvent        *xev;
   void          *gl_void;
} mfl_canvas_handler_event, *pmfl_canvas_handler_event;

typedef struct xvs_font {
   int             size;
   XFontStruct    *info;
} xvs_font;

typedef struct raster_pos {
   double x;
   double y;
} raster_pos;

typedef struct xvs_dl_font_elem {
   int             size;
   XFontStruct    *info;
   int             base;
   int             nglyph;
} xvs_dl_font_elem;

typedef struct xvs_dl_font {
   int               n;
   int               b;
   int               ofst;
   int               ng;
   xvs_dl_font_elem  *f;
} xvs_dl_font;

typedef struct xvs_panel {
   FL_OBJECT   *gl;
   int          font_init;
   int          wt;
} xvs_panel;

typedef  FL_OBJECT *gl_panel_array[MAX_PANEL][MAX_PANEL];

typedef  xvs_panel xvs_panel_array[MAX_PANEL][MAX_PANEL];

#endif
