#ifndef MISCDEF

#include    <sysincludes.h>
#include    "win_types.h"
#include    "xy_types.h"

extern       double  X_mouse;
extern       double  Y_mouse;

int          iclamp(int i, int imin, int imax, int idef);
void         err1(char *,char *);
void         err2(char *,char *);
void         dump_dq_stack(PDQBIND top);
PDQBIND      make_pdqbind(DQUAD,PDQBIND,PDQBIND);
PXYF         make_pxyf(DQUAD,int,int,int);
PXYWINF      make_pxywinf();
void         free_pxywinf(PXYWINF pxywinf);
void         window_ortho2(WT);
void         window_stats(WT);
void         dump_PXYDVBIND(char *s, PXYDVBIND p);
void         dump_wt_iquad(WT wt,char *s,int ltrace);
void         window_sense(WT);
IQUAD        old_iquad_window_sense(WT);
IQUAD        iquad_window_sense(WT);
IQUAD        iquad_from_winno(int);
IQUAD        relative_iquad_from_winno(int);
void         old_dump_window_xy_data(WT);
void         dump_window_xy_data(WT);
void         scan_all_pxy(WT);
void         scan_pxydvbind(PXYDVBIND,char *);
void         test_ring(WT);
void         dump_mallinfo();
WT           old_wt_from_winno(int);
WT           wt_from_winno(int);
void         link_xywinf_to_xyf(WT);
void         set_display_index(WT,int);
void         set_display_index_current(WT);
int          get_display_index(WT);
double       display_index_to_unit_interval(WT wt);
PXYDVEC      pnth_XYDVEC(PXYDVBIND,int);
int          set_must_remap(WT);
int          unset_must_remap(WT);
int          get_must_remap(WT);
int          set_must_redraw(WT);
int          unset_must_redraw(WT);
int          get_must_redraw(WT);
int          set_domain_mode(WT,int);
int          get_domain_mode(WT);
void         set_marker_type(WT wt,int marker_type);
void         set_marker_size(WT wt,double marker_size);
void         set_point_size(WT wt,int point_size);
void         set_marker_size_relative(WT wt,int n_times_default);
void         set_marker_npoly(WT wt,int npoly);
int          set_marker_multi_mode_old(WT);
int          set_marker_multi_mode(WT);
void         set_marker_multi_mode_val(WT wt,int val);
int          unset_marker_multi_mode_old(WT);
int          unset_marker_multi_mode(WT);
int          set_marker_limits(WT wt);
int          set_marker_rainbow_mode(WT);
int          set_marker_line_auto_break(WT wt);
int          unset_marker_line_auto_break(WT wt);
int          unset_marker_rainbow_mode(WT);
int          get_marker_multi_mode(WT);
int          set_border_color(WT,int);
int          change_border_color(WT,int);
PDQBIND      flush_dq_stack(PDQBIND);
PDQBIND      flush_dq_stack_no_empty(PDQBIND p);
PDQBIND      push_dq(PDQBIND,DQUAD);
PDQBIND      pop_dq(PDQBIND);
PDQBIND      pop_dq_no_empty(PDQBIND);
PDQBIND      replace_dq(PDQBIND,DQUAD);
int          dq_stack_depth(PDQBIND);
void         dqc_from_dqb(WT wt);
void         dqc_reset(WT wt);
void         dqc_from_current_xrange(WT wt);
DQUAD        dq_wt(WT);
DQUAD        dq_xydv_list(PXYDVBIND);
DQUAD        dq_xydv_list_r(PXYDVBIND,double,double);
DQUAD        dq_xydv(PXYDVBIND);
DQUAD        dq_xydv_r(PXYDVBIND,double,double);
void         dqc_from_xycurr(WT);
void         dqc_for_full_scale(WT wt);
int          var_dquad_display_mode(WT wt);
void         dqc_for_var_dquad_zoom(WT wt);
void         dqc_for_full_scale_x_and_y(WT wt);
void         auto_border_x_wt(WT);
void         auto_border_xy_wt(WT);
void         manual_border_wt(WT);
void         push_limits_r(WT,double,double);

void         safe_set_pxy_wt(WT);
void         thin_wt(WT,double);

void         apply_func_0_wt(int,PXYDVBIND_FCN);
void         time_reverse_wt(WT wt);

WT           wt_from_name(char *);

double       wt_xmin(WT);
double       wt_xmax(WT);
double       wt_ymin(WT);
double       wt_ymax(WT);

int          wait_for_mouse();

double       x_mouse_after_button();
double       y_mouse_after_button();

int          clone_wt(WT);
void         old_copy_xyf(WT wt1,WT wt2);
void         copy_xyf(WT wt1,WT wt2);
void         copy_xywinf(WT,WT);

int          create_reduced_wt(WT wt);
void         create_reduced_xyf(WT wt1,WT wt2);

void         centre_mouse_in_wt(WT);
int          mouse_is_near_wt(WT wt,double fracx,double fracy);
int          heads_up_status(void);
void         toggle_heads_up(WT);
void         set_heads_up(WT);
void         unset_heads_up(WT);
void         toggle_heads_up_lim(WT);
void         set_heads_up_lim(WT);
void         unset_heads_up_lim(WT);

void         scan_windows();
int          is_next_key_ESCKEY();

void         set_line_color(WT,int);
void         set_line_width(WT,int);
void         set_marker_color(WT,int);

int          Q_border_color(WT);
void         set_status_wt(WT,int);

void         move_window(void);
void         move_window_1(int opcode);

double       wtstringwidth(WT wt,fmfonthandle fh,char *string);
double       wtfracstringwidth(WT wt,fmfonthandle fh,char *string);
#define      DS_LL      0
#define      DS_UL      1
#define      DS_UR      2
#define      DS_LR      3
void         old_wtdisplaystringoffset(
                                   WT wt,fmfonthandle fh,char *string,int col,
                                   double xoffset,double yoffset,int code);
void         wtdisplaystringoffset(WT wt,fmfonthandle fh,char *string,int col,
                                   double xoffset,double yoffset,int code);
void         wtdisplaystringabsolute(WT wt,fmfonthandle fh,char *string,int col,
                                   int x,int y);

BAR_GAUGE    make_default_range_gauge(void);
void         dump_range_gauge(BAR_GAUGE range_gauge);

int          ix_first_visible(DQUAD dq,DVEC x,int n);
int          ix_last_visible(DQUAD dq,DVEC x,int n);
int          n_visible(DQUAD dq,DVEC x,int n);
int          n_visible_xy(DQUAD dq,DVEC x,DVEC y,int n);
void         get_ix_visible(WT wt,int *ix_min,int *ix_max);
void         set_full_scale_mode(WT wt);
void         unset_full_scale_mode(WT wt);
void         toggle_full_scale_mode(WT wt);

void         _fsleep(void);
void         fsleep(float secs);


#define MISCDEF
#endif
