#ifndef DEF_MYGL
#define DEF_MYGL
typedef long  Boolean;  
typedef float Coord;  
typedef short Scoord; 
typedef long  Icoord;
typedef unsigned short Device; 
typedef unsigned short Colorindex; 

typedef long *fmfonthandle;
typedef struct fmfontinfo {
   long printermatched;
   long reserved0;
   double matrix00;
   double matrix01;
   double matrix10;
   double matrix11;
   long type;     /* see fmfontinfo->type  below */
   long encoding;
   long fixed_width;
   long xorig;
   long yorig;
   long xsize;
   long ysize;
   long height;
   long nglyphs;
   long bitsdeep;     /* if nonzero, the depth of all glyphs in font */
   long width;     /* the largest setwidth in the font */
   long resolution;
   long weight;       /* [0..1000], the # of black bits that would be on if this were an of 1000-pixel chars */
   long firstcol;
   long lastcol;
   long firstrow;
   long lastrow;
   long padding[26];   /* for future expansion */
} fmfontinfo; 

extern void prefposition(long x1, long x2, long y1, long y2);
extern void noborder(void);
extern void winclose(long gwid);
extern long winget();
extern long winopen(char *name);
extern void winpop(void);
extern void winposition(long x1, long x2, long y1, long y2);
extern void winset(long gwid);

extern void attachcursor(Device vx, Device vy);
extern void bgnline(void);
extern void endline(void);
extern void bgnpoint(void);
extern void endpoint(void);
extern void bgnpolygon(void);
extern void endpolygon(void);
extern void clear(void);
extern void cmov2(Coord x, Coord y);
extern void cmov2i(Icoord x, Icoord y);
extern void cmov2s(Scoord x, Scoord y);
extern void color(Colorindex c);
extern void curson(void);
extern void cursoff(void);
extern Boolean getbutton(Device num);
extern void getcpos(short *ix, short *iy);
extern void getcursor(short *index, Colorindex *color, Colorindex *wtm, Boolean *b);
extern long getgdesc(long inquiry);
extern void getorigin(long *x, long *y);
extern long getplanes(void);
extern void getsize(long *x, long *y);
extern long getvaluator(Device dev);
extern void getmcolor(Colorindex i, short *red, short *green, short *blue);
extern short linewidth(short n);
extern void mapcolor(Colorindex i, short red, short green, short blue);
extern void ortho2(Coord left, Coord right, Coord bottom, Coord top);
extern void rect(Coord x1, Coord y1, Coord x2, Coord y2);
extern void rectf(Coord x1,  Coord y1, Coord x2, Coord y2);
extern void rectfi(Icoord x1, Icoord y1, Icoord x2, Icoord y2);
extern void reshapeviewport(void);
extern void ringbell(void);
extern void setvaluator(Device v, short init, short vmin, short vmax);
extern void v2d(double *vector);

extern void unqdevice(Device dev);
extern void qdevice(Device dev);
extern void qenter(Device dev, short val);
extern long qread(short *data);
extern void qreset(void);
extern long qtest(void);

extern void foreground(void);
extern void gconfig(void);

extern void backbuffer(Boolean b);
extern void frontbuffer(Boolean b);
extern void doublebuffer(void);
extern void swapbuffers(void);

extern void addtopup(long pup, char *str, ...);
extern long dopup(long pup);
extern long freepup(long pup);
extern long newpup(void);

extern void fmenumerate(void (*callback) ());
extern fmfonthandle fmfindfont(char *face);
extern void fmfreefont(fmfonthandle fh);
extern long fmgetfontinfo(fmfonthandle fh, fmfontinfo *info);
extern long fmgetstrwidth(fmfonthandle fh, char *str);
extern void fminit(void);
extern long fmoutchar(fmfonthandle fh, unsigned int ch);
extern long fmprstr(char *str);
extern fmfonthandle fmscalefont(fmfonthandle fh, double scale);
extern void fmsetfont(fmfonthandle fh);

#endif
