/*   U T I L I T Y     M A T H     R O U T I N E S    */

#include <math.h>
#include "mymath.h"

double dmin(double d1,double d2) {
   return((d1 < d2) ? d1 : d2);
}

double dmax(double d1,double d2) {
   return((d1 > d2) ? d1 : d2);
}

double dsign(double d){
   return( (d >= 0.0) ? 1.0 : -1.0 );
}

int imin(int i1,int i2) {
   return((i1 < i2) ? i1 : i2);
}

int imax(int i1,int i2) {
   return((i1 > i2) ? i1 : i2);
}

int fuzz_eq(double d1,double d2,double d3) {
   if( d1 == 0.0 ) {
      return d2 < fabs(d3);
   } else {
      return (fabs(d1 - d2) / fabs(d1)) <= fabs(d3);
   }
}

int fuzz_ne(double d1,double d2,double d3) {
   return( !fuzz_eq(d1,d2,d3) );
}

int fuzz_le(double d1,double d2,double d3) {
   return( fuzz_eq(d1,d2,d3) || (d1 < d2) );
}

int fuzz_ge(double d1,double d2,double d3) {
   return( fuzz_eq(d1,d2,d3) || (d1 > d2) );
}
