#include "project.h"

int                Ser_video_state;
IQUAD              Save_scope_iquad;

/*   CITA enable/disable commands ...    
char               Video_to_video_command[] = "rs170sg";
char               Video_to_console_command[] = "hz60";
                                                 ...              */

/*   Pre-video lab Texas enable/disable commands ... 
char               Video_to_video_command[] = "ntsc";
char               Video_to_console_command[] = "reset";
                                                 ...              */

char              *Video_to_video_command   = NULL;
char              *Video_to_console_command = NULL;

int                Video_enable = OFF;
int                Video_test   = OFF;

char              *Video_overstrike_fname = NULL;
IVECN              Video_overstrike = {NULL,0};

/* Save and restore server window position (for video interface). */

#define     WINNO         wds[scope_wt].sgi_winno

void ser_to_video()
{
   int      ltrace = OFF;
      
   if( ltrace ) {
      printf("ser_to_video: In routine.\n");
   }
   if( Ser_video_state != VIDEO_VIDEO ) {

      scope_to_PANEL_MODE_no_repanel();
      if( Ser_video_state == VIDEO_CONSOLE ) {
         Save_scope_iquad = iquad_window_sense(scope_wt);
      }

      winclose(WINNO);
      Scope_wid = VIDEO_SCOPE_WID;
      Status_wid = VIDEO_SCOPE_WID;
      Scope_hit = VIDEO_SCOPE_HIT;
      prefposition(VIDEO_STATUS_XLC,VIDEO_STATUS_XLC + Status_wid,
                   VIDEO_STATUS_YLC,VIDEO_STATUS_YLC + SCOPE_HEAD_HIT);
/*    Make main 'vs' window borderless even if video is not enabled ... */
      if( video_enabled() ) {
         noborder();
      }

      WINNO = (scope_sgi_winno = winopen(scope_name)); 
      winset(WINNO); color(SCOPE_COLOR); clear(); swapbuffers();

      window_sense(scope_wt);
      centre_mouse_in_wt(scope_wt);
      set_video_display();
      repanel(n_windows_1());
      loadmap_from_file(Default_video_color_map_file);
      if( Video_enable ) {
         if( serving_on_video_host() && !Video_test ) {
            if( video_open_rs232() ) {
               if( ltrace ) {
                  scope_mess_and_bell("Video port opened.",1);
               }
               if( Video_to_video_command ) {
                  system(Video_to_video_command);     
               }
            } else {
               scope_mess_and_bell("Video port open failed.",1);
            }
         } else {
            scope_mess_and_bell("Not serving on video host.",1);
         }
      }
      Ser_video_state = VIDEO_VIDEO;
      video_set_record_trace();
      apply_all_wt_1((PFV_II) Set_display_mode,FREEZE_MODE);
      apply_all_wt_0((PFV_I) set_must_redraw);
      set_Heads_up_values(Ser_video_state);
      force_scope_redraw();
   } else {
      if( ltrace ) {
         printf("ser_to_video: Already in VIDEO_VIDEO.\n");
      }
   }
}

void ser_to_console()
{
   int      ltrace = OFF;

   if( ltrace ) {
      printf("ser_to_console: In routine.\n");
   }
   if( Ser_video_state != VIDEO_CONSOLE ) {

      winclose(WINNO);
      Scope_wid = DEFAULT_SCOPE_WID;
      Status_wid = DEFAULT_SCOPE_WID;
      Scope_hit = DEFAULT_SCOPE_HIT;
      prefposition(Save_scope_iquad.x1,Save_scope_iquad.x1 + Status_wid,
                   Save_scope_iquad.y1,Save_scope_iquad.y1 + SCOPE_HEAD_HIT);
      WINNO = (scope_sgi_winno = winopen(scope_name));
      winset(WINNO); color(SCOPE_COLOR); clear(); swapbuffers();

      window_sense(scope_wt);
      repanel(n_windows_1());
      set_console_display();
      if( ltrace ) {
         fprintf(stderr,"ser_to_console: Calling loadmap_from_file(%s)\n",
                 Default_color_map_file);
      }
      loadmap_from_file(Default_color_map_file);
      if( Video_enable && ( Ser_video_state == VIDEO_VIDEO) 
                       && serving_on_video_host() && !Video_test ) {
         if( video_close_rs232() ) {
            if( ltrace ) {
               scope_mess_and_bell("Video port closed.",1);
            }  
         } else {
            scope_mess_and_bell("Video port close failed.",1);
         }
         if( Video_to_console_command ) {
            system(Video_to_console_command);
         }
      }
      centre_mouse_in_wt(scope_wt);
      Ser_video_state = VIDEO_CONSOLE;
      video_unset_record_trace();
      apply_all_wt_0((PFV_I) set_must_redraw);
      set_Heads_up_values(Ser_video_state);
      force_scope_redraw();
   } else {
      if( ltrace ) {
         printf("ser_to_video: Already in VIDEO_CONSOLE.\n");
      }
   }
}

void ser_to_full_screen()
{
   int      ltrace = OFF;
      
   if( ltrace ) {
      printf("ser_to_full_screen: In routine.\n");
   }
   if( Ser_video_state != VIDEO_FULL_SCREEN ) {

      scope_to_PANEL_MODE_no_repanel();
      if( Ser_video_state == VIDEO_CONSOLE ) {
         Save_scope_iquad = iquad_window_sense(scope_wt);
      }

      winclose(WINNO);
      Scope_wid = FULL_SCREEN_SCOPE_WID;
      Status_wid = FULL_SCREEN_SCOPE_WID;
      Scope_hit = FULL_SCREEN_SCOPE_HIT;
      prefposition(FULL_SCREEN_STATUS_XLC,FULL_SCREEN_STATUS_XLC + Status_wid,
                   FULL_SCREEN_STATUS_YLC,FULL_SCREEN_STATUS_YLC + SCOPE_HEAD_HIT);
      WINNO = (scope_sgi_winno = winopen(scope_name));
      winset(WINNO); color(SCOPE_COLOR); clear(); swapbuffers();

      window_sense(scope_wt);
      centre_mouse_in_wt(scope_wt);
      set_full_screen_display();
      repanel(n_windows_1());
      loadmap_from_file(Default_color_map_file);
      if( Video_enable && ( Ser_video_state == VIDEO_VIDEO) 
                       && serving_on_video_host() && !Video_test ) {
         system(Video_to_console_command);
      }
      Ser_video_state = VIDEO_FULL_SCREEN;
      video_unset_record_trace();
      apply_all_wt_0((PFV_I) set_must_redraw);
      set_Heads_up_values(Ser_video_state);
      force_scope_redraw();
   } else {
      if( ltrace ) {
         printf("ser_to_full_screen: Already in VIDEO_FULL_SCREEN.\n");
      }
   }
}

void ser_video_transition(int new_video_state)
{
   int    ltrace = OFF;
   if( ltrace ) {
      printf("ser_video_transition: In routine.\n");
   }

   switch( new_video_state ) {
   case VIDEO_VIDEO:
      ser_to_video();
      break;
   case VIDEO_CONSOLE:
      ser_to_console();
      break;
   case VIDEO_FULL_SCREEN:
      ser_to_full_screen();
      break;
   default:
      printf("ser_video_transition: Unknown new_video_state %d.\n",
             new_video_state);
      break;
   }
}

void set_console_display()
{
   border_width = BORDER_WIDTH;
   Default_line_color = DEFAULT_LINE_COLOR;
   Default_line_width = DEFAULT_LINE_WIDTH;
   Default_poly_color = DEFAULT_POLY_COLOR;
   Default_marker_color = Default_poly_color;
   set_all_markers(POINT_TYPE,1,DEFAULT_MARKER_NPOLY);
   apply_all_wt_0((PFV_I) set_status_window_flag);
   T_border_color = DEFAULT_TITLE_BORDER_COLOR;
   Synch_mode = OFF;    
}

void set_video_display()
{
   border_width = VIDEO_BORDER_WIDTH;
   Default_point_color = DEFAULT_VIDEO_POINT_COLOR;
   Default_line_color = DEFAULT_VIDEO_LINE_COLOR;
   Default_line_width = DEFAULT_VIDEO_LINE_WIDTH;
   Default_poly_color = DEFAULT_VIDEO_POLY_COLOR;
   Default_marker_color = Default_poly_color;
   set_all_markers(POLY_TYPE,2,VIDEO_MARKER_NPOLY);
   apply_all_wt_0((PFV_I) unset_status_window_flag);
   T_border_color = BLACK;

   Synch_mode = ON;    
}

void set_full_screen_display()
{
   border_width = BORDER_WIDTH;
   Default_point_color = DEFAULT_FULL_SCREEN_POINT_COLOR;
   Default_line_color = DEFAULT_FULL_SCREEN_LINE_COLOR;
   Default_line_width = DEFAULT_FULL_SCREEN_LINE_WIDTH;
   Default_poly_color = DEFAULT_FULL_SCREEN_POLY_COLOR;
   Default_marker_color = Default_poly_color;
   set_all_markers(POINT_TYPE,1,DEFAULT_MARKER_NPOLY);
   apply_all_wt_0((PFV_I) unset_status_window_flag);
   T_border_color = DEFAULT_TITLE_BORDER_COLOR;
   Synch_mode = OFF;    
}

void set_all_markers(int marker_type,int marker_size,int marker_npoly)
{
   apply_all_wt_1((PFV_II) set_line_color,Default_line_color);
   apply_all_wt_1((PFV_II) set_line_width,Default_line_width);
   apply_all_wt_1((PFV_II) set_marker_color,Default_marker_color);
   apply_all_wt_1((PFV_II) set_marker_size_relative, marker_size);
   apply_all_wt_1((PFV_II) set_marker_npoly, marker_npoly);
   apply_all_wt_1((PFV_II) set_marker_type,marker_type);
}

#undef      WINNO

int serving_on_video_host(void) {
   int    ltrace = OFF;

   if( ltrace ) {
      printf("serving_on_video_host: Serving on %s.\n",shostname);
   }
   return !strcmp(shostname,"einstein");
}

int video_active() {
   return video_enabled() && video_video_state();
}

int video_enabled() {
   return Video_enable || Video_test;
}

int video_video_state() {
   return Ser_video_state == VIDEO_VIDEO;
}

void force_scope_redraw(void) {
   if( wt_from_mouse() == SCOPE_WT ) { 
      last_S_wt = -1;
   }
   activate_window_with_mouse();
}

int nvs_video_record_n_seconds(double pm_n,int prompt) {
   double n;
   int    n_frames, default_n = 1.0;
   int    ltrace = OFF;

   n = fabs(pm_n);

   if( prompt ) {
      GET_DOUBLE(n,default_n,"Record time (secs)");
   }
   if( video_enabled() ) { 
/*    cursoff();  */
      if( pm_n > 0.0 ) {
         apply_all_wt_1((PFV_II) set_border_color,VIDEO_RECORD_BORDER_COLOR);
         apply_all_wt_0((PFV_I) display_window_1);
      }
      winset(wds[S_wt].sgi_winno); 
      if( !Video_sequence_label ) {
         video_set_sequence_label(wds[S_wt].name);
      }
      n_frames = Video_test ? 
                 (n * FRAMES_PER_SECOND) : video_record_n_seconds(n);
      if( ltrace ) {
         sprintf(O_buf,"Recorded %d frames.",n_frames);
         scope_mess_and_bell(O_buf,1);
      }
   } else {
      scope_mess_and_bell("Video not enabled.",1);
   }
   return 0;
}

int old_nvs_video_record_one_frame(void) {
   int    n_frames;
   int    ltrace = OFF;

   if( video_enabled() ) { 
/*    cursoff();  */
      apply_all_wt_1((PFV_II) set_border_color,VIDEO_RECORD_BORDER_COLOR);
      apply_all_wt_0((PFV_I) display_window_1);
      winset(wds[S_wt].sgi_winno); 
      if( !Video_sequence_label ) {
         video_set_sequence_label(wds[S_wt].name);
      }
      n_frames = video_record_one_frame();
      if( ltrace ) {
         sprintf(O_buf,"Recorded %d frames.",n_frames);
         scope_mess_and_bell(O_buf,1);
      }
   } else {
      scope_mess_and_bell("Video not enabled.",1);
   }
   return 0;
}

int  nvs_video_record_n_frames(int n_frames) {
   int    i_frame;
   int    n_recorded = 0;
   int    ltrace = OFF;

   if( video_enabled() ) { 
      apply_all_wt_1((PFV_II) set_border_color,VIDEO_RECORD_BORDER_COLOR);
      apply_all_wt_0((PFV_I) display_window_1);
      winset(wds[S_wt].sgi_winno); 
      if( !Video_sequence_label ) {
         video_set_sequence_label(wds[S_wt].name);
      }
      if( Video_test ) {
         n_recorded = n_frames;
      } else { 
         for( i_frame = 0; i_frame < n_frames; i_frame++ ) {
            n_recorded += video_record_one_frame();
         }
      }
      if( ltrace ) {
         sprintf(O_buf,"Recorded %d frames.",n_recorded);
         scope_mess(O_buf,1);
      }
   } else {
      scope_mess_and_bell("Video not enabled.",1);
   }
   return( n_recorded );
}

int nvs_video_record_one_frame(void) {
   return(nvs_video_record_n_frames(1));
}

void set_Heads_up_values(int code) {
   switch( code ) {
   case VIDEO_VIDEO:
   case VIDEO_FULL_SCREEN:
      if( V_heads_up_lim_format ) free(V_heads_up_lim_format);
      V_heads_up_lim_format = strdup(V_heads_up_lim_default_format_video);
   case VIDEO_CONSOLE:
      Heads_up_xoffset = V_Heads_up_xoffset[code];
      Heads_up_yoffset = V_Heads_up_yoffset[code];
      Heads_up_color = V_Heads_up_color[code];
      Heads_up_short_format = V_Heads_up_short_format[code];
      Heads_up_long_format = V_Heads_up_long_format[code];
      Heads_up_fh = V_Heads_up_fh[code];

      Heads_up_lim_xlc = V_Heads_up_lim_xlc[code];
      Heads_up_lim_ylc = V_Heads_up_lim_ylc[code];
      Heads_up_lim_xuc = V_Heads_up_lim_xuc[code];
      Heads_up_lim_yuc = V_Heads_up_lim_yuc[code];
      Heads_up_lim_color = V_Heads_up_lim_color[code];
      Heads_up_lim_fh = V_Heads_up_lim_fh[code];
      if( !V_heads_up_lim_format ) {
         V_heads_up_lim_format = strdup(V_heads_up_lim_default_format);
      }

      break;
   default:
      printf("set_Heads_up_values: Unrecognized code: %d.\n",code);
      break;
   }
   return;
}

int wtcursorstate(WT wt) {
   short       index;
   Colorindex  color,  wtm;
   Boolean     b;

   int         ltrace = OFF;
   
   if( wds[wt].sgi_winno >= 0 ) {
      winset(wds[wt].sgi_winno);
      getcursor(&index,&color,&wtm,&b);
      if( ltrace ) {
         printf("wtcursorstate(%d): Cursor state: %d.\n",wt,b);
      }
      return b;
   } else {
      return 0;
   }
}

void wtcursoron(WT wt) {
   if( wds[wt].sgi_winno >= 0 ) {
      winset(wds[wt].sgi_winno);
      curson();
   }
}

void wtcursoroff(WT wt) {
   if( wds[wt].sgi_winno >= 0 ) {
      winset(wds[wt].sgi_winno);
      cursoff();
   }
}

void  wtcursortoggle(WT wt) {
   if( wds[wt].sgi_winno >= 0 ) {
      winset(wds[wt].sgi_winno);
      wtcursorstate(wt) ? wtcursoroff(wt) : wtcursoron(wt);
   }
}
