#include "project.h"

/* Intermediate level queue--handler routines. */

#define  PP  wds[S_wt].winf.pwf.pxywinf
#define  FP  wds[S_wt].pf.pxyf
#define  ABORT_IF_NULL(a) if( a == NULL ) return

void do_main_menu (void) {
   if( Enable_pup ) {
      In_pup = 1; (void) fl_dopup(main_menu); In_pup = 0;
/*    Force redraw of all windows and main form ... */
      apply_all_wt_0((PFV_I) set_must_redraw);
      fl_redraw_form(Xvsf->main);
   } else {
      Enable_pup = 1;
   }
}

int do_picking(int button) {
   static char R[] = "do_picking";
   int   ltrace = Ltrace;
   int   rc = 0;

   if( ltrace ) fprintf(stderr,"%s: button=%d\n",R,button);
   if( Form_state == FORM_STATE_PICKING ) {
      picked_wt();
      rc = 1;
   }
   if( Form_state == FORM_STATE_MPICKING ) {
      switch( button ) {
      case LEFTMOUSE:
      case RIGHTMOUSE:
         mpick_wt(MPICK_ADD,0);
         break;
      case MIDDLEMOUSE:
         mpick_wt(MPICK_END,0);
         break;
      default:
         break;
      }
      rc = 1;
   }
   return rc;
}

int do_splitting(int button) {
   static char R[] = "do_splitting";
   int   ltrace = Ltrace;
   int   rc = 0;

   if( ltrace ) fprintf(stderr,"%s: button=%d wt=%d\n",R,button,S_wt);
   if( Form_state == FORM_STATE_SPLITTING ) {
      if( ltrace ) {
         fprintf(stderr,"%s: Would split window at x=%g\n",R,
            xmouse_w_wt(S_wt));
         fprintf(stderr,"%s: Split direction=%d\n",R,Split_dir);
      }
      (void) xvs_split_wt(S_wt,xmouse_w_wt(S_wt),Split_dir,OFF);
      scope_mess_perm(" ");
      xvs_form_state_pop();
      rc = 1;
   }
   return rc;
}

/*----------------------------------------------------
Implementation still subject to modification ...
----------------------------------------------------*/
void qd_MIDDLEMOUSE(void) {
   static char R[] = "qd_MIDDLEMOUSE";

   int     ltrace = Ltrace;

   if( ltrace ) {
      fprintf(stderr,"%s: S_wt=%d\n",R,S_wt);
   }

/* Handle edit mode first ... */ 
   if( PP ) {
      if( PP->display_mode == EDIT_MODE ) {
         qd_EDIT(S_wt,MIDDLEMOUSE);
         return;
      }
   }

/* Handle picking ... */
   if( do_picking(MIDDLEMOUSE) ||
       do_splitting(MIDDLEMOUSE) ) return;

/* Return if control panel is up and mouse is not in active window ... */
   if( (Form_state == FORM_STATE_CONTROL) &&
       (wt_from_mouse() != S_wt ))  {
      return;
   }

   if(        alt_ctrl_keys_pressed() ) {
      do_close_wt(S_wt);
   } else if( alt_key_pressed() || ctrl_key_pressed() ) {
      if( ltrace ) {
         fprintf(stderr,"%s: Invoking do_scope_mode_transition()\n",R);
      }
      do_scope_mode_transition();
   } else {
      ABORT_IF_NULL(PP);
      switch( PP->display_mode ) {
      case SSTEP_MODE:
         if( Synch_mode ) {
            qd_synch_SSTEP(lalhead->wtl,MIDDLEMOUSE);
         } else {
            qd_SSTEP(S_wt,MIDDLEMOUSE);
         }
         break;
      case X_ZOOM_MODE:
         qd_X_ZOOM(S_wt,MIDDLEMOUSE);
         break;
      case Y_ZOOM_MODE:
         qd_Y_ZOOM(S_wt,MIDDLEMOUSE);
         break;
      case XY_ZOOM_MODE:
         qd_XY_ZOOM(S_wt,MIDDLEMOUSE);
         break;
      case X_RANGE_XMIN_MODE:
      case X_RANGE_XMAX_MODE:
         qd_X_RANGE(S_wt,MIDDLEMOUSE);
         break;
      case Y_RANGE_YMIN_MODE:
      case Y_RANGE_YMAX_MODE:
         qd_Y_RANGE(S_wt,MIDDLEMOUSE);
         break;
      case EFFECTS_MODE:
         qd_EFFECTS(S_wt,MIDDLEMOUSE);
         break;
      case FREEZE_MODE:
         break;
      case AUTO_MODE:
         if( PP->auto_break_mode == AUTO_BREAK_WAIT) {
            if( video_active() ) {
               if( ltrace ) {
                  fprintf(stderr,"qd_MIDDLEMOUSE: Start_frame %d ",Start_frame);
                  fprintf(stderr,"Finish_frame %d.\n",Finish_frame);
                  
               }
               if( Start_frame == NO_START_FRAME ) {
                  Start_frame = video_get_ldr_frame();
                  video_set_sequence_label(wds[S_wt].name);
                  if( ltrace ) {
                     fprintf(stderr,
                          "qd_MIDDLEMOUSE: Start_frame: %d ",Start_frame);
                     fprintf(stderr,
                          "Video_sequence_label: %s.\n",Video_sequence_label);
                  }
                  cursoff();
                  video_unset_record_trace();
               } else {
                  video_set_record_trace();
                  Finish_frame = video_get_ldr_frame();
                  if( ltrace ) {
                     fprintf(stderr,
                          "qd_MIDDLEMOUSE:: Finish_frame %d ",Finish_frame);
                     fprintf(stderr,
                          "Video_sequence_label: %s.\n",Video_sequence_label);
                  }
                  video_record_trace_sequence(Start_frame,Finish_frame);
                  Start_frame = NO_START_FRAME;
                  curson();
               }
            }
            if( video_active() && Synch_mode ) {
               apply_all_wt_0((PFV_I) reset_auto_break);
               if( FP->display_index != 1 ) {
                  apply_all_wt_0((PFV_I) auto_advance);
               }
            } else {
               if( control_apply_all_wt() ) {
                  apply_all_wt_0((PFV_I) reset_auto_break);
                  if( FP->display_index != 1 ) {
                     apply_all_wt_0((PFV_I) auto_advance);
                  }
               } else {
                  reset_auto_break(S_wt);
                  if( FP->display_index != 1 ) {
                     auto_advance(S_wt);
                  }
               }
            }
         }
         break;
      case WHERE_IS_MOUSE_MODE:
         where_is_mouse(WHERE_IS_MOUSE_OFF);
         break;
      default:
         printf("qd_MIDDLEMOUSE: Unexpected display_mode %d.\n",
                PP->display_mode);
      break;
      }
   }
}

/*----------------------------------------------------
Implementation still subject to modification ...
----------------------------------------------------*/
void qd_RIGHTMOUSE() {
   static char R[] = "qd_RIGHTMOUSE";
   int rc;

   int ltrace = Ltrace;

   if( ltrace ) {
      fprintf(stderr,"%s: S_wt=%d\n",R,S_wt);
   }

/* Handle picking ... */
   if( do_picking(RIGHTMOUSE) ||
       do_splitting(RIGHTMOUSE) ) return;

/* Return if control panel is up and mouse is not in active window ... */
   if( (Form_state == FORM_STATE_CONTROL) &&
       (wt_from_mouse() != S_wt ))  {
      return;
   }

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case SSTEP_MODE:
      if( Synch_mode ) {
         qd_synch_SSTEP(lalhead->wtl,RIGHTMOUSE);
      } else {
         qd_SSTEP(S_wt,RIGHTMOUSE);
      }
      break;
   case X_ZOOM_MODE:
      qd_X_ZOOM(S_wt,RIGHTMOUSE);
      break;
   case Y_ZOOM_MODE:
      qd_Y_ZOOM(S_wt,RIGHTMOUSE);
      break;
   case XY_ZOOM_MODE:
      qd_XY_ZOOM(S_wt,RIGHTMOUSE);
      break;
   case X_RANGE_XMIN_MODE:
   case X_RANGE_XMAX_MODE:
      qd_X_RANGE(S_wt,RIGHTMOUSE);
      break;
   case Y_RANGE_YMIN_MODE:
   case Y_RANGE_YMAX_MODE:
      break;
   case EFFECTS_MODE:
      qd_EFFECTS(S_wt,RIGHTMOUSE);
      break;
   case FREEZE_MODE:
   case AUTO_MODE:
      if( shift_key_pressed() && !alt_key_pressed() ) {
         set_display_mode(X_RANGE_XMAX_MODE);
      } else {
         do_main_menu();
      }
      break;
   case WHERE_IS_MOUSE_MODE:
      (void) dump_xymouse_w_wt(S_wt);
      break;
   case EDIT_MODE:
      qd_EDIT(S_wt,RIGHTMOUSE);
      break;
   default:
      printf("qd_RIGHTMOUSE: Unexpected display_mode %d.\n",
             PP->display_mode);
      break;
   }
}

/*----------------------------------------------------
Implementation still subject to modification ...
----------------------------------------------------*/
void qd_LEFTMOUSE(void) {
   static char R[] = "qd_LEFTMOUSE";
   int wt;
   int rc;

   int ltrace = Ltrace;

   if( ltrace ) {
      fprintf(stderr,"%s: S_wt=%d Form_state=%d\n",R,S_wt,Form_state);
   }

/* Handle picking ... */
   if( do_picking(LEFTMOUSE) ||
       do_splitting(LEFTMOUSE) ) return;

/* Handle window selection while control panel is up ... */
   if( (Form_state == FORM_STATE_CONTROL) &&
       (wt_from_mouse() != S_wt ) )  {
      activate_window_with_mouse();
      widgets_set_all(S_wt);
      return;
   }

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case SSTEP_MODE:
   if( Synch_mode ) {
         qd_synch_SSTEP(lalhead->wtl,LEFTMOUSE);
      } else {
         qd_SSTEP(S_wt,LEFTMOUSE);
      }
      break;
   case X_ZOOM_MODE:
      qd_X_ZOOM(S_wt,LEFTMOUSE);
      break;
   case Y_ZOOM_MODE:
      qd_Y_ZOOM(S_wt,LEFTMOUSE);
      break;
   case XY_ZOOM_MODE:
      qd_XY_ZOOM(S_wt,LEFTMOUSE);
      break;
   case X_RANGE_XMIN_MODE:
   case X_RANGE_XMAX_MODE:
      qd_X_RANGE(S_wt,RIGHTMOUSE);
      break;
   case Y_RANGE_YMIN_MODE:
   case Y_RANGE_YMAX_MODE:
      break;
   case EFFECTS_MODE:
      qd_EFFECTS(S_wt,LEFTMOUSE);
      break;
   case FREEZE_MODE:
/*
      if( shift_key_pressed() && !alt_key_pressed() ) {
         set_display_mode(X_RANGE_XMIN_MODE);
         qenter(MIDDLEMOUSE,(short) ON);
      } else {
           (void) edit_display_mouse_and_nearest_data(S_wt);
      }
      if( shift_key_pressed() && !alt_key_pressed() ) {
         set_display_mode(X_RANGE_XMIN_MODE);
         qenter(MIDDLEMOUSE,(short) ON);
      } else {
         do_main_menu();
      }
*/
      if( shift_key_pressed() && !alt_key_pressed() ) {
         set_display_mode(X_RANGE_XMIN_MODE);
      } 
      if( S_wt >= 0 ) {
         set_must_redraw(S_wt);
      }
      break;
   case AUTO_MODE:
/*
      if( shift_key_pressed() && !alt_key_pressed() ) {
         set_display_mode(X_RANGE_XMIN_MODE);
      } else {
         do_main_menu();
      }
*/
      break;
   case WHERE_IS_MOUSE_MODE:
      (void) dump_xymouse_w_wt(S_wt);
      break;
   case EDIT_MODE:
      qd_EDIT(S_wt,LEFTMOUSE);
      break;
   default:
      printf("qd_LEFTMOUSE: Unexpected display_mode %d.\n",
             PP->display_mode);
      break;
   }
}

/*----------------------------------------------------
Implementation still subject to modification ...
----------------------------------------------------*/
void qd_ROLL_FORWARD_MOUSE(void) {
   static char R[] = "qd_ROLL_FORWARD_MOUSE";
   int rc;

   int ltrace = Ltrace;

   if( ltrace ) {
      fprintf(stderr,"%s: S_wt=%d\n",R,S_wt);
   }

/* Return if control panel is up and mouse is not in active window ... */
   if( (Form_state == FORM_STATE_CONTROL) &&
       (wt_from_mouse() != S_wt ))  {
      return;
   }

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case SSTEP_MODE:
      if( Synch_mode ) {
         qd_synch_SSTEP(lalhead->wtl,RIGHTMOUSE);
      } else {
         qd_SSTEP(S_wt,RIGHTMOUSE);
      }
      break;
   default:
      break;
   }
}

/*----------------------------------------------------
Implementation still subject to modification ...
----------------------------------------------------*/
void qd_ROLL_BACKWARD_MOUSE(void) {
   static char R[] = "qd_ROLL_BACKWARD_MOUSE";
   int wt;
   int rc;

   int ltrace = Ltrace;

   if( ltrace ) {
      fprintf(stderr,"%s: S_wt=%d Form_state=%d\n",R,S_wt,Form_state);
   }

/* Return if control panel is up and mouse is not in active window ... */
   if( (Form_state == FORM_STATE_CONTROL) &&
       (wt_from_mouse() != S_wt ))  {
      return;
   }

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case SSTEP_MODE:
   if( Synch_mode ) {
         qd_synch_SSTEP(lalhead->wtl,LEFTMOUSE);
      } else {
         qd_SSTEP(S_wt,LEFTMOUSE);
      }
      break;
   default:
      break;
   }
}

void qd_ESCKEY() 
{
   int     ltrace = OFF;
   if( ltrace ) {
      fprintf(stderr,"qd_ESCKEY: In routine. S_wt: %d  display_mode: %d\n",
              S_wt,PP->display_mode);
   }
   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case SSTEP_MODE:
      break;
   case X_ZOOM_MODE:
      break;
   case Y_ZOOM_MODE:
      break;
   case XY_ZOOM_MODE:
      break;
   case X_RANGE_XMIN_MODE:
      qd_X_RANGE(S_wt,ESCKEY);
      break;
   case X_RANGE_XMAX_MODE:
      qd_X_RANGE(S_wt,ESCKEY);
      break;
   case Y_RANGE_YMIN_MODE:
      qd_Y_RANGE(S_wt,ESCKEY);
      break;
   case Y_RANGE_YMAX_MODE:
      qd_Y_RANGE(S_wt,ESCKEY);
      break;
   case EFFECTS_MODE:
      break;
   case FREEZE_MODE:
      break;
   case AUTO_MODE:
      break;
   case WHERE_IS_MOUSE_MODE:
      break;
   case EDIT_MODE:
      break;
   default:
      break;
   }
}

void qd_UPARROW() {

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case EFFECTS_MODE:
      qd_EFFECTS(S_wt,UPARROWKEY);
      break;
   case EDIT_MODE:
      qd_EDIT(S_wt,UPARROWKEY);
      break;
   default:
      printf("qd_UPARROW: Unexpected display_mode %d.\n",
             PP->display_mode);
      break;
   }
}

void qd_DOWNARROW()
{

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case EFFECTS_MODE:
      qd_EFFECTS(S_wt,DOWNARROWKEY);
      break;
   case EDIT_MODE:
      qd_EDIT(S_wt,DOWNARROWKEY);
      break;
   default:
      printf("qd_DOWNARROW: Unexpected display_mode %d.\n",
             PP->display_mode);
      break;
   }
}

void qd_PADLEFTARROW() {

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case X_ZOOM_MODE:
      qd_X_ZOOM(S_wt,PADLEFTARROWKEY);
      break;
   default:
      printf("qd_PADLEFTARROW: Unexpected display_mode %d.\n",
             PP->display_mode);
      break;
   }
}

void qd_PADRIGHTARROW() {

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case X_ZOOM_MODE:
      qd_X_ZOOM(S_wt,PADRIGHTARROWKEY);
      break;
   default:
      printf("qd_PADRIGHTARROW: Unexpected display_mode %d.\n",
             PP->display_mode);
      break;
   }
}

void qd_INSERTKEY(void) {

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case EDIT_MODE:
      qd_EDIT(S_wt,INSERTKEY);
      break;
   default:
      (void) nvs_video_record_n_seconds(0.0,1);
      break;
   }
}

void qd_DELKEY(void) {

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case EDIT_MODE:
      qd_EDIT(S_wt,DELKEY);
      break;
   default:
      break;
   }
}

void qd_UKEY(void) {

   ABORT_IF_NULL(PP);
   switch( PP->display_mode ) {
   case EDIT_MODE:
      qd_EDIT(S_wt,UKEY);
      break;
   default:
      break;
   }
}

#undef   PP
#undef   FP

void qd_SSTEP(WT wt,Device device)
{
#define  PP  wds[wt].winf.pwf.pxywinf
#define  FP  wds[wt].pf.pxyf

   make_xy_ring(wt);

   switch( device ) {
   case LEFTMOUSE: 
      FP->xycurr = (FP->xycurr)->prev;
      set_must_redraw(wt);
      break;
   case RIGHTMOUSE:
      FP->xycurr = (FP->xycurr)->next;
      set_must_redraw(wt);
      break;
   case MIDDLEMOUSE:
#define PPP PP->prev_display_mode
      PP->display_mode = (PPP != AUTO_MODE) ? FREEZE_MODE : FREEZE_MODE;
#undef  PPP
      set_must_redraw(wt);
      break;
   default:
      printf("qd_SSTEP: Unexpected device value %d.\n",device);
   }

   restore_ring_state(wt);
}

void qd_synch_SSTEP(PWTBIND pwt,Device device)
{
   PWTBIND      ppwt;

   int          ltrace = OFF;
   
   if( ltrace ) { 
      printf("qd_synch_SSTEP: stepping ");
   }
   for( ppwt = pwt; ppwt != NULL; ppwt = ppwt->next ) {
      qd_SSTEP(ppwt->wt,device);
      if( ltrace ) {
         printf("%d ",ppwt->wt);
      }
   }
   if( ltrace ) {
      printf("\n");
   }
}

/* Don't zoom in if only single point is visible ... */
void qd_X_ZOOM(WT wt,Device device)
{
   double     xmouse,          xhwidth;
   double     xmin,            xmax;
   int        ixmin,           ixmax;
   PWTBIND    p;
#define       PP  wds[wt].winf.pwf.pxywinf
#define       FP  wds[wt].pf.pxyf
#define       CO              (FP->dqc)->dq
#define       GCO             (FP->dqb)->dq

   if( wt != wt_from_mouse() ) return;

   switch( device ) {
   case LEFTMOUSE:
      if( alt_key_pressed() ) {
         xmouse = xmouse_w_wt(wt);
         xhwidth = 0.5 * (CO.x2 - CO.x1) * X_ZOOM_FACTOR;
         xmin = dmax(GCO.x1,xmouse - xhwidth);
         xmax = dmin(GCO.x2,xmouse + xhwidth);
         if( All ) {
            for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
               wt = p->wt;
               FP->dqc = push_dq(FP->dqc,dq_xydv_r(FP->xycurr,xmin,xmax));
               set_must_remap(wt); set_must_redraw(wt);
            }
         } else {
            FP->dqc = push_dq(FP->dqc,dq_xydv_r(FP->xycurr,xmin,xmax));
            set_must_remap(wt); set_must_redraw(wt);
         }
      } else {
         if( All ) {
            for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
               wt = p->wt;
               FP->dqc = pop_dq_no_empty(FP->dqc);
               set_must_remap(wt); set_must_redraw(wt); 
            }
         } else {
            FP->dqc = pop_dq_no_empty(FP->dqc);
            set_must_remap(wt); set_must_redraw(wt); 
         }
      }
      break;
   case RIGHTMOUSE:
      xmouse = xmouse_w_wt(wt);
      if( alt_key_pressed() ) {
         xhwidth = 0.5 * (GCO.x2 - GCO.x1) / X_ZOOM_FACTOR;
         xmin = dmax(GCO.x1,xmouse - xhwidth);
         xmax = dmin(GCO.x2,xmouse + xhwidth);
      } else {
         xhwidth = 0.5 * (CO.x2 - CO.x1) / X_ZOOM_FACTOR;
         xmin = dmax(CO.x1,xmouse - xhwidth);
         xmax = dmin(CO.x2,xmouse + xhwidth);
      }
      if( All ) {
         for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
            wt = p->wt;
            FP->dqc = push_dq(FP->dqc,dq_xydv_r(FP->xycurr,xmin,xmax));
            if( n_visible_xy(FP->dqc->dq,FP->xycurr->data->x,
                             FP->xycurr->data->y,FP->xycurr->data->n) <= 1 ) {
               FP->dqc = pop_dq_no_empty(FP->dqc);
               scope_mess("Can't zoom in any further.",1);
            }
            set_must_remap(wt); set_must_redraw(wt);
         }
      } else {
         FP->dqc = push_dq(FP->dqc,dq_xydv_r(FP->xycurr,xmin,xmax));
         if( n_visible_xy(FP->dqc->dq,FP->xycurr->data->x,
                          FP->xycurr->data->y,FP->xycurr->data->n) <= 1 ) {
            FP->dqc = pop_dq_no_empty(FP->dqc);
            scope_mess("Can't zoom in any further.",1);
         }
         set_must_remap(wt); set_must_redraw(wt);
      }
      break;
   case MIDDLEMOUSE:
#define PPP    PP->prev_display_mode
      if( All ) {
         for( p = tail_wtal(wtal); p != NULL; p = p->prev) {
            wt = p->wt;
            dqc_from_current_xrange(wt);
            FP->dqsz = flush_dq_stack(FP->dqsz);
            PP->display_mode = (PPP == X_ZOOM_MODE) ? FREEZE_MODE : PPP;
         }
      } else {
         dqc_from_current_xrange(wt);
         FP->dqsz = flush_dq_stack(FP->dqsz);
         PP->display_mode = (PPP == X_ZOOM_MODE) ? FREEZE_MODE : PPP;
      }
#undef  PPP 
      break;
#define   X   FP->xycurr->data->x
#define   N   FP->xycurr->data->n
   case PADLEFTARROWKEY:
      if( N < 2 ) break;
      get_ix_visible(S_wt,&ixmin,&ixmax);
      if( ixmin < 0 || ixmax < 0 ) {
         fprintf(stderr,"qd_X_ZOOM: PADLEFTARROWKEY: Should not be here.\n");
      } else {
         if( shift_key_pressed() ) {
            ixmin = imax(0,ixmin-1);
         } else {
            ixmin = imin(ixmax-1,ixmin+1);
         }
         ixmax = imax(ixmax,ixmin+1);
      }
      FP->dqc = replace_dq(FP->dqc,dq_xydv_r(FP->xycurr,X[ixmin],X[ixmax]));
      set_must_remap(wt); set_must_redraw(wt);
      break;
   case PADRIGHTARROWKEY:
      if( N < 2 ) break;
      get_ix_visible(S_wt,&ixmin,&ixmax);
      if( ixmin < 0 || ixmax < 0 ) {
         fprintf(stderr,"qd_X_ZOOM: PADRIGHTARROWKEY: Should not be here.\n");
      } else {
         if( shift_key_pressed() ) {
            ixmax = imin(N-1,ixmax+1);
         } else {
            ixmax = imax(ixmin+1,ixmax-1);
         }
         ixmax = imax(ixmax,ixmin+1);
      }
      FP->dqc = replace_dq(FP->dqc,dq_xydv_r(FP->xycurr,X[ixmin],X[ixmax]));
      set_must_remap(wt); set_must_redraw(wt);
      break;
#undef     X
#undef     N
   default:
      printf("qd_X_ZOOM: Unexpected device value %d.\n",device);
   }
#undef       CO
}

void qd_Y_ZOOM(WT wt,Device device)
{
   double     xmouse,          xhwidth;
   double     ymouse,          yhwidth;
   double     xmin,            xmax;
   double     ymin,            ymax;
   int        dm;

#define       CO              (FP->dqc)->dq
#define       GCO             (FP->dqb)->dq

   if( wt != wt_from_mouse() ) return;

   dm = get_domain_mode(wt);

   switch( device ) {

   case LEFTMOUSE:
      if( alt_key_pressed() ) {
         ymouse = ymouse_w_wt(wt);
         yhwidth = 0.5 * (CO.y2 - CO.y1) * Y_ZOOM_FACTOR;
         ymin = dmax(GCO.y1,ymouse - yhwidth);
         ymax = dmin(GCO.x2,ymouse + yhwidth);
         if(        dm == FLOATING_DOMAIN ) {
            FP->dqc = push_dq(FP->dqc,make_dquad(GCO.x1,ymin,GCO.x2,ymax));
         } else if( dm == FIXED_DOMAIN ) {
            FP->dqc = push_dq(FP->dqc,make_dquad( CO.x1,ymin, CO.x2,ymax));
         }
         set_must_remap(wt); set_must_redraw(wt);
      } else {
         FP->dqc = pop_dq_no_empty(FP->dqc);
         set_must_remap(wt); set_must_redraw(wt); 
      }
      break;
   case RIGHTMOUSE:
      ymouse = ymouse_w_wt(wt);
      if( alt_key_pressed() ) {
         yhwidth = 0.5 * (GCO.y2 - GCO.y1) / Y_ZOOM_FACTOR;
         ymin = dmax(GCO.y1,ymouse - yhwidth);
         ymax = dmin(GCO.y2,ymouse + yhwidth);
      } else {
         yhwidth = 0.5 * (CO.y2 - CO.y1) / Y_ZOOM_FACTOR;
         ymin = dmax(CO.y1,ymouse - yhwidth);
         ymax = dmin(CO.y2,ymouse + yhwidth);
      }
      if(        dm == FLOATING_DOMAIN ) {
         FP->dqc = push_dq(FP->dqc,make_dquad(GCO.x1,ymin,GCO.x2,ymax));
      } else if( dm == FIXED_DOMAIN ) {
         FP->dqc = push_dq(FP->dqc,make_dquad( CO.x1,ymin, CO.x2,ymax));
      }
      set_must_remap(wt); set_must_redraw(wt);
      break;
   case MIDDLEMOUSE:
      set_must_remap(wt); set_must_redraw(wt);
#define PPP    PP->prev_display_mode
      PP->display_mode = (PPP == Y_ZOOM_MODE) ? FREEZE_MODE : PPP;
#undef PPP 
      break;
   default:
      printf("qd_X_ZOOM: Unexpected device value %d.\n",device);
   }
#undef       CO
}


void qd_X_RANGE(WT wt,Device device) {
#define       OCO               (FP->dqc)->dq
   static char R[] = "qd_X_RANGE";

   double      nx;
   int         ltrace  =   Ltrace;

   if( ltrace ) {
      fprintf(stderr,"%s: wt=%d Device=%d\n",R,wt,(int) device);
   }
   switch( device ) {
   case MIDDLEMOUSE:
   case RIGHTMOUSE:
   case LEFTMOUSE:
      switch( PP->display_mode ) {
      case X_RANGE_XMIN_MODE:
         set_xmin_xmax_wt(wt,nx = xmouse_w_wt(wt),-1);
         PP->display_mode = PP->prev_display_mode;
         break;
      case X_RANGE_XMAX_MODE:
         set_xmin_xmax_wt(wt,nx = xmouse_w_wt(wt), 1);
         PP->display_mode = PP->prev_display_mode;
         break;
      default: 
         break;
      }
      break;
   case ESCKEY:
      PP->display_mode = PP->prev_display_mode;
      set_must_redraw(wt);
      break;
   default:
      break;
   }
}

void set_xmin_xmax_wt(wt,value,opcode)  
   WT         wt;
   double     value;
   int        opcode;
{
   double     save_value;
   int        dm;

   dm = get_domain_mode(wt);

   switch( opcode ) {
   case  -1:
      if(        dm == FLOATING_DOMAIN ) {
         save_value = OCO.x2;
         FP->dqc = flush_dq_stack(FP->dqc);
         push_limits_r(wt,value,save_value);
      } else if( dm == FIXED_DOMAIN ) {
         FP->dqc = push_dq(FP->dqc,make_dquad(value,OCO.y1,OCO.x2,OCO.y2));
      } else {
         err2("set_xmin_xmax_wt","Unexpected domain mode.");
      }
      break;
   case   1:
      if(        dm == FLOATING_DOMAIN ) {
         save_value = OCO.x1;
         FP->dqc = flush_dq_stack(FP->dqc);
         push_limits_r(wt,save_value,value);
      } else if( dm == FIXED_DOMAIN ) {
         FP->dqc = push_dq(FP->dqc,make_dquad(OCO.x1,OCO.y1,value,OCO.y2));
      } else {
         err2("set_xmin_xmax_wt","Unexpected domain mode.");
      }
      break;
   default:
      printf("set_xmin_xmax_wt: Invalid opcode %d.\n",opcode);
      break;
   }
   set_must_remap(wt); set_must_redraw(wt);
}

double xmin_wt(wt)
   WT         wt;
{
   return     OCO.x1;
}

double xmax_wt(wt)
   WT         wt;
{
   return     OCO.x2;
}

double global_xmin_wt(WT wt) {
   return GCO.x1;
}

double global_xmax_wt(WT wt) {
   return GCO.x2;
}

#undef        OCO

void qd_Y_RANGE(WT wt,Device device)
{
#define       OCO               (FP->dqc)->dq

   double     ny;
   int        lecho  =   OFF;

   switch( device ) {
   case MIDDLEMOUSE:
      switch( PP->display_mode ) {
      case Y_RANGE_YMIN_MODE:
         set_ymin_ymax_wt(S_wt,ny = ymouse_w_wt(S_wt),-1);
         PP->display_mode = PP->prev_display_mode;
         if( lecho ) {
            printf("%g\n",ny);
         }
         break;
      case Y_RANGE_YMAX_MODE:
         set_ymin_ymax_wt(S_wt,ny = ymouse_w_wt(S_wt), 1);
         PP->display_mode = PP->prev_display_mode;
         if( lecho ) {
            printf("%g\n",ny);
         }
         break;
      default: 
         break;
      }
      break;
   case ESCKEY:
      PP->display_mode = PP->prev_display_mode;
      set_must_redraw(wt);
      break;
   default:
      break;
   }
}

void set_ymin_ymax_wt(wt,value,opcode)  
   WT         wt;
   double     value;
   int        opcode;
{
   switch( opcode ) {
   case  -1:
      FP->dqc = push_dq(FP->dqc,make_dquad(OCO.x1,value,OCO.x2,OCO.y2));
      set_must_remap(wt); set_must_redraw(wt);
      break;
   case   1:
      FP->dqc = push_dq(FP->dqc,make_dquad(OCO.x1,OCO.y1,OCO.x2,value));
      set_must_remap(wt); set_must_redraw(wt);
      break;
   default:
      printf("set_ymin_ymax_wt: Invalid opcode %d.\n",opcode);
      break;
   }
}

double ymin_wt(wt)
   WT         wt;
{
   return     OCO.y1;
}

double ymax_wt(wt)
   WT         wt;
{
   return     OCO.y2;
}

#undef        OCO

void qd_XY_ZOOM(WT wt,Device device)
{
   double     xmouse,          xhwidth;
   double     xmin,            xmax;
   double     ymouse,          yhwidth;
   double     ymin,            ymax;
#define       CO              (FP->dqc)->dq
#define       GCO             (FP->dqb)->dq

#define       DEBUG1          printf("qd_XY_ZOOM: new dq: "); dump_dquad((FP->dqc)->dq)

   if( wt != wt_from_mouse() ) return;

   switch( device ) {
   case LEFTMOUSE:
      if( alt_key_pressed() ) {
         xmouse = xmouse_w_wt(wt);        ymouse = ymouse_w_wt(wt);

         xhwidth = 0.5 * (CO.x2 - CO.x1) * X_ZOOM_FACTOR;
         yhwidth = 0.5 * (CO.y2 - CO.y1) * Y_ZOOM_FACTOR;

         xmin = dmax(GCO.x1,xmouse - xhwidth);
         xmax = dmin(GCO.x2,xmouse + xhwidth);
         ymin = dmax(GCO.y1,ymouse - yhwidth);
         ymax = dmin(GCO.y2,xmouse + yhwidth);

         FP->dqc = push_dq(FP->dqc,make_dquad(xmin,ymin,xmax,ymax));
         set_must_remap(wt); set_must_redraw(wt);
      } else {
         FP->dqc = pop_dq_no_empty(FP->dqc);
         set_must_remap(wt); set_must_redraw(wt); 
      }
      break;
   case RIGHTMOUSE:
      xmouse = xmouse_w_wt(wt);           ymouse = ymouse_w_wt(wt);
      if( alt_key_pressed() ) {
         xhwidth = 0.5 * (GCO.x2 - GCO.x1) / X_ZOOM_FACTOR;
         yhwidth = 0.5 * (GCO.y2 - GCO.y1) / Y_ZOOM_FACTOR;

         xmin = dmax(GCO.x1,xmouse - xhwidth);
         xmax = dmin(GCO.x2,xmouse + xhwidth);
         ymin = dmax(GCO.y1,ymouse - yhwidth);
         ymax = dmin(GCO.y2,ymouse + yhwidth);
      } else {
         xhwidth = 0.5 * (CO.x2 - CO.x1) / X_ZOOM_FACTOR;
         yhwidth = 0.5 * (CO.y2 - CO.y1) / Y_ZOOM_FACTOR;
 
         xmin = dmax(CO.x1,xmouse - xhwidth);
         xmax = dmin(CO.x2,xmouse + xhwidth);
         ymin = dmax(CO.y1,ymouse - yhwidth);
         ymax = dmin(CO.y2,ymouse + yhwidth);
      }
      FP->dqc = push_dq(FP->dqc,make_dquad(xmin,ymin,xmax,ymax));
      set_must_remap(wt); set_must_redraw(wt);
      break;
   case MIDDLEMOUSE:
      set_must_remap(wt);
      set_must_redraw(wt);
#define PPP    PP->prev_display_mode
      PP->display_mode = (PPP == XY_ZOOM_MODE) ? FREEZE_MODE : PPP;
#undef  PPP 
      break;
   default:
      printf("qd_X_ZOOM: Unexpected device value %d.\n",device);
   }
#undef       CO
}


void qd_EFFECTS(WT wt,Device device)
{
   switch( device ) {
   case MIDDLEMOUSE:
/*    FP->dqc = pop_dq_no_empty(FP->dqc);  */
/*    set_must_remap(wt); set_must_redraw(wt);  */
      set_must_redraw(wt);
      PP->display_mode = PP->prev_display_mode;
      break;
   case RIGHTMOUSE:
      if(        alt_key_pressed() ) {
         qd_EFFECTS_marker_size(wt,MARKER_SIZE_SMALLER);
      } else if( ctrl_key_pressed() ) { 
         qd_EFFECTS_line_width(wt,LINE_WIDTH_THICKER);
      } else {
         qd_EFFECTS_marker_color(wt);
      }
      break;
   case LEFTMOUSE:
      if(        alt_key_pressed() ) {
         qd_EFFECTS_marker_size(wt,MARKER_SIZE_BIGGER);
      } else if( ctrl_key_pressed() ) {
         qd_EFFECTS_line_width(wt,LINE_WIDTH_THINNER);
      } else {
         qd_EFFECTS_marker_npoly(wt);
      }
      break;
#define             PPMT PP->marker_type
   case UPARROWKEY:
      if( ctrl_key_pressed() ) {
         border_width = inc_ring(border_width,1,20);
         apply_all_wt_0((PFV_I) set_must_redraw);
      } else {
         PPMT = inc_ring(PPMT,MIN_MARKER_TYPE,MAX_MARKER_TYPE);
         set_must_redraw(wt);
      }
      break;
   case DOWNARROWKEY:
      if( ctrl_key_pressed() ) {
         border_width = dec_ring(border_width,1,20);
         apply_all_wt_0((PFV_I) set_must_redraw);
      } else {
         PPMT = dec_ring(PPMT,MIN_MARKER_TYPE,MAX_MARKER_TYPE);
         set_must_redraw(wt);
      }
      break;
#undef              PPMT
   default:
      break;
   }
}

/* Shorthand for marker type, multi--marking induced some code changes ... */

#define          M_TYPE      PP->marker_type

int get_base_marker_type(wt) 
   WT            wt;
{
   int           ltrace = OFF;

   if( ltrace ) {
      printf("get_base_marker_type:: Window %d. Base marker type %d.\n",
             wt,((M_TYPE % VARY_SIZE_OFFSET) % RAINBOW_OFFSET) % MULTI_OFFSET);
   }
   return (((M_TYPE % VARY_SIZE_OFFSET) % RAINBOW_OFFSET) % MULTI_OFFSET);
}

int to_base_marker_type(wt) 
   WT            wt;
{
   int           ltrace = OFF;

   if( ltrace ) {
      printf("to_base_marker_type(in ):: Window %d: Marker type %d.\n",
             wt,M_TYPE);
   }
   M_TYPE = ((M_TYPE % VARY_SIZE_OFFSET) % RAINBOW_OFFSET) % MULTI_OFFSET;
   if( ltrace ) {
      printf("to_base_marker_type(out):: Window %d: Marker type %d.\n",wt,M_TYPE);
   }
   return 0;
}

void qd_EFFECTS_marker_color(wt)
   WT            wt;
{
   switch( get_base_marker_type(wt) ) {
   case POINT_TYPE:
   case POLY_TYPE:
   case LINE_AND_POLY_TYPE:
      PP->marker_color = 
         inc_ring(PP->marker_color,Min_marker_color,Max_marker_color); 
      set_must_redraw(wt);
      if( PP->marker_type == LINE_AND_POLY_TYPE ) goto both;
      break;
both:
   case LINE_TYPE:
      PP->line_color = 
         inc_ring(PP->line_color,Min_marker_color,Max_marker_color); 
      set_must_redraw(wt);
      break;
   default:
      break;
   }
}

void qd_EFFECTS_marker_npoly(wt)
   WT            wt;
{
   int           l_marker_type;

/* printf("qd_EFFECTS_marker_npoly: in routine.\n");  */
   l_marker_type = get_base_marker_type(wt);
   if( l_marker_type == POLY_TYPE   ||
       l_marker_type == LINE_AND_POLY_TYPE ) {
      PP->marker_npoly = inc_ring(PP->marker_npoly,MIN_NPOLY,MAX_NPOLY);
      set_must_redraw(wt);
   }
}

int inc_ring(i,imin,imax) 
   int           i, imin, imax;
{
   return (++i > imax) ? imin : i;
}

int dec_ring(i,imin,imax) 
   int           i, imin, imax;
{
   return (--i < imin) ? imax : i;
}

void qd_EFFECTS_marker_size(wt,code)
   WT            wt;
   int           code;
{
   int           l_marker_type;

/* printf("qd_EFFECTS_marker_size: in routine.\n");  */
   l_marker_type = get_base_marker_type(wt);
   if( l_marker_type == POLY_TYPE   ||
       l_marker_type == LINE_AND_POLY_TYPE ) {
      switch( code ) {
      case MARKER_SIZE_BIGGER:
/*       printf("qd_EFFECTS_marker_size: BIGGER.\n");  */
         PP->marker_size = dmin((double)(PP->marker_size) * MARKER_SIZE_STEP,
                                (double) MARKER_MAX_SIZE);
         set_must_redraw(wt);
         break;
      case MARKER_SIZE_SMALLER:
/*       printf("qd_EFFECTS_marker_size: SMALLER.\n");  */
         PP->marker_size = dmax((double)(PP->marker_size) / MARKER_SIZE_STEP,
                                (double) MARKER_MIN_SIZE);
         set_must_redraw(wt);
         break;
      default:
         break;
      }
   }
}

void qd_EFFECTS_line_width(wt,code)
   WT            wt;
   int           code;
{
   switch( get_base_marker_type(wt) ) {
   case LINE_TYPE:
   case LINE_AND_POLY_TYPE:
      switch( code ) {
      case LINE_WIDTH_THICKER:
         PP->line_width = inc_ring(PP->line_width,MINIMUM_LINE_WIDTH,
                                   MAXIMUM_LINE_WIDTH);
         break;
      case LINE_WIDTH_THINNER:
         PP->line_width = dec_ring(PP->line_width,MINIMUM_LINE_WIDTH,
                                   MAXIMUM_LINE_WIDTH);
         break;
      }
      set_must_redraw(wt);
      break;
   default:    
      break;
   }
}

#undef     M_TYPE

#undef     FP
#undef     PP

void equate_screen_and_world_coordinates(winno)
   int         winno;
{
   long        orgx,        orgy;
   long        dx,          dy;   

   winset(winno);
   getorigin(&orgx,&orgy); getsize(&dx,&dy);
   ortho2(orgx,orgx+dx-1,orgy,orgy+dy-1);
}


/* Assumes window in double buffered mode. */

char *old_get_string_from_window0(int winno,fmfonthandle fh,
     int text_color,int back_color,int prompt_color,
     char *prompt,float x,float y) 
{
   Device    dev;
   short     val;

   long      orgx,    orgy;
   long      dx,      dy;
   Scoord    cposx,   cposy;

   char      string[2];

   char      buffer[BUFLEN];
   Scoord    cx[BUFLEN];

   int       i;

#define      RETURN       13
#define      BACKSPACE     8
#define      DELETE      127
#define      KILL         21
#define      KILL_CHAR i--; color(back_color); cmov2s(cx[i],cposy); fmoutchar(fh,(char) buffer[i]); cmov2s(cx[i],cposy) 
#define      CLEAN_UP unqdevice(KEYBD); frontbuffer(OFF); backbuffer(ON); color(back_color); clear(); swapbuffers();


   winset(winno);
   equate_screen_and_world_coordinates(winno);
   fmsetfont(fh);

   qdevice(KEYBD); qdevice(ESCKEY);
   frontbuffer(ON);
   backbuffer(OFF);
   color(back_color); clear();

   getsize(&dx,&dy);
   getorigin(&orgx,&orgy);
   cmov2i((int) (orgx + x * dx), (int) (orgy + y * dy));
   color(prompt_color); 
   fmprstr(prompt);
   getcpos(&cposx,&cposy);

   i = 0;
   while( 1 ) {
      while( qtest()) {
         switch( qread(&val) ) {
         case KEYBD:
            switch( val ) {
            case RETURN:
               buffer[i] = 0;
               CLEAN_UP;
               if( i > 0 ) {
                  return strdup(buffer); 
               } else {
                  return (char *) NULL;
               }
            case BACKSPACE:
            case DELETE:
               if( i > 0 ) {
                  KILL_CHAR;
               }
               break;
            case KILL:
               return old_get_string_from_window0(winno,fh,text_color,
                         back_color,prompt_color,prompt,x,y);
            default:
               buffer[i] = val;
               getcpos(cx+i,&cposy);
               color(text_color);
               cposx = cx[i] + fmoutchar(fh,(char) val);
               cmov2s(cposx,cposy);
               i++;
               break; 
            }
            break;
         case LEFTMOUSE:
         case RIGHTMOUSE:
         case MIDDLEMOUSE:
            buffer[i] = 0;
            CLEAN_UP;
            if( i > 0 ) {
               return strdup(buffer);
            } else {
               return (char *) NULL;
            }
         case ESCKEY:
            CLEAN_UP;
            return (char *) NULL;
         default:
            break;
         }
      }
   }
#undef       RETURN
#undef       BACKSPACE
#undef       TAB
#undef       DELETE
#undef       KILL
#undef       KILL_CHAR
#undef       SET_UP
#undef       CLEAN_UP
}

char *old_get_string_from_window1(int winno,fmfonthandle fh,
      int text_color,int back_color,int prompt_color,
      char *prompt,float x,float y) 
{
   Device    dev;
   short     val;

   long      orgx,    orgy;
   long      dx,      dy;
   Scoord    cposx,   cposy;

   char      string[2];

   char      buffer[BUFLEN];
   Scoord    cx[BUFLEN];

   int       i;

#define      RETURN       13
#define      BACKSPACE     8
#define      TAB           9
#define      DELETE      127
#define      KILL         21
#define      KILL_CHAR i--; color(back_color); cmov2s(cx[i],cposy); fmoutchar(fh,(char) buffer[i]); cmov2s(cx[i],cposy) 
#define      SET_UP color(back_color); clear(); cmov2i((int) (orgx + x * dx), (int) (orgy + y * dy)); color(prompt_color); fmprstr(prompt); qreset();
#define      CLEAN_UP unqdevice(KEYBD); frontbuffer(OFF); backbuffer(ON); color(back_color); clear(); swapbuffers();


   winset(winno);
   equate_screen_and_world_coordinates(winno);
   getsize(&dx,&dy);
   getorigin(&orgx,&orgy);

   fmsetfont(fh);
   qdevice(KEYBD); qdevice(ESCKEY);
   frontbuffer(ON);
   backbuffer(OFF);

   SET_UP;
  
   getcpos(&cposx,&cposy);

   i = 0;
   while( 1 ) {
      while( qtest()) {
         switch( qread(&val) ) {
         case KEYBD:
            switch( val ) {
            case RETURN:
               buffer[i] = 0;
               CLEAN_UP;
               if( i > 0 ) {
                  return strdup(buffer); 
               } else {
                  return (char *) NULL;
               }
            case BACKSPACE:
            case DELETE:
               if( i > 0 ) {
                  KILL_CHAR;
               }
               break;
            case KILL:
               return old_get_string_from_window1(winno,fh,text_color,
                         back_color,prompt_color,prompt,x,y);
            case TAB:
               break;
            default:
               buffer[i] = val;
               getcpos(cx+i,&cposy);
               color(text_color);
               cposx = cx[i] + fmoutchar(fh,(char) val);
               cmov2s(cposx,cposy);
               i++;
               break; 
            }
            break;
         case MIDDLEMOUSE:
            if( alt_key_pressed() && val ) {
               if( get_cut_buffer(I_buf) ) {
                  int i;
/*                printf("get_ ...: cut buffer contents: %s.\n",I_buf);  */
                  for( i = 0; i < strlen(I_buf); i++ ) {
                     qenter(KEYBD,(short) I_buf[i]);
                  }
               }
            } else {
               goto Mouse_continue;
            }
            break;
         Mouse_continue:
         case LEFTMOUSE:
         case RIGHTMOUSE:
            if( val ) {
               buffer[i] = 0;
               CLEAN_UP;
               if( i > 0 ) {
                  return strdup(buffer);
               } else {
                  return (char *) NULL;
               }
            }
            break;
         case ESCKEY:
            CLEAN_UP;
            return (char *) NULL;
         default:
            break;
         }
      }
   }
#undef       RETURN
#undef       BACKSPACE
#undef       TAB
#undef       DELETE
#undef       KILL
#undef       KILL_CHAR
#undef       SET_UP
#undef       CLEAN_UP
}

/*   
     This version uses double buffering and complete redraw of string 
     on every character change ... 

     Modified to call fname_expand to replace leading ~ with $HOME
*/

char *get_string_from_window(int winno,fmfonthandle fh,
      int text_color,int back_color,int prompt_color,
      char *prompt,float x,float y) {
   Device    dev;
   short     val;

   long      orgx,    orgy;
   long      dx,      dy;
   Scoord    oposx,   oposy;

   char      string[2];

   char      buffer[BUFLEN], space[] = " ";

   int       curs = 0,    redraw = ON;

#define      RETURN       13
#define      BACKSPACE     8
#define      TAB           9
#define      DELETE      127
#define      KILL         21
#define      SET_UP color(back_color); clear(); cmov2i((int) (orgx + x * dx), (int) (orgy + y * dy)); color(prompt_color); fmprstr(prompt); qreset();
#define      CLEAN_UP unqdevice(KEYBD); color(back_color); clear(); swapbuffers();

   int       ltrace = OFF;


   winset(winno);
   equate_screen_and_world_coordinates(winno);
   getsize(&dx,&dy);
   getorigin(&orgx,&orgy);

   fmsetfont(fh);
   qdevice(KEYBD); qdevice(ESCKEY);

/* Clear window ... set and remember character position ... */

   cmov2i((int) (orgx + x * dx),(int) (orgy + y * dy));
   getcpos(&oposx,&oposy);
   qreset();

/* Initialize buffer ... */

   buffer[curs] = '\0';
   
   while( 1 ) {
      if( redraw ) {
         cmov2( (Coord) oposx, (Coord) oposy );
         color(back_color); 
         clear();
         color(prompt_color);
         fmprstr(prompt);
         fmprstr(space);
         color(text_color);
         fmprstr(buffer);
         if( ltrace ) {
            fprintf(stderr,"get_string_from_window: <%s> <%s> <%s>.\n",
                    prompt,space,buffer);
         }
         swapbuffers();
         redraw = OFF;
      }
      while( qtest()) {
         switch( qread(&val) ) {
         case KEYBD:
            switch( val ) {
            case RETURN:
               CLEAN_UP;
               if( curs > 0 ) {
                  return fname_expand(buffer); 
               } else {
                  return (char *) NULL;
               }
            case BACKSPACE:
            case DELETE:
               if( curs > 0 ) {
                  curs--;
                  buffer[curs] = '\0';
                  redraw = ON;
               }
               break;
            case KILL:
               return get_string_from_window(winno,fh,text_color,back_color,
                                             prompt_color,prompt,x,y);
            case TAB:
               break;
            default:
               buffer[curs] = val;
               curs++;
               if( curs < BUFLEN ) {
                  buffer[curs] = '\0';
               } else {
                  fprintf(stderr,
                     "get_string_from_window: Internal buffer overflow.\n");
                  return (char *) NULL;
               }
               redraw = ON;
               break; 
            }
            break;
         case MIDDLEMOUSE:
            if( alt_key_pressed() && val ) {
               if( get_cut_buffer(I_buf) ) {
                  int i;
                  if( ltrace ) {
                     fprintf(stderr,"get_string_from_window: ");
                     fprintf(stderr,"cut buffer contents: %s.\n",I_buf);    
                  }
                  for( i = 0; i < strlen(I_buf); i++ ) {
                     qenter(KEYBD,(short) I_buf[i]);
                  }
               }
            } else {
               goto Mouse_continue;
            }
            break;
         Mouse_continue:
         case LEFTMOUSE:
         case RIGHTMOUSE:
            if( val ) {
               CLEAN_UP;
               if( curs > 0 ) {
                  return strdup(buffer);
               } else {
                  return (char *) NULL;
               }
            }
            break;
         case ESCKEY:
            CLEAN_UP;
            return (char *) NULL;
         default:
            break;
         }
      }
   }
#undef       RETURN
#undef       BACKSPACE
#undef       TAB
#undef       DELETE
#undef       KILL
#undef       KILL_CHAR
#undef       SET_UP
#undef       CLEAN_UP
}
double get_double_from_window_old(int winno,fmfonthandle fh,
       int text_color,int back_color,int prompt_color,
       char *prompt,float x,float y,double default_value) {
   char             *string;
   double            double_input;
   int               not_done = ON;

   for(; not_done ; ) {
      if( !(string = get_string_from_window(winno,fh,text_color,back_color,
                        prompt_color,prompt,x,y)) ) {
         double_input = default_value;
         not_done = OFF;
      } else {
         not_done = !sscanf(string,"%lf",&double_input);
         free(string);
      }
   }
   return double_input;
}

double get_double_from_window(int winno,fmfonthandle fh,
       int text_color,int back_color,int prompt_color,
       char *prompt,float x,float y,double default_value) {
   char             *string;
   double            double_input;
   int               not_done = ON;

   return xvs_get_double(prompt,default_value);
}

DQUAD get_dquad_from_window(int winno,fmfonthandle fh,
      int text_color,int back_color,int prompt_color,
      char *prompt,float x,float y,DQUAD default_dquad) 
{
   char             *string;
   DQUAD             dquad_input;
   int               not_done = ON;

   int               ltrace = OFF;

   for(; not_done ; ) {
      if( !(string = get_string_from_window(winno,fh,text_color,back_color,
                        prompt_color,prompt,x,y)) ) {
         dquad_input = default_dquad;
         not_done = OFF;
      } else {
         not_done = sscanf(string,"%lf %lf %lf %lf",
                           &dquad_input.x1,&dquad_input.y1,
                           &dquad_input.x2,&dquad_input.y2) != 4;
         free(string);
      }
   }
   if( ltrace ) {
      fprintf(stderr,"get_dquad_from_window: Selected dquad.\n");
      dump_dquad(dquad_input);
   }
   return dquad_input;
}

DPAIR get_dpair_from_window(int winno,fmfonthandle fh,int text_color,
     int back_color,int prompt_color,char *prompt,
     float x,float y,DPAIR default_dpair)
{
   char             *string;
   DPAIR             dpair_input;
   int               not_done = ON;

   int               ltrace = Ltrace;

   for(; not_done ; ) {
      if( !(string = get_string_from_window(winno,fh,text_color,back_color,
                        prompt_color,prompt,x,y)) ) {
         dpair_input = default_dpair;
         not_done = OFF;
      } else {
         not_done = sscanf(string,"%lf %lf",
                           &dpair_input.x,&dpair_input.y) != 2;
         free(string);
      }
   }
   if( ltrace ) {
      fprintf(stderr,"get_dpair_from_window: Selected dpair.\n");
      dump_dpair(dpair_input);
   }
   return dpair_input;
}

void put_string_to_window(int winno,fmfonthandle fh,char *s,
   int text_color,int back_color,float x,float y)
{
   long             orgx,    orgy;
   long             dx,      dy;

   winset(winno);
   equate_screen_and_world_coordinates(winno);
   fmsetfont(fh);

   color(back_color); clear();
   getsize(&dx,&dy);
   getorigin(&orgx,&orgy);
   cmov2i((int) (orgx + x * dx), (int) (orgy + y * dy));

   color(text_color);
   fmprstr(s);       
   swapbuffers();
}

#undef ABORT_IF_NULL
