#include "project.h"

int    Rgbdump = OFF;
int    Rgb_wt  = -1;
int    Rgb_save_display_mode;
int    Rgb_save_auto_break_mode;
int    Rgb_index;
int    Rrb_remove_rgb_files = ON;
int    Rrb_force_even_row_col = OFF;
char  *Last_mpg_name = (char *) NULL;
char  *Rgb_wt_name   = (char *) NULL;       /* De-speced window name ... */
char   Rgb_buffer[1024];
const  char Default_mpeg_play[] = "mpeg_play";

int rgbdump_enable(void) {
   int  ltrace = OFF;
   
   if( is_active_wt(S_wt) ) {
      Rgbdump = ON;
      Rgb_wt  = S_wt;
      Rgb_save_display_mode = wds[Rgb_wt].winf.pwf.pxywinf->display_mode;
      Rgb_save_auto_break_mode = wds[Rgb_wt].winf.pwf.pxywinf->auto_break_mode;
      Rgb_index = -1;
      Rgb_wt_name = str2anu(wds[Rgb_wt].name);
      if( ltrace ) {
         fprintf(stderr,"rgbdump_enable: RGB dumping enabled for window %d.\n",
                 Rgb_wt);
         fprintf(stderr,"rgbdump_enable: Using label %s.\n",
                 Rgb_wt_name);
      }
   }
   return 0;
}

int rgbdump_disable(void) {
   int  ltrace = OFF;
   
   Rgbdump = OFF;
   if( is_active_wt(Rgb_wt) ) {
      sprintf(Rgb_buffer,"(cd %s; makempeg -fs 0000 -fe %04d -base %s -ext rgb)",wds[Rgb_wt].wd,Rgb_index,Rgb_wt_name);
      if( ltrace ) {
         fprintf(stderr,"rgbdump_output: Executing <%s>\n",Rgb_buffer);
      }
      system(Rgb_buffer);

      if( Rrb_remove_rgb_files ) {
         sprintf(Rgb_buffer,"(cd %s; /bin/rm %s.*.rgb)",wds[Rgb_wt].wd,
                 Rgb_wt_name);
         if( ltrace ) {
            fprintf(stderr,"rgbdump_output: Executing <%s>\n",Rgb_buffer);
         }
         system(Rgb_buffer);
      }

      if( Last_mpg_name ) {
         free(Last_mpg_name);
      }
      sprintf(Rgb_buffer,"%s/%s.mpg",wds[Rgb_wt].wd,Rgb_wt_name);
      Last_mpg_name = strdup(Rgb_buffer);
      if( ltrace ) {
         fprintf(stderr,"rgbdump_disable: Last_mpg_name <%s>\n",Last_mpg_name);
      }
      fprintf(stderr,"%s\n",Last_mpg_name);
      scope_mess(Last_mpg_name,1);
      wds[Rgb_wt].winf.pwf.pxywinf->display_mode    = Rgb_save_display_mode;
      wds[Rgb_wt].winf.pwf.pxywinf->auto_break_mode = Rgb_save_auto_break_mode;
      if( Rgb_wt_name ) free(Rgb_wt_name);
   }
   if( ltrace ) {
      fprintf(stderr,"rgbdump_disable: RGB dumping disabled.\n");
   }
   return 0;
}

int rgbdump_output(void) {
   int   ltrace = OFF;

/* Offsets for use in forcing even # of rows and columns ... */

   int   xO = 0,      yO = 0;

#define  I  wds[Rgb_wt].winf.wiq
   if( Rrb_force_even_row_col ) {
      if( !((I.x2 - I.x1) % 2) ) {
         if( ltrace ) {
            fprintf(stderr,"rgbdump_output: Odd # of cols. Will omit last.\n");
         }
         xO = 1;
      }
      if( !((I.y2 - I.y1) % 2) ) {
         if( ltrace ) {
            fprintf(stderr,"rgbdump_output: Odd # of rows. Will omit last.\n");
         }
         yO = 1;
      }
   }
   Rgb_index++;
   sprintf(Rgb_buffer,"/usr/sbin/scrsave %s/%s.%04d.rgb %d %d %d %d",
           wds[Rgb_wt].wd,Rgb_wt_name,Rgb_index,I.x1,I.x2-xO,I.y1,I.y2-yO);
   if( ltrace ) {
      fprintf(stderr,"rgbdump_output: Executing <%s>\n",Rgb_buffer);
   }
   system(Rgb_buffer);
   return 0;
#undef   I
}

/* Modified to query VS_MPEG_PLAY environment variable to get command 
   to play a .mpg movie ... */

int mpeg_play(char *name) {
   int        ltrace = OFF;
   char      *command;

   if( name ) {
      if( !(command = getenv("VS_MPEG_PLAY")) ) {
         command = (char *) Default_mpeg_play;
      }
      sprintf(Rgb_buffer,"%s %s &",command,name);    
      if( ltrace ) {
         fprintf(stderr,"mpeg_play: Executing <%s>\n",Rgb_buffer);
      }
      system(Rgb_buffer);
   }
   return 0;
}

int wt_to_rgb(WT wt) {
#define  I  wds[wt].winf.wiq
   int   ltrace = OFF;
   char *tag = (char *) NULL;
   if( is_active_wt(wt) ) {
      if( RGB_dump_enabled ) {
         tag = str2anu(wds[wt].name);
         sprintf(O_buf,"%s/%s.%05d.rgb",wds[wt].wd,tag,get_display_index(wt));
         sprintf(Rgb_buffer,
                "/usr/sbin/scrsave %s %d %d %d %d",O_buf,I.x1,I.x2,I.y1,I.y2);
         system(Rgb_buffer);
         fprintf(stderr,"%s\n",O_buf);
         fprintf(stderr,"To view image, execute:\n\n   ipaste -n %s\n",O_buf);
         scope_mess(O_buf,1);
         if( tag ) free( tag );
      } else {
         scope_mess_and_bell(".rgb dumping is not enabled",1);
      }
   }
   return 0;
#undef   I
}
