#ifndef    SCOPEDEF
#define    SCOPEDEF

#define    SMALL_XLC          500
#define    SMALL_YLC          200
#define    SMALL_WID          500
#define    SMALL_HIT          500

#define    BIG_XLC            745
#define    BIG_YLC            430
#define    BIG_WID            640
#define    BIG_HIT            640

#define    SCOPE_XLC          SMALL_XLC
#define    SCOPE_YLC          SMALL_YLC
#define    DEFAULT_SCOPE_WID  SMALL_WID
#define    DEFAULT_SCOPE_HIT  SMALL_HIT

#define    VIDEO_SCOPE_XLC    120
#define    VIDEO_SCOPE_YLC     45
#define    VIDEO_SCOPE_WID    400
#define    VIDEO_SCOPE_HIT    400

#define    FULL_SCREEN_SCOPE_XLC    180
#define    FULL_SCREEN_SCOPE_YLC     25
#define    FULL_SCREEN_SCOPE_WID    660
#define    FULL_SCREEN_SCOPE_HIT    660

#define    MIN_SCOPE_HIT      320 
#define    MAX_SCOPE_HIT     1000
#define    MIN_SCOPE_WID      320
#define    MAX_SCOPE_WID     1000

#define    SCOPE_RESIZE_INC    40

#define    GRID_WH              6
#define    GRID_COLOR           0

#define    SCOPE_HEAD_HIT      30
#define    SCOPE_HEAD_SPACE    2 * GRID_WH

#define    VIDEO_STATUS_XLC  VIDEO_SCOPE_XLC
#define    VIDEO_STATUS_YLC  VIDEO_SCOPE_YLC + VIDEO_SCOPE_HIT + SCOPE_HEAD_SPACE 

#define    FULL_SCREEN_STATUS_XLC  FULL_SCREEN_SCOPE_XLC
#define    FULL_SCREEN_STATUS_YLC  FULL_SCREEN_SCOPE_YLC + FULL_SCREEN_SCOPE_HIT + SCOPE_HEAD_SPACE 

#define    SCOPE_COLOR          0

#define    Q_BORDER_COLOR       RED
#define    Q_SCOPE_BORDER_COLOR BLACK
#define    A_SCOPE_BORDER_COLOR BLUE
#define    BLOCK_BORDER_COLOR   YELLOW
#define    A_BORDER_COLOR       GREEN
#define    P_BORDER_COLOR       BLUE 
#define    VIDEO_RECORD_BORDER_COLOR   GREEN
#define    BORDER_WIDTH         5
#define    VIDEO_BORDER_WIDTH   10
#define    DEFAULT_TITLE_BORDER_COLOR   MAGENTA
#define    DEFAULT_TITLE_BORDER_WIDTH           2 * BORDER_WIDTH

#define    INITIAL_CALL         0
#define    NOT_INITIAL_CALL     1

#define    SWAP_BUFFERS         0
#define    NO_SWAP_BUFFERS      1

#define    PANEL_MODE           0 
#define    SINGLE_MODE          1 

extern     WT                   scope_wt;
extern     int                  scope_sgi_winno;

extern     WT                   First_wt;
extern     WT                   Last_wt;

extern     int                  Scope_wid,  Scope_hit;
extern     int                  scope_xlc,  scope_xuc;
extern     int                  scope_ylc,  scope_yuc;

extern     int                  panel_lev;
extern     int                  panel_xlc[MAX_PANEL_LEV];
extern     int                  panel_xuc[MAX_PANEL_LEV];
extern     int                  panel_ylc[MAX_PANEL_LEV];
extern     int                  panel_yuc[MAX_PANEL_LEV];
extern     int                  panel_wid;
extern     int                  panel_hit;

extern     int                  scope_mode;
extern     int                  current_border_color;
extern     int                  border_width;

extern     char                 scope_name[]; 

/* F U N C T I O N S. */

void       compute_panel(int call);
void       set_init_scope_corners(void);
WT         scope_open();
int        srx(int);
int        sry(int);
int        open_in_panel(char *);
int        open_and_repanel(WT,char *);
void       repanel(int);
void       redraw_window_in_panel(WT);
void       old_border_window(WT) ;
void       new_border_window(WT) ;
void       outline_IQUAD(IQUAD dq,int color);
void       redraw_scope();
int        scope_to_SINGLE_MODE(WT);
int        scope_to_PANEL_MODE();
int        scope_to_PANEL_MODE_no_repanel();
int        mouse_in_ser_domain();

void       set_First_and_Last_wt(void);
#endif
