#include "sm.h"

#define   WINNAME   wds[wt].name
#define   IQ        wds[wt].winf.wiq
#define   DQ       (wds[wt].pf.pxyf->dqc)->dq
#define   P         wds[wt].pf.pxyf->xycurr
#define   INDEX     P->index
#define   DATA      P->data
#define   TIME      P->time
#define   X         DATA->x
#define   Y         DATA->y
#define   PTAG      P->tdata
#define   TAG       P->tdata->tag
#define   N         P->data->n
#define   NEVENTS   wds[wt].pf.pxyf->nevents

char     *Sm_dir = (char *) NULL;
char     *Sm_input_fname = (char *) NULL;
char      Sm_input_fname_default[] = "sm_input";
char     *Sm_xname = (char *) NULL;
char      Sm_xname_default[] = "x";
char     *Sm_yname = (char *) NULL;
int       Sm_n_ptype = SM_N_PTYPE;
int       Sm_ptype[SM_N_PTYPE][2] = {{3,0}, {4,0}, {5,0}, {6,0}, {7,0}};
int       Sm_OK;
char     *Sm_term_cmd = (char *) NULL;
char     *Sm_term_cmd_default = "xterm";


int handle_sm_menu(int code) {
   handle_sm_menu_1(code,0);
   return 1;
}

int handle_sm_menu_1(int code,int opcode) {
   static     char R[] = "handle_sm_menu_1";
   PXYDVEC    xyvecs = (PXYDVEC) NULL;
   int        wt;
   int        ivec,              nvec;
   static int code_save;

   FILE      *sd,               *smfile;
   char      *label;
   char      *cmdterm = (char *) NULL;

   char       editor[BUFLEN];

   int        ltrace = Ltrace;

#define ERRMESS1(a) sprintf(O_buf,"Can not work in directory %s",a); scope_mess(O_buf,1)
#define CDMESS1(a)  sprintf(O_buf,"-> %s",a); scope_mess(O_buf,1); fprintf(stderr,"%s\n",a);

   if( ltrace ) fprintf(stderr,"%s: In routine opcode=%d\n",R,opcode);
   if( opcode == 0 ) {
      Menu_deferred = MENU_DEFERRED_SM;
      Menu_deferred_wt = S_wt;
      assert(is_active_wt(Menu_deferred_wt));
      code_save = code;
      return 1;
   }

   wt = Menu_deferred_wt;
   if( !is_active_wt(wt) ) return( 0 );

   if( ltrace ) {
      fprintf(stderr,"handle_sm_menu: Invoked with code %d in window %d\n",
              code_save,wt);
   }
   if( test_Sm_dir(Sm_dir) ) {
      if( ltrace ) {
          fprintf(stderr,"handle_sm_menu: Working directory <%s>\n",Sm_dir);
      }
   } else {
      ERRMESS1(Sm_dir);
      return( 0 );
   }

   switch( code_save ) {

   case SM_GENERATE:
   case SM_GENERATE_EPS_AND_PRINT:
      xyvecs = split_XYDVEC_by_x_sense(DATA,&nvec);
      label = str2anu(WINNAME);
      if( !strlen(label) ) {
         label = strdup("vec");
         if( !Sm_input_fname ) Sm_input_fname = strdup(Sm_input_fname_default);
      } else {
         if( Sm_input_fname ) free(Sm_input_fname);
         sprintf(O_buf,"sm_%s",label);
         Sm_input_fname = strdup(O_buf);
      }
      for( ivec = 0; ivec < nvec; ivec++ ) {
         sprintf(O_buf,"%s/%s_%d.dat",Sm_dir,label,ivec);
         if( dvvput(O_buf,xyvecs[ivec].x,xyvecs[ivec].y,xyvecs[ivec].n) ==
             xyvecs[ivec].n ) {
            fprintf(stderr,"handle_sm_menu: Wrote %d xy pairs to %s\n",
                    xyvecs[ivec].n,O_buf);
         } else {
            sprintf(W_buf,"Error writing data to %s",O_buf);
            fprintf(stderr,"handle_sm_menu: %s\n",W_buf);
            scope_mess(W_buf,1);
            scope_mess("Operation aborted",1);
goto Done_sm_generate;
         }
      }
      sprintf(O_buf,"%s/%s",Sm_dir,Sm_input_fname);
      if( (smfile = fopen(O_buf,"w")) ) {
         fprintf(smfile,"# Generated from group %d data of window labelled <%s> (%s)\n",INDEX,WINNAME,label);
         fprintf(smfile,"# Type 'input %s' to refresh\n",Sm_input_fname);
         if(         code_save == SM_GENERATE ) {
            fprintf(smfile,"#location 3500 31000 3500 31000\n");
            fprintf(smfile,"location 4700 31700 4000 31000\n");
            fprintf(smfile,"device x11\n");
            fprintf(smfile,"#device postencap %s.ps\n",label);
         } else if(  code_save == SM_GENERATE_EPS_AND_PRINT ) {
            fprintf(smfile,"#device x11\n");
            fprintf(smfile,"device postencap %s.ps\n",label);
         }
         fprintf(smfile,"erase\n");
         for( ivec = 0; ivec < nvec; ivec++ ) {
            fprintf(smfile,"data %s_%d.dat\n",label,ivec);
            fprintf(smfile,"read {x%d 1 y%d 2}\n",ivec,ivec);
         }
         fprintf(smfile,"limits %g %g %g %g\n",DQ.x1,DQ.x2,DQ.y1,DQ.y2);
         fprintf(smfile,"expand 1.5001\n");
         fprintf(smfile,"box\n");
         for( ivec = 0; ivec < nvec; ivec++ ) {
            int   ip;

            ip = ivec % Sm_n_ptype;
            fprintf(smfile,"ptype %d %d\n",Sm_ptype[ip][0],Sm_ptype[ip][1]);
            fprintf(smfile,"points x%d y%d\n",ivec,ivec);
            fprintf(smfile,"#connect x%d y%d\n",ivec,ivec);
         }
         fprintf(smfile,"expand 1.5001\n");
/*       XNAME ... */
         fprintf(smfile,"xlabel %s\n",Sm_xname ? Sm_xname : "x");
         fprintf(smfile,"ylabel %s\n",Sm_yname ? Sm_yname : WINNAME);
         fclose(smfile);
         if(         code_save == SM_GENERATE ) {
            if( getenv("EDITOR") ) {
               sprintf(editor,"%s",getenv("EDITOR"));
            } else {
               sprintf(editor,"%s","vi");
            }
            if( getenv("XVSTERM") ) {
               cmdterm = strdup(getenv("XVSTERM"));
            } else {
               cmdterm = strdup("xterm");
            }
            if( !strcmp(editor,"emacs") ) {
/*             Don't generate separate winterm for emacs ... */
               sprintf(O_buf,"(cd %s; emacs %s &) &", Sm_dir,Sm_input_fname);
               system(O_buf);
               sprintf(O_buf,
                  "(cd %s; %s -name SM_via_ser -e sm input %s) &",
                  Sm_dir,cmdterm,Sm_input_fname);
               system(O_buf);
            } else {
               sprintf(O_buf,
                  "(cd %s; %s -name %s/%s -e %s %s) &",
                  Sm_dir,cmdterm,Sm_dir,Sm_input_fname,editor,Sm_input_fname);
               system(O_buf);
               sprintf(O_buf,
                  "(cd %s; %s -name SM_via_ser -e sm input %s) &",
                  Sm_dir,cmdterm,Sm_input_fname);
               system(O_buf);
            }
            if( cmdterm ) free(cmdterm);
         } else if(  code_save == SM_GENERATE_EPS_AND_PRINT ) {
            sprintf(O_buf,
               "(cd %s; sm -S < %s; lpr %s.ps;sleep 2;lpq) &",
               Sm_dir,Sm_input_fname,label);
            system(O_buf);
            sprintf(O_buf,"Generated and printed %s.ps",label);
            scope_mess(O_buf,3);
         }
      } else {
         fprintf(stderr,"handle_sm_menu: Error opening %s for write\n",O_buf);
         sprintf(W_buf,"Could not open %s for write",O_buf);
         scope_mess(W_buf,1);
      }
Done_sm_generate:
      if( label ) free(label);
      free_split_XYDVEC(xyvecs,nvec);
      break;
   case SM_CD:
      get_New_dir();
      if( test_Sm_dir(New_dir) ) {
         if( Sm_dir ) free(Sm_dir);
         Sm_dir = strdup(New_dir);
         CDMESS1(Sm_dir);
      } else {
         ERRMESS1(New_dir);
      }
      break;
   case SM_CSD:
      if( sd = fopen(Sd_name,"r") ) {
         fscanf(sd,"%s",I_buf);
         fclose(sd);
         if( test_Sm_dir(I_buf) ) {
            if( Sm_dir ) free(Sm_dir);
            Sm_dir = strdup(I_buf);
            CDMESS1(Sm_dir);
         } else {
            ERRMESS1(Sm_dir);
         }
      } else {
         scope_mess("csd failed.",1);
         return -1;
      }
      break;
   case SM_CD_DEFAULT:
      set_Sm_dir_default();
      if( test_Sm_dir(Sm_dir) ) {
         CDMESS1(Sm_dir);
      } else {
         ERRMESS1(Sm_dir);
      }
      break;
   case SM_PWD:
      if( test_Sm_dir(Sm_dir) ) {
         CDMESS1(Sm_dir);
      } else {
         ERRMESS1(Sm_dir);
      }
      break;
   default:
      fprintf(stderr,"handle_sm_menu: Unrecognized code: %d\n",code_save);
      break;

   }

   if( ltrace ) {
      fprintf(stderr,"%s: Calling update_browser_sm(%d)\n",R,wt);
   }
   update_browser_sm(wt);

   return( code_save );
}

int test_Sm_dir(char *dirname) {
   int       ltrace = OFF;
   sprintf(O_buf,"mkdir %s > /dev/null 2>&1",dirname);
   if( ltrace ) {
      fprintf(stderr,"test_Sm_dir: Executing the following command:\n%s\n", 
              O_buf);
   }
   if( system(O_buf) ) {
      sprintf(O_buf,
              "test \\( -d %s \\) -a \\( -w %s \\) -a \\( -x %s \\) > /dev/null 2>&1",
              dirname,dirname,dirname);
      if( ltrace ) {
         fprintf(stderr,"test_Sm_dir: Executing the following command:\n%s\n", 
                 O_buf);
      }
      if( system(O_buf) ) {
         return(0);
      } else {
         return(1);
      }
   } else {
      return(1);
   }
}

void set_Sm_dir_default(void) {
   if( getenv("USER") ) {
      sprintf(O_buf,"/tmp/sm_%s",getenv("USER"));
   } else {
      sprintf(O_buf,"/tmp/sm");
   }
   if( Sm_dir ) free(Sm_dir);
   Sm_dir = strdup(O_buf);
}
