#include <sysincludes.h>

/* Returns index of substring s2 in s1, -1 if not found. */

int istrstr(s1,s2)
   char   *s1,  *s2;
{
   char  *c;
   int    ls1,  ls2,  i1 = 0,  newi1,  j;

   if( (ls1 = strlen(s1)) && (ls2 = strlen(s2)) ) {
      while( i1 < ls1 ) {
         if( c = strchr(s1+i1,s2[0]) ) {
            newi1 = i1 + (int) (c - s1+i1);
            if( (ls1 - newi1) < ls2 ) {
               return -1;
            } else {
               for( j = 0; j < ls2 && s1[newi1++] == s2[j++];);
               if( j == ls2 ) {
                  return newi1 - ls2;
               } else {
                  i1 = newi1 + 1;
               }
            }
         } else {
            return -1;
         }
      }
      return -1;
   } else {
      return -1;
   }
}

/* Returns 1 if fname (file name presumably) has extension ext */ 
/* which should contain '.' */

int has_ext(fname,ext)
   char     *fname,  *ext;
{
   int       offset;

   offset = strlen(fname) - strlen(ext);

   return (offset >= 0) && (istrstr(fname,ext) == offset);
}

char *de_ext(char *fname,char *ext) {
   char  *s;
   int    i;

   if( (i = istrstr(fname,ext)) > 0 ) {
      s = (char *) malloc(i + 1);
      s = strncpy(s,fname,i);
      s[i] = '\0';
   } else {
      s = strdup(fname);
   }
   return(s);
}

int has_pre_ext(fname,pre_ext)
   char     *fname,  *pre_ext;
{
   return istrstr(fname,pre_ext) == 0;
}

/* Predicate form of strchr. */

int pstrchr(s,c)
   char      *s;
   int        c;
{
   return strchr(s,c) != NULL;
}

static char first[] = 
              "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
static char subs [] = 
              "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789";

int is_f77_id(s)
   char      *s;
{
   if( s ) {
      int   l;
      for(l = 0; *s; l++, s++ ) {
         if( ! pstrchr(l == 0 ? first : subs, *s) ) return 0;
      }
      return 1;
   } else {
      return 0;
   }
}

/* Given <pathname>, returns mallocated string with leading pathname
   component removed.                                                 */

char  *s_remove_lpc(pathname)
   char     *pathname;
{
   char     *new_pathname1,    *new_pathname2;
   int       new_pathname_len;

   int      ltrace = OFF;

   if( ltrace ) {
      printf("s_remove_lpc:: In routine: pathname %s.\n",pathname);
   }
   new_pathname1 = strdup(pathname);
   if( new_pathname1[0] == '/' ) {
      sscanf(pathname,"%*[/] %*[^/] %s",new_pathname1);    
   } else {
      sscanf(pathname,"%*[^/] %*[/] %*[^/] %s",new_pathname1);    
   }
   if( ltrace ) {
      printf("s_remove_lpc:: Extracted trailing components %s.\n",
             new_pathname1);
   }
   new_pathname_len = strlen(new_pathname1);
   if( ltrace ) {
      printf("s_remove_lpc:: Length of new pathname: %d.\n",new_pathname_len);
   }
   new_pathname2 = malloc((new_pathname_len + 1) * sizeof(char));
   strcpy(new_pathname2,new_pathname1);
   free(new_pathname1);
   return new_pathname2;
}

char *strim(char *s,char trimchar) {
   char  *news = NULL;
   int    len = strlen(s);
   int    bgn = 0,    end = len - 1;
   if( len > 0 ) {
      while( s[bgn] == trimchar ) {
         bgn++;
      }
      while( s[end] == trimchar ) {
         end--;
      }
      if( bgn > end ) {
         bgn = 0;
         len = 1;
      } else {
         len = end - bgn + 1;
      }
      news = (char *) malloc((len + 1) * sizeof(char));
      news = strncpy(news,s + bgn,len);
      news[len] = '\0';
   } 
   return( news );
}

/* Converts f77 string to C string ... */

char *fs2cs_sgi(char *f77s,int f77len) {
   char   *cs;

   cs = (char *) malloc((f77len + 1) * sizeof(char));
   cs = strncpy(cs,f77s,f77len);
   cs[f77len] = '\0';
   return(cs);
}
