#include "project.h"

FTNS               Load_fname[MAX_LOAD_FNAME];
FTNS               Load_blanks = " ";
char               Load_command[512];
int                Load_nfcn;
int                Load_ifcn;
int                Load_ng;
int                Load_iv[MAX_LIV]; 
int                Load_liv;
int                Load_wt;

char             **Font_list;
int                Font_menu = -1;
int                N_fonts = 0;
int                I_font  = 0;

long               Pick_wt_dev;

struct direct    **TheDir[1024];

#define           TYPE      PPARMS_VS_OPEN_XY1

TYPE  Pmake_PARMS_VS_OPEN_XY1(name,limits,scale_option,max_lxy,max_nevents)
   STRING        name;
   DQUAD         limits;
   int           scale_option;
   int           max_lxy;
   int           max_nevents;
{
   TYPE          p;

   if( (p = (TYPE) malloc(sizeof(PARMS_VS_OPEN_XY1))) != NULL ) {
      int    namelen;
      if( (namelen = strlen(name)) == 0 ) {
#define      DEFAULT_NAME "x"
         name = strdup(DEFAULT_NAME); 
         namelen = strlen(name);
      }
      p->name = name;
      p->namelen = namelen; 
      p->limits = limits;
      p->scale_option = scale_option;
      p->max_lxy = max_lxy;
      p->max_nevents = max_nevents;
   }
   return p;
#undef       DEFAULT_NAME
}

WT    vs_open_xy1(p) 
   TYPE          p;
{
   return 0;
}
#undef           P

char             has_ext_EXTENSION[1024];

int has_ext_scandir(d)
   struct direct *d;
{
   return has_ext(d->d_name,has_ext_EXTENSION);    
}


int has_pre_ext_scandir(d)
   struct direct *d;
{
   return has_pre_ext(d->d_name,has_ext_EXTENSION);    
}


int is_directory_scandir(d)
   struct direct *d;
{
   struct stat   st;
   int           ltrace = OFF;

   (void) stat(d->d_name,&st);
   if( ltrace && (st.st_mode & S_IFDIR)) {
      printf("is_directory_scandir: %s is directory.\n",d->d_name);
   }
   return st.st_mode & S_IFDIR;
}

void free_direct_array(da,n_ent)
   struct direct **da[];
   int             n_ent;
{
#define  FREE(a)   if( a ) free(a);
   int             i;

   for( i = 0; i < n_ent; i++ ) FREE( (*da)[i] );
   FREE( *da );

#undef  FREE
}

void choose_file_by_ext(dir,ext,tit,file_name)
   char  *dir;
   char  *ext;
   char  *tit;
   char  *file_name;
{
   int       n_ent;
   int       nm,   i,   pos;

   char     buffer[1024];
   
#define     NAME  (*TheDir)[i]->d_name
   if( dir && ext ) {
      strcpy(has_ext_EXTENSION,ext);
      n_ent = scandir(dir,TheDir,has_ext_scandir,alphasort);
/*    printf("choose_file_by_ext: n_ent %d.\n",n_ent);  */
      if( n_ent > 0 ) {
         nm = newpup();
      } else {
         sprintf(O_buf,"No %s files.",ext); scope_mess_and_bell(O_buf,1);
         file_name[0] = '\0'; free_direct_array(TheDir,n_ent); return;
      }
      if( tit ) {
         sprintf(buffer,"%s %%t",tit);
         addtopup(nm,buffer);
      }
      for( i = 0; i < n_ent; i++ ) {
         pos = istrstr(NAME,ext);
         strncpy(buffer,NAME,pos); buffer[pos] = 0;
         addtopup(nm,buffer);
      }

      Dopup_code = dopup(nm);

      if( Dopup_code > 0 ) {
         strcpy(file_name,(*TheDir)[Dopup_code-1]->d_name);
      } else {
         file_name[0] = 0;
      }
      free_direct_array(TheDir,n_ent);
      freepup(nm);
   } else {
      file_name[0] = 0; return;
   }
   return;
#undef      NAME
}

void choose_file_by_pre_ext(dir,pre_ext,tit,file_name)
   char  *dir;
   char  *pre_ext;
   char  *tit;
   char  *file_name;
{
   int       n_ent;
   int       nm,   i,   pos;

   char     buffer[1024];
   
#define     NAME  (*TheDir)[i]->d_name
   if( dir && pre_ext ) {
      strcpy(has_ext_EXTENSION,pre_ext);
      n_ent = scandir(dir,TheDir,has_pre_ext_scandir,alphasort);
/*    printf("choose_file_by_pre_ext: n_ent %d.\n",n_ent);  */
      if( n_ent > 0 ) {
         nm = newpup();
      } else {
         sprintf(O_buf,"No %s files.",pre_ext); scope_mess(O_buf,1);
         file_name[0] = 0; free_direct_array(TheDir,n_ent); return;
      }
      if( tit ) {
         sprintf(buffer,"%s %%t",tit);
         addtopup(nm,buffer);
      }
      for( i = 0; i < n_ent; i++ ) {
         pos = strlen(NAME) - strlen(pre_ext);
         strncpy(buffer,NAME + strlen(pre_ext),pos); buffer[pos] = 0;
         addtopup(nm,buffer);
      }

      Dopup_code = dopup(nm);

      if( Dopup_code > 0 ) {
         strcpy(file_name,(*TheDir)[Dopup_code-1]->d_name);
      } else {
         file_name[0] = 0;
      }
      free_direct_array(TheDir,n_ent);
      freepup(nm);
   } else {
      file_name[0] = 0; return;
   }
   return;
#undef      NAME
}

char *choose_file_with_ext(dir,ext)
   char  *dir;
   char  *ext;
{
   int       n_ent;
   int       nm,   i,   pos;
   char     *file_name;

   char     buffer[1024];
   
#define     NAME  (*TheDir)[i]->d_name
   if( dir && ext ) {
      strcpy(has_ext_EXTENSION,ext);
      n_ent = scandir(dir,TheDir,has_ext_scandir,alphasort);
      if( n_ent > 0 ) {
         nm = newpup();
      } else {
         sprintf(O_buf,"No %s files.",ext); scope_mess(O_buf,1);
         return NULL;
      }
      for( i = 0; i < n_ent; i++ ) {
         pos = istrstr(NAME,ext);
         printf("pos: %d.\n",pos);
         strncpy(buffer,NAME,pos); buffer[pos] = 0;
         printf("buffer: %s.\n",buffer);
         addtopup(nm,buffer);
      }

      Dopup_code = dopup(nm);

      printf("Dopup_code: %d.\n",Dopup_code);
      if( Dopup_code > 0 ) {
         file_name = strdup((*TheDir)[Dopup_code-1]->d_name);
      } else {
         file_name = NULL;
      }
      free_direct_array(TheDir,n_ent);
      freepup(nm);
   } else {
      file_name = NULL;
   }
   return file_name;
#undef      NAME
}

/* In place compresssion of PDXY list via index vector iv. */

int compress_in_place_wt(wt,iv,niv)
   WT         wt;
   IVEC       iv;
   int        niv;
{
#define       P          wds[wt].pf.pxyf

   int        ltrace = OFF;

   unmake_xy_ring(wt);

   if( ltrace ) {
      printf("window %d has %d vectors before ",wt,P->lxy);
      printf(" compression with the following index vector.\n");
      ivprint(iv,niv,"Compression vector");
   }

   P->xyhead  = compress_in_place_XYDVlist(P->xyhead,iv,niv);
   for( P->xytail = P->xyhead; (P->xytail)->next != NULL;
        P->xytail = (P->xytail)->next );
   set_lxy(P);
   reindex_XYDVlist(P->xyhead,1);
   P->nevents = n_events_wt(wt);

   if( ltrace ) {
      printf("window %d has %d vectors after ",wt,P->lxy);
      printf(" compression with the following index vector.\n");
      ivprint(iv,niv,"Compression vector");
   }

   safe_set_pxy_wt(wt);

/* Always rescale after compression (regardless of domain_mode setting) ... */

   if( ltrace ) {
      printf("rescaling ...\n");
   }
   if( P->dqb != (PDQBIND) NULL )
         free(P->dqb);
   P->dqb = make_pdqbind(P->limits = dq_wt(wt),NULL,NULL);
   if( ltrace ) {
      printf("new limits: "); dump_dquad(P->limits);
   }
   dqc_from_dqb(wt);
   restore_ring_state(wt);
   set_must_remap(wt); set_must_redraw(wt);

   return 0;

#undef        P
}

PXYDVBIND compress_in_place_XYDVlist(p,iv,niv) 
   PXYDVBIND         p;
   IVEC              iv;
   int               niv;
{
   PXYDVBIND         head,           pp;
   int               pos;
   
   int               ltrace = OFF;

   for( head = p; p != NULL ; ) {
      if( (pos = ivindx_(iv,&niv,&(p->index))) ) {
         if( ltrace ) {
            printf("%d found at position %d.\n",p->index,pos);
         }
         p = p->next;
      } else {
         if( ltrace ) {
            printf("%d not found, deleting node.\n",p->index);
         }
         if( (p->next) != NULL ) {
            (p->next)->prev = p->prev;
         }
         if( (p->prev) != NULL ) {   
            (p->prev)->next = p->next;
         }
         if( (p == head) ) {
            head = p->next;
         }
         pp = p; p = p->next;
         free_XYDVBIND(pp); 
      }
   }
   return head;
}

/* Modified to maintain display index if possible ... */

int clip_wt(WT wt)    {
#define              P        wds[wt].pf.pxyf

   int               save_pos = get_display_index(wt);
   int               ltrace = OFF;

   if( !is_active_wt(wt) ) return 0;

   unmake_xy_ring(wt);

   if( ltrace ) {
      printf("clip_wt: window %d has %d vectors before clipping.\n",wt,P->lxy);
      printf("clip_wt: clipping quad: "); dump_dquad(P->dqc->dq);
   }
   P->xyhead = clip_XYDVLIST(P->xyhead,P->dqc->dq);
   set_lxy(P); 
   reindex_XYDVlist(P->xyhead,1);
   P->nevents = n_events_wt(wt);
   if( ltrace ) {
      printf("window %d has %d vectors after clipping.\n",wt,P->lxy);
   }

   if( P->lxy > 0 ) {
      safe_set_pxy_wt(wt);
      switch( get_domain_mode(wt) ) {
      case FLOATING_DOMAIN:
         if( ltrace ) {
            printf("clip_wt: rescaling ...\n");
         }
         if( P->dqb != (PDQBIND) NULL ) free(P->dqb);
         P->dqb = make_pdqbind(P->limits = dq_wt(wt),NULL,NULL);
         if( ltrace ) {
            printf("new limits: "); dump_dquad(P->limits);
         }
         dqc_from_dqb(wt);
         break;
      case FIXED_DOMAIN:
         P->dqb->dq.x1 = P->dqc->dq.x1;
         P->dqb->dq.x2 = P->dqc->dq.x2;
         P->limits.x1 =  P->dqc->dq.x1;
         P->limits.x2 =  P->dqc->dq.x2;
         break;
      default:
         fprintf(stderr,"clip_wt: Unexpected domain_mode: %d\n",
                 get_domain_mode(wt));
         break;
      }

/*    Clear zoom stack (except for current dq) ... */

      P->dqc = flush_dq_stack_no_empty(P->dqc);
      set_xycurr_nth(wt,save_pos);
      restore_ring_state(wt);
      set_must_remap(wt); set_must_redraw(wt);
   } else {
      if( ltrace ) {
         printf("clip_wt: closing window %d.\n",wt);
      }
      (void) scope_to_PANEL_MODE_no_repanel();
      (void) xvs_close_wt(S_wt,YES);
   }
   return 0;

#undef               P
}

PXYDVBIND old_clip_XYDVLIST(p,dq)
   PXYDVBIND         p;
   DQUAD             dq;
{
   PXYDVBIND         head,         pp;
   int               i,            j;

   int               mess_freq = OFF;
   int               ltrace = OFF;
   
   for( i = 0, j = 0, head = p; p != NULL; ) {
      if( !(p->data = clip_XYDVEC(p->data,dq)) ) {
         if( ltrace ) {
            printf("clip_XYDVLIST: Deleting vector: %d.\n",i);
         }
         if( (p->next) != NULL ) {
            (p->next)->prev = p->prev;
         }
         if( (p->prev) != NULL ) {
            (p->prev)->next = p->next;
         }
         if( (p == head) ) {
            head = p->next;
         }
         pp = p;         p = p->next;
         free(pp);
      } else {
         ++j;
         p = p->next;
      }
      ++i;
      if( (mess_freq > 0)  &&  ((i % mess_freq) == 0) ) {
         sprintf(O_buf,"Clipped vector %d.\n",i);
         put_string_to_window(scope_sgi_winno,fh_prompt,
            O_buf,RED,BLACK,0.01,0.20);
      }
   }
   if( mess_freq > 0 ) {
      scope_mess("Clipping completed.",1);
   }
   return head;
}

PXYDVBIND clip_XYDVLIST(PXYDVBIND p,DQUAD dq)
{
   XY_PDATA_AND_PTAG data_and_tag;
   PXYDVBIND         head,         pp;
   int               i,            j;

   int               mess_freq = OFF;
   int               ltrace = OFF;
   
   for( i = 0, j = 0, head = p; p != NULL; ) {
      data_and_tag = clip_XYDVEC_AND_TAG(p->data,p->tdata,dq);
      if( !data_and_tag.data ) {
         if( ltrace ) {
            printf("clip_XYDVLIST: Deleting vector: %d.\n",i);
         }
         if( (p->next) != NULL ) {
            (p->next)->prev = p->prev;
         }
         if( (p->prev) != NULL ) {
            (p->prev)->next = p->next;
         }
         if( (p == head) ) {
            head = p->next;
         }
         pp = p;         p = p->next;
         free(pp);
      } else {
         p->data  = data_and_tag.data; 
         p->tdata = data_and_tag.tdata; 
         ++j;
         p = p->next;
      }
      ++i;
      if( (mess_freq > 0)  &&  ((i % mess_freq) == 0) ) {
         sprintf(O_buf,"Clipped vector %d.\n",i);
         put_string_to_window(scope_sgi_winno,fh_prompt,
            O_buf,RED,BLACK,0.01,0.20);
      }
   }
   if( mess_freq > 0 ) {
      scope_mess("Clipping completed.",1);
   }
   return head;
}

/* BEGIN  Directory manipulation aliases ... */

#define      OLD_DIR wds[wt].wd
#define      SET_OLD_DIR if( OLD_DIR ) {if( chdir(OLD_DIR) != 0 ) { sprintf(O_buf,"Can't chdir to wds[%d].wd",wt); MESS_OUT(2);}}
#define      GET_NEW_DIR if( OLD_DIR ) free(OLD_DIR); OLD_DIR = getcwd((char *) NULL,PATH_MAX); OLD_DIR = strcpy(OLD_DIR,OLD_DIR + (istrstr(OLD_DIR,NFS_HEAD) ? 0 : strlen(NFS_HEAD)));
#define      MESS_OUT(a) sprintf(O_buf,". --> %s.",OLD_DIR); scope_mess_1(O_buf,15.0,a,WHITE); printf("%s\n",OLD_DIR);

/* Modifications so that "new directory" is specified via global New_dir.  */
/* defined in plot.c                                                       */

void get_New_dir(void) {
   if( New_dir ) {
      free(New_dir);
   }
   New_dir = get_string_from_window(scope_sgi_winno,fh_prompt,GREEN,BLACK,CYAN,
                "cd ",0.01,0.20);
}   

int old_do_cd_wt(wt)
   WT        wt;
{
   get_New_dir();
   SET_OLD_DIR
   if( New_dir ) {
      if( chdir(New_dir) == 0 ) {
         free(New_dir);
         GET_NEW_DIR;
         MESS_OUT(1);
         return 0;
      } else {
         free(New_dir);
         scope_mess("cd failed.",1);
         if( OLD_DIR ) {
            MESS_OUT(1);
         }
         return -1;
      }
   } else {
      if( OLD_DIR ) {
            MESS_OUT(1);
      }
      return -1;
   }
}

int do_cd_wt(WT wt,int prompt)
{
   int       rc;

   if( prompt ) {
      get_New_dir();
   }
   SET_OLD_DIR
   rc = cd_wt(wt,New_dir);
   return( rc );
}

int cd_wt(wt,dir)
   WT        wt;
   char     *dir;
{
   SET_OLD_DIR
   if( dir ) {
      if( chdir(dir) == 0 ) {
         GET_NEW_DIR;
         MESS_OUT(1);
         return 0;
      } else {
         scope_mess("cd failed.",1);
         if( OLD_DIR ) {
            MESS_OUT(1);
         }
         return -1;
      }
   } else {
      if( OLD_DIR ) {
            MESS_OUT(1);
      }
      return -1;
   }
}

int do_csd_wt(WT wt,int echo)
{
   FILE      *sd;

   if( sd = fopen(Sd_name,"r") ) {
      fscanf(sd,"%s",I_buf);
      fclose(sd);
/*    printf("do_csd_wt: from %s: %s.\n",Sd_name,I_buf);  */
      if( chdir(I_buf) == 0 ) {
         GET_NEW_DIR;
         if( echo ) {
            MESS_OUT(1);
         }
         return 0;
      } else {
         scope_mess("csd failed.",1);
         return -1;
      }
   } else {
      sprintf(O_buf,"Could not find %s.",Sd_name);
      scope_mess(O_buf,2);
      return -1;
   }      
}

int do_remove_lpc_wt(wt)
   WT         wt;
{
   char      *new_wd;

   int        ltrace = OFF;

   if( ltrace ) {
      printf("do_remove_lpc_wt:: Window: %d. Old wd: %s.\n",wt,OLD_DIR);
   }
   new_wd = s_remove_lpc(OLD_DIR);
   free(OLD_DIR);
   wds[wt].wd = new_wd;
   wds[wt].wdlen = strlen(new_wd);
   MESS_OUT(1);
   if( ltrace ) {
      printf("do_remove_lpc_wt:: New wd: %s  Length: %d\n",wds[wt].wd,
             wds[wt].wdlen);
   }
   return 0;
}

int do_sd_wt(wt)
   WT         wt;
{
   FILE      *sd;

   if( sd = fopen(Sd_name,"w") ) {
      int   i;
      i  = ( istrstr(OLD_DIR,NFS_HEAD) ? 0 : strlen(NFS_HEAD) );
      fprintf(sd,"%s",OLD_DIR+i);
      fclose(sd);
      return do_csd_wt(wt,ON);
   } else {
      sprintf(O_buf,"Could not find %s.",Sd_name);
      scope_mess(O_buf,2);
      return -1;
   }      
}

int do_pwd_wt(wt)
   WT         wt;
{
   int        i;

   if( OLD_DIR ) {
      MESS_OUT(2);
   }
   return 0;
}

#undef       MESS_OUT
#undef       GET_NEW_DIR
#undef       SET_OLD_DIR
#undef       OLD_DIR

/* END    Directory manipulation aliases ... */

/* Hack job for loading .segdat file. */

int old_do_load_segdat_wt(WT wt) {
   int       u,     open_code;
   int       rc,     i,     i1,     nm;
   char      fname[FTN_SLEN];

   char     *i_buf;
   int       mxliv,        inf,       sup;
   int       one = 1;
   int       tiv_OK = OFF;
   int       ltrace = OFF; 

   if( strlen(Selected_file_name) ) {
      open_code = 1;
      (void) strcpy(Buffer,wds[wt].wd); (void) strcat(Buffer,"/");
      (void) strcat(Buffer,Selected_file_name);
#ifndef __ 
      u = open_segdat_(Buffer,&open_code,strlen(Buffer));
#else
      u = open_segdat__(Buffer,&open_code,strlen(Buffer));
#endif
      if( u > 0 ) {
         for( i = 0; i < MAX_LOAD_FNAME; i++ ) {
            strncpy(Load_fname[i],Load_blanks,FTN_SLEN);
         }
         sprintf(O_buf,"%s opened.",Selected_file_name); scope_mess(O_buf,1);
         segscn_(&u,Load_fname,&Load_nfcn,&Load_ng);
         sprintf(O_buf,"File contains %d %s, %d %s.",
                 Load_nfcn,(Load_nfcn == 1) ? "function" : "functions",
                 Load_ng  ,(Load_ng   == 1) ? "group" : "groups");
         scope_mess(O_buf,1);
         if( Load_ng > 0 ) {
            if( Load_nfcn > 1 ) {
               nm = newpup();
               addtopup(nm,"functions %%t");
               for( i = 0; i < Load_nfcn; i++ ) {
                  strncpy(fname,Load_fname[i],FTN_SLEN);
                  addtopup(nm,fname);
               }
               Load_ifcn = dopup(nm);
               freepup(nm);
            } else {
               Load_ifcn = 1;
            }
            strncpy(fname,Load_fname[Load_ifcn-1],
               i = indlnb_(Load_fname[Load_ifcn-1],FTN_SLEN));
            if( i < FTN_SLEN ) fname[i] = 0;
            sprintf(O_buf,"Loading %s.\n",fname); scope_mess(O_buf,1);

            if( Load_ng > 1 ) {
               mxliv = MAX_LIV; inf = 1; sup = Load_ng;
               while( !tiv_OK ) {
                  sprintf(O_buf,"Select from %d to %d: ",inf,sup);
                  i_buf = get_string_from_window(scope_sgi_winno,
                          fh_prompt,GREEN,BLACK,CYAN,O_buf,0.01,0.20);
                  if( i_buf ) {
                     tiv_OK = ((rc = irdiv_(Load_iv,&Load_liv,&mxliv,&inf,&sup,
                                       i_buf,strlen(i_buf))) >= OK_IRDIVN );
                     if( ltrace ) {
                        printf("do_load_segdat: rc: %d  Load_liv: %d.\n",
                               rc,Load_liv);
                        ivprint(Load_iv,Load_liv,"Load index vector");
                     }
                  } else {
                     tiv_OK = ON;
                  }
               }
               if( !i_buf ) {   
                  i_buf = strdup(".");
               }
            } else {
               i_buf = strdup(".");
            }

#ifndef __ 
            u = close_segdat_(); 
#else
            u = close_segdat__(); 
#endif
            Buffer[i = strlen(Buffer) - strlen(".segdat")] = 0;
            i  = ( istrstr(Buffer,NFS_HEAD) ? 0 : strlen(NFS_HEAD) );
            i1 = ( istrstr(strcpy(O_buf,wds[wt].wd),NFS_HEAD)      
                 ? 0 : strlen(NFS_HEAD) );
            sprintf(Load_command,"%s 'cd %s; %s  %s %d %s '&",         
                    RSH,O_buf+i1,SEGDAT_LOAD_CMD,Buffer+i,Load_ifcn,i_buf);
            if( ltrace ) {
               printf("do_load_segdat: Command: %s.\n",Load_command);
               sprintf(O_buf,"%s closed.",Selected_file_name); 
               scope_mess(O_buf,1);
            }
            rc = system(Load_command);
            if( ltrace ) {
               fprintf(stderr,"do_load_segdat: system('%s') returns %d\n",
                              Load_command,rc);
            }

            if( i_buf ) free(i_buf);
         }
      } else {
         sprintf(O_buf,"Open failed for %s.",Selected_file_name);
         scope_mess(O_buf,1);
      }
   }
   return 0;
}

/* Streamlined version which uses 'seg2vs' ... requires only file 
   name ... */

int do_load_segdat(WT wt) {
   int       ltrace = OFF; 

   if( strlen(Selected_file_name) ) {
      if( ltrace ) {
         fprintf(stderr,"do_load_segdat: Selected_file_name: '%s'\n",
                 Selected_file_name);
         fprintf(stderr,"do_load_segdat: Working directory: '%s'\n",
                 wds[wt].wd);
      }
      sprintf(O_buf,"%s %s/%s &",SEGDAT_LOAD_CMD,wds[wt].wd,Selected_file_name);
      if( ltrace ) {
         fprintf(stderr,"do_load_segdat: Executing system('%s')\n",O_buf);
      }
      system(O_buf);
   }
   return 0;
}

/* ... as above, but for rnpl produced .sdf files ... */

int do_load_sdf(WT wt) {
   int       ltrace = OFF; 

   if( strlen(Selected_file_name) ) {
      if( ltrace ) {
         fprintf(stderr,"do_load_sdf: Selected_file_name: '%s'\n",
                 Selected_file_name);
         fprintf(stderr,"do_load_sdf: Working directory: '%s'\n",
                 wds[wt].wd);
      }
      sprintf(O_buf,"(cd %s; %s %s) &",
              wds[wt].wd,SDF_LOAD_CMD,Selected_file_name);
      fprintf(stderr,"%s\n",O_buf);
      system(O_buf);
   }
   return 0;
}

void do_cd_menu(dir,tit,dir_name)
   char  *dir;
   char  *tit;
   char  *dir_name;
{
   int       n_ent;
   int       nm,   i,   pos;

   char     buffer[1024];
   
#define     NAME  (*TheDir)[i]->d_name
   if( dir ) {
      n_ent = scandir(dir,TheDir,is_directory_scandir,alphasort);
      if( n_ent > 0 ) {
         nm = newpup();
      } else {
         dir_name[0] = 0; free_direct_array(TheDir,n_ent); return;
      }
      if( tit ) {
         sprintf(buffer,"%s %%t",tit);
         addtopup(nm,buffer);
      }
      for( i = 0; i < n_ent; i++ ) {
         addtopup(nm,NAME);
      }

      Dopup_code = dopup(nm);

      if( 1 <= Dopup_code <= n_ent ) {
#define     NEW_DIR_NAME      (*TheDir)[Dopup_code-1]->d_name
         assert( NEW_DIR_NAME );
         strcpy(dir_name,NEW_DIR_NAME);
      } else {
         dir_name[0] = 0;
      }
      free_direct_array(TheDir,n_ent);
      freepup(nm);
   } else {
      dir_name[0] = 0; return;
   }
   return;
#undef      NEW_DIR_NAME
#undef      NAME
}

int get_cut_buffer(buffer)
   char    *buffer;
{
   FILE    *f;
   int      rc;

   if( f = fopen(CUT_BUFFER,"r") ) {
      rc = fscanf(f,"%s",buffer);
      fclose(f);
   } else {
      buffer[0] = 0;
      err2("get_cut_buffer","fopen failed.");
      rc = -1;
   }
   return rc;
}

int put_cut_buffer(buffer)
   char    *buffer;
{
   FILE    *f;
   int      rc;
   
   if( f = fopen(CUT_BUFFER,"w") ) {
      rc = fprintf(f,"%s",buffer);
      fclose(f);
   } else {
      err2("put_cut_buffer","fopen failed.");
      rc = -1;
   }
   return rc;
}

void load_color_map_from_sw_string() 
{
   char      *filetag;

   filetag = get_string_from_window(scope_sgi_winno,
             fh_prompt,GREEN,BLACK,CYAN,"Enter color map tag: ",0.01,0.20);
   if( filetag ) {
      if( loadmap_from_file(filetag) < 0 ) {
         sprintf(O_buf,"Could not find .colormap.%s.",filetag);
      } else {
         sprintf(O_buf,".colormap.%s loaded.",filetag);
      }
      scope_mess(O_buf,1);
      free(filetag);
   } else {
      scope_mess("Color map load aborted.",1);
   }
}

void save_color_map_to_sw_string() 
{
   char      *filetag;

   filetag = get_string_from_window(scope_sgi_winno,
             fh_prompt,GREEN,BLACK,CYAN,"Enter color map tag: ",0.01,0.20);
   if( filetag ) {
      if( !savemap_to_file(filetag) ) {
         sprintf(O_buf,"Color map saved to .color.%s",filetag);
         scope_mess(O_buf,1);
      } else {
         scope_mess("Color map save failed.",1);
      }
      free(filetag);
   } else {
      scope_mess("Color map save aborted.",1);
   }
}

void marker_set_root_color(void)
{
   int      map_entry = 0;
   
   GET_DOUBLE(map_entry,map_entry,"Color map index");
   set_root_to_map_entry_color(map_entry);
}

int confirm_overwrite(file_name,prompt)
   char   *file_name;
   char   *prompt;
{
   FILE   *file;
   char   *reply;
   int     rc;

   if( file = fopen(file_name,"r") ) {
      reply = get_string_from_window(scope_sgi_winno,fh_prompt,
                 GREEN,BLACK,CYAN,prompt,0.01,0.20);
      fclose(file);
      rc = is_affirmative_reply(reply);
      free(reply);
      return rc;
   } else {
      return ON;
   }
}

int is_affirmative_reply(reply)
   char   *reply;
{
   return ( reply ? (strchr(reply,'y') != NULL  ||  strchr(reply,'Y') != NULL)
                  : OFF );
}

int pick_wt_old()
{
   short    val;
   int      wt_prev,    wt_curr;

   if( n_windows() < 2 ) {
      scope_mess_and_bell("Not enough windows to pick!",1);
/*    return S_wt;  */
      return -S_wt;    
   }

   wt_prev = S_wt;

   if( scope_mode == SINGLE_MODE ) {
      (void) scope_to_PANEL_MODE();
   }
   qreset();

   wt_curr = wt_from_mouse();
   current_border_color = P_BORDER_COLOR;
   if( wt_prev != wt_curr ) {
      change_border_color(wt_prev,Q_border_color(wt_prev));
   }
   change_border_color(wt_curr,current_border_color);
   last_S_wt = wt_curr;
   while( 1 ) {
      while( qtest() ) {
         switch( (Pick_wt_dev = qread(&val)) ) {
         case LEFTMOUSE:
         case MIDDLEMOUSE:
         case RIGHTMOUSE:
            if( val ) {
               if( (wt_curr = wt_from_mouse()) > 0 ) {
                  current_border_color = A_BORDER_COLOR;
                  change_border_color(wt_curr,current_border_color);
                  qreset();
                  return wt_curr;
               }
            }
         default:
            activate_and_redraw_window_with_mouse();
         break;
         }
      }
   }
}

int pick_wt(void) {
   return pick_wt_1(0);
}

int picked_wt(void) {
   scope_clear();
   return pick_wt_1(1);
}

int pick_wt_1(int opcode) {
   int ltrace = Ltrace;
   if( (opcode != 0) && (opcode != 1) ) {
      fprintf(stderr,"pick_wt_1: Unimplemented opcode=%d\n",opcode);
   }
   if( opcode == 0 ) {
      if( is_active_wt(S_wt) ) {
         wds[S_wt].winf.pwf.pxywinf->border_color = P_BORDER_COLOR;
         set_must_redraw(S_wt);
      }
      Form_state = FORM_STATE_PICKING; 
   } else {
      if( is_active_wt(S_wt) ) {
         wds[S_wt].winf.pwf.pxywinf->border_color = A_BORDER_COLOR;
         set_must_redraw(S_wt);
         Picked_wt = S_wt;
         if( ltrace ) {
            fprintf(stderr,"pick_wt_1: Picked_wt=%d\n",Picked_wt);
         }
      } else {
         fprintf(stderr,"pick_wt_1: FATAL: S_wt=%d not active after pick operation.\n",
            S_wt);
         exit(1);
      }
      Form_state = FORM_STATE_PICKED; 
   }
   return 1;
}

IVECN mpick_wt_old(void) {
   IVECN    wt_list = {(IVEC) NULL,0};
   int      wt;

   if( n_wt() ) {
      while(1) {
         sprintf(O_buf,"Pick window %d ...",wt_list.n + 1);
         wt = pick_wt_with_mess(O_buf);
         if( wt < 0  || Pick_wt_dev == MIDDLEMOUSE ) break;
         wt_list = ivecn_append(wt_list,wt);
      }
   }
   return(wt_list);
}

void mpick_wt(int opcode,int npick) {
   static        char R[] = "mpick_wt";
   int           ltrace = Ltrace;
   static int    l_npick = 0;
   int           i;

   if( ltrace ) {
      fprintf(stderr,"%s: opcode=%d npick=%d\n",R,opcode,npick);
      fprintf(stderr,"%s: S_wt=%d %s active\n",
         R,S_wt,is_active_wt(S_wt) ? "is" : "is not");
      fprintf(stderr,"%s: Picked_wt_list.n=%d\n",R,Picked_wt_list.n);
   }
   switch( opcode ) {
   case MPICK_START:
      if( is_active_wt(S_wt) ) {
         wds[S_wt].winf.pwf.pxywinf->border_color = P_BORDER_COLOR;
         set_must_redraw(S_wt);
      }
      if( Picked_wt_list.n && Picked_wt_list.v ) {
         free(Picked_wt_list.v);
         Picked_wt_list.v = (IVEC) NULL;
         Picked_wt_list.n = 0;
      }
      l_npick = npick;
      if( l_npick > 0 ) {
         if( ltrace ) fprintf(stderr,"%s: Picking %d windows\n",R,l_npick);
         assert(Pick_prompts.v != NULL);
         for( i = 0; i < l_npick; i++ ) assert(Pick_prompts.v[i] != NULL);
         sprintf(O_buf,"%s",Pick_prompts.v[0]);
      } else {
         if( ltrace ) fprintf(stderr,"%s: Picking arb. # of windows\n",R);
         sprintf(O_buf,"Pick window %d ...",Picked_wt_list.n + 1);
      }
      scope_mess_perm(O_buf);
      xvs_form_state_push(FORM_STATE_MPICKING);
      if( ltrace ) ivecn_dump(Picked_wt_list,"Picked_wt_list from mpick_wt(MPICK_START)");
      break;

   case MPICK_ADD:
      assert(Form_state == FORM_STATE_MPICKING);
      assert(is_active_wt(S_wt));
      Picked_wt_list = ivecn_append(Picked_wt_list,S_wt);
      if( l_npick == Picked_wt_list.n ) {
         mpick_wt(MPICK_END,0);
         return;
      } 
      if( l_npick > 0 ) { 
         sprintf(O_buf,"%s",Pick_prompts.v[Picked_wt_list.n]);
      } else {
         sprintf(O_buf,"Pick window %d ...",Picked_wt_list.n + 1);
      }
      scope_mess_perm(O_buf);
      if( ltrace ) ivecn_dump(Picked_wt_list,"Picked_wt_list from mpick_wt(MPICK_ADD)");
      break;

   case MPICK_END:
      assert(Form_state == FORM_STATE_MPICKING);
      if( is_active_wt(S_wt) ) {
         wds[S_wt].winf.pwf.pxywinf->border_color = A_BORDER_COLOR;
         set_must_redraw(S_wt);
      }
      sprintf(O_buf,"%d windows picked.",Picked_wt_list.n);
      scope_mess(O_buf,1);
      Form_state = FORM_STATE_MPICKED;
      if( ltrace ) ivecn_dump(Picked_wt_list,"Picked_wt_list from mpick_wt(MPICK_END)");
      break;

   default:
      break;
   }
}

IVECN mpicked_wt(void) {
   IVECN    wt_list = {(IVEC) NULL,0};
   fprintf(stderr,"mpicked_wt: Not implemented\n");
   return wt_list;
}

IVECN mpick_wt_stub(void) {
   IVECN    wt_list = {(IVEC) NULL,0};
   int      wt;

   if( n_wt() ) {
      while(1) {
         sprintf(O_buf,"Pick window %d ...",wt_list.n + 1);
         wt = pick_wt_with_mess(O_buf);
         if( wt < 0  || Pick_wt_dev == MIDDLEMOUSE ) break;
         wt_list = ivecn_append(wt_list,wt);
      }
   }
   return(wt_list);
}

PXYDVBIND_VECN pxydv_list_from_wt_list(IVECN wt_list) {
   PXYDVBIND_VECN  the = {(PXYDVBIND *) NULL,0};
   int        i;

   the = make_PXYDVBIND_VECN(wt_list.n);
   for( i = 0; i < the.n; i++ ) {
      the.v[i] = wds[wt_list.v[i]].pf.pxyf->xyhead;
   }
   return(the);

}

int pick_wt_with_mess(char *mess) {
   WT         wt;

   fprintf(stderr,"pick_wt_with_mess: mess='%s'\n",mess);
   scope_mess_perm(mess);
   pick_wt();
   return 1;
}

int do_check_pair(prompt1,prompt2)
   STRING    prompt1,   prompt2;
{
   int       wt1,       wt2;  

Begin:
   sprintf(O_buf,"Pick %s ...",prompt1); scope_mess_perm(O_buf);
   wt1 = pick_wt();                      scope_clear();
   sprintf(O_buf,"Pick %s ...",prompt2); scope_mess_perm(O_buf);
   wt2 = pick_wt();                      scope_clear();
   if( wt1 == wt2 ) {
      ringbell(); scope_mess("Same window picked twice!",1);
      goto Begin;
   }
   return wts_are_fully_compatible(wt1,wt2);
}

void get_and_check_wt_pair(WTPAIR *pthe,STRING prompt1,STRING prompt2,
                           PFI_II check_fcn) {
   int       wt1,       wt2;  

Begin:
   sprintf(O_buf,"Pick %s ...",prompt1); scope_mess_perm(O_buf);
   wt1 = pick_wt();                      scope_clear();
   sprintf(O_buf,"Pick %s ...",prompt2); scope_mess_perm(O_buf);
   wt2 = pick_wt();                      scope_clear();
   if( wt1 == wt2 ) {
      ringbell(); scope_mess("Same window picked twice!",1);
      goto Begin;
   }
   if( (check_fcn) (wt1,wt2) ) {
      load_WTPAIR(pthe,wt1,wt2);
   } else {
      load_WTPAIR(pthe,-wt1,-wt2); 
   }
}

void get_and_check_wt_triple(WTTRIPLE *pthe,STRING prompt1,STRING prompt2,
                             STRING prompt3,PFI_II check_fcn) {
   int       wt1,       wt2,        wt3;  
   int       ltrace = OFF;

Begin:
   sprintf(O_buf,"Pick %s ...",prompt1); scope_mess_perm(O_buf);
   wt1 = pick_wt();                      scope_clear();
   sprintf(O_buf,"Pick %s ...",prompt2); scope_mess_perm(O_buf);
   wt2 = pick_wt();                      scope_clear();
   if( wt1 == wt2 ) {
      ringbell(); scope_mess("Same window picked twice!",1);
      goto Begin;
   }
   sprintf(O_buf,"Pick %s ...",prompt3); scope_mess_perm(O_buf);
   wt3 = pick_wt();                      scope_clear();
   if( wt1 == wt3 || wt2 == wt3 ) {
      ringbell(); scope_mess("Same window picked twice!",1);
      goto Begin;
   }
   if( ltrace ) {
      fprintf(stderr,"get_and_check_wt_triple: Picked %d %d %d\n",
              wt1,wt2,wt3);
   }
   if( (check_fcn)(wt1,wt2)  && (check_fcn)(wt1,wt3) ) {
      load_WTTRIPLE(pthe,wt1,wt2,wt3);
   } else {
      load_WTTRIPLE(pthe,-wt1,-wt2,-wt3); 
   }
}

void get_and_check_wt_quad(WTQUAD *pthe,STRING prompt1,STRING prompt2,
                           STRING prompt3,STRING prompt4,PFI_II check_fcn) {
   int       wt1,       wt2,        wt3,        wt4;  

#define E1(p) if( (p) ) { ringbell(); scope_mess("Same window picked twice!",1);goto Begin; }

Begin:
   sprintf(O_buf,"Pick %s ...",prompt1); scope_mess_perm(O_buf);
   wt1 = pick_wt();                      scope_clear();
   sprintf(O_buf,"Pick %s ...",prompt2); scope_mess_perm(O_buf);
   wt2 = pick_wt();                      scope_clear();
   E1(wt1 == wt2);
   sprintf(O_buf,"Pick %s ...",prompt3); scope_mess_perm(O_buf);
   wt3 = pick_wt();                      scope_clear();
   E1(wt1 == wt3); E1(wt2 == wt3);
   sprintf(O_buf,"Pick %s ...",prompt4); scope_mess_perm(O_buf);
   wt4 = pick_wt();                      scope_clear();
   E1(wt1 == wt4); E1(wt2 == wt4); E1(wt3 == wt4);
   if( (check_fcn)(wt1,wt2)  && 
       (check_fcn)(wt1,wt3)  &&
       (check_fcn)(wt1,wt4) ) {
      load_WTQUAD(pthe,wt1,wt2,wt3,wt4);
   } else {
      load_WTQUAD(pthe,-wt1,-wt2,-wt3,-wt4); 
   }
}
#undef E1 

void get_and_check_wt_sex(WTSEX *pthe,STRING prompt1,STRING prompt2,
                          STRING prompt3,STRING prompt4,
                          STRING prompt5,STRING prompt6, PFI_II check_fcn) {
   int       wt1,       wt2,        wt3,        wt4,      wt5,     wt6;  

#define E1(p) if( (p) ) { ringbell(); scope_mess("Same window picked twice!",1);goto Begin; }

Begin:
   sprintf(O_buf,"Pick %s ...",prompt1); scope_mess_perm(O_buf);
   wt1 = pick_wt();                      scope_clear();
   sprintf(O_buf,"Pick %s ...",prompt2); scope_mess_perm(O_buf);
   wt2 = pick_wt();                      scope_clear();
   E1(wt1 == wt2);
   sprintf(O_buf,"Pick %s ...",prompt3); scope_mess_perm(O_buf);
   wt3 = pick_wt();                      scope_clear();
   E1(wt1 == wt3); E1(wt2 == wt3);
   sprintf(O_buf,"Pick %s ...",prompt4); scope_mess_perm(O_buf);
   wt4 = pick_wt();                      scope_clear();
   E1(wt1 == wt4); E1(wt2 == wt4); E1(wt3 == wt4);
   sprintf(O_buf,"Pick %s ...",prompt5); scope_mess_perm(O_buf);
   wt5 = pick_wt();                      scope_clear();
   E1(wt1 == wt5); E1(wt2 == wt5); E1(wt3 == wt5);
   E1(wt4 == wt5); 
   sprintf(O_buf,"Pick %s ...",prompt6); scope_mess_perm(O_buf);
   wt6 = pick_wt();                      scope_clear();
   E1(wt1 == wt6); E1(wt2 == wt6); E1(wt3 == wt6);
   E1(wt4 == wt6); E1(wt5 == wt6);
   if( (check_fcn)(wt1,wt2)  && 
       (check_fcn)(wt1,wt3)  &&
       (check_fcn)(wt1,wt4)  &&
       (check_fcn)(wt1,wt5)  &&
       (check_fcn)(wt1,wt6) ) {
      load_WTSEX(pthe,wt1,wt2,wt3,wt4,wt5,wt6);
   } else {
      load_WTSEX(pthe,-wt1,-wt2,-wt3,-wt4,-wt5,-wt6); 
   }
}
#undef E1 

IVECN get_and_check_wt_list(PFI_II check_fcn,int select_all) {
   IVECN   wt_list = {(IVEC) NULL,0};
   int     i;

/* DISABLED:
   if( select_all ) {
      wt_list = wt_list_from_wtal();
   } else {
      wt_list = mpick_wt();
   }
   if( wt_list.n > 1 ) {
      for( i = 1; i < wt_list.n; i++ ) {
         if( ! (check_fcn) (wt_list.v[0],wt_list.v[i]) ) {
            free_IVECN(wt_list);
            wt_list.n = -1;
            return(wt_list);
         }
      }
   }
*/
   return(wt_list);
}

int check_wt_list(IVECN wt_list, PFI_II check_fcn) {
   int     i, rc = 1;
   if( wt_list.n > 1 ) {
      for( i = 1; i < wt_list.n; i++ ) {
         if( ! (check_fcn) (wt_list.v[0],wt_list.v[i]) ) {
            return 0;
         }
      }
   }
   return 1;
}

/* Routines for titling ... */

void do_title_1(wt)
   WT       wt;
#define     WINNO         wds[wt].sgi_winno
{
   char    *title;
   long     orgx,         orgy,
            dx,           dy;
   int      length_title;
   fmfonthandle           fh,   fh1;
   double                 fontsize;

   title = get_string_from_window(scope_sgi_winno,fh_prompt,
                                  GREEN,BLACK,CYAN,"Title: ",0.01,0.20);
   if( title ) {
      winset(WINNO);
      equate_screen_and_world_coordinates(WINNO);
      getsize(&dx,&dy); getorigin(&orgx,&orgy);
      color(DEFAULT_BACK_COLOR); clear();
      color(DEFAULT_TITLE_BORDER_COLOR);
      linewidth(DEFAULT_TITLE_BORDER_WIDTH);
      rect(orgx,orgy,orgx+dx-2,orgy+dy-2);
      length_title = fmgetstrwidth(fh_prompt,title);
      fh1 = fmfindfont(get_font_from_menu());
      GET_DOUBLE(fontsize,FH_PROMPT_DEF_SIZE,"Font size: ");
      winset(WINNO);
      fh = fmscalefont(fh1,fontsize);
      fmsetfont(fh);
      cmov2i(orgx + (dx - length_title) / 2, orgy + dy / 2);
      color(CYAN);
      fmprstr(title);
      swapbuffers(); 
      (void) x_mouse_after_button();
      free(title);
   }
   set_must_remap(wt); set_must_redraw(wt);
}

void do_font_scan(wt)
   WT                wt;
{
   long              orgx,         orgy,
                     dx,           dy;
   fmfonthandle      fh1,          fh;
   fmfontinfo        fontinfo;
   char             *fontname;
   double            fontsize;
   int               length_string;

   double            Minimum_font_size    =    1.0;
   double            Maximum_font_size    =    75.0;

   int               i,            j,          op,           ngroups;
   char              string[17];

   if( alt_key_pressed() ) {
      fontname = get_string_from_window(scope_sgi_winno,fh_prompt,
                 GREEN,BLACK,CYAN,"fontname ",0.01,0.20);
   } else {
      fontname = get_font_from_menu();
   }
   fontsize = FH_PROMPT_DEF_SIZE;
   fh1 = fmfindfont(fontname);
   if( fh1 ) {
      fh = fmscalefont(fh1,fontsize);
      fmgetfontinfo(fh,&fontinfo);
      sprintf(O_buf,"Nglyphs: %d",fontinfo.nglyphs);
      scope_mess(O_buf,1);
      ngroups = (1 + fontinfo.nglyphs) / 8;
      winset(WINNO);
      equate_screen_and_world_coordinates(WINNO);
      getsize(&dx,&dy); getorigin(&orgx,&orgy);
      for( i = 0; i < ngroups; ) {
         for( j = 0; j < 8; j++ ) {
            string[j] = (char) (8 * i + j);
         }
         string[8] = '\0';
         color(DEFAULT_BACK_COLOR); clear();
         color(DEFAULT_TITLE_BORDER_COLOR);
         linewidth(DEFAULT_TITLE_BORDER_WIDTH);
         rect(orgx,orgy,orgx+dx-2,orgy+dy-2);
         length_string = fmgetstrwidth(fh,string);
         fmsetfont(fh);
         cmov2i(orgx + (dx - length_string) / 2, orgy + dy / 2);
         color(CYAN);
         fmprstr(string);
         sprintf(O_buf,"%s: %d --- %d:  %s",fontname,i * 8, i * 8 + 7,string);
         scope_mess_perm(O_buf);
         winset(WINNO);
         swapbuffers();
         if( op = wait_for_mouse() ) {
            i += op; if( i < 0 ) i = 0;
         } else {
            fontsize = (int) (Minimum_font_size + (Y_mouse - orgy) / dy *
                             (Maximum_font_size - Minimum_font_size));
            sprintf(O_buf,"Fontsize: %g.\n",fontsize);
            scope_mess(O_buf,1);
/*          fmfreefont(fh1); fmfreefont(fh);   */
            fh1 = fmfindfont(fontname);
            fh = fmscalefont(fh1,fontsize);
         }
         scope_mess_perm(" ");
         winset(WINNO);
      }
/*    fmfreefont(fh1); fmfreefont(fh);  */
   } else {
      sprintf(O_buf,"Font <%s> Size <%g> not found.\n",fontname,fontsize);
      scope_mess_and_bell(O_buf,2);
   }
   set_must_remap(wt); set_must_redraw(wt);
}
#undef       WINNO

void make_font_list()
{
   fmenumerate(count_fonts);
   Font_list = malloc(N_fonts * sizeof(char *));
   fmenumerate(build_font_list);
   make_font_menu();
}

void dump_font_list()
{
   int        i;

   for( i = 0; i < N_fonts; i++ ) {
      printf("Font %d --> %s.\n",i+1,Font_list[i]);
   }
}

void count_fonts(str)
   char      *str;
{
   ++N_fonts;
}

void build_font_list(str)
   char      *str;
{
   Font_list[I_font++] = strdup(str);
}

int make_font_menu()
{
   int        menu,    i;

   menu = newpup();
   sprintf(O_buf,"%s %%t","FONTS");
   addtopup(menu,O_buf);
   for( i = 0; i < N_fonts; addtopup(menu,Font_list[i++]) );
   Font_menu = menu;
   return menu;
}

char *get_font_from_menu()
{
   if( Font_menu < 0 ) {
      make_font_menu();
   }
   return Font_list[dopup(Font_menu)-1];
}

int is_available_font(fontname)
   char       *fontname;
{
   int         i;
   
   for( i = 0; i < N_fonts; i++ ) {
      if( !strcmp(fontname,Font_list[i]) ) return 1;
   }
   return 0;
}

void rename_wt_1(WT wt,int opcode) {
   static char R[] = "rename_wt_1";
   int         ltrace = Ltrace;
   static int  save_wt;
   int         i;

   if( ltrace ) {
      fprintf(stderr,"%s: wt=%d opcode=%d\n",R,wt,opcode);
   }

   if( opcode == 0 ) {
      save_wt = wt;
      Apply_all = control_apply_all_wt();
      Menu_deferred = MENU_DEFERRED_RENAME;
      return;
   }
   if( Apply_all ) {
      apply_all_wt_0((PFV_I) rename_wt_2);
   } else {
      rename_wt_2(save_wt);
   }
}

void rename_wt_2(WT wt) {
   char       *new_name;
   new_name = xvs_get_string("new name",wds[wt].name);
   if( valid_name(new_name) && check_dup_name(wt,new_name) ) {
      free(wds[wt].name);
      wds[wt].name = strdup(new_name);
      set_must_redraw(wt);
   }
   if( new_name ) free(new_name);
}

void rename_wt(int wt) {
   rename_wt_1(wt,0);
}

void rename_wt_old(wt)
   WT        wt;
{
   char     *new_name;

#define   NAME   wds[wt].name
   centre_mouse_in_wt(wt);
   sprintf(O_buf,"New name (%s): ",NAME);
   new_name = get_string_from_window(scope_sgi_winno,fh_prompt,
              GREEN,BLACK,CYAN,O_buf,0.01,0.20);
   if( new_name ) {
      if( NAME ) free(NAME);
         NAME = strdup(new_name);
         free(new_name);
      }
   set_must_redraw(wt);
#undef    NAME
}

int check_dup_name(WT wt,char *name) {
   int wtn = wt_from_name(name);

   if( wtn < 0 || wtn == wt ) {
      return 1;
   } else {
      sprintf(B,"Window named '%s' already exists.",name);
      scope_mess_and_bell(B,1);
      return 0;
   }
}

void Set_display_index_wt_old(wt)
   WT         wt;
{
#define       P          wds[wt].pf.pxyf
#define       LXY        P->lxy

   int        req_index, all_windows;
   char      *buffer;

   all_windows = alt_key_pressed();

   if( !is_active_wt(wt) ) return;

   sprintf(O_buf,"Index (1-%d): ",LXY);
Get_req_index:
   buffer = get_string_from_window(scope_sgi_winno,fh_prompt,
            GREEN,BLACK,CYAN,O_buf,0.01,0.20);
   if( buffer ) {
      if( ( sscanf(buffer,"%d",&req_index) != 1 ) ||
          ( 1 > req_index )  ||  ( req_index > LXY ) ) {
         ringbell(); goto Get_req_index;
      }
      free(buffer);
      if( all_windows ) {
         apply_all_wt_1((PFV_II) set_xycurr_nth,req_index);
      } else {
         set_xycurr_nth(wt,req_index);
      }
   } else {
      scope_mess_and_bell("Operation aborted.",1);
   }
#undef        LXY
#undef        P
}

#define       P          wds[wt].winf.pwf.pxywinf

void set_accept_frequency_wt(wt,accept_frequency)
   WT           wt;
   int          accept_frequency;
{
   if( is_active_wt(wt) ) {
      P->accept_frequency = accept_frequency;
   }
}

void Set_accept_frequency_wt(wt)
   WT           wt;
{
   int          accept_frequency;
   int          all_windows;
   char        *buffer;

   all_windows = alt_key_pressed();

   if( !is_active_wt(wt) ) return;

Get_accept_frequency:
   buffer = get_string_from_window(scope_sgi_winno,fh_prompt,
            GREEN,BLACK,CYAN,"Accept every: ",0.01,0.20);
   if( buffer ) {
      if( ( sscanf(buffer,"%d",&accept_frequency) != 1 ) ) {
         ringbell(); goto Get_accept_frequency;
      }
      free(buffer);
      if( all_windows ) {
         apply_all_wt_1((PFV_II) set_accept_frequency_wt,accept_frequency);
      } else {
         set_accept_frequency_wt(wt,accept_frequency);
      }
   } else {
      scope_mess_and_bell("Operation aborted.",1);
   }
}
#undef        P

void change_wt_from_wt(wt,n_skip)
   WT             wt;
   int            n_skip;
{
   if( scope_mode == PANEL_MODE ) {
      centre_mouse_in_wt(wt_from_index(index_from_wt_plus_skip(wt,n_skip)));
   }
}

int index_from_wt_plus_skip(wt,n_skip)
   WT              wt;
   int             n_skip;
{
   int             n_wt,    oi,    ni;

   n_wt = n_windows();
   if( (oi = index_from_wt(wt)) > 0 ) {
      ni = oi + n_skip;
      ni = (ni > n_wt) ? 1 : (ni < 1 ) ? n_wt : ni;
   } else {
      ni = 1;
   }
   return ni;
}

void swaptrace(char *routine,char *mess) {
   fprintf(stderr,"swaptrace:: %s: %s.\n",routine,mess);
   sleep(1);
}

void save_as_sdf(WT wt) {
   int     ltrace = OFF;
   if( is_active_wt(wt) ) {
      sprintf(O_buf,"(cd %s; %s '%s') &",wds[wt].wd,SDF_SAVE_CMD,wds[wt].name);
   }
   fprintf(stderr,"%s\n",O_buf);
   system(O_buf);
}

int int_env(char *env, int defval) {
   int  val;
   if( getenv(env) ) {
      if( !(sscanf(getenv(env),"%d",&val) == 1) ) val = defval;
   } else {
      val = defval;
   }
   return val;
}

double double_env(char *env, double defval) {
   double val;
   if( getenv(env) ) {
      if( !(sscanf(getenv(env),"%lf",&val) == 1) ) val = defval;
   } else {
      val = defval;
   }
   return val;
}
