#ifndef   UTILDEF
#define   UTILDEF
#include <sysincludes.h>
#include "util_types.h"
#include "xy.h"

/* Now send data to server via 'seg2vs' which takes only the 
   .segdat file name or tag and sends all time groups of the 
   first function  ... */

#define                   SEGDAT_LOAD_CMD  "seg2vs"
#define                   SEGDAT_SAVE_CMD  "vs2seg"
#define                   SDF_LOAD_CMD     "sdftovs"
#define                   SDF_SAVE_CMD     "vstosdf"

#define                   NFS_HEAD         "/nevermore/nevermore"
#define                   RSH              "/usr/bsd/rsh einstein -n "
#define                   CUT_BUFFER       "/tmp/.cutbuffer"

#define                   MAX_LOAD_FNAME  100

#define                   FTN_SLEN        16
typedef char              FTNS[FTN_SLEN]; 

extern FTNS               Load_fname[];
extern FTNS               Load_blanks; 
extern char               Load_command[];
extern int                Load_nfcn;
extern int                Load_ifcn;
extern int                Load_ng;
extern int                Load_iv[]; 
extern int                Load_liv;
extern int                Load_wt;

extern char             **Font_list;
extern int                Font_menu;
extern int                N_fonts;
extern int                I_font;

extern long               Pick_wt_dev;

PPARMS_VS_OPEN_XY1        Pmake_PARMS_VS_OPEN_XY1();
WT                        vs_open_xy1();
int                       has_ext_scandir(struct direct *);
int                       has_pre_ext_scandir(struct direct *);
int                       is_directory_scandir(struct direct *);
void                      free_direct_array(struct direct ***,int);
void                      choose_file_by_ext(char *,char *,char *,char *);
void                      choose_file_by_pre_ext(char *,char *,char *,char *);
char                     *choose_file_with_ext(char *,char *);
int                       compress_in_place_wt(WT,IVEC,int);
PXYDVBIND                 compress_in_place_XYDVlist(PXYDVBIND,IVEC,int);
int                       clip_wt(WT);
PXYDVBIND                 old_clip_XYDVLIST(PXYDVBIND,DQUAD);
PXYDVBIND                 clip_XYDVLIST(PXYDVBIND p,DQUAD dq);
void                      get_New_dir(void);
int                       old_do_cd_wt(WT);
int                       do_cd_wt(WT wt,int prompt);
int                       cd_wt(WT,char *);
int                       do_csd_wt(WT wt,int echo);
int                       do_remove_lpc_wt(WT);
int                       do_sd_wt(WT);
int                       do_pwd_wt(WT);
int                       old_do_load_segdat_wt(WT);
int                       do_load_segdat(WT wt);
int                       do_load_sdf(WT wt);
void                      do_cd_menu(char *,char *,char *);
int                       get_cut_buffer(char *);
int                       put_cut_buffer(char *);
void                      load_color_map_from_sw_string(void);
void                      save_color_map_to_sw_string(void);

int                       confirm_overwrite(char *,char *);
int                       is_affirmative_reply(char *);

int                       pick_wt(void);
int                       picked_wt(void);
int                       pick_wt_1(int opcode);
int                       pick_wt_with_mess(STRING);
void                      mpick_wt(int opcode,int npick);
PXYDVBIND_VECN            pxydv_list_from_wt_list(IVECN wt_list);
int                       do_check_pair(STRING,STRING);
void                      get_and_check_wt_pair
                            (WTPAIR *pthe,
                             STRING prompt1,STRING  
                             prompt2,PFI_II check_fcn);
void                      get_and_check_wt_triple
                             (WTTRIPLE *pthe,
                              STRING prompt1,STRING prompt2,STRING prompt3,
                              PFI_II check_fcn);
void                      get_and_check_wt_quad
                             (WTQUAD *pthe,
                              STRING prompt1,STRING prompt2,STRING prompt3,
                              STRING prompt4,PFI_II check_fcn);
void                      get_and_check_wt_sex
                             (WTSEX *pthe,
                              STRING prompt1,STRING prompt2,STRING prompt3,
                              STRING prompt4,STRING prompt5,STRING prompt6,
                              PFI_II check_fcn);
IVECN                     get_and_check_wt_list(PFI_II check_fcn,int select_all);
int                       handle_apply2_menu(int code);

void                      do_title_1(WT);
void                      do_font_scan(WT);
void                      make_font_list(); 
void                      dump_font_list(); 
void                      count_fonts(char *);
void                      build_font_list(char *);
int                       make_font_menu();
char                     *get_font_from_menu();
int                       is_available_font(char *);
extern                    void rename_wt_1(WT wt,int opcode);
extern                    void rename_wt_2(WT wt);
extern                    void rename_wt(int);
extern                    int check_dup_name(WT wt,char *name);
void                      Set_display_index_wt_old(WT);
void                      set_accept_frequency_wt(WT,int);
void                      Set_accept_frequency_wt(WT);

void                      change_wt_from_wt(WT,int);
int                       index_from_wt_plus_skip(WT,int);

void                      swaptrace(char *routine,char *mess); 

void                      save_as_sdf(WT wt);

extern char               has_ext_EXTENSION[];

int                       int_env(char *env, int defval);
double                    double_env(char *env, double defval);

#endif 
