#include "../sysincludes.h"
#include "plot_c.h"

/* Assumes graphics is initialized ... */

int loadmap_from_file(filetag)
   char      *filetag;
{
   static char ext[] = ".colormap.";
   static char default_ext[] = "/usr/people/matt/utilplot/.colormap.";

	int    ltrace = OFF;

   char    *filename;
   FILE    *colormap;

   Colorindex  c_entry;
   short       c_r,   c_g,   c_b;

	if( ltrace ) {
		fprintf(stderr,"loadmap_from_file: In routine with <%s>\n",filetag);
	}
   if( strlen(filetag) == 1 && filetag[0] == '-' ) {   
      colormap = stdin;
   } else {
      if( !(colormap = fopen(filetag,"r")) ) {
         filename = (char *) 
            malloc((strlen(ext)+strlen(filetag)+1) * sizeof(char));
         filename = strcat(strcpy(filename,ext),filetag);
         if( !(colormap = fopen(filename,"r")) ) {
            free(filename);
            filename = (char *) 
               malloc(strlen(default_ext)+strlen(filetag) * sizeof(char));
            filename = strcat(strcpy(filename,default_ext),filetag);
            if( !(colormap = fopen(filename,"r")) ) {
               free(filename);
               return -1;
            }
         }
			if( ltrace ) {
				fprintf(stderr,"loadmap_from_file: File %s opened for read.\n",
                    filename);
			}
         free(filename);
      } 
   }
   while( fscanf(colormap,"%hd %hd %hd %hd",&c_entry,&c_r,&c_g,&c_b) == 4 ) {
      (void) mapcolor(c_entry,c_r,c_g,c_b);    
		if( ltrace ) {
			fprintf(stderr,"loadmap_from_file: Entry %d -- (%3d,%3d,%3d)\n",
                 c_entry,c_r,c_g,c_b);
		}
   }
   fclose(colormap);
/* system("makemap");  */

   return 0;
}

int savemap_part_to_file(filetag,min_index,max_index)
   char      *filetag;
   int        min_index,       max_index;
{
   static char ext[] = "/usr/people/matt/utilplot/.colormap.";

   char    *filename;
   FILE    *colormap;

   Colorindex  c_entry;
   short       c_r,   c_g,   c_b;

   filename = (char *) 
      malloc((strlen(ext)+strlen(filetag)+1) * sizeof(char));
   sprintf(filename,"%s%s",ext,filetag);
   if( !(colormap = fopen(filename,"w")) ) {
      free(filename);
      return -1; 
   }
   for( c_entry = min_index; c_entry <= max_index; c_entry++ ) {
      (void) getmcolor(c_entry,&c_r,&c_g,&c_b);
      fprintf(colormap,"%d %d %d %d\n",c_entry,c_r,c_g,c_b);    
   }
   fclose(colormap);
   free(filename);
   return 0;
}

int savemap_to_file(filetag)
   char      *filetag;
{
   return savemap_part_to_file(filetag,0,255);
}

/* Set backgrond to solid color given by map entry map_entry ... */

void set_root_to_map_entry_color(int map_entry)
{
	short    r_val,  g_val,  b_val;
	char     system_command[1024];

	getmcolor((Colorindex) map_entry,&r_val,&g_val,&b_val);
	sprintf(system_command,"xsetroot -solid \"#%02x%02x%02x\"",
           r_val,g_val,b_val);
	system(system_command);

}
