#ifndef VIDEO_DEF
#define VIDEO_DEF

#include "../sysincludes.h"
#include "video_types.h"
#include "video_gl_constants.h"


extern      jmp_buf     Video_ldr_off_jbuf;
extern      int         Video_ldr_state;
extern      int         Video_ldr_mode;
extern      int         Video_ldr_off_time;

extern      int         Video_videolab_state;
extern      char        Video_videolab_init_cmd[];
extern      char       *Video_videolab_initfile;
extern      int         Video_videolab_init_sleep;

extern      int         Video_rs232;
extern      char        Video_rs232_pseudo_file[];
extern      int         Video_trace;

extern      int         Video_record_trace;
extern      int         Video_record_trace_prev;
extern      char       *Video_sequence_label;
extern      char        Video_sequence_file[];
extern      char        Video_sequence_file_prev[];
extern      FILE       *Video_sequence_FILE;
extern      int         Video_sequence_count;
extern      int         Video_start_frame;
extern      int         Video_finish_frame;

extern      char        Video_buffer[];

extern      int         Video_trace_state;

#define     VIDEO_NO_START_FRAME  -1
#define     VIDEO_ON                    0
#define     VIDEO_OFF                   1
#define     VIDEO_UNKNOWN               2
#define     VIDEO_PLAY                  0
#define     VIDEO_RECORD                1

#define     DEFAULT_VIDEO_AUTO_SEQUENCE_FILE ".video_trace"


extern      int              Video_auto_sequence_state;
extern      char            *Video_auto_sequence_filename;
extern      FILE            *Video_auto_sequence_FILE;
extern      char            *Video_auto_sequence_label;
extern      int              Video_auto_sequence_bgn;
extern      int              Video_auto_sequence_end;
extern      VIDEO_SEQ_LIST   Video_auto_seq_list;
extern      int              Video_auto_sequence_trace;

extern      int         video_open_rs232(void);
extern      int         video_close_rs232(void);
extern      int         video_record_one_frame(void);
extern      int         video_record_one_frame_0(void);
extern      int         video_record_one_frame_no_cursor(void);
extern      int         video_record_n_seconds(double n);
extern      void        video_trace_on(void);
extern      void        video_trace_off(void);

extern      int         video_get_ldr_response(char *com);
extern      int         video_get_ldr_error_code(void);
extern      char       *video_get_ldr_general_response(void);
extern      int         video_set_ldr_frame(int frame_number);
extern      int         video_get_ldr_frame(void);
extern      void        video_send_ldr_command(char *command);
extern      int         int_in_range(int n, int lo, int hi);

extern      int         video_ldr_playback_with_pause(
                           int first_frame, int last_frame, int speed, 
                           int pre_pause, int post_pause );
extern      int         video_ldr_playback(
                           int first_frame, int last_frame, int speed );
extern      int         video_ldr_playback_with_prompt(
                           int first_frame, int last_frame, int speed );

extern      void        countdown(char *mess, int nsecs);

extern      int         video_ldr_cancel(void);

extern      void        video_set_record_trace(void);
extern      void        video_unset_record_trace(void);
extern      void        video_set_sequence_label(char *label);
extern      void        video_record_trace_sequence(int start,int end);
extern      void        video_record_trace(void);

extern      int         video_rs232_not_open(char *routine);

extern      int         video_on_line_0(int mode);
extern      int         video_on_line(void);
extern      int         video_off_line(void);
extern      int         video_set_record_mode(void);
extern      int         video_set_record_mode_0(void);
extern      int         video_clear_record_mode(void);
extern      int         video_clear_record_mode_0(void);
extern      int         video_on_line_lock(void);
extern      int         video_on_line_unlock(void);
extern      int         video_eject(void);
extern      int         video_load(void);

extern      char*       video_player_status(void);

extern      void        video_onalarm(void);
extern      int         video_get_ldr_state(char *routine);
extern      int         video_init_ldr(char *routine,int mode);

extern      int         video_set_videolab_initfile(char *initfile);

extern      int         video_standard_controls(Video_Control_Type op, 
                                                double speed,int frame_num);
extern      int         video_play0(double speed);
extern      int         video_still(void);
extern      int         video_step(int nsteps);
extern      int         video_sequence_playback_forward(int bgn,int end,
                                                        int speed);
extern      int         video_sequence_playback_reverse(int bgn,int end,
                                                        int speed);
extern      int         video_sequence_playback(Video_Control_Type op,
                                                double speed,int bgn,int end);

extern      VIDEO_SEQ_LIST    null_video_seq_list(void);
extern      VIDEO_SEQ_LIST    free_video_seq_list(VIDEO_SEQ_LIST the);
extern      void              dump_video_seq_list(VIDEO_SEQ_LIST the);
extern      void              loc_ivfdump(FILE *fp,IVEC v,int n,char *s);
extern      VIDEO_SEQ_LIST    get_video_seq_list_from_file(char *fname);

extern      int               video_set_auto_sequence(char *filename);
extern      VIDEO_SEQ_LIST    append_seq_list(VIDEO_SEQ_LIST in);
extern      int               put_video_seq_list_to_file(VIDEO_SEQ_LIST the,
                                                         char *fname);
extern      int               video_set_auto_sequence_label(char *label);

#endif
