#ifndef WIN_TYPES

#include "xy_types.h"
#include "wt_types.h"
#include "util_types.h"
#include "mfl_types.h"

/*
    When modifying this structure, update functions

      PXYWINF make_pxywinf()
      free_pxywinf()
      window_stats(wt)
      copy_xywinf(wt1,wt2)

    in <misc.c>.
*/

typedef      struct        XYWINF {
   int                        back_color;
   int                        border_color;
   int                        marker_type;
   int                        marker_color;
   float                      marker_size;
   int                        point_size;
   int                        marker_npoly;
   int                        marker_multi_mode;
   int                        marker_line_auto_break;
   int                        line_color;
   int                        line_width;
   int                        must_remap;
   int                        new_domain;
   int                        must_redraw;
   int                        domain_mode;
   int                        display_mode;
   int                        prev_display_mode;
   int                        auto_sub_mode;
   int                        auto_break_mode;
   int                        full_scale_mode;
   int                        var_dquad;      
   double                     var_dquad_zoom;      
   int                        heads_up;
   char                      *heads_up_t_format;
   int                        heads_up_lim;
   BAR_GAUGE                  range_gauge;
   int                        accept_frequency;
   int                        status_window_flag;
   int                        status_sgi_winno;
   int                       *plxy;
   int                       *pdisplay_index;
}                          XYWINF,   *PXYWINF;

typedef      struct        WINF {
   IQUAD                      wiq;
   int                        d_buff;           
   union {
      PXYWINF                   pxywinf;
   }                          pwf;
}                          WINF;

/* Add a pointer to main form? */
typedef      struct        WINDOW {
   int                        sgi_winno;
   char                      *name;
   int                        namelen;
   int                        owner;
   char                      *wd;
   int                        wdlen;
   int                        status;
   union {
      PXYF                       pxyf;
   }                          pf;
   WINF                       winf;
   xvs_dl_font               *AN_dl_fonts;
   int                       *n_AN_dl_fonts;
}                          WINDOW,  *PWINDOW;

#define      WINDOW_DEFAULT    -1
#define      WINDOW_NOT_ACTIVE  0
#define      WINDOW_ACTIVE      1
#define      WINDOW_BLOCKING    2

#define      D_BUFF_OFF         0
#define      D_BUFF_ON          1

#define WIN_TYPES
#endif
