#ifndef  WTDEFS
#define  WTDEFS

#include <v_types.h>
#include "vs.h"
#include "wt_types.h"

#define   MAXWT         MAX_WINDOWS
#define   BASE_WT       1
#define   SCOPE_WT      0            /* Scope's window tag. */

extern   WT           hiwt;
extern   PWTBIND      wtal;
extern   PWTBIND      save_wtal;
extern   PWTND        wtfl;    

extern   PWTND        make_WTND(WT,PWTND);
extern   void         free_WTND(PWTND); 
extern   PWTBIND      make_WTBIND(WT,PWTBIND,PWTBIND);
extern   void         free_WTBIND(PWTBIND);
extern   WT           new_wt();
extern   WT           new_wt_1();
extern   int          free_wt(WT);
extern   int          move_wt_after_wt(WT,WT);
extern   int          move_wt_before_wt(WT,WT);
extern   int          is_active_wt(WT);
extern   WT           wt_from_xyhead(PXYDVBIND xyhead);
extern   int          n_windows();
extern   int          n_windows_1();
extern   PWTBIND      tail_wtal(PWTBIND);
extern   int          index_from_wt(WT);
extern   WT           wt_from_index(WT);

extern   void         dump_wtal();
extern   void         rdump_wtal();
extern   void         dump_wtfl();

extern   WTPAIR       make_WTPAIR(WT,WT);
extern   void         load_WTPAIR(WTPAIR *pthe,WT wt1,WT wt2);
extern   int          is_null_WTPAIR(WTPAIR);

extern   WTTRIPLE     make_WTTRIPLE(WT,WT,WT);
extern   void         load_WTTRIPLE(WTTRIPLE *pthe,WT wt1,WT wt2,WT wt3);
extern   int          is_null_WTTRIPLE(WTTRIPLE);

extern   WTQUAD       make_WTQUAD(WT,WT,WT,WT);
extern   void         load_WTQUAD(WTQUAD *pthe,WT wt1,WT wt2,WT wt3,WT wt4);
extern   int          is_null_WTQUAD(WTQUAD quad);

extern   WTSEX        make_WTSEX(WT,WT,WT,WT,WT,WT);
extern   void         load_WTSEX(WTSEX *pthe,WT wt1,WT wt2,WT wt3,WT wt4,
                                 WT wt5,WT wt6);
extern   int          is_null_WTSEX(WTSEX);

extern   void         apply_all_wt_0(PFV_I f0);
extern   void         apply_all_wt_1(PFV_II f1,int arg1);
extern   void         apply_all_wt_d(PFV_ID f,double arg1);
extern   void         apply_all_wt_d_d(PFV_IDD f,double arg1,double arg2);

extern   void         printf_wt_name(WT wt);
extern   IVECN        wt_list_from_wtal(void);

#endif
