#ifndef SER_DEF
#define SER_DEF

#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glx.h>
#include <GL/glu.h>
#include <forms.h>

#include "sysincludes.h"
#include "quad_types.h"
#include "mfl_types.h"
#include "win_types.h"
#include "sdf_types.h"
#include "xvs_gui.h"

enum {
   XVS_FETCH_OK,
   XVS_FETCH_INVALID_REQUEST,
   XVS_FETCH_NO_SUCH_NAME,
   XVS_FETCH_NO_SUCH_INDEX
};

enum {
   XVS_LEFT,
   XVS_RIGHT
};


extern          char           *P;

extern          WINDOW          wds[];
extern          int             max_windows;
extern          int             Max_panel;
extern          int             Pnl,  Pnl_prev;

extern          char            shostname[];
extern          int             shnlen;

extern          char           *Cwd;

extern          FD_main        *Xvsf;
extern          FD_main        *Ixvsf;
extern          FD_info        *Xvsf_info;
extern          FD_markers     *Xvsf_markers;
extern          FD_view        *Xvsf_view;
extern          FD_file        *Xvsf_file;
extern          FD_ops         *Xvsf_ops;
extern          FD_control     *Xvsf_control;
extern          FD_mpeg        *Xvsf_mpeg;
extern          FD_sm          *Xvsf_sm;
extern          FD_browse      *Xvsf_browse;
extern          FD_label       *Xvsf_label;

extern          int             Ltrace;
extern          int             Ltrace_cb_glcanvas_main;

extern          int             Control_form_posn_pref;
extern          int             Main_form_border;
extern          int             Last_data_wt;
extern          char           *Last_data_dir;

/*
extern          XFontStruct    *Glfont[];
extern          XFontStruct    *Glf;
char            Glfont_name[];
*/

extern          void            xvs_help_www(void);
extern          int             xvs_has_focus(void);
extern          int             pnl_to_ncr(int pnl);
extern          int             xvs_form_state_push(int state);
extern          int             xvs_form_state_pop(void);
extern          int             pnl_to_ncr(int pnl);
extern          int             xvs_get_wt_w(WT wt);
extern          int             xvs_get_wt_h(WT wt);

extern          void            xvs_set_form_geometry(int code);
extern          void            dump_Xvsf(FD_main *the,char *s);
extern          void            dump_Pnl(char *s);

extern          void            all_ds_init(void);
extern          void            xvs_hide_panel(int pnl);
extern          void            xvs_show_panel(int pnl);
extern          int             xvs_panel_append(WT wt);
extern          int             xvs_open_and_repanel(WT wt_to_open);
extern          void            xvs_repanel(int nw);
extern          void            xvs_resense(void);
extern          int             xvs_close_wt(WT wt,int reposition_mouse);
extern          int             xvs_close_Picked_wt_list(void);
extern          int             xvs_close_all_wt(int reposition_mouse);
extern          void            wds_init(void);
extern          void            wds_init_1(WT wt,int winno,char *name,
                                    int owner,char *wd);
extern          void            wds_init_2(WT wt,DQUAD dq,int scale_option,
                                    int max_lxy,int max_nevents);

extern          int             xvs_dump(char *s);
extern          int             xvs_insert_SDFDS(PSDFDS the);
extern          WT              wt_from_SDFDS(PSDFDS the);
extern          WT              wt_from_gl(FL_OBJECT *gl);
extern          FL_OBJECT      *gl_from_wt(WT wt);
extern          xvs_dl_font    *f_from_gl(FL_OBJECT *gl);
extern          xvs_dl_font    *f_from_wt(WT wt);

extern          int             xvs_wt_import(WT wt,char *fmt);
extern          void            xvs_wt_to_jpeg(WT wt,char *dir,char *name);
extern          void            xvs_jpeg_seq_to_mpeg(char *dir,char *name,
                                   int nseq);

#endif
