/* Data types for xy plotting (double precision data assumed). */
#ifndef  XY_TYPESDEF
#define  XY_TYPESDEF

#include <v.h>
#include <quad_types.h>


typedef      struct        XYDVEC {
   int                        n;
   DVEC                       x,     y;
}                          XYDVEC,   *PXYDVEC;

typedef      struct        XYTAGVEC {
   int                        n;
   IVEC                       tag;
}                          XYTAGVEC, *PXYTAGVEC;

typedef      struct        XY_PDATA_AND_PTAG {
   PXYDVEC                    data;
   PXYTAGVEC                 tdata;
}                          XY_PDATA_AND_PTAG;

typedef      struct        XYDVBIND {
   int                        index;
   double                     time;
   int                        tag;
   PXYDVEC                    data;
   PXYTAGVEC                  tdata;
   struct XYDVBIND   *        prev;
   struct XYDVBIND   *        next;
}                          XYDVBIND, *PXYDVBIND; 

typedef      struct        PXYDVBIND_VECN {
   PXYDVBIND                 *v;
   int                        n;
}                          PXYDVBIND_VECN;

typedef      XYDVBIND    *(*PXYDVBIND_FCN)();

typedef      struct        DQBIND {
   DQUAD                      dq; 
   struct DQBIND  *           next;
   struct DQBIND  *           prev;
}                          DQBIND,   *PDQBIND;

typedef      struct        XYIVEC {
   int                        n;
   IVEC                       x,     y;
}                          XYIVEC,   *PXYIVEC;

typedef      struct        XYIVBIND {
   XYIVEC                     xy;
   struct XYIVBIND   *        next;
   struct XYIVBIND   *        prev;
}                          XYIVBIND, *PXYIVBIND;


typedef      struct        IQBIND {
   IQUAD                      dq;
   struct IQBIND  *           next;
   struct IQBIND  *           prev;
}                          IQBIND,   *PIQBIND;

#define      NO_LIMITS_COMPUTED      0
#define      LIMITS_COMPUTED         1
#define      NO_SCALE_AS_LOADED      0
#define      SCALE_AS_LOADED         1
#define      DEFAULT_MAX_LXY         1000000
#define      DEFAULT_MAX_NEVENTS     1000000
#define      RING_OFF                OFF
#define      RING_ON                 ON
#define      AUTO_THIN_ON            ON
#define      AUTO_THIN_OFF           OFF

extern          
             int           scale_option;

typedef      struct        XYF    {
   DQUAD                      limits;
   int                        limits_computed;
   int                        scale_option;
   int                        thin_option;
   int                        ring_state;

   int                        new_data;

   PDQBIND                    dqb;
   PDQBIND                    dqc;
   PDQBIND                    dqsz;

   PXYDVBIND                  xyhead;
   PXYDVBIND                  xytail;

   PXYDVBIND                  xymr;

   PXYDVBIND                  xyfirst;
   PXYDVBIND                  xycurr;
   PXYDVBIND                  xylast;

   int                        display_index;

   int                        lxy;
   int                        max_lxy;

   int                        nevents;
   int                        max_nevents;
}                          XYF,      *PXYF;

#endif
